﻿using System;
using System.Linq;
using System.Text;
using System.IO;
using System.Net;
using System.Xml;
using System.Security.Cryptography.X509Certificates;
using System.Security.Policy;
using AETShared;

namespace AETService
{
    class ESWebService
    {
        private string m_post_data = string.Empty;

        private string m_url = string.Empty;
        private string m_mviID = string.Empty;

        private string m_Estatus = string.Empty;
        private string m_Edate = string.Empty;

        private bool m_WriteLog = false;
        private int m_logid = 0;

        private string m_espayload = string.Empty;
        private string m_ESUN = string.Empty;
        private string m_ESPW = string.Empty;

        private string m_line1 = string.Empty;
        private string m_city = string.Empty;
        private string m_state = string.Empty;
        private string m_zipcode = string.Empty;


        public string Line1
        {
            get { return m_line1; }
            set { m_line1 = value; }
        }

        public string City
        {
            get { return m_city; }
            set { m_city = value; }
        }
        public string State
        {
            get { return m_state; }
            set { m_state = value; }
        }
        public string ZipCode
        {
            get { return m_zipcode; }
            set { m_zipcode = value; }
        }
        public int LOGID
        {
            get { return m_logid; }
            set { m_logid = value; }
        }

        public bool WriteLog
        {
            get { return m_WriteLog; }
            set { m_WriteLog = value; }
        }

        public string ESUN
        {
            get { return m_ESUN; }
            set { m_ESUN = value; }
        }
        public string Payload
        {
            get { return m_espayload; }
            set { m_espayload = value; }
        }

        public string ESPW
        {
            get { return m_ESPW; }
            set { m_ESPW = value; }
        }

        public string URL
        {
            get { return m_url; }
            set { m_url = value; }
        }
        public string MVI_ID
        {
            get { return m_mviID; }
            set { m_mviID = value; }
        }
        public string Status
        {
            get { return m_Estatus; }
            set { m_Estatus = value; }
        }
        public string Date
        {
            get { return m_Edate; }
            set { m_Edate = value; }
        }
        public string GetFileData(string fileName)
        {
            string RtnData = "";
            try
            {
                using (StreamReader sr = new StreamReader(fileName))
                {
                    //This allows you to do one Read operation.
                    RtnData = sr.ReadToEnd();
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("The process failed: {0}", e);
            }

            return RtnData;

        }

        /// <summary>
        /// //////////////////////////////////////////////////////////
        /// </summary>
        /// <returns></returns>
        public string CALL_ES()
        {
            string sRTN = string.Empty;
            string outXML = string.Empty;

            bool bLogESPostXML = m_WriteLog;





            //string XMLPOST1 = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\r\n";
            string XMLPOST2 = "<soap:Envelope xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:wsa=\"http://schemas.xmlsoap.org/ws/2004/08/addressing\" xmlns:wsse=\"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd\" xmlns:wsu=\"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd\">\r\n";
            string XMLPOST3 = "<soap:Header>\r\n";
            string XMLPOST4 = "  <wsse:Security soap:mustUnderstand=\"1\">\r\n";
            string XMLPOST5 = "     <wsse:UsernameToken xmlns:wsu=\"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd\" wsu:Id=\"SecurityToken-3e774eaa-9840-4888-9e4c-e966b3bf6092\">\r\n";
            string XMLPOST6 = String.Format("       <wsse:Username>{0}</wsse:Username>\r\n", m_ESUN);
            string XMLPOST7 = String.Format("      <wsse:Password Type=\"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-username-token-profile-1.0#PasswordText\">{0}</wsse:Password>\r\n", m_ESPW);
            string XMLPOST8 = "    </wsse:UsernameToken>\r\n";
            string XMLPOST9 = "   </wsse:Security>\r\n";
            string XMLPOST10 = " </soap:Header>\r\n";
            string XMLPOST11 = "  <soap:Body>\r\n";
            string XMLPOST12 = "   <getEESummaryRequest xmlns=\"http://DNS.URL       /schemas\">\r\n";
            string XMLPOST13 = String.Format("     <key>{0}</key>\r\n", m_mviID);
            string XMLPOST14 = "     <requestName>aetRequest</requestName>\r\n";
            string XMLPOST15 = "   </getEESummaryRequest>\r\n";
            string XMLPOST16 = " </soap:Body>\r\n";
            string XMLPOST17 = "</soap:Envelope>\r\n";

            if (m_url.Trim().Length == 0)
            {
                sRTN = "ERR:" + "NO URL";
                return sRTN;

            }

            m_post_data = /*XMLPOST1 +*/ XMLPOST2 + XMLPOST3 + XMLPOST4 + XMLPOST5 + XMLPOST6 + XMLPOST7 + XMLPOST8 + XMLPOST9 + XMLPOST10 + XMLPOST11 + XMLPOST12 + XMLPOST13 + XMLPOST14 + XMLPOST15 + XMLPOST16 + XMLPOST17;

            sRTN = MakeSOAPCall(bLogESPostXML);

            return sRTN;
        }
        /// <summary>
        /// ////////////////////////////////////////////
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="certificate"></param>
        /// <param name="chain"></param>
        /// <param name="sslPolicyErrors"></param>
        /// <returns></returns>
        public static bool MyCertValidationCb(object sender, X509Certificate certificate, X509Chain chain, System.Net.Security.SslPolicyErrors sslPolicyErrors)
        {
            if ((sslPolicyErrors & System.Net.Security.SslPolicyErrors.RemoteCertificateChainErrors)
                      == System.Net.Security.SslPolicyErrors.RemoteCertificateChainErrors)
            {
                return true;
            }
            else if ((sslPolicyErrors & System.Net.Security.SslPolicyErrors.RemoteCertificateNameMismatch)
                            == System.Net.Security.SslPolicyErrors.RemoteCertificateNameMismatch)
            {
                Zone z;
                z = Zone.CreateFromUrl(((HttpWebRequest)sender).RequestUri.ToString());
                if (z.SecurityZone == System.Security.SecurityZone.Intranet
                  || z.SecurityZone == System.Security.SecurityZone.MyComputer)
                {
                    return true;
                }
                return false;
            }
            return true;
        }
        /// <summary>
        /// ////////////////////////////////////////////
        /// </summary>
        /// <param name="bLogESPostXML"></param>
        /// <returns></returns>
        private string MakeSOAPCall(bool bLogESPostXML)
        {





            string sRTN = string.Empty;


            int m_timeOut = 60;
            //////////////////////////////////////////////////////////////////////////////
            // Make sure we have some data to send.
            if (m_post_data.Length == 0)
            {
                sRTN = "ERR: POST data was empty.";
                return sRTN;
            }
            if (bLogESPostXML)
            {
                string cDri = Environment.CommandLine;
                cDri = cDri.Replace("AETService.exe", "");
                cDri = cDri.Replace("\"", "");
                string ESPostFile = String.Format("{0}{1}_ESRequest.xml", cDri, m_logid);
                using (System.IO.StreamWriter writer = new System.IO.StreamWriter(ESPostFile, false))
                {
                    writer.Write(m_post_data);
                    writer.Close();
                }
            }
            //////////////////////////////////////////////////////////////////////////////
            // Install out SSL CertValidation call back function
            ServicePointManager.ServerCertificateValidationCallback = MyCertValidationCb;
            byte[] postBytes = Encoding.ASCII.GetBytes(m_post_data);    // turn our request string into a byte stream
            //////////////////////////////////////////////////////////////////////////////
            // Create out http(s) request & load the URL
            HttpWebRequest request = (HttpWebRequest)
            WebRequest.Create(m_url);

            // The certificate was loaded so populate (ONLY THE ONES NEEDED) the rest of the Http(s) request values.
            request.Method = "POST";
            request.KeepAlive = true;
            request.ProtocolVersion = HttpVersion.Version10;

            request.ContentType = "text/xml; charset=utf-8";
            request.ContentLength = postBytes.Length; // this is important - make sure you specify type this way

            request.Timeout = 1000 * m_timeOut;
            request.AllowAutoRedirect = true; 

            ServicePointManager.Expect100Continue = true;
            ServicePointManager.SecurityProtocol = SecurityProtocolType.Ssl3 | SecurityProtocolType.Tls | SecurityProtocolType.Tls11 | SecurityProtocolType.Tls12;

            // Keith Baldwin 5/18/2016 - MVI call was blowing up so I logged a lot of information
            //Logging.WriteLogFile("");
            //Logging.WriteLogFile("ES m_url: " + m_url);
            ////Logging.WriteLogFile("ES m_sCertName: " + m_sCertName);
            ////Logging.WriteLogFile("ES m_mvipayload: " + m_mvipayload);
            ////Logging.WriteLogFile("ES bLogMVIPostXML: " + bLogMVIPostXML);
            //Logging.WriteLogFile("ES Request.Uri: " + request.RequestUri.ToString());
            //Logging.WriteLogFile("ES Request.Method: " + request.Method);
            //Logging.WriteLogFile("ES Request.ContentType: " + request.ContentType);
            //Logging.WriteLogFile("ES Request.ContentLength: " + request.ContentLength);
            ////Logging.WriteLogFile("Request.Method: " + request.Method);
            //ServicePointManager.SecurityProtocol = SecurityProtocolType.Ssl3 | SecurityProtocolType.Tls | SecurityProtocolType.Tls11 | SecurityProtocolType.Tls12;
            //if ((ServicePointManager.SecurityProtocol & SecurityProtocolType.Ssl3) == SecurityProtocolType.Ssl3)
                //Logging.WriteLogFile("ES: SSL 3 is available for security protocol");
            //if ((ServicePointManager.SecurityProtocol & SecurityProtocolType.Tls) == SecurityProtocolType.Tls)
                //Logging.WriteLogFile("ES: TLS 1.0 is available for security protocol");
            //if ((ServicePointManager.SecurityProtocol & SecurityProtocolType.Tls11) == SecurityProtocolType.Tls11)
                //Logging.WriteLogFile("ES: TLS 1.1 is available for security protocol");
            //if ((ServicePointManager.SecurityProtocol & SecurityProtocolType.Tls12) == SecurityProtocolType.Tls12)
                //Logging.WriteLogFile("ES: TLS 1.2 is available for security protocol");
            ////Logging.WriteLogFile("ES m_post_data: " + m_post_data);
            //Logging.WriteLogFile("");

            Stream requestStream = request.GetRequestStream();   // Creat a Request Stream.
            requestStream.Write(postBytes, 0, postBytes.Length); // Now send it.
            requestStream.Close();

            string sc = string.Empty;
            string xmlData = string.Empty;


            try
            {

                // Grab te response and print it out to the console along with the status code
                HttpWebResponse response = (HttpWebResponse)request.GetResponse();
                sc = response.StatusCode.ToString();
                using (StreamReader sr = new StreamReader(response.GetResponseStream()))
                {
                    xmlData = sr.ReadToEnd();
                }

                if (bLogESPostXML)
                {
                    string cDri = Environment.CommandLine;
                    cDri = cDri.Replace("AETService.exe", "");
                    cDri = cDri.Replace("\"", "");
                    string ESPostFile = String.Format("{0}{1}_ESResponse.xml", cDri, m_logid);
                    using (System.IO.StreamWriter writer = new System.IO.StreamWriter(ESPostFile, false))
                    {
                        writer.Write(xmlData);
                        writer.Close();
                    }
                }
                try
                {


                    ///////////////////////////////////////////////////////////////////////////////////////////////////////////
                    // Variable’s needed to extract and determine the proper demographics information.
                    string addressTypeCode = string.Empty;
                    string addressChangeEffectiveDate = string.Empty;
                    string addressChangeDateTime = string.Empty;
                    string endDate = string.Empty;

                    string Tline1 = string.Empty;
                    string Tcity = string.Empty;
                    string Tstate = string.Empty;
                    string TzipCode = string.Empty;
                    string TzipPlus4 = string.Empty;
                    string TbadAddressReason = string.Empty;

                    string Pline1 = string.Empty;
                    string Pcity = string.Empty;
                    string Pstate = string.Empty;
                    string PzipCode = string.Empty;
                    string PzipPlus4 = string.Empty;
                    string PbadAddressReason = string.Empty;
                    bool bHasTemp = false;
                    bool bHasEndDate = false;

                    DateTime TdateTime = DateTime.Now;
                    DateTime PdateTime = DateTime.Now;

                    m_espayload = xmlData;

                    XmlDocument xd = new XmlDocument();
                    xd.LoadXml(xmlData);
                    // Apply necessary XML namespace
                    XmlNamespaceManager nsMan = new XmlNamespaceManager(xd.NameTable);
                    nsMan.AddNamespace("ee", "http://DNS.URL       /schemas");


                    //ZEB VA118-11-D-1009 9/9/13 (+9) Detect condition where ES returns empty response and return appropriate error
                    XmlNodeList summary = xd.GetElementsByTagName("summary");
                    if (summary.Count == 0)
                    {
                        return "NF";
                    }
                    if (!summary[0].HasChildNodes)
                    {
                        return "NF";
                    }

                    ///////////////////////////////////////////////////////////////////////////////////////////////////////////
                    // Setup to extract the demographics information from the ES payload.
                    XmlElement demographics = (XmlElement)xd.GetElementsByTagName("demographics")[0];
                    XmlElement contactInfo = (XmlElement)demographics.GetElementsByTagName("contactInfo")[0];
                    XmlElement addresses = (XmlElement)contactInfo.GetElementsByTagName("addresses")[0];
                    XmlNodeList idNodes = addresses.GetElementsByTagName("address");
                    foreach (XmlNode idNode in idNodes)
                    {

                        // Extratc the Temporary and Permanent address information.
                        try { addressTypeCode = idNode["addressTypeCode"].InnerText; }
                        catch { }

                        // Extract the Temporary address information..
                        if (addressTypeCode == "Temporary")
                        {
                            try
                            {
                                endDate = idNode["endDate"].InnerText;
                                string[] md = endDate.Split('T');
                                if (md.Any())
                                    endDate = md[0];
                                endDate = endDate.Replace("-", "");
                                if (endDate.Length == 8)
                                {
                                    int y = int.Parse(endDate.Substring(0, 4));
                                    int m = int.Parse(endDate.Substring(4, 2));
                                    int d = int.Parse(endDate.Substring(6, 2));
                                    TdateTime = new DateTime(y, m, d);
                                    bHasEndDate = true;
                                }

                            }
                            catch { bHasEndDate = false; }

                            try { TbadAddressReason = idNode["badAddressReason"].InnerText; }
                            catch { }
                            if (TbadAddressReason.Length == 0)
                            {
                                try { TzipPlus4 = idNode["zipPlus4"].InnerText; }
                                catch { }
                                try { TzipCode = idNode["zipCode"].InnerText; }
                                catch { }
                                try { Tstate = idNode["state"].InnerText; }
                                catch { }
                                try { Tcity = idNode["city"].InnerText; }
                                catch { }
                                try { Tline1 = idNode["line1"].InnerText; }
                                catch { }
                            }

                            bHasTemp = true;
                        }
                        // Extract the Permanent address information..
                        else if (addressTypeCode == "Permanent")
                        {


                            try { PbadAddressReason = idNode["badAddressReason"].InnerText; }
                            catch { }
                            if (PbadAddressReason.Length == 0)
                            {
                                try { PzipPlus4 = idNode["zipPlus4"].InnerText; }
                                catch { }
                                try { PzipCode = idNode["zipCode"].InnerText; }
                                catch { }
                                try { Pstate = idNode["state"].InnerText; }
                                catch { }
                                try { Pcity = idNode["city"].InnerText; }
                                catch { }
                                try { Pline1 = idNode["line1"].InnerText; }
                                catch { }
                            }
                        }
                    }

                    if (bHasTemp)
                    {
                        if (bHasEndDate)
                        {

                            if (DateTime.Compare(TdateTime, PdateTime) >= 0)
                            {
                                if (Tline1.Length > 0)
                                {

                                    Pline1 = Tline1;
                                    Pcity = Tcity;
                                    Pstate = Tstate;
                                    PzipCode = TzipCode;

                                }
                            }
                        }
                        else
                        {
                            if (Tline1.Length > 0)
                            {

                                Pline1 = Tline1;
                                Pcity = Tcity;
                                Pstate = Tstate;
                                PzipCode = TzipCode;

                            }

                        }

                    }

                    m_line1 = Pline1;
                    m_city = Pcity;
                    m_state = Pstate;
                    m_zipcode = PzipCode;


                    string status;
                    string statusDateString;

                    // Get eligibilityStatus
                    try { status = xd.SelectSingleNode("//ee:eligibilityStatus", nsMan).InnerText; }
                    catch { }

                    // Get eligibilityStatusDate
                    try { statusDateString = xd.SelectSingleNode("//ee:eligibilityStatusDate", nsMan).InnerText; }
                    catch { }
                    // Get enrollmentDate
                    try { m_Edate = xd.SelectSingleNode("//ee:enrollmentDate", nsMan).InnerText; }
                    catch { }
                    // Get enrollmentStatus
                    try { m_Estatus = xd.SelectSingleNode("//ee:enrollmentStatus", nsMan).InnerText; }
                    catch { }


                    sRTN = "OK!";
                }
                catch (Exception ex)
                {
                    // Write any exceptions to a log file.

                    string errMsg = String.Format("[{0}]-ES-1 Exception: {1}", m_logid, ex.Message);
                    //System.Diagnostics.EventLog.WriteEntry("AETService", errMsg, System.Diagnostics.EventLogEntryType.Error, 200, 500);
                    sRTN = "NX";


                }

            }
            catch (System.Net.WebException ex)
            {
                // Write any exceptions to a log file.

                m_espayload = ex.Message;
                string errMsg = String.Format("[{0}]-ES-2 Exception: {1}", m_logid, ex.Message);
                //System.Diagnostics.EventLog.WriteEntry("AETService", errMsg, System.Diagnostics.EventLogEntryType.Error, 201, 500);

                string cDri = Environment.CommandLine;
                cDri = cDri.Replace("AETService.exe", "");
                cDri = cDri.Replace("\"", "");
                string ESPostFile = String.Format("{0}{1}_ESResponce.xml", cDri, m_logid);


                HttpWebResponse response1 = (HttpWebResponse)ex.Response;
                using (StreamReader sr1 = new StreamReader(response1.GetResponseStream()))
                {
                    xmlData = sr1.ReadToEnd();
                }
                if (response1.StatusCode == HttpStatusCode.InternalServerError)
                {
                    errMsg = String.Format("[{0}]-ES-3 Exception-Data: {1}", m_logid, xmlData);
                    //System.Diagnostics.EventLog.WriteEntry("AETService", errMsg, System.Diagnostics.EventLogEntryType.Error, 201, 500);
                    using (System.IO.StreamWriter writer = new System.IO.StreamWriter(ESPostFile, false))
                    {
                        writer.Write(xmlData);
                        writer.Close();

                    }

                    if (xmlData.Contains("No Record Found: ICN/VPID Does Not Exist:"))
                    {
                        sRTN = "NF";
                    }
                    else
                    {

                        sRTN = "NX";
                    }
                }
                else
                {

                    using (System.IO.StreamWriter writer = new System.IO.StreamWriter(ESPostFile, false))
                    {
                        sRTN = "ERR:" + ex.Message;
                        writer.Write(ex.Message);
                        writer.Close();
                    }

                }











                //string LogFile = @"C:\ES_Exception.txt";
                //using (System.IO.StreamWriter writer = new System.IO.StreamWriter(LogFile, false))
                //{
                //sRTN = "ERR:" + ex.Message.ToString();
                //writer.Write(ex.Message.ToString());
                //writer.Close();
                //}


            }

            return sRTN;
        }

    }
}
