﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration.Install;
using System.Linq;
using System.Diagnostics;
using Microsoft.Win32;

namespace AETService
{
    [RunInstaller(true)]
    public partial class ProjectInstaller : Installer
    {
        public ProjectInstaller()
        {
            InitializeComponent();
        }
		
		//ZEB VA118-11-D-1009 3/26/13 (+method) rewrote so MSI installer was actually viable
        public override void Install(IDictionary stateServer)
        {
            //Microsoft.Win32.RegistryKey system,
                //currentControlSet,  //HKEY_LOCAL_MACHINE\System\CurrentControlSet
                //services,           //...\Services
                //service,            //...\<Service Name>
                //config;             //...\Parameters - this is where you can put service-specific configuration

            try
            {
                RegistryKey CCS;
                RegistryKey services;
                RegistryKey aet;
                RegistryKey parameters;

                base.Install(stateServer);

                //write new values to registry
                //add any values that don't exist, including STC* values

                CCS = Registry.LocalMachine.OpenSubKey(@"System\CurrentControlSet\", true);

                services = CCS.OpenSubKey("services", true);
                if (services == null)
                {
                    CCS.CreateSubKey("services");
                    services = CCS.OpenSubKey("services", true);
                }

                aet = services.OpenSubKey("AETService", true);
                if (aet == null)
                {
                    services.CreateSubKey("AETService");
                    aet = services.OpenSubKey("AETService", true);
                }

                parameters = aet.OpenSubKey("Parameters", true);
                if (parameters == null)
                {
                    aet.CreateSubKey("Parameters");
                    parameters = aet.OpenSubKey("Parameters", true);
                }

                List<string> paramVals = parameters.GetValueNames().ToList();

                parameters.SetValue("AETPort", Context.Parameters["EDITA1"].ToString(), RegistryValueKind.String);
                parameters.SetValue("CtlPort", Context.Parameters["EDITA2"].ToString(), RegistryValueKind.String);
                parameters.SetValue("MVIURL", Context.Parameters["EDITA3"].ToString(), RegistryValueKind.String);
                parameters.SetValue("MVIPKI", Context.Parameters["EDITA4"].ToString(), RegistryValueKind.String);

                parameters.SetValue("ESURL", Context.Parameters["EDITB1"].ToString(), RegistryValueKind.String);
                parameters.SetValue("ESUN", Context.Parameters["EDITB2"].ToString(), RegistryValueKind.String);
                parameters.SetValue("ESPW", Context.Parameters["EDITB3"].ToString(), RegistryValueKind.String);

                parameters.SetValue("SSLName", Context.Parameters["EDITC1"].ToString(), RegistryValueKind.String);
                parameters.SetValue("IPWL", Context.Parameters["EDITC2"].ToString(), RegistryValueKind.String);

                //create registry values if they don't already exist
                if (!paramVals.Contains("ANSIDatabase"))
                {
                    parameters.SetValue("ANSIDatabase", "", RegistryValueKind.String);
                }

                if (!paramVals.Contains("ANSIPassword"))
                {
                    parameters.SetValue("ANSIPassword", "", RegistryValueKind.String);
                }

                if (!paramVals.Contains("ANSIServer"))
                {
                    parameters.SetValue("ANSIServer", "", RegistryValueKind.String);
                }

                if (!paramVals.Contains("ANSIUser"))
                {
                    parameters.SetValue("ANSIUser", "", RegistryValueKind.String);
                }

                if (!paramVals.Contains("ImportUpdate"))
                {
                    parameters.SetValue("ImportUpdate", "", RegistryValueKind.String);
                }

                if (!paramVals.Contains("LEIEDatabase"))
                {
                    parameters.SetValue("LEIEDatabase", "", RegistryValueKind.String);
                }

                if (!paramVals.Contains("LEIEImportFolder"))
                {
                    parameters.SetValue("LEIEImportFolder", "", RegistryValueKind.String);
                }

				if (!paramVals.Contains("NPIImportFolder"))
				{
					parameters.SetValue("NPIImportFolder", "", RegistryValueKind.String);
				}

					if (!paramVals.Contains("LEIEPassword"))
                {
                    parameters.SetValue("LEIEPassword", "", RegistryValueKind.String);
                }

                if (!paramVals.Contains("LEIEServer"))
                {
                    parameters.SetValue("LEIEServer", "", RegistryValueKind.String);
                }

                if (!paramVals.Contains("LEIEUser"))
                {
                    parameters.SetValue("LEIEUser", "", RegistryValueKind.String);
                }

                if (!paramVals.Contains("LogDatabase"))
                {
                    parameters.SetValue("LogDatabase", "", RegistryValueKind.String);
                }

                if (!paramVals.Contains("LogPassword"))
                {
                    parameters.SetValue("LogPassword", "", RegistryValueKind.String);
                }

                if (!paramVals.Contains("LogServer"))
                {
                    parameters.SetValue("LogServer", "", RegistryValueKind.String);
                }

                if (!paramVals.Contains("LogUser"))
                {
                    parameters.SetValue("LogUser", "", RegistryValueKind.String);
                }

                if (!paramVals.Contains("MVIPKIVC"))
                {
                    parameters.SetValue("MVIPKIVC", "", RegistryValueKind.String);
                }

                if (!paramVals.Contains("SSLNameVC"))
                {
                    parameters.SetValue("SSLNameVC", "", RegistryValueKind.String);
                }

                if (!paramVals.Contains("STCDatabase"))
                {
                    parameters.SetValue("STCDatabase", "", RegistryValueKind.String);
                }

                if (!paramVals.Contains("STCPassword"))
                {
                    parameters.SetValue("STCPassword", "", RegistryValueKind.String);
                }

                if (!paramVals.Contains("STCServer"))
                {
                    parameters.SetValue("STCServer", "", RegistryValueKind.String);
                }

                if (!paramVals.Contains("STCUser"))
                {
                    parameters.SetValue("STCUser", "", RegistryValueKind.String);
                }

                if (!paramVals.Contains("ZipDatabase"))
                {
                    parameters.SetValue("ZipDatabase", "", RegistryValueKind.String);
                }

                if (!paramVals.Contains("ZipImportFolder"))
                {
                    parameters.SetValue("ZipImportFolder", "", RegistryValueKind.String);
                }

                if (!paramVals.Contains("ZipPassword"))
                {
                    parameters.SetValue("ZipPassword", "", RegistryValueKind.String);
                }

                if (!paramVals.Contains("ZipServer"))
                {
                    parameters.SetValue("ZipServer", "", RegistryValueKind.String);
                }

                if (!paramVals.Contains("ZipUser"))
                {
                    parameters.SetValue("ZipUser", "", RegistryValueKind.String);
                }

                parameters.Close();
                aet.Close();
                services.Close();
                CCS.Close();
            }
            catch (Exception ex)
            {
                EventLog.WriteEntry("AETService Installer", "Exception encountered during installation:\r\n" + ex.ToString(), EventLogEntryType.Error);
            }
        }

        public override void Uninstall(IDictionary stateServer)
        {
            EventLog.WriteEntry("AETService Installer","Starting uninstall in ProjectInstaller.cs");
                        RegistryKey system,
                        currentControlSet,  //HKEY_LOCAL_MACHINE\Services\CurrentControlSet
                        services,           //...\Services
                        service;            //...\<Service Name>

                try
                {
                    system = Registry.LocalMachine.OpenSubKey("System");    //Drill down to the service key and open it with write permission
                    currentControlSet = system.OpenSubKey("CurrentControlSet");
                    services = currentControlSet.OpenSubKey("Services");
                    try
                    {
                        service = services.OpenSubKey(AETServiceInstaller.ServiceName, true);
                        service.DeleteSubKeyTree("Parameters");                                 //Delete the Parameters created during installation.
                    }
                    catch
                    {
                        //silently deal if the keys have already been deleted
                    }
                }
                catch (Exception ex)
                {
                    EventLog.WriteEntry("AETService Installer", "Exception encountered while uninstalling service:\r\n" + ex.ToString(),EventLogEntryType.Error);
                }
                finally
                {
                    //Let the project installer do its job
                    EventLog.WriteEntry("AETService Installer", "Ending uninstall in ProjectInstaller.cs");
                    base.Uninstall(stateServer);
                }
        }

        public void AETServiceInstaller_AfterInstall(object sender, System.Configuration.Install.InstallEventArgs e)
        {
        }
        /// <summary>
        /// Delete XML file created during install so as not to leave the install folder on the drive.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void AETServiceInstaller_BeforeUninstall(object sender, System.Configuration.Install.InstallEventArgs e)
        {
        }
    }
}
