' VBScript source code

'----------------------------------------------------------------------
' Define the global Variables
Dim objDocument
'----------------------------------------------------------------------
' Create a Instance of Internet Explorer
Set objExplorer = CreateObject("InternetExplorer.Application")
'----------------------------------------------------------------------
' Setup the look and feel of Explorer
objExplorer.Navigate "about:blank"  
objExplorer.ToolBar = 0
objExplorer.StatusBar = 0
objExplorer.Width = 1024
objExplorer.Height = 900
objExplorer.Left = 100
objExplorer.Top = 10
objExplorer.Visible = 1            
'----------------------------------------------------------------------
' Wait for Explorer to become active.
Do While (objExplorer.Busy)
Loop  
'----------------------------------------------------------------------
'Create and Open a new HTML document .
Set objDocument = objExplorer.Document    
objDocument.Open                

BeginHTMLDocument ("AET Windows Application Event Log")				' Create the document header and title tags.
    BuildApplicationEventsLogHeader
    ViewApplicationEventsLog

EndHTMLDocument						' Create the document trailer tags.
'objExplorer.Visible = 1   
'/////////////////////////////////END OF MAIN CODE////////////////////////////////////////////////

Sub BuildApplicationEventsLogHeader

Dim MessageData
strComputer = "."
Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\" _
    & strComputer & "\root\cimv2")
Set colLoggedEvents = objWMIService.ExecQuery _
    ("Select * from Win32_NTLogEvent " _
        & "Where Logfile = 'Application'")
For Each objEvent in colLoggedEvents
    
if objEvent.SourceName = "AETService" Then
	MessageData= "Computer Name: " & objEvent.ComputerName & + "<br>" _
	& "Source Name: " & objEvent.SourceName & + "<br>"

    objDocument.Writeln "<font color=#0000ff>" & + MessageData + "</font><br>"
	
	
	'objDocument.Writeln "<font color=#0000ff>" & + "BLUE" + "</font><br>"
		
	'objDocument.Writeln "<font color=#7E3517>" & + "BROWN" + "</font><br>"
	
	'objDocument.Writeln  "<font color=#FFA500>" & + "GOLD" + "</font><br>"
	
	'objDocument.Writeln  "<font color=#4E9258>" & + "GREEN" + "</font><br>"
	
	'objDocument.Writeln  "<font color=#FF0000>" & + "RED" + "</font><br>"
	





	Exit Sub


end if

next
End Sub
'-------------------------------------------------------------------------------------------------------------------------------------------------------
' ViewApplicationEventsLog

Sub ViewApplicationEventsLog

Dim MessageData


strComputer = "."
Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\" _
    & strComputer & "\root\cimv2")
Set colLoggedEvents = objWMIService.ExecQuery _
    ("Select * from Win32_NTLogEvent " _
        & "Where Logfile = 'Application'")
For Each objEvent in colLoggedEvents
    
if objEvent.SourceName = "AETService" Then
 


	MessageData = "<font color=#7E3517>Event Type: </font>" & objEvent.Type &  "<br>" & vbCRLF  _
	& "<font color=#7E3517>Message: </font>" & objEvent.Message & "<br>" & vbCRLF _
    & "<font color=#7E3517>Time Written: </font>" & objEvent.TimeWritten & + "<br>" & vbCRLF _
    & "<font color=#7E3517>Record Number: </font>" & objEvent.RecordNumber & + "<br>" & vbCRLF
    	
    if Left(objEvent.Message,52) = "A client is attempted to connect to the AET service." then
        objDocument.Writeln  "------------------------- <font color=#0000ff>Beginning a New 270 Eligibility Request</font> -------------------------------<br>"
    else 
        objDocument.Writeln  "-------------------------------------------------------------------------------------------------<br>"
    end if  	
    	
      if objEvent.Type = "information" then objDocument.Writeln "<font color=#4E9258>" &  MessageData & "</font><br>"
      if objEvent.Type = "warning" then objDocument.Writeln "<font color=#FFA500>" & + MessageData + "</font><br>"
      if objEvent.Type = "error" then objDocument.Writeln "<font color=#FF0000>" & + MessageData + "</font><br>"
      
      
	

end if

Next 

	

End Sub
'-------------------------------------------------------------------------------------------------------------------------------------------------------


'-------------------------------------------------------------------------------------------------------------------------------------------------------
' Output segments to HTML page
Function  OutPutSegments( objSegmentsCollection )
Dim objTimer, objSegment
Dim lLineCnt, lLPM






MessageData= "Category: " & objEvent.Category & + "<br>" _
    	& "Computer Name: " & objEvent.ComputerName & + "<br>" _
    	& "Event Code: " & objEvent.EventCode & + "<br>" _
    	& "Message: " & objEvent.Message & + "<br>" _
    	& "Record Number: " & objEvent.RecordNumber & + "<br>" _
    	& "Source Name: " & objEvent.SourceName & + "<br>" _
    	& "Time Written: " & objEvent.TimeWritten & + "<br>" _
    	& "Event Type: " & objEvent.Type & + "<br>" _
    	& "User: " & objEvent.User & + "<br>"
	objDocument.Writeln MessageData + "<br>"

	
	lLineCnt=0				' Set the Line Count to 0.
	lLPM=0					' Set the Lines/per/min to 0
	
	objDocument.Writeln "<hr id='hrSECTION'>"	
	

	objDocument.Writeln "--- OutPutSegments ---<br>"	' Write our banner.
	objDocument.Writeln " Count: " & CStr(objSegmentsCollection.Count) + "<br>"	' OutPut the collection count.
	If objSegmentsCollection.Count > 0 Then ' Make sure we have at least one item in the segments collection
		
		Set objTimer = CreateObject("CWCSCORE.HiResTimer.1")	' Create a timer
		objTimer.Start 1										' Start the timer,

		For Each objSegment In objSegmentsCollection		' Loop through segment collection
		
			DisplayKey=objSegment.Key
			SegmentData=objSegment.Value
			
			objDocument.Writeln "[" + DisplayKey + "] [" + SegmentData + "]<br>"			' No Output normal.
			lLineCnt=lLineCnt+1	' Update the line count.
		
		Next	' Segments in the Segments collection Loop.
		
		objTimer.Stop 1	' Stop the timer.
		
		lLPM=lLineCnt/objTimer(1)
		'Cal the lines per min we processed. 
		OutPutSegments=  "Listed " + CStr(lLineCnt) + " Items in " + FormatNumber(objTimer(1),6) + " seconds. (" + FormatNumber(lLPM,2) + ") per second."
	
	Else
			OutPutSegments=""
			
	End If		
		
	
		
End Function
'/////////////////////////////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////////////////////////////////////

'----------------------------------------------
' Create the HTML document Tags (Header)
Sub BeginHTMLDocument( t )
	objDocument.Writeln "<html>"
	objDocument.Writeln "<head>"

	objDocument.Writeln "<title>" + CStr(t) + "</title>"

	objDocument.Writeln "</head>"

	objDocument.Writeln "<body>"
	
	objDocument.Writeln "<table width='100%' border='0'>"
	objDocument.Writeln "<tr valign='bottom'>" & vbCRLF & "<td align='center'>"
	objDocument.Writeln "<input type='button' ID='closeButton' onclick='self.close()' value='Close Window' name='closeButton' >" 
	objDocument.Writeln "</td>" & vbCRLF & "</tr>"
	objDocument.Writeln "</table>"			
	
	objDocument.Writeln "<hr id='hrFIRST'>"	
	

End Sub
' ----------------------------------------------
' Create the HTML document Tags (Trailer)
Sub EndHTMLDocument()
	' ----------------------------------------------
	'        Create the documents closing HTML tags	
	
	objDocument.Writeln "<hr id='hrLAST'>"		
	objDocument.Writeln "<table width='100%' border='0'>"
	objDocument.Writeln "<tr valign='bottom'>" & vbCRLF & "<td align='center'>"
	objDocument.Writeln "<input type='button' ID='closeButton' onclick='self.close()' value='Close Window' name='closeButton' >" 
	objDocument.Writeln "</td>" & vbCRLF & "</tr>"
	objDocument.Writeln "</table>"			
	
	objDocument.Writeln "</body>"
	objDocument.Writeln "</html>"
	objDocument.Write()
	objDocument.Close 
End Sub