﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using X12Engine.BO.X12._278;
using X12Engine.BO.X12._278.XModel;

namespace X12Engine.BLL.X12._278.XParse
{
   public static class DependentDetailManager
   {
      public static DependentDetail Parse(ref Settings settings, string loopCode, string loop)
      {
			DependentDetail objReturn = new DependentDetail(settings);
			List<AAA> requestValidation = new List<AAA>();
			string[] segments = loop.Split(settings.Segment_Terminator);
         if (segments != null)
         {
            foreach (string segment in segments)
            {
               if (string.IsNullOrEmpty(segment)) continue;

               string[] elements = segment.Split(settings.Data_Element_Separator);
               if (elements != null && !string.IsNullOrEmpty(elements[0]))
               {
                  string segmentId = elements[0].ToUpper();

                  if (segmentId == "HL")
                     objReturn.DependentLevel = HLManager.Parse(ref settings, loopCode, segment, ref requestValidation);
						else if (segmentId == "TRN")
						{
							if (objReturn.DependentTraceNumber == null) objReturn.DependentTraceNumber = new List<TRN>();
							objReturn.DependentTraceNumber.Add(TRNManager.Parse(ref settings, loopCode, segment, ref requestValidation));
						}
						else if (Utils.IsEntitySegment(segmentId))
                     objReturn.DependentName = EntityBaseManager.Parse(ref settings, loopCode, 1, segment, objReturn.DependentName);
                  else
                     objReturn.Other = DetailBaseManager.Parse(ref settings, loopCode, 1, segment, objReturn.Other);
               }
					
				}

				objReturn.RequestValidation = requestValidation;
			}

         return objReturn;
      }
   }
}
