﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using X12Engine.BO.X12._278;
using X12Engine.BO.X12._278.XModel;

namespace X12Engine.BLL.X12._278.XParse
{
   public static class UmoDetailManager
   {
      public static UmoDetail Parse(ref Settings settings, string loopCode, string loop)
		{
         UmoDetail objReturn = new UmoDetail(settings);
			List<AAA> requestValidation = new List<AAA>();

			string[] segments = loop.Split(settings.Segment_Terminator);
         if (segments != null)
         {
				int i = 0;
            foreach (string segment in segments)
            {
               if (string.IsNullOrEmpty(segment)) continue;

               string[] elements = segment.Split(settings.Data_Element_Separator);
               if (elements != null && !string.IsNullOrEmpty(elements[0]))
               {
                  string segmentId = elements[0].ToUpper();

						if (segmentId == "HL")
						{
							objReturn.UMOLevel = HLManager.Parse(ref settings, loopCode, segment, ref requestValidation);

							if (objReturn.UMOLevel != null && !string.IsNullOrEmpty(objReturn.UMOLevel.HierarchicalParentIdNumber))
							{
								i++;
								requestValidation.Add(AAAManager.GetAAA(ref settings, "2010A", i, "N", "42", "C", "CommonManager.HLManager - Hierarchy Parent ID is not used"));
							}
						} 
						else if (Utils.IsEntitySegment(segmentId))
						{
							objReturn.UMOName = EntityBaseManager.Parse(ref settings, loopCode, 1, segment, objReturn.UMOName);
						}
						else
							objReturn.Other = DetailBaseManager.Parse(ref settings, loopCode, 1, segment, objReturn.Other);
               }
            }

				objReturn.RequestValidation = requestValidation;
         }

         return objReturn;
      }
   }
}
