﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace X12Engine.BO.X12._278
{
   [Serializable()]
   public class ISA
   {
      private IDENTIFIER _authorizationInformationQualifier;
      private string _authorizationInformation;
      private IDENTIFIER _securityInformationQualifier;
      private string _securityInformation;
      private IDENTIFIER _interchangeSenderIdQualifier;
      private string _interchangeSenderId;
      private IDENTIFIER _interchangeReceiverIdQualifier;
      private string _interchangeReceiverId;
      private DateTime? _interchangeDate;
      private string _interchangeDateString;
      private DateTime? _interchangeTime;
      private string _interchangeTimeString;
      private string _repetitionSeperator;
      private IDENTIFIER _interchangeControlVersionNumber;
      private int? _interchangeControlNumber;
      private IDENTIFIER _acknowledgmentRequested;
      private IDENTIFIER _interchangeUsageIndicator;
      private string _componentElementSeparator;

		private Settings settings;

		public ISA(Settings s)
		{
			settings = s;
		}

		public IDENTIFIER AuthorizationInformationQualifier
      {
         get { return _authorizationInformationQualifier; }
         set { _authorizationInformationQualifier = value; }
      }

      public string AuthorizationInformation
      {
         get { return _authorizationInformation; }
         set { _authorizationInformation = value; }
      }

      public IDENTIFIER SecurityInformationQualifier
      {
         get { return _securityInformationQualifier; }
         set { _securityInformationQualifier = value; }
      }

      public string SecurityInformation
      {
         get { return _securityInformation; }
         set { _securityInformation = value; }
      }

      public IDENTIFIER InterchangeSenderIdQualifier
      {
         get { return _interchangeSenderIdQualifier; }
         set { _interchangeSenderIdQualifier = value; }
      }

      public string InterchangeSenderId
      {
         get { return _interchangeSenderId; }
         set { _interchangeSenderId = value; }
      }

      public IDENTIFIER InterchangeReceiverIdQualifier
      {
         get { return _interchangeReceiverIdQualifier; }
         set { _interchangeReceiverIdQualifier = value; }
      }

      public string InterchangeReceiverId
      {
         get { return _interchangeReceiverId; }
         set { _interchangeReceiverId = value; }
      }

      public DateTime? InterchangeDate
      {
         get { return _interchangeDate; }
         set { _interchangeDate = value; }
      }

      public string InterchangeDateString
      {
         get { return _interchangeDateString; }
         set { _interchangeDateString = value; }
      }

      public DateTime? InterchangeTime
      {
         get { return _interchangeTime; }
         set { _interchangeTime = value; }
      }

      public string InterchangeTimeString
      {
         get { return _interchangeTimeString; }
         set { _interchangeTimeString = value; }
      }

      public string RepetitionSeperator
      {
         get { return _repetitionSeperator; }
         set { _repetitionSeperator = value; }
      }

      public IDENTIFIER InterchangeControlVersionNumber
      {
         get { return _interchangeControlVersionNumber; }
         set { _interchangeControlVersionNumber = value; }
      }

      public int? InterchangeControlNumber
      {
         get { return _interchangeControlNumber; }
         set { _interchangeControlNumber = value; }
      }

      public IDENTIFIER AcknowledgmentRequested
      {
         get { return _acknowledgmentRequested; }
         set { _acknowledgmentRequested = value; }
      }

      public IDENTIFIER InterchangeUsageIndicator
      {
         get { return _interchangeUsageIndicator; }
         set { _interchangeUsageIndicator = value; }
      }

      public string ComponentElementSeparator
      {
         get { return _componentElementSeparator; }
         set { _componentElementSeparator = value; }
      }

      public override string ToString()
      {
         string strReturn = "ISA" + settings.Data_Element_Separator;

         if (_authorizationInformationQualifier != null)
               strReturn += _authorizationInformationQualifier.ToString() + settings.Data_Element_Separator;
         else
               strReturn += settings.Data_Element_Separator;

         strReturn += _authorizationInformation + settings.Data_Element_Separator;

         if (_securityInformationQualifier != null)
               strReturn += _securityInformationQualifier.ToString() + settings.Data_Element_Separator;
         else
               strReturn += settings.Data_Element_Separator;

         strReturn += _securityInformation + settings.Data_Element_Separator;

         if (_interchangeSenderIdQualifier != null)
               strReturn += _interchangeSenderIdQualifier.ToString() + settings.Data_Element_Separator;
         else
               strReturn += settings.Data_Element_Separator;

         strReturn += _interchangeSenderId + settings.Data_Element_Separator;

         if (_interchangeReceiverIdQualifier != null)
               strReturn += _interchangeReceiverIdQualifier.ToString() + settings.Data_Element_Separator;
         else
               strReturn += settings.Data_Element_Separator;

         strReturn += _interchangeReceiverId + settings.Data_Element_Separator;

         strReturn += _interchangeDateString + settings.Data_Element_Separator;

         strReturn += _interchangeTimeString + settings.Data_Element_Separator;

         strReturn += _repetitionSeperator + settings.Data_Element_Separator;

         if (_interchangeControlVersionNumber != null)
               strReturn += _interchangeControlVersionNumber.ToString() + settings.Data_Element_Separator;
         else
               strReturn += settings.Data_Element_Separator;

         if (_interchangeControlNumber != null)
               strReturn += _interchangeControlNumber.Value.ToString() + settings.Data_Element_Separator;
         else
               strReturn += settings.Data_Element_Separator;

         if (_acknowledgmentRequested != null)
               strReturn += _acknowledgmentRequested.ToString() + settings.Data_Element_Separator;
         else
               strReturn += settings.Data_Element_Separator;

         if (_interchangeUsageIndicator != null)
               strReturn += _interchangeUsageIndicator.ToString() + settings.Data_Element_Separator;
         else
               strReturn += settings.Data_Element_Separator;

         strReturn += _componentElementSeparator + settings.Data_Element_Separator;

         return Utils.TerminateSegment(settings, strReturn);
      }

   }

   [Serializable()]
   public class GS
   {

      private IDENTIFIER _functionalIdentifierCode;
      private string _applicationSendersCode;
      private string _applicationReceiversCode;
      private DateTime? _date;
      private string _dateString;
      private DateTime? _time;
      private string _timeString;
      private int? _groupControlNumber;
      private IDENTIFIER _responsibleAgencyCode;
      private string _versionReleaseIndustryIdentifierCode;

		private Settings settings;

		public GS(Settings s)
		{
			settings = s;
		}

		public IDENTIFIER FunctionalIdentifierCode
      {
         get { return _functionalIdentifierCode; }
         set { _functionalIdentifierCode = value; }
      }

      public string ApplicationSendersCode
      {
         get { return _applicationSendersCode; }
         set { _applicationSendersCode = value; }
      }

      public string ApplicationReceiversCode
      {
         get { return _applicationReceiversCode; }
         set { _applicationReceiversCode = value; }
      }

      public DateTime? Date
      {
         get { return _date; }
         set { _date = value; }
      }

      public string DateString
      {
         get { return _dateString; }
         set { _dateString = value; }
      }

      public DateTime? Time
      {
         get { return _time; }
         set { _time = value; }
      }

      public string TimeString
      {
         get { return _timeString; }
         set { _timeString = value; }
      }

      public int? GroupControlNumber
      {
         get { return _groupControlNumber; }
         set { _groupControlNumber = value; }
      }

      public IDENTIFIER ResponsibleAgencyCode
      {
         get { return _responsibleAgencyCode; }
         set { _responsibleAgencyCode = value; }
      }

      public string VersionReleaseIndustryIdentifierCode
      {
         get { return _versionReleaseIndustryIdentifierCode; }
         set { _versionReleaseIndustryIdentifierCode = value; }
      }

      public override string ToString()
      {
         string strReturn = "GS" + settings.Data_Element_Separator;

         if (_functionalIdentifierCode != null)
               strReturn += _functionalIdentifierCode.ToString() + settings.Data_Element_Separator;
         else
               strReturn += settings.Data_Element_Separator;

         strReturn += _applicationSendersCode + settings.Data_Element_Separator;

         strReturn += _applicationReceiversCode + settings.Data_Element_Separator;

         strReturn += _dateString + settings.Data_Element_Separator;

         strReturn += _timeString + settings.Data_Element_Separator;

         if (_groupControlNumber != null)
               strReturn += _groupControlNumber.Value.ToString() + settings.Data_Element_Separator;
         else
               strReturn += settings.Data_Element_Separator;

         if (_responsibleAgencyCode != null)
               strReturn += _responsibleAgencyCode.ToString() + settings.Data_Element_Separator;
         else
               strReturn += settings.Data_Element_Separator;

         strReturn += _versionReleaseIndustryIdentifierCode + settings.Data_Element_Separator;

         return Utils.TerminateSegment(settings, strReturn);
      }

   }

   [Serializable()]
   public class GE
   {
      private int? _numberOfTransactionSetsIncluded;
      private int? _groupControlNumber;

		private Settings settings;

		public GE(Settings s)
		{
			settings = s;
		}

		public int? NumberOfTransactionSetsIncluded
      {
         get { return _numberOfTransactionSetsIncluded; }
         set { _numberOfTransactionSetsIncluded = value; }
      }

      public int? GroupControlNumber
      {
         get { return _groupControlNumber; }
         set { _groupControlNumber = value; }
      }

      public override string ToString()
      {
         string strReturn = "GE" + settings.Data_Element_Separator;

         if (_numberOfTransactionSetsIncluded != null)
               strReturn += _numberOfTransactionSetsIncluded.Value.ToString() + settings.Data_Element_Separator;
         else
               strReturn += settings.Data_Element_Separator;

         if (_groupControlNumber != null)
               strReturn += _groupControlNumber.Value.ToString() + settings.Data_Element_Separator;
         else
               strReturn += settings.Data_Element_Separator;

         return Utils.TerminateSegment(settings, strReturn);
      }

   }

   [Serializable()]
   public class IEA
   {
      private int? _numberOfIncludedFunctionalGroups;
      private int? _interchangeControlNumber;

		private Settings settings;

		public IEA(Settings s)
		{
			settings = s;
		}

		public int? NumberOfIncludedFunctionalGroups
      {
         get { return _numberOfIncludedFunctionalGroups; }
         set { _numberOfIncludedFunctionalGroups = value; }
      }

      public int? InterchangeControlNumber
      {
         get { return _interchangeControlNumber; }
         set { _interchangeControlNumber = value; }
      }

      public override string ToString()
      {
         string strReturn = "IEA" + settings.Data_Element_Separator;

         if (_numberOfIncludedFunctionalGroups != null)
               strReturn += _numberOfIncludedFunctionalGroups.Value.ToString() + settings.Data_Element_Separator;
         else
               strReturn += settings.Data_Element_Separator;

         if (_interchangeControlNumber != null)
               strReturn += _interchangeControlNumber.Value.ToString() + settings.Data_Element_Separator;
         else
               strReturn += settings.Data_Element_Separator;

         return Utils.TerminateSegment(settings, strReturn);
      }

   }

   [Serializable()]
   public class ST
   {
      private IDENTIFIER _transactionSetIdentifierCode;
      private string _transactionSetControlNumber;
      private string _implementationConventionReference;

		private Settings settings;

		public ST(Settings s)
		{
			settings = s;
		}

		public IDENTIFIER TransactionSetIdentifierCode
      {
         get { return _transactionSetIdentifierCode; }
         set { _transactionSetIdentifierCode = value; }
      }

      public string TransactionSetControlNumber
      {
         get { return _transactionSetControlNumber; }
         set { _transactionSetControlNumber = value; }
      }

      public string ImplementationConventionReference
      {
         get { return _implementationConventionReference; }
         set { _implementationConventionReference = value; }
      }

      public override string ToString()
      {
         string strReturn = "ST" + settings.Data_Element_Separator;

         if (_transactionSetIdentifierCode != null)
               strReturn += _transactionSetIdentifierCode.ToString() + settings.Data_Element_Separator;
         else
               strReturn += settings.Data_Element_Separator;

         strReturn += _transactionSetControlNumber + settings.Data_Element_Separator;
         strReturn += _implementationConventionReference + settings.Data_Element_Separator;

         return Utils.TerminateSegment(settings, strReturn);
      }
   }

   [Serializable()]
   public class BHT
   {

      private IDENTIFIER _hierarchicalStructureCode;
      private IDENTIFIER _transactionSetPurposeCode;
      private string _referenceIdentification;
      private DateTime? _date;
      private string _dateString;
      private DateTime? _time;
      private string _timeString;
      private IDENTIFIER _transactionTypeCode;

		private Settings settings;

		public BHT(Settings s)
		{
			settings = s;
		}

		public IDENTIFIER HierarchicalStructureCode
      {
         get { return _hierarchicalStructureCode; }
         set { _hierarchicalStructureCode = value; }
      }

      public IDENTIFIER TransactionSetPurposeCode
      {
         get { return _transactionSetPurposeCode; }
         set { _transactionSetPurposeCode = value; }
      }

      public string ReferenceIdentification
      {
         get { return _referenceIdentification; }
         set { _referenceIdentification = value; }
      }

      public DateTime? Date
      {
         get { return _date; }
         set { _date = value; }
      }

      public string DateString
      {
         get { return _dateString; }
         set { _dateString = value; }
      }

      public DateTime? Time
      {
         get { return _time; }
         set { _time = value; }
      }

      public string TimeString
      {
         get { return _timeString; }
         set { _timeString = value; }
      }

      public IDENTIFIER TransactionTypeCode
      {
         get { return _transactionTypeCode; }
         set { _transactionTypeCode = value; }
      }

      public override string ToString()
      {
         string strReturn = "BHT" + settings.Data_Element_Separator;

         if (_hierarchicalStructureCode != null)
               strReturn += _hierarchicalStructureCode.ToString() + settings.Data_Element_Separator;
         else
               strReturn += settings.Data_Element_Separator;

         if (_transactionSetPurposeCode != null)
               strReturn += _transactionSetPurposeCode.ToString() + settings.Data_Element_Separator;
         else
               strReturn += settings.Data_Element_Separator;

         strReturn += _referenceIdentification + settings.Data_Element_Separator;
         strReturn += _dateString + settings.Data_Element_Separator;
         strReturn += _timeString + settings.Data_Element_Separator;

         if (_transactionTypeCode != null)
               strReturn += _transactionTypeCode.ToString() + settings.Data_Element_Separator;
         else
               strReturn += settings.Data_Element_Separator;

         return Utils.TerminateSegment(settings, strReturn);
      }

   }

   [Serializable()]
   public class SE
   {

      private int? _numberOfIncludedSegments;
      private string _transactionSetControlNumber;

		private Settings settings;

		public SE(Settings s)
		{
			settings = s;
		}

		public int? NumberOfIncludedSegments
      {
         get { return _numberOfIncludedSegments; }
         set { _numberOfIncludedSegments = value; }
      }

      public string TransactionSetControlNumber
      {
         get { return _transactionSetControlNumber; }
         set { _transactionSetControlNumber = value; }
      }

      public override string ToString()
      {
         string strReturn = "SE" + settings.Data_Element_Separator;

         if (_numberOfIncludedSegments != null)
               strReturn += _numberOfIncludedSegments.Value.ToString() + settings.Data_Element_Separator;
         else
               strReturn += settings.Data_Element_Separator;

         strReturn += _transactionSetControlNumber + settings.Data_Element_Separator;

         return Utils.TerminateSegment(settings, strReturn);
      }

   }
}
