﻿using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using X12Engine.BLL.X12._278;
using X12Engine.BO.X12._278.XModel;

namespace X12Engine.BO.X12._278
{


   [Serializable()]
   public class MessageBase
   {
		public bool TransErrorFound = false;
		public bool ErrorFound = false;
		public bool ValidConnection = true;
		public List<PatientEventDetail> PatientEventDetails = new List<PatientEventDetail>();

		private ISA _interchangeControlHeader;
      private GS _functionalGroupHeader;
      private MessageGroup _xMessage = new MessageGroup();

      private GE _functionalGroupTrailer;
      private IEA _interchangeControlTrailer;
		public string ErrorMessage = "";

		private string _SSN = "";
		private string _UAK = "";
		private string _DateOfBirth = "";
		private string _GenderCode = "";
		private string _NameFirst = "";
		private string _NameLast = "";
		private SPatient _Patient;
		private List<SFeeVendor> _FeeVendors = new List<SFeeVendor>();
		private Institution _Institution;


		private string _VendorQualifier = "";
		private string _FeeVendorID = "";
		private string _GroupControlNumber = "";
		private string _EventTraceNumber = "";

		public Institution FeeInstitution
		{
			get { return _Institution; }
			set { _Institution = value; }
		}


		public SPatient Patient
		{
			get { return _Patient; }
			set { _Patient = value; }
		}

		public List<SFeeVendor> FeeVendors
		{
			get { return _FeeVendors; }
			set { _FeeVendors = value; }
		}

		public string SSN
		{
			get { return _SSN; }
			set { _SSN = value; }
		}

		public string NameFirst
		{
			get { return _NameFirst; }
			set { _NameFirst = value; }
		}

		public string NameLast
		{
			get { return _NameLast; }
			set { _NameLast = value; }
		}
		public string UAK
		{
			get { return _UAK; }
			set { _UAK = value; }
		}

		public string DateOfBirth
		{
			get { return _DateOfBirth; }
			set { _DateOfBirth = value; }
		}

		public string GenderCode
		{
			get { return _GenderCode; }
			set { _GenderCode = value; }
		}

		public string FeeVendorID
		{
			get { return _FeeVendorID; }
			set { _FeeVendorID = value; }
		}

		public string VendorQualifier
		{
			get { return _VendorQualifier; }
			set { _VendorQualifier = value; }
		}

		public string GroupControlNumber
		{
			get { return _GroupControlNumber; }
			set { _GroupControlNumber = value; }
		}

		public string EventTraceNumber
		{
			get { return _EventTraceNumber; }
			set { _EventTraceNumber = value; }
		}




      public ISA InterchangeControlHeader
      {
         get { return _interchangeControlHeader; }
         set { _interchangeControlHeader = value; }
      }

      public GS FunctionalGroupHeader
      {
         get { return _functionalGroupHeader; }
         set { _functionalGroupHeader = value; }
      }

      public MessageGroup XMessage
      {
         get { return _xMessage; }
         set { _xMessage = value; }
      }



      public GE FunctionalGroupTrailer
      {
         get { return _functionalGroupTrailer; }
         set { _functionalGroupTrailer = value; }
      }

      public IEA InterchangeControlTrailer
      {
         get { return _interchangeControlTrailer; }
         set { _interchangeControlTrailer = value; }
      }

      public bool ValidateMessage()
      {
         bool validMessage = true;

         if (XMessage != null) validMessage = XMessage.ValidateMessage();


         return validMessage;
      }

		public void AddErrorToPatientEvent(ref Settings settings, string responseCode, string rejectCode, string followUp, string errorMessage)
		{
			if (XMessage != null) XMessage.AddErrorToPatientEvent(ref settings, responseCode, rejectCode, followUp, errorMessage);
		}

		public void AddErrorToSubscriber(ref Settings settings, string responseCode, string rejectCode, string followUp, string errorMessage)
		{
			if (XMessage != null) XMessage.AddErrorToSubscriber(ref settings, responseCode, rejectCode, followUp, errorMessage);
		}

		public void GetPatientInfo(ref string lastName, ref string firstName, ref string ssn, ref DateTime? dateOfBirth)
      {
         if (XMessage != null) XMessage.GetPatientInfo(ref lastName, ref firstName, ref ssn, ref dateOfBirth);
      }

      public void GetVendorInfo(ref string vendorTin, ref string vendorName)
      {
         if (XMessage != null) XMessage.GetVendorInfo(ref vendorTin, ref vendorName);
      }

      public void GetLookupDates(ref DateTime? issueDate, ref DateTime? fromDate, ref DateTime? toDate)
      {
         if (XMessage != null) XMessage.GetLookupDates(ref issueDate, ref fromDate, ref toDate);
      }

		public void UpdateUmoDetail(Institution institution)
      {
			if (XMessage != null) XMessage.UpdateUmoDetail(institution);
      }


      public void UpdateRequesterDetail()
      {
         if (XMessage != null) XMessage.UpdateRequesterDetail();
      }

      public void UpdateSubscriberDetail(Settings settings, SPatient sPatient)
      {
         if (XMessage != null) XMessage.UpdateSubscriberDetail(settings, sPatient);
      }

      public void UpdateDependentDetail()
      {
         if (XMessage != null) XMessage.UpdateDependentDetail();
      }

		public void UpdatePatientEventDetail(Settings settings, List<PatientEventDetail> patientEventDetails)
      {
			try
			{
				if (XMessage != null) XMessage.UpdatePatientEventDetail(settings, patientEventDetails);
			}
			catch (Exception)
			{
			}
			
      }


      public void UpdateServiceDetail()
      {
         if (XMessage != null) XMessage.UpdateServiceDetail();
      }

      public void FormatForResponse(Settings settings)
      {
			try
			{
				if (XMessage != null)
				{
					XMessage.UpdateSegmentIds();
					XMessage.UpdateSegmentCount(settings);
				}
			}
			catch (Exception)
			{
			}

      }

      public override string ToString()
      {
         string strReturn = string.Empty;

         if (_interchangeControlHeader != null) strReturn += _interchangeControlHeader.ToString();
         if (_functionalGroupHeader != null) strReturn += _functionalGroupHeader.ToString();
         if (XMessage != null) strReturn += XMessage.ToString();
         if (_functionalGroupTrailer != null) strReturn += _functionalGroupTrailer.ToString();
         if (_interchangeControlTrailer != null) strReturn += _interchangeControlTrailer.ToString();

         return strReturn;
      }

   }
}
