﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace X12Engine.BO.X12._278.XModel
{
	[Serializable()]
	public class DependentDetail
	{

		private HL _dependentLevel;
		private DetailBase _other;
		private EntityBase _dependentName;
		private List<TRN> _dependentTraceNumber;
		private List<AAA> _requestValidation = new List<AAA>();

		private Settings settings;

		public DependentDetail(Settings s)
		{
			settings = s;
		}

		public List<TRN> DependentTraceNumber
		{
			get { return _dependentTraceNumber; }
			set { _dependentTraceNumber = value; }
		}

		public HL DependentLevel
		{
			get { return _dependentLevel; }
			set { _dependentLevel = value; }
		}

		public List<AAA> RequestValidation
		{
			get { return _requestValidation; }
			set { _requestValidation = value; }
		}


		public DetailBase Other
		{
			get { return _other; }
			set { _other = value; }
		}

		public EntityBase DependentName
		{
			get { return _dependentName; }
			set { _dependentName = value; }
		}


		public override string ToString()
		{
			string strReturn = string.Empty;

			if (_dependentLevel != null) strReturn += _dependentLevel.ToString();

			if (_dependentTraceNumber != null)
			{
				foreach (TRN t in _dependentTraceNumber)
				{
					strReturn += t.ToString();
				}
			}

			if (_other != null) strReturn += _other.ToString();

			if (_dependentName != null)
			{
				strReturn += _dependentName.EntityBaseToString("HL4", _requestValidation);
			}
			
			return strReturn;
		}

	}
}
