﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace X12Engine.BO.X12._278.XModel
{
   [Serializable()]
   public class PatientEventDetail
   {
		public bool ErrorFound = false;
		private Settings settings;

		public PatientEventDetail(Settings s)
		{
			settings = s;
			_messageText = new MSG(settings, "");
		}

		public DateTime? FromDate = null;
		public DateTime? ToDate = null;
		public DateTime? IssueDateFrom = null;
		public DateTime? IssueDateTo = null;
		public DateTime? AdmissionDateFrom = null;
		public DateTime? AdmissionDateTo = null;
		public List<FeeAuthorization> FeeAuthorizations = new List<FeeAuthorization>();

		private HL _patientEventLevel;
      private List<TRN> _patientEventTraceNumber = new List<TRN>();
      private List<AAA> _requestValidation = new List<AAA>();
		private UM _healthCareServicesReviewInformation;
      private HCR _healthCareServicesReview;
      private REF _previousReviewAuthorizationNumber;
      private REF _previousReviewAdministrativeReferenceNumber;
      private DTP _accidentDate;
      private DTP _lastMenstrualPeriodDate;
      private DTP _estimatedDateOfBirth;
      private DTP _onsetOfCurrentSymptomsOrIllnessDate;
      private DTP _eventDate;
      private DTP _admissionDate;
      private DTP _dischargeDate;
      private DTP _certificationIssueDate;
      private DTP _certificationExpirationDate;
      private DTP _certificationEffectiveDate;
		private DTP _healthCareServicesReviewRequestDate;
		private HI _patientDiagnosis;
      private HSD _healthCareServicesDelivery;
      private CRC _ambulanceCertificationInformation;
      private CRC _chiropracticCertificationInformation;
      private CRC _durableMedicalEquipmentInformation;
      private CRC _oxygenTherapyCertificationInformation;
      private CRC _functionalLimitationsInformation;
      private CRC _activitiesPermittedInformation;
      private CRC _mentalStatusInformation;
      private CL1 _institutionalClaimCode;
      private CR1 _ambulanceTransportInformation;
      private CR2 _spinalManipulationServiceInformation;
      private CR5 _homeOxygenTherapyInformation;
      private CR6 _homeHealthCareInformation;
      private List<PWK> _additionalPatientInformation;
      private MSG _messageText;
      private DetailBase _other;
      private List<EntityBase> _patientEventProviderName;
      private EntityBase _additionalPatientInformationContactName;
      private List<EntityBase> _patientEventTransportInformation;



      public HL PatientEventLevel
      {
         get { return _patientEventLevel; }
         set { _patientEventLevel = value; }
      }

      public List<TRN> PatientEventTraceNumber
      {
         get { return _patientEventTraceNumber; }
         set { _patientEventTraceNumber = value; }
      }

		public List<AAA> RequestValidation
		{
			get { return _requestValidation; }
			set { _requestValidation = value; }
		}

		public UM HealthCareServicesReviewInformation
      {
         get { return _healthCareServicesReviewInformation; }
         set { _healthCareServicesReviewInformation = value; }
      }

      public HCR HealthCareServicesReview
      {
         get { return _healthCareServicesReview; }
         set { _healthCareServicesReview = value; }
      }

      public REF PreviousReviewAuthorizationNumber
      {
         get { return _previousReviewAuthorizationNumber; }
         set { _previousReviewAuthorizationNumber = value; }
      }

      public REF PreviousReviewAdministrativeReferenceNumber
      {
         get { return _previousReviewAdministrativeReferenceNumber; }
         set { _previousReviewAdministrativeReferenceNumber = value; }
      }

      public DTP AccidentDate
      {
         get { return _accidentDate; }
         set { _accidentDate = value; }
      }

      public DTP LastMenstrualPeriodDate
      {
         get { return _lastMenstrualPeriodDate; }
         set { _lastMenstrualPeriodDate = value; }
      }

      public DTP EstimatedDateOfBirth
      {
         get { return _estimatedDateOfBirth; }
         set { _estimatedDateOfBirth = value; }
      }

      public DTP OnsetOfCurrentSymptomsOrIllnessDate
      {
         get { return _onsetOfCurrentSymptomsOrIllnessDate; }
         set { _onsetOfCurrentSymptomsOrIllnessDate = value; }
      }

      public DTP EventDate
      {
         get { return _eventDate; }
         set { _eventDate = value; }
      }

      public DTP AdmissionDate
      {
         get { return _admissionDate; }
         set { _admissionDate = value; }
      }


		public DTP CertificationIssueDate
		{
			get { return _certificationIssueDate; }
			set { _certificationIssueDate = value; }
		}


		public DTP DischargeDate
      {
         get { return _dischargeDate; }
         set { _dischargeDate = value; }
      }


      public DTP CertificationExpirationDate
      {
         get { return _certificationExpirationDate; }
         set { _certificationExpirationDate = value; }
      }

      public DTP CertificationEffectiveDate
      {
         get { return _certificationEffectiveDate; }
         set { _certificationEffectiveDate = value; }
      }

		public DTP HealthCareServicesReviewRequestDate
		{
			get { return _healthCareServicesReviewRequestDate; }
			set { _healthCareServicesReviewRequestDate = value; }
		}

		public HI PatientDiagnosis
      {
         get { return _patientDiagnosis; }
         set { _patientDiagnosis = value; }
      }

      public HSD HealthCareServicesDelivery
      {
         get { return _healthCareServicesDelivery; }
         set { _healthCareServicesDelivery = value; }
      }

      public CRC AmbulanceCertificationInformation
      {
         get { return _ambulanceCertificationInformation; }
         set { _ambulanceCertificationInformation = value; }
      }

      public CRC ChiropracticCertificationInformation
      {
         get { return _chiropracticCertificationInformation; }
         set { _chiropracticCertificationInformation = value; }
      }

      public CRC DurableMedicalEquipmentInformation
      {
         get { return _durableMedicalEquipmentInformation; }
         set { _durableMedicalEquipmentInformation = value; }
      }

      public CRC OxygenTherapyCertificationInformation
      {
         get { return _oxygenTherapyCertificationInformation; }
         set { _oxygenTherapyCertificationInformation = value; }
      }

      public CRC FunctionalLimitationsInformation
      {
         get { return _functionalLimitationsInformation; }
         set { _functionalLimitationsInformation = value; }
      }

      public CRC ActivitiesPermittedInformation
      {
         get { return _activitiesPermittedInformation; }
         set { _activitiesPermittedInformation = value; }
      }

      public CRC MentalStatusInformation
      {
         get { return _mentalStatusInformation; }
         set { _mentalStatusInformation = value; }
      }

      public CL1 InstitutionalClaimCode
      {
         get { return _institutionalClaimCode; }
         set { _institutionalClaimCode = value; }
      }

      public CR1 AmbulanceTransportInformation
      {
         get { return _ambulanceTransportInformation; }
         set { _ambulanceTransportInformation = value; }
      }

      public CR2 SpinalManipulationServiceInformation
      {
         get { return _spinalManipulationServiceInformation; }
         set { _spinalManipulationServiceInformation = value; }
      }

      public CR5 HomeOxygenTherapyInformation
      {
         get { return _homeOxygenTherapyInformation; }
         set { _homeOxygenTherapyInformation = value; }
      }

      public CR6 HomeHealthCareInformation
      {
         get { return _homeHealthCareInformation; }
         set { _homeHealthCareInformation = value; }
      }

      public List<PWK> AdditionalPatientInformation
      {
         get { return _additionalPatientInformation; }
         set { _additionalPatientInformation = value; }
      }

      public MSG MessageText
      {
         get { return _messageText; }
         set { _messageText = value; }
      }

      public DetailBase Other
      {
         get { return _other; }
         set { _other = value; }
      }

      public List<EntityBase> PatientEventProviderName
      {
         get { return _patientEventProviderName; }
         set { _patientEventProviderName = value; }
      }

      public EntityBase AdditionalPatientInformationContactName
      {
         get { return _additionalPatientInformationContactName; }
         set { _additionalPatientInformationContactName = value; }
      }

      public List<EntityBase> PatientEventTransportInformation
      {
         get { return _patientEventTransportInformation; }
         set { _patientEventTransportInformation = value; }
      }

      public override string ToString()
      {
         string strReturn = string.Empty;
			string gotAAA = ":";

			// HL
			//if (_requestValidation.Count > 0)
			//{
			//	_patientEventLevel.HierarchicalChildCode = new IDENTIFIER("0");
			//}

			if (_patientEventLevel != null) strReturn += _patientEventLevel.ToString();

         // TRN
         if (_patientEventTraceNumber.Count > 0)
         {
            foreach (TRN t in _patientEventTraceNumber)
            {
               strReturn += t.ToString();
            }
         }

			// AAA
			if (_requestValidation.Count > 0)
			{
				int aaaCount = 0;
				foreach (AAA aaa in _requestValidation)
				{
					if (gotAAA.Contains(":" + aaa.RejectReasonCode.Code + ":") && !":15:79:97:".Contains(":" + aaa.RejectReasonCode.Code + ":")) continue;
					gotAAA += aaa.RejectReasonCode.Code + ":";
					aaaCount++; if (aaaCount > 9) break;
					strReturn += aaa.ToString();
				}
			}


			// UM
			if (_healthCareServicesReviewInformation != null) strReturn += _healthCareServicesReviewInformation.ToString();

         // HCR
         if (_healthCareServicesReview != null) strReturn += _healthCareServicesReview.ToString();

			// REF
			// do not return --- if (_previousReviewAuthorizationNumber != null) strReturn += _previousReviewAuthorizationNumber.ToString();


			// return AdministrativeReferenceNumber only if no authorization found.  set ReferenceIdentification to ResponseId after creating response record
			if (FeeAuthorizations.Count == 0)
			{
				REF refInfo = new REF(settings);
				refInfo.ReferenceIdentificationQualifier = new IDENTIFIER("NT");
				refInfo.ReferenceIdentification = "[ReferenceIdentification]";
				strReturn += refInfo.ToString();
			}



         if (_other != null) _other.CheckSegment("REF", ref strReturn);

         // DTP
			if (_requestValidation.Count == 0)
			{
				if (_accidentDate != null) strReturn += _accidentDate.ToString();

				if (_lastMenstrualPeriodDate != null) strReturn += _lastMenstrualPeriodDate.ToString();

				if (_estimatedDateOfBirth != null) strReturn += _estimatedDateOfBirth.ToString();

				if (_onsetOfCurrentSymptomsOrIllnessDate != null) strReturn += _onsetOfCurrentSymptomsOrIllnessDate.ToString();

				if (_eventDate != null) strReturn += _eventDate.ToString();

				if (_admissionDate != null) strReturn += _admissionDate.ToString();

				if (_dischargeDate != null) strReturn += _dischargeDate.ToString();

				if (_certificationIssueDate != null) strReturn += _certificationIssueDate.ToString();

				if (_certificationExpirationDate != null) strReturn += _certificationExpirationDate.ToString();

				if (_certificationEffectiveDate != null) strReturn += _certificationEffectiveDate.ToString();

				if (_healthCareServicesReviewRequestDate != null) strReturn += _healthCareServicesReviewRequestDate.ToString();

				if (_other != null) _other.CheckSegment("DTP", ref strReturn);
			}


         // HI
         if (_patientDiagnosis != null) strReturn += _patientDiagnosis.ToString();

			// SV1
			if (_other != null) _other.CheckSegment("SV1", ref strReturn);

			// SV2
			if (_other != null) _other.CheckSegment("SV2", ref strReturn);

			// SV3
			if (_other != null) _other.CheckSegment("SV3", ref strReturn);

			// TOO
			if (_other != null) _other.CheckSegment("TOO", ref strReturn);

         // HSD
         if (_healthCareServicesDelivery != null) strReturn += _healthCareServicesDelivery.ToString();

         // CRC
         if (_ambulanceCertificationInformation != null) strReturn += _ambulanceCertificationInformation.ToString();

         if (_chiropracticCertificationInformation != null) strReturn += _chiropracticCertificationInformation.ToString();

         if (_durableMedicalEquipmentInformation != null) strReturn += _durableMedicalEquipmentInformation.ToString();

         if (_oxygenTherapyCertificationInformation != null) strReturn += _oxygenTherapyCertificationInformation.ToString();

         if (_functionalLimitationsInformation != null) strReturn += _functionalLimitationsInformation.ToString();

         if (_activitiesPermittedInformation != null) strReturn += _activitiesPermittedInformation.ToString();

         if (_mentalStatusInformation != null) strReturn += _mentalStatusInformation.ToString();

         if (_other != null) _other.CheckSegment("CRC", ref strReturn);

         // CL1
         if (_institutionalClaimCode != null) strReturn += _institutionalClaimCode.ToString();

         // CR1
         if (_ambulanceTransportInformation != null) strReturn += _ambulanceTransportInformation.ToString();

         // CR2
         if (_spinalManipulationServiceInformation != null) strReturn += _spinalManipulationServiceInformation.ToString();

			// CR4
			if (_other != null) _other.CheckSegment("CR4", ref strReturn);

         // CR5
         if (_homeOxygenTherapyInformation != null) strReturn += _homeOxygenTherapyInformation.ToString();

         // CR6
         if (_homeHealthCareInformation != null) strReturn += _homeHealthCareInformation.ToString();

			// CR7
			if (_other != null) _other.CheckSegment("CR7", ref strReturn);

			// CR8
			if (_other != null) _other.CheckSegment("CR8", ref strReturn);

         // PWK
         if (_additionalPatientInformation != null)
         {
            foreach (PWK p in _additionalPatientInformation)
            {
               strReturn += p.ToString();
            }
         }

			// MSG
			if (_requestValidation.Count == 0 && _messageText != null)
			{
				if (!string.IsNullOrEmpty(_messageText.FreeFormMessageText))
				{
					strReturn += _messageText.ToString();
				}
			}
			
			// Loop 2010EA - Patient Event Provider Name
			if (_patientEventProviderName != null)
         {
            foreach (EntityBase e in _patientEventProviderName)
            {
               strReturn += e.EntityBaseToString("EVA", null);
            }
         }


			// Loop 2010EC - Patient Event Other UMO Name.  do not respond
			//if (_additionalPatientInformationContactName != null) strReturn += _additionalPatientInformationContactName.EntityBaseToString("EVC", null);


			// Loop 2010EB - Patient Event Transport Information.   Switched around in response!
			if (_patientEventTransportInformation != null)
			{
				foreach (EntityBase e in _patientEventTransportInformation)
				{
					strReturn += e.EntityBaseToString("EVB", null);
				}
			}

			return strReturn;
      }


   }
}
