﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace X12Engine.BO.X12._278.XModel
{
   [Serializable()]
   public class RequesterDetail
   {

      private HL _requesterLevel;
      private DetailBase _other;
      private EntityBase _requesterName;
		private List<AAA> _requestValidation = new List<AAA>();


		private Settings settings;

		public RequesterDetail(Settings s)
		{
			settings = s;
		}


		public HL RequesterLevel
      {
         get { return _requesterLevel; }
         set { _requesterLevel = value; }
      }

		public List<AAA> RequestValidation
		{
			get { return _requestValidation; }
			set { _requestValidation = value; }
		}

		public DetailBase Other
      {
         get { return _other; }
         set { _other = value; }
      }

      public EntityBase RequesterName
      {
         get { return _requesterName; }
         set { _requesterName = value; }
      }


      public override string ToString()
      {
         string strReturn = string.Empty;
			// HL
			if (_requestValidation.Count > 0)
			{
				_requesterLevel.HierarchicalChildCode = new IDENTIFIER("0");
			}
			if (_requesterLevel != null) strReturn += _requesterLevel.ToString();

         if (_other != null) strReturn += _other.ToString();

			if (_requesterName != null)
         {
				strReturn += _requesterName.EntityBaseToString("HL2", _requestValidation);
         }


			return strReturn;
      }


   }
}
