﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace X12Engine.BO.X12._278.XModel
{
   [Serializable()]
   public class SubscriberDetail
   {
		private Settings settings;
		public SubscriberDetail(Settings s)
		{
			settings = s;
		}

		private HL _subscriberLevel;
      private DetailBase _other;
      private EntityBase _subscriberName;
		private List<AAA> _requestValidation = new List<AAA>();
		private List<TRN> _subscriberTraceNumber;

      public HL SubscriberLevel
      {
         get { return _subscriberLevel; }
         set { _subscriberLevel = value; }
      }

		public List<AAA> RequestValidation
		{
			get { return _requestValidation; }
			set { _requestValidation = value; }
		}

		public List<TRN> SubscriberTraceNumber
		{
			get { return _subscriberTraceNumber; }
			set { _subscriberTraceNumber = value; }
		}

		public DetailBase Other
      {
         get { return _other; }
         set { _other = value; }
      }

      public EntityBase SubscriberName
      {
         get { return _subscriberName; }
         set { _subscriberName = value; }
      }


      public override string ToString()
      {
         string strReturn = string.Empty;


			// HL
			if (_requestValidation.Count > 0)
			{
				_subscriberLevel.HierarchicalChildCode = new IDENTIFIER("0");
			}
			if (_subscriberLevel != null) strReturn += _subscriberLevel.ToString();


			if (_subscriberTraceNumber != null)
			{
				foreach (TRN t in _subscriberTraceNumber)
				{
					strReturn += t.ToString();
				}
			}

			if (_other != null) strReturn += _other.ToString();

         if (_subscriberName != null) strReturn += _subscriberName.EntityBaseToString("HL3", _requestValidation);

			return strReturn;
      }

   }
}
