﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace X12Engine.BO.X12._278.XModel
{
   [Serializable()]
   public class UmoDetail
   {
		private Settings settings;

		public UmoDetail(Settings s)
		{
			settings = s;
		}

		private HL _uMOLevel;
      private List<AAA> _requestValidation = new List<AAA>();
      private DetailBase _other;
      private EntityBase _uMOName;


      public HL UMOLevel
      {
         get { return _uMOLevel; }
         set { _uMOLevel = value; }
      }

      public List<AAA> RequestValidation
      {
         get { return _requestValidation; }
         set { _requestValidation = value; }
      }

      public DetailBase Other
      {
         get { return _other; }
         set { _other = value; }
      }

      public EntityBase UMOName
      {
         get { return _uMOName; }
         set { _uMOName = value; }
      }


      public override string ToString()
      {
         string strReturn = string.Empty;

			if (_uMOLevel != null && _other == null) strReturn = _uMOLevel.ToString();

			if (_requestValidation.Count > 0)
			{
				int aaaCount = 0;
				foreach (AAA a in _requestValidation)
				{
					aaaCount++; if (aaaCount > 9) break;
					strReturn += a.ToString();
					if (a.RejectReasonCode.Code == "42")
					{
						return strReturn;
					}
				}
			}

			// add PER websit
			if (_uMOName.AdministrativeCommunicationsContact.Count == 0)
			{
				PER per = new PER(settings);
				per.ContactFunctionCode = new IDENTIFIER("IC");
				per.CommunicationNumberQualifier1 = new IDENTIFIER("UR");
				per.CommunicationNumber1 = "www2.va.gov/directory/guide/rpt_fac_list.cfm";
				_uMOName.AdministrativeCommunicationsContact.Add(per);
			}


			if (_other != null) _other.CheckSegment("TRN", ref strReturn);

         if (_other != null) strReturn += _other.ToString();

         if (_uMOName != null) strReturn += _uMOName.EntityBaseToString("HL1", null);

			return strReturn;
      }


   }
}
