﻿using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using X12Engine.BO.X12._278;

namespace X12Engine
{
	public class Settings
	{
		private string _transType = "005010X217";
		private char _dataElementSeparator = '*';
		private char _segmentTerminator = '~';
		private char _repetitionSeparator = '^';
		private char _componentElementSeparator = ':';

		private List<SqlCommand> _SqlCommands = new List<SqlCommand>();
		private List<SqlCommand> _SqlCommandsResponse = new List<SqlCommand>();
		private List<DataRoutingCode> _DataRoutingCode = new List<DataRoutingCode>();

		public int AuthorizationCount = 0;
		public int AAACount = 0;
		public int HIIndex = 0;

		public StringBuilder LogMessages =  new StringBuilder();

		public List<SqlCommand> SqlCommands
		{
			get { return _SqlCommands; }
			set { _SqlCommands = value; }
		}

		public List<SqlCommand> SqlCommandsResponse
		{
			get { return _SqlCommandsResponse; }
			set { _SqlCommandsResponse = value; }
		}


		public List<DataRoutingCode> DataRoutingCode
		{
			get { return _DataRoutingCode; }
			set { _DataRoutingCode = value; }
		}

		public string TransType
		{
			get { return _transType; }
			set { _transType = value; }
		}

		public char Data_Element_Separator
		{
			get { return _dataElementSeparator; }
			set { _dataElementSeparator = value; }
		}

		public char Repetition_Separator
		{
			get { return _repetitionSeparator; }
			set { _repetitionSeparator = value; }
		}

		public char Component_Element_Separator
		{
			get { return _componentElementSeparator; }
			set { _componentElementSeparator = value; }
		}

		public char Segment_Terminator
		{
			get { return _segmentTerminator; }
			set { _segmentTerminator = value; }
		}

		public void Reset()
		{
			_repetitionSeparator = '^';
			_componentElementSeparator = ':';
		}
	}
}
