package va.gov.domain;

import java.lang.reflect.Type;

import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonSerializationContext;
import com.google.gson.JsonSerializer;

import va.gov.jpa.dto.AuditLog;
import va.gov.jpa.service.GeneralService;



public class AuditLogAdapter implements JsonSerializer<AuditLog>{

	
	
	    public JsonElement serialize(AuditLog sp, Type type, JsonSerializationContext jsc) {
	        JsonObject jsonObject = new JsonObject();
	        if (sp.getReasonCode()!=null && sp.getReasonCode()!=""){
		        String rCode= sp.getReasonCode().toString();
		        String rdescr = GeneralService.getInstance().findDenyReasonDescrById(rCode);
		        jsonObject.addProperty("reason", rdescr);
	        }
	        jsonObject.addProperty("status", sp.getAuditAction());
	        jsonObject.addProperty("Queue", sp.getQueue());
	        if (sp.getQueue()!=null){
		        String qCode= sp.getQueue().toString();
		        String qdescr = GeneralService.getInstance().findQDescrebyQueueId(qCode);
		        jsonObject.addProperty("Queue", qdescr);
	        }
	        jsonObject.addProperty("user", sp.getUserId());
	        jsonObject.addProperty("time", sp.getDateTimeStamp().toString());
	        
	        return jsonObject;      
	    }
	}
	

