package va.gov.jpa.dto;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;



@Entity
@Table(name = "AuditLog") // @Table is optional, but "user" is a keyword in many SQL variants */
@NamedQueries({
	@NamedQuery(name = "AuditLog.findAuditLogByPatID", query = "select alog from AuditLog alog where alog.requestId=:rid")

					
})

public class AuditLog implements java.io.Serializable{
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)  
	@Column(name = "AuditLogRecordNumber", unique = true, nullable = false)
	Long auditLogRecordNumber;   
	@Column(name = "RequestId")
    int requestId;
 	@Column(name = "DateTimeStamp", nullable = false)    
    String dateTimeStamp ;
    @Column(name = "AuditAction")
    String auditAction;  
    @Column(name = "UserId")
    String userId;
    @Column(name = "Queue")
    String queue;
    @Column(name = "ReasonCode")
    String reasonCode;
	public Long getAuditLogRecordNumber() {
		return auditLogRecordNumber;
	}
	public void setAuditLogRecordNumber(Long auditLogRecordNumber) {
		this.auditLogRecordNumber = auditLogRecordNumber;
	}
	
	public int getRequestId() {
		return requestId;
	}
	public void setRequestId(int requestId) {
		this.requestId = requestId;
	}
	
	public String getDateTimeStamp() {
		return dateTimeStamp;
	}
	public void setDateTimeStamp(String dateTimeStamp) {
		this.dateTimeStamp = dateTimeStamp;
	}
	public String getAuditAction() {
		return auditAction;
	}
	public void setAuditAction(String auditAction) {
		this.auditAction = auditAction;
	}
	public String getUserId() {
		return userId;
	}
	public void setUserId(String userId) {
		this.userId = userId;
	}
	public String getQueue() {
		return queue;
	}
	public void setQueue(String queue) {
		this.queue = queue;
	}
	public String getReasonCode() {
		return reasonCode;
	}
	public void setReasonCode(String reasonCode) {
		this.reasonCode = reasonCode;
	}  
   
    
	
		
}