package va.gov.jpa.dto;

import java.sql.Timestamp;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;



@Entity
@Table(name = "CertificationInformation") // @Table is optional, but "user" is a keyword in many SQL variants */
@NamedQueries({
	@NamedQuery(name = "CertificationInformation.findDateInforByReqIdlcode", query = "select alog from CertificationInformation alog where alog.requestId=:rid and alog.loopCode=:lcode")

					
})

public class CertificationInformation implements java.io.Serializable{
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)  
	@Column(name = "CRCRecordNumber", unique = true, nullable = false)
	Long cRCRecordNumber;   
	@Column(name = "RequestId")
    int requestId;
 	@Column(name = "LoopCode")
    String loopCode;
   	@Column(name = "LoopNumber")
    String loopNumber;
   	@Column(name = "SequenceNumber")
    String sequenceNumber; 	
   	@Column(name = "CategoryCode", nullable = false)    
    String categoryCode ;
    @Column(name = "Response")
    String response;  
    @Column(name = "CoditionIndicatorCode1")
    String conditionIndicatorCode1;
    @Column(name = "CoditionIndicatorCode2")
    String conditionIndicatorCode2;
    @Column(name = "CoditionIndicatorCode3")
    String conditionIndicatorCode3;
    @Column(name = "CoditionIndicatorCode4")
    String conditionIndicatorCode4;
    @Column(name = "CoditionIndicatorCode5")
    String conditionIndicatorCode5;
    @Column(name = "CoditionIndicatorCode6")
    String conditionIndicatorCode6;
    
	public Long getcRCRecordNumber() {
		return cRCRecordNumber;
	}
	public void setcRCRecordNumber(Long cRCRecordNumber) {
		this.cRCRecordNumber = cRCRecordNumber;
	}
	
	public int getRequestId() {
		return requestId;
	}
	public void setRequestId(int requestId) {
		this.requestId = requestId;
	}
	public String getLoopCode() {
		return loopCode;
	}
	public void setLoopCode(String loopCode) {
		this.loopCode = loopCode;
	}
	public String getLoopNumber() {
		return loopNumber;
	}
	public void setLoopNumber(String loopNumber) {
		this.loopNumber = loopNumber;
	}
	
	public String getSequenceNumber() {
		return sequenceNumber;
	}
	public void setSequenceNumber(String sequenceNumber) {
		this.sequenceNumber = sequenceNumber;
	}
	public String getCategoryCode() {
		return categoryCode;
	}
	public void setCategoryCode(String categoryCode) {
		this.categoryCode = categoryCode;
	}
	public String getResponse() {
		return response;
	}
	public void setResponse(String response) {
		this.response = response;
	}
	public String getConditionIndicatorCode1() {
		return conditionIndicatorCode1;
	}
	public void setConditionIndicatorCode1(String conditionIndicatorCode1) {
		this.conditionIndicatorCode1 = conditionIndicatorCode1;
	}
	public String getConditionIndicatorCode2() {
		return conditionIndicatorCode2;
	}
	public void setConditionIndicatorCode2(String conditionIndicatorCode2) {
		this.conditionIndicatorCode2 = conditionIndicatorCode2;
	}
	public String getConditionIndicatorCode3() {
		return conditionIndicatorCode3;
	}
	public void setConditionIndicatorCode3(String conditionIndicatorCode3) {
		this.conditionIndicatorCode3 = conditionIndicatorCode3;
	}
	public String getConditionIndicatorCode4() {
		return conditionIndicatorCode4;
	}
	public void setConditionIndicatorCode4(String conditionIndicatorCode4) {
		this.conditionIndicatorCode4 = conditionIndicatorCode4;
	}
	public String getConditionIndicatorCode5() {
		return conditionIndicatorCode5;
	}
	public void setConditionIndicatorCode5(String conditionIndicatorCode5) {
		this.conditionIndicatorCode5 = conditionIndicatorCode5;
	}
	public String getConditionIndicatorCode6() {
		return conditionIndicatorCode6;
	}
	public void setConditionIndicatorCode6(String conditionIndicatorCode6) {
		this.conditionIndicatorCode6 = conditionIndicatorCode6;
	}
	
    
		
}