package va.gov.jpa.dto;

import java.sql.Timestamp;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;



@Entity
@Table(name = "ContactInformation") // @Table is optional, but "user" is a keyword in many SQL variants */
@NamedQueries({
	@NamedQuery(name = "ContactInformation.findDAddByReqIdLoopCode", query = "select alog from ContactInformation alog where alog.requestId=:rid and alog.loopCode=:lcode")

					
})

public class ContactInformation implements java.io.Serializable{
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)  
	@Column(name = "PERRecordNumber", unique = true, nullable = false)
	Long pERRecordNumber;   
	@Column(name = "RequestId")
    int requestId;
	@Column(name = "LoopCode")
    String loopCode;
   	@Column(name = "LoopNumber")
    String loopNumber;
   	@Column(name = "SequenceNumber")
    String sequenceNumber; 	
   	@Column(name = "ContactFunctionId", nullable = false)    
    String contactFunctionId ;
    @Column(name = "ContactName")
    String contactName;  
    @Column(name = "CommNumberQualifier1")
    String commNumberQualifier1;
    @Column(name = "CommNumberQualifier2")
    String commNumberQualifier2;
    @Column(name = "CommNumberQualifier3")
    String commNumberQualifier3;
    @Column(name = "CommNumber1")
    String commNumber1;
    @Column(name = "CommNumber2")
    String commNumber2;
    @Column(name = "CommNumber3")
    String commNumber3;
	public Long getpERRecordNumber() {
		return pERRecordNumber;
	}
	public void setpERRecordNumber(Long pERRecordNumber) {
		this.pERRecordNumber = pERRecordNumber;
	}
	
	public int getRequestId() {
		return requestId;
	}
	public void setRequestId(int requestId) {
		this.requestId = requestId;
	}
	public static long getSerialversionuid() {
		return serialVersionUID;
	}
	public String getLoopCode() {
		return loopCode;
	}
	public void setLoopCode(String loopCode) {
		this.loopCode = loopCode;
	}
	public String getLoopNumber() {
		return loopNumber;
	}
	public void setLoopNumber(String loopNumber) {
		this.loopNumber = loopNumber;
	}
	public String getSequenceNumber() {
		return sequenceNumber;
	}
	public void setSequenceNumber(String sequenceNumber) {
		this.sequenceNumber = sequenceNumber;
	}
	public String getContactFunctionId() {
		return contactFunctionId;
	}
	public void setContactFunctionId(String contactFunctionId) {
		this.contactFunctionId = contactFunctionId;
	}
	public String getContactName() {
		return contactName;
	}
	public void setContactName(String contactName) {
		this.contactName = contactName;
	}
	public String getCommNumberQualifier1() {
		return commNumberQualifier1;
	}
	public void setCommNumberQualifier1(String commNumberQualifier1) {
		this.commNumberQualifier1 = commNumberQualifier1;
	}
	public String getCommNumberQualifier2() {
		return commNumberQualifier2;
	}
	public void setCommNumberQualifier2(String commNumberQualifier2) {
		this.commNumberQualifier2 = commNumberQualifier2;
	}
	public String getCommNumberQualifier3() {
		return commNumberQualifier3;
	}
	public void setCommNumberQualifier3(String commNumberQualifier3) {
		this.commNumberQualifier3 = commNumberQualifier3;
	}
	public String getCommNumber1() {
		return commNumber1;
	}
	public void setCommNumber1(String commNumber1) {
		this.commNumber1 = commNumber1;
	}
	public String getCommNumber2() {
		return commNumber2;
	}
	public void setCommNumber2(String commNumber2) {
		this.commNumber2 = commNumber2;
	}
	public String getCommNumber3() {
		return commNumber3;
	}
	public void setCommNumber3(String commNumber3) {
		this.commNumber3 = commNumber3;
	}
    
	
    
		
}