package va.gov.jpa.dto;

import java.sql.Timestamp;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;



@Entity
@Table(name = "DateInformation") // @Table is optional, but "user" is a keyword in many SQL variants */
@NamedQueries({
	@NamedQuery(name = "DateInformation.findDateInforByReqIDDqteQual", query = "select alog from DateInformation alog where alog.requestId=:rid and alog.dateTimeQualifier=:dateQual and alog.loopNumber=:lno"),
	@NamedQuery(name = "DateInformation.findDateInforByReqIdlcode", query = "select alog from DateInformation alog where alog.requestId=:rid and alog.loopCode=:lcode and alog.loopNumber=:lno"),
	@NamedQuery(name = "DateInformation.findLoopDateInfo", query = "select max(alog.loopNumber) from DateInformation alog where alog.requestId=:rid and alog.loopCode=:lcode  ")
})

public class DateInformation implements java.io.Serializable{
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)  
	@Column(name = "DTPRecordNumber", unique = true, nullable = false)
	Long dTPRecordNumber;   
	@Column(name = "RequestId")
    int requestId;
	@Column(name = "LoopCode")
    String loopCode;
   	@Column(name = "LoopNumber")
    String loopNumber;
   	@Column(name = "SequenceNumber")
    String sequenceNumber; 	
    @Column(name = "DateTimeQualifier")
    String dateTimeQualifier;
    @Column(name = "DateTimePeriodFormat")
    String dateTimePeriodFormat;
    @Column(name = "DateTimePeriod")
    String dateTimePeriod;
	public Long getdTPRecordNumber() {
		return dTPRecordNumber;
	}
	public void setdTPRecordNumber(Long dTPRecordNumber) {
		this.dTPRecordNumber = dTPRecordNumber;
	}
	
	
	public int getRequestId() {
		return requestId;
	}
	public void setRequestId(int requestId) {
		this.requestId = requestId;
	}
	public String getLoopCode() {
		return loopCode;
	}
	public void setLoopCode(String loopCode) {
		this.loopCode = loopCode;
	}
	public String getLoopNumber() {
		return loopNumber;
	}
	public void setLoopNumber(String loopNumber) {
		this.loopNumber = loopNumber;
	}
	
	public String getSequenceNumber() {
		return sequenceNumber;
	}
	public void setSequenceNumber(String sequenceNumber) {
		this.sequenceNumber = sequenceNumber;
	}
	public String getDateTimeQualifier() {
		return dateTimeQualifier;
	}
	public void setDateTimeQualifier(String dateTimeQualifier) {
		this.dateTimeQualifier = dateTimeQualifier;
	}
	public String getDateTimePeriodFormat() {
		return dateTimePeriodFormat;
	}
	public void setDateTimePeriodFormat(String dateTimePeriodFormat) {
		this.dateTimePeriodFormat = dateTimePeriodFormat;
	}
	public String getDateTimePeriod() {
		return dateTimePeriod;
	}
	public void setDateTimePeriod(String dateTimePeriod) {
		this.dateTimePeriod = dateTimePeriod;
	}
 
    
		
}