package va.gov.jpa.dto;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;



@Entity
@Table(name = "DiagnosisInformation") // @Table is optional, but "user" is a keyword in many SQL variants */
@NamedQueries({
	@NamedQuery(name = "DiagnosisInformation.findByrIDLcode", query = "select alog from DiagnosisInformation alog where alog.requestId=:rid and alog.loopCode=:lcode and alog.loopNumber=:lnumber")

					
})

public class DiagnosisInformation implements java.io.Serializable{
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)  
	@Column(name = "HIRecordNumber", unique = true, nullable = false)
	Long dMGRecordNumber;   
	@Column(name = "RequestId")
    int requestId;
 	@Column(name = "LoopCode")
    String loopCode;
   	@Column(name = "LoopNumber")
    String loopNumber;
   	@Column(name = "SequenceNumber")
    String sequenceNumber;
   	@Column(name = "ElementNumber")
    String elementNumber;
   	@Column(name = "CodeListQualifierCode")
    String codeListQuaifierCode;
   	@Column(name = "IndustryCode")
    String industryCode;
    @Column(name = "DateTimePeriodQualifier")
    String dateTimePeriodQualifier;
    @Column(name = "DateTimePeriod")
    String dateTimePeriod;
	public Long getdMGRecordNumber() {
		return dMGRecordNumber;
	}
	public void setdMGRecordNumber(Long dMGRecordNumber) {
		this.dMGRecordNumber = dMGRecordNumber;
	}
	
	public int getRequestId() {
		return requestId;
	}
	public void setRequestId(int requestId) {
		this.requestId = requestId;
	}
	public String getLoopCode() {
		return loopCode;
	}
	public void setLoopCode(String loopCode) {
		this.loopCode = loopCode;
	}
	public String getLoopNumber() {
		return loopNumber;
	}
	public void setLoopNumber(String loopNumber) {
		this.loopNumber = loopNumber;
	}
	public String getSequenceNumber() {
		return sequenceNumber;
	}
	public void setSequenceNumber(String sequenceNumber) {
		this.sequenceNumber = sequenceNumber;
	}
	public String getElementNumber() {
		return elementNumber;
	}
	public void setElementNumber(String elementNumber) {
		this.elementNumber = elementNumber;
	}
	public String getCodeListQuaifierCode() {
		return codeListQuaifierCode;
	}
	public void setCodeListQuaifierCode(String codeListQuaifierCode) {
		this.codeListQuaifierCode = codeListQuaifierCode;
	}
	public String getIndustryCode() {
		return industryCode;
	}
	public void setIndustryCode(String industryCode) {
		this.industryCode = industryCode;
	}
	public String getDateTimePeriodQualifier() {
		return dateTimePeriodQualifier;
	}
	public void setDateTimePeriodQualifier(String dateTimePeriodQualifier) {
		this.dateTimePeriodQualifier = dateTimePeriodQualifier;
	}
	public String getDateTimePeriod() {
		return dateTimePeriod;
	}
	public void setDateTimePeriod(String dateTimePeriod) {
		this.dateTimePeriod = dateTimePeriod;
	}
    

		
}