package va.gov.jpa.dto;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;



@Entity
@Table(name = "EntityAddress") // @Table is optional, but "user" is a keyword in many SQL variants */
@NamedQueries({
	@NamedQuery(name = "EntityAddress.findDAddByReqIdLoopCode", query = "select alog from EntityAddress alog where alog.requestId=:rid and alog.loopCode=:lcode")

					
})

public class EntityAddress implements java.io.Serializable{
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)  
	@Column(name = "N3RecordNumber", unique = true, nullable = false)
	Long n3RecordNumber;   
	@Column(name = "RequestId")
    int requestId; 
	@Column(name = "LoopCode")
    String loopCode;
   	@Column(name = "LoopNumber")
    String loopNumber;
   	@Column(name = "SequenceNumber")
    String sequenceNumber;
   	@Column(name = "Address1")
    String address1;
   	@Column(name = "Address2")
    String address2;
   	@Column(name = "City")
    String city;
    @Column(name = "StateProvCode")
    String stateProvCode;
    @Column(name = "PostalCode")
    String postalCode;
    @Column(name = "CountryCode")
    String countryCode;
    @Column(name = "CountrySubCode")
    String CountrySubCode;
	
	public Long getN3RecordNumber() {
		return n3RecordNumber;
	}
	public void setN3RecordNumber(Long n3RecordNumber) {
		this.n3RecordNumber = n3RecordNumber;
	}
	public int getRequestId() {
		return requestId;
	}
	public void setRequestId(int requestId) {
		this.requestId = requestId;
	}
	public static long getSerialversionuid() {
		return serialVersionUID;
	}
	public String getLoopCode() {
		return loopCode;
	}
	public void setLoopCode(String loopCode) {
		this.loopCode = loopCode;
	}
	public String getLoopNumber() {
		return loopNumber;
	}
	public void setLoopNumber(String loopNumber) {
		this.loopNumber = loopNumber;
	}
	public String getSequenceNumber() {
		return sequenceNumber;
	}
	public void setSequenceNumber(String sequenceNumber) {
		this.sequenceNumber = sequenceNumber;
	}
	public String getAddress1() {
		return address1;
	}
	public void setAddress1(String address1) {
		this.address1 = address1;
	}
	public String getAddress2() {
		return address2;
	}
	public void setAddress2(String address2) {
		this.address2 = address2;
	}
	
	public String getCity() {
		return city;
	}
	public void setCity(String city) {
		this.city = city;
	}
	public String getStateProvCode() {
		return stateProvCode;
	}
	public void setStateProvCode(String stateProvCode) {
		this.stateProvCode = stateProvCode;
	}
	public String getPostalCode() {
		return postalCode;
	}
	public void setPostalCode(String postalCode) {
		this.postalCode = postalCode;
	}
	public String getCountryCode() {
		return countryCode;
	}
	public void setCountryCode(String countryCode) {
		this.countryCode = countryCode;
	}
	public String getCountrySubCode() {
		return CountrySubCode;
	}
	public void setCountrySubCode(String countrySubCode) {
		CountrySubCode = countrySubCode;
	}
   
    
}