package va.gov.jpa.dto;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;



@Entity
@Table(name = "EntityName") // @Table is optional, but "user" is a keyword in many SQL variants */
@NamedQueries({
	@NamedQuery(name = "EntityName.findEntityByReqIDLoopCode", query = "select alog from EntityName alog where alog.requestId=:rid and alog.loopCode=:lcode")

					
})

public class EntityName implements java.io.Serializable{
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)  
	@Column(name = "NM1RecordNumber", unique = true, nullable = false)
	Long nameRecordNumber;   
	@Column(name = "RequestId")
    int requestId; 
	@Column(name = "LoopCode")
    String loopCode;
   	@Column(name = "LoopNumber")
    String loopNumber;
   	@Column(name = "SequenceNumber")
    String sequenceNumber;
   	@Column(name = "EntityIdCode")
    String entityIdCode;
   	@Column(name = "EntityType")
    String entityType;
   	@Column(name = "NameLastOrganization")
    String nameLastOrganization;
    @Column(name = "NameFirst")
    String nameFirst;
    @Column(name = "NameMiddle")
    String nameMiddle;
    
    @Column(name = "NamePrefix")
    String namePrefix;
    @Column(name = "NameSuffix")
    String NameSuffix;
    @Column(name = "EntityIdCodeQualifier")
    String entityIdCodeQualifier;
    @Column(name = "EntityIdentificationCode")
    String entityIdentificationCode;
    @Column(name = "DateOfBirth")
    String dateOfBirth;
    @Column(name = "Gender")
    String gender;
    
	public Long getNameRecordNumber() {
		return nameRecordNumber;
	}
	public void setNameRecordNumber(Long nameRecordNumber) {
		this.nameRecordNumber = nameRecordNumber;
	}
	
	public int getRequestId() {
		return requestId;
	}
	public void setRequestId(int requestId) {
		this.requestId = requestId;
	}
	public String getLoopCode() {
		return loopCode;
	}
	public void setLoopCode(String loopCode) {
		this.loopCode = loopCode;
	}
	public String getLoopNumber() {
		return loopNumber;
	}
	public void setLoopNumber(String loopNumber) {
		this.loopNumber = loopNumber;
	}
	public String getSequenceNumber() {
		return sequenceNumber;
	}
	public void setSequenceNumber(String sequenceNumber) {
		this.sequenceNumber = sequenceNumber;
	}
	public String getEntityIdCode() {
		return entityIdCode;
	}
	public void setEntityIdCode(String entityIdCode) {
		this.entityIdCode = entityIdCode;
	}
	public String getEntityType() {
		return entityType;
	}
	public void setEntityType(String entityType) {
		this.entityType = entityType;
	}
	public String getNameLastOrganization() {
		return nameLastOrganization;
	}
	public void setNameLastOrganization(String nameLastOrganization) {
		this.nameLastOrganization = nameLastOrganization;
	}
	public String getNameFirst() {
		return nameFirst;
	}
	public void setNameFirst(String nameFirst) {
		this.nameFirst = nameFirst;
	}
	public String getNameMiddle() {
		return nameMiddle;
	}
	public void setNameMiddle(String nameMiddle) {
		this.nameMiddle = nameMiddle;
	}
	public String getNamePrefix() {
		return namePrefix;
	}
	public void setNamePrefix(String namePrefix) {
		this.namePrefix = namePrefix;
	}
	public String getNameSuffix() {
		return NameSuffix;
	}
	public void setNameSuffix(String nameSuffix) {
		NameSuffix = nameSuffix;
	}
	public String getEntityIdCodeQualifier() {
		return entityIdCodeQualifier;
	}
	public void setEntityIdCodeQualifier(String entityIdCodeQualifier) {
		this.entityIdCodeQualifier = entityIdCodeQualifier;
	}
	public String getEntityIdentificationCode() {
		return entityIdentificationCode;
	}
	public void setEntityIdentificationCode(String entityIdentificationCode) {
		this.entityIdentificationCode = entityIdentificationCode;
	}
	public String getDateOfBirth() {
		return dateOfBirth;
	}
	public void setDateOfBirth(String dateOfBirth) {
		this.dateOfBirth = dateOfBirth;
	}
	public String getGender() {
		return gender;
	}
	public void setGender(String gender) {
		this.gender = gender;
	}
    
	
		
}