package va.gov.jpa.dto;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;



@Entity
@Table(name = "HealthCareServicesDelivery") // @Table is optional, but "user" is a keyword in many SQL variants */
@NamedQueries({
	@NamedQuery(name = "HealthCareServicesDelivery.findToothByReqIdlcode", query = "select alog from HealthCareServicesDelivery alog where alog.requestId=:rid and alog.loopCode=:lcode and alog.loopNumber=:lnumber")

					
})

public class HealthCareServicesDelivery implements java.io.Serializable{
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)  
	@Column(name = "HSDRecordNumber", unique = true, nullable = false)
	Long hSDRecordNumber;   
	@Column(name = "RequestId")
    int requestId; 
	@Column(name = "LoopCode")
    String loopCode;
   	@Column(name = "LoopNumber")
    String loopNumber;
   	@Column(name = "SequenceNumber")
    String sequenceNumber;
   	@Column(name = "QuantityQualifierCode")
    String quantityQualifierCode;
   	@Column(name = "Quantity")
    String quantity;
   	@Column(name = "UnitCode")
    String unitCode;
    @Column(name = "Frequency")
    String frequency;
    @Column(name = "NumberofPeriods")
    String numberofPeriods;
    @Column(name = "DeliveryCode")
    String deliveryCode;
    @Column(name = "DeliveryPatternCode")
    String deliveryPatternCode;
    @Column(name = "TimePeriodCode")
    String timePeriodCode;
    
	public Long gethSDRecordNumber() {
		return hSDRecordNumber;
	}
	public void sethSDRecordNumber(Long hSDRecordNumber) {
		this.hSDRecordNumber = hSDRecordNumber;
	}
	public int getRequestId() {
		return requestId;
	}
	public void setRequestId(int requestId) {
		this.requestId = requestId;
	}
	public String getLoopCode() {
		return loopCode;
	}
	public void setLoopCode(String loopCode) {
		this.loopCode = loopCode;
	}
	public String getLoopNumber() {
		return loopNumber;
	}
	public void setLoopNumber(String loopNumber) {
		this.loopNumber = loopNumber;
	}
	public String getSequenceNumber() {
		return sequenceNumber;
	}
	public void setSequenceNumber(String sequenceNumber) {
		this.sequenceNumber = sequenceNumber;
	}
	public String getQuantityQualifierCode() {
		return quantityQualifierCode;
	}
	public void setQuantityQualifierCode(String quantityQualifierCode) {
		this.quantityQualifierCode = quantityQualifierCode;
	}
	public String getQuantity() {
		return quantity;
	}
	public void setQuantity(String quantity) {
		this.quantity = quantity;
	}
	public String getUnitCode() {
		return unitCode;
	}
	public void setUnitCode(String unitCode) {
		this.unitCode = unitCode;
	}
	public String getFrequency() {
		return frequency;
	}
	public void setFrequency(String frequency) {
		this.frequency = frequency;
	}
	public String getNumberofPeriods() {
		return numberofPeriods;
	}
	public void setNumberofPeriods(String numberofPeriods) {
		this.numberofPeriods = numberofPeriods;
	}
	public String getDeliveryCode() {
		return deliveryCode;
	}
	public void setDeliveryCode(String deliveryCode) {
		this.deliveryCode = deliveryCode;
	}
	public String getDeliveryPatternCode() {
		return deliveryPatternCode;
	}
	public void setDeliveryPatternCode(String deliveryPatternCode) {
		this.deliveryPatternCode = deliveryPatternCode;
	}
	public String getTimePeriodCode() {
		return timePeriodCode;
	}
	public void setTimePeriodCode(String timePeriodCode) {
		this.timePeriodCode = timePeriodCode;
	}
    
	
    
}