package va.gov.jpa.dto;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;



@Entity
@Table(name = "HealthServicesReview") // @Table is optional, but "user" is a keyword in many SQL variants */
@NamedQueries({
	@NamedQuery(name = "HealthServicesReview.findHealthReviewByReqId", query = "select alog from HealthServicesReview alog where alog.requestId=:rid and alog.loopCode=:lcode and alog.loopNumber=:lno  ")

					
})

public class HealthServicesReview implements java.io.Serializable{
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)  
	@Column(name = "UMRecordNumber", unique = true, nullable = false)
	Long addressRecordNumber;   
	@Column(name = "RequestId")
    int requestId;  
	@Column(name = "LoopCode")
    String loopCode;
   	@Column(name = "LoopNumber")
    String loopNumber;
   	@Column(name = "SequenceNumber")
    String sequenceNumber;
   	@Column(name = "RequestCategCode")
    String requestCategCode;
 	@Column(name = "CertificationType")
    String certificationType;
   	
   	@Column(name = "ServicesTypeCode")
    String servicesTypeCode;
   	@Column(name = "Facility")
    String facility;
    @Column(name = "FacilityQualifier")
    String facilityQualifier;
    @Column(name = "RelatedCauseCode1")
    String relatedCauseCode1;
    @Column(name = "RelatedCauseCode2")
    String relatedCauseCode2;
    @Column(name = "RelatedCauseCode3")
    String relatedCauseCode3;
    @Column(name = "StateProvCode")
    String stateProvCode;
    @Column(name = "CountryCode")
    String countryCode;
    @Column(name = "LevelOfServiceCode")
    String levelOfServiceCode;   
    @Column(name = "CurrentHealthConditionCode")
    String currentHealthConditionCode;
    @Column(name = "PrognosisCode")
    String prognosisCode;
    @Column(name = "ReleaseOfInformationCode")
    String releaseOfInformationCode;
    @Column(name = "DelayReasonCode")
    String delayReasonCode;
	public Long getAddressRecordNumber() {
		return addressRecordNumber;
	}
	public void setAddressRecordNumber(Long addressRecordNumber) {
		this.addressRecordNumber = addressRecordNumber;
	}
	
	public int getRequestId() {
		return requestId;
	}
	public void setRequestId(int requestId) {
		this.requestId = requestId;
	}
	public String getLoopCode() {
		return loopCode;
	}
	public void setLoopCode(String loopCode) {
		this.loopCode = loopCode;
	}
	public String getLoopNumber() {
		return loopNumber;
	}
	public void setLoopNumber(String loopNumber) {
		this.loopNumber = loopNumber;
	}
	public String getSequenceNumber() {
		return sequenceNumber;
	}
	public void setSequenceNumber(String sequenceNumber) {
		this.sequenceNumber = sequenceNumber;
	}
	
	public String getRequestCategCode() {
		return requestCategCode;
	}
	public void setRequestCategCode(String requestCategCode) {
		this.requestCategCode = requestCategCode;
	}
	public String getServicesTypeCode() {
		return servicesTypeCode;
	}
	public void setServicesTypeCode(String servicesTypeCode) {
		this.servicesTypeCode = servicesTypeCode;
	}
	public String getFacility() {
		return facility;
	}
	public void setFacility(String facility) {
		this.facility = facility;
	}
	public String getFacilityQualifier() {
		return facilityQualifier;
	}
	public void setFacilityQualifier(String facilityQualifier) {
		this.facilityQualifier = facilityQualifier;
	}
	public String getRelatedCauseCode1() {
		return relatedCauseCode1;
	}
	public void setRelatedCauseCode1(String relatedCauseCode1) {
		this.relatedCauseCode1 = relatedCauseCode1;
	}
	public String getRelatedCauseCode2() {
		return relatedCauseCode2;
	}
	public void setRelatedCauseCode2(String relatedCauseCode2) {
		this.relatedCauseCode2 = relatedCauseCode2;
	}
	public String getRelatedCauseCode3() {
		return relatedCauseCode3;
	}
	public void setRelatedCauseCode3(String relatedCauseCode3) {
		this.relatedCauseCode3 = relatedCauseCode3;
	}
	public String getStateProvCode() {
		return stateProvCode;
	}
	public void setStateProvCode(String stateProvCode) {
		this.stateProvCode = stateProvCode;
	}
	public String getCountryCode() {
		return countryCode;
	}
	public void setCountryCode(String countryCode) {
		this.countryCode = countryCode;
	}
	public String getLevelOfServiceCode() {
		return levelOfServiceCode;
	}
	public void setLevelOfServiceCode(String levelOfServiceCode) {
		this.levelOfServiceCode = levelOfServiceCode;
	}
	public String getCurrentHealthConditionCode() {
		return currentHealthConditionCode;
	}
	public void setCurrentHealthConditionCode(String currentHealthConditionCode) {
		this.currentHealthConditionCode = currentHealthConditionCode;
	}
	public String getPrognosisCode() {
		return prognosisCode;
	}
	public void setPrognosisCode(String prognosisCode) {
		this.prognosisCode = prognosisCode;
	}
	public String getReleaseOfInformationCode() {
		return releaseOfInformationCode;
	}
	public void setReleaseOfInformationCode(String releaseOfInformationCode) {
		this.releaseOfInformationCode = releaseOfInformationCode;
	}
	public String getDelayReasonCode() {
		return delayReasonCode;
	}
	public void setDelayReasonCode(String delayReasonCode) {
		this.delayReasonCode = delayReasonCode;
	}
	public String getCertificationType() {
		return certificationType;
	}
	public void setCertificationType(String certificationType) {
		this.certificationType = certificationType;
	}
    
    
	
}