package va.gov.jpa.dto;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;



@Entity
@Table(name = "HomeHealthCare") // @Table is optional, but "user" is a keyword in many SQL variants */
@NamedQueries({
	@NamedQuery(name = "HomeHealthCare.findHomeHealthCareByReqIdlcode", query = "select alog from HomeHealthCare alog where alog.requestId=:rid and alog.loopCode=:lcode and alog.loopNumber=:lnumber")

					
})

public class HomeHealthCare implements java.io.Serializable{
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)  
	@Column(name = "CR6RecordNumber", unique = true, nullable = false)
	Long cR6RecordNumber;   
	@Column(name = "RequestId")
    int requestId;
 	@Column(name = "LoopCode")
    String loopCode;
   	@Column(name = "LoopNumber")
    String loopNumber;
   	@Column(name = "SequenceNumber")
    String sequenceNumber;
   	@Column(name = "PrognosisCode")
    String prognosisCode;
   	@Column(name = "ServiceStartDate")
    String prognoisisDate;
   	@Column(name = "DateTimeQualifier1")
    String dateTimeQualifier1;
    @Column(name = "DateTimePeriod1")
    String dateTimePeriod1;
    @Column(name = "YesNo")
    String yesNo;
    @Column(name = "CertificationTypeCode")
    String certificationTypeCode;
    @Column(name = "SurgeryDate")
    String surgeryDate;
    @Column(name = "ProductServiceIDQualifier")
    String productServiceIDQualifier;
    @Column(name = "MedicalCareValue")
    String medicalCareValue;
    @Column(name = "OrdersReceivedDate")
    String ordersReceivedDate;
    @Column(name = "LastVisitDate")
    String lastVisitDate;   
    @Column(name = "PhysicianContactDate")
    String physicianContactDate;
    @Column(name = "DateTimeQualifier")
    String dateTimeQualifier2;
    @Column(name = "DateTimePeriod")
    String dateTimePeriod2;
    
	public Long getcR6RecordNumber() {
		return cR6RecordNumber;
	}
	public void setcR6RecordNumber(Long cR6RecordNumber) {
		this.cR6RecordNumber = cR6RecordNumber;
	}
	
	public int getRequestId() {
		return requestId;
	}
	public void setRequestId(int requestId) {
		this.requestId = requestId;
	}
	public String getLoopCode() {
		return loopCode;
	}
	public void setLoopCode(String loopCode) {
		this.loopCode = loopCode;
	}
	public String getLoopNumber() {
		return loopNumber;
	}
	public void setLoopNumber(String loopNumber) {
		this.loopNumber = loopNumber;
	}
	public String getSequenceNumber() {
		return sequenceNumber;
	}
	public void setSequenceNumber(String sequenceNumber) {
		this.sequenceNumber = sequenceNumber;
	}
	public String getPrognosisCode() {
		return prognosisCode;
	}
	public void setPrognosisCode(String prognosisCode) {
		this.prognosisCode = prognosisCode;
	}
	public String getPrognoisisDate() {
		return prognoisisDate;
	}
	public void setPrognoisisDate(String prognoisisDate) {
		this.prognoisisDate = prognoisisDate;
	}
	public String getDateTimeQualifier1() {
		return dateTimeQualifier1;
	}
	public void setDateTimeQualifier1(String dateTimeQualifier1) {
		this.dateTimeQualifier1 = dateTimeQualifier1;
	}
	public String getDateTimePeriod1() {
		return dateTimePeriod1;
	}
	public void setDateTimePeriod1(String dateTimePeriod1) {
		this.dateTimePeriod1 = dateTimePeriod1;
	}
	public String getYesNo() {
		return yesNo;
	}
	public void setYesNo(String yesNo) {
		this.yesNo = yesNo;
	}
	public String getCertificationTypeCode() {
		return certificationTypeCode;
	}
	public void setCertificationTypeCode(String certificationTypeCode) {
		this.certificationTypeCode = certificationTypeCode;
	}
	public String getSurgeryDate() {
		return surgeryDate;
	}
	public void setSurgeryDate(String surgeryDate) {
		this.surgeryDate = surgeryDate;
	}
	public String getProductServiceIDQualifier() {
		return productServiceIDQualifier;
	}
	public void setProductServiceIDQualifier(String productServiceIDQualifier) {
		this.productServiceIDQualifier = productServiceIDQualifier;
	}
	public String getMedicalCareValue() {
		return medicalCareValue;
	}
	public void setMedicalCareValue(String medicalCareValue) {
		this.medicalCareValue = medicalCareValue;
	}
	public String getOrdersReceivedDate() {
		return ordersReceivedDate;
	}
	public void setOrdersReceivedDate(String ordersReceivedDate) {
		this.ordersReceivedDate = ordersReceivedDate;
	}
	public String getLastVisitDate() {
		return lastVisitDate;
	}
	public void setLastVisitDate(String lastVisitDate) {
		this.lastVisitDate = lastVisitDate;
	}
	public String getPhysicianContactDate() {
		return physicianContactDate;
	}
	public void setPhysicianContactDate(String physicianContactDate) {
		this.physicianContactDate = physicianContactDate;
	}
	
	public String getDateTimePeriod2() {
		return dateTimePeriod2;
	}
	public void setDateTimePeriod2(String dateTimePeriod2) {
		this.dateTimePeriod2 = dateTimePeriod2;
	}
	public String getDateTimeQualifier2() {
		return dateTimeQualifier2;
	}
	public void setDateTimeQualifier2(String dateTimeQualifier2) {
		this.dateTimeQualifier2 = dateTimeQualifier2;
	}
	
    
    
    
  
}