package va.gov.jpa.dto;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;



@Entity
@Table(name = "HomeOxygenTherapy") // @genTable is optional, but "user" is a keyword in many SQL variants */
@NamedQueries({
	@NamedQuery(name = "HomeOxygenTherapy.findHomeOxygenByReqIdlcode", query = "select alog from HomeOxygenTherapy alog where alog.requestId=:rid and  alog.loopCode=:lcode")

					
})

public class HomeOxygenTherapy implements java.io.Serializable{
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)  
	@Column(name = "CR5RecordNumber", unique = true, nullable = false)
	Long cR5RecordNumber;   
	@Column(name = "RequestId")
    int requestId; 
	@Column(name = "LoopCode")
    String loopCode;
   	@Column(name = "LoopNumber")
    String loopNumber;
   	@Column(name = "SequenceNumber")
    String sequenceNumber;
   	@Column(name = "OxygenEquipmentCode1")
    String oxygenEquimentCode1;
   	@Column(name = "OxygenEquipmentCode2")
    String oxygenEquimentCode2;
   	@Column(name = "Description1")
    String description1;
    @Column(name = "Quantity1")
    String quantity1;
    @Column(name = "Quantity2")
    String quantity2;
    @Column(name = "Quantity3")
    String quantity3;
    @Column(name = "Description2")
    String description2;
    @Column(name = "Quantity4")
    String quantity4;
    @Column(name = "Quantity5")
    String quantity5;
    @Column(name = "OxygenTestConditionCode")
    String oxygenTestCondCode;
    @Column(name = "OxygenTestCodeFind1")
    String oxygenTestFindCode1;   
    @Column(name = "OxygenTestCodeFind2")
    String oxygenTestFindCode2;
    @Column(name = "OxygenTestCodeFind3")
    String OxygenTestFindCode3;
    @Column(name = "Quantity6")
    String quantity6;
    @Column(name = "OxygenSystemDeliveryCode")
    String oxygenDeliverySystemCode;
    @Column(name = "OxygenEquipmentCode")
    String OxygenEquimentCode;
	public Long getcR5RecordNumber() {
		return cR5RecordNumber;
	}
	public void setcR5RecordNumber(Long cR5RecordNumber) {
		this.cR5RecordNumber = cR5RecordNumber;
	}
	
	public int getRequestId() {
		return requestId;
	}
	public void setRequestId(int requestId) {
		this.requestId = requestId;
	}
	public String getLoopCode() {
		return loopCode;
	}
	public void setLoopCode(String loopCode) {
		this.loopCode = loopCode;
	}
	public String getLoopNumber() {
		return loopNumber;
	}
	public void setLoopNumber(String loopNumber) {
		this.loopNumber = loopNumber;
	}
	public String getSequenceNumber() {
		return sequenceNumber;
	}
	public void setSequenceNumber(String sequenceNumber) {
		this.sequenceNumber = sequenceNumber;
	}
	public String getOxygenEquimentCode1() {
		return oxygenEquimentCode1;
	}
	public void setOxygenEquimentCode1(String oxygenEquimentCode1) {
		this.oxygenEquimentCode1 = oxygenEquimentCode1;
	}
	public String getOxygenEquimentCode2() {
		return oxygenEquimentCode2;
	}
	public void setOxygenEquimentCode2(String oxygenEquimentCode2) {
		this.oxygenEquimentCode2 = oxygenEquimentCode2;
	}
	public String getDescription1() {
		return description1;
	}
	public void setDescription1(String description1) {
		this.description1 = description1;
	}
	public String getQuantity1() {
		return quantity1;
	}
	public void setQuantity1(String quantity1) {
		this.quantity1 = quantity1;
	}
	public String getQuantity2() {
		return quantity2;
	}
	public void setQuantity2(String quantity2) {
		this.quantity2 = quantity2;
	}
	public String getQuantity3() {
		return quantity3;
	}
	public void setQuantity3(String quantity3) {
		this.quantity3 = quantity3;
	}
	public String getDescription2() {
		return description2;
	}
	public void setDescription2(String description2) {
		this.description2 = description2;
	}
	public String getQuantity4() {
		return quantity4;
	}
	public void setQuantity4(String quantity4) {
		this.quantity4 = quantity4;
	}
	public String getQuantity5() {
		return quantity5;
	}
	public void setQuantity5(String quantity5) {
		this.quantity5 = quantity5;
	}
	public String getOxygenTestCondCode() {
		return oxygenTestCondCode;
	}
	public void setOxygenTestCondCode(String oxygenTestCondCode) {
		this.oxygenTestCondCode = oxygenTestCondCode;
	}
	public String getOxygenTestFindCode1() {
		return oxygenTestFindCode1;
	}
	public void setOxygenTestFindCode1(String oxygenTestFindCode1) {
		this.oxygenTestFindCode1 = oxygenTestFindCode1;
	}
	public String getOxygenTestFindCode2() {
		return oxygenTestFindCode2;
	}
	public void setOxygenTestFindCode2(String oxygenTestFindCode2) {
		this.oxygenTestFindCode2 = oxygenTestFindCode2;
	}
	public String getOxygenTestFindCode3() {
		return OxygenTestFindCode3;
	}
	public void setOxygenTestFindCode3(String oxygenTestFindCode3) {
		OxygenTestFindCode3 = oxygenTestFindCode3;
	}
	public String getQuantity6() {
		return quantity6;
	}
	public void setQuantity6(String quantity6) {
		this.quantity6 = quantity6;
	}
	public String getOxygenDeliverySystemCode() {
		return oxygenDeliverySystemCode;
	}
	public void setOxygenDeliverySystemCode(String oxygenDeliverySystemCode) {
		this.oxygenDeliverySystemCode = oxygenDeliverySystemCode;
	}
	public String getOxygenEquimentCode() {
		return OxygenEquimentCode;
	}
	public void setOxygenEquimentCode(String oxygenEquimentCode) {
		OxygenEquimentCode = oxygenEquimentCode;
	}
	
    
	
  
}