package va.gov.jpa.dto;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;



@Entity
@Table(name = "InstitutionClaim") // @genTable is optional, but "user" is a keyword in many SQL variants */
@NamedQueries({
	@NamedQuery(name = "InstitutionClaim.findInstitutionClaimByReqIdlcode", query = "select alog from InstitutionClaim alog where alog.requestId=:rid and  alog.loopCode=:lcode")

					
})

public class InstitutionClaim implements java.io.Serializable{
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)  
	@Column(name = "CL1RecordNumber", unique = true, nullable = false)
	Long cL1RecordNumber;   
	@Column(name = "RequestId")
    int requestId; 
	@Column(name = "LoopCode")
    String loopCode;
   	@Column(name = "LoopNumber")
    String loopNumber;
   	@Column(name = "SequenceNumber")
    String sequenceNumber;
   	@Column(name = "AddmissionTypeCode")
    String addmissionTypeCode;
   	@Column(name = "AddmissionSourceCode")
    String addmissionSourceCode;
   	@Column(name = "PatientStatusCode")
    String patientStatusCode;
    @Column(name = "ResidentialStatusCode")
    String residentialStatusCode;
    
	public Long getcL1RecordNumber() {
		return cL1RecordNumber;
	}
	public void setcL1RecordNumber(Long cL1RecordNumber) {
		this.cL1RecordNumber = cL1RecordNumber;
	}
	
	public int getRequestId() {
		return requestId;
	}
	public void setRequestId(int requestId) {
		this.requestId = requestId;
	}
	public String getLoopCode() {
		return loopCode;
	}
	public void setLoopCode(String loopCode) {
		this.loopCode = loopCode;
	}
	public String getLoopNumber() {
		return loopNumber;
	}
	public void setLoopNumber(String loopNumber) {
		this.loopNumber = loopNumber;
	}
	public String getSequenceNumber() {
		return sequenceNumber;
	}
	public void setSequenceNumber(String sequenceNumber) {
		this.sequenceNumber = sequenceNumber;
	}
	public String getAddmissionTypeCode() {
		return addmissionTypeCode;
	}
	public void setAddmissionTypeCode(String addmissionTypeCode) {
		this.addmissionTypeCode = addmissionTypeCode;
	}
	public String getAddmissionSourceCode() {
		return addmissionSourceCode;
	}
	public void setAddmissionSourceCode(String addmissionSourceCode) {
		this.addmissionSourceCode = addmissionSourceCode;
	}
	public String getPatientStatusCode() {
		return patientStatusCode;
	}
	public void setPatientStatusCode(String patientStatusCode) {
		this.patientStatusCode = patientStatusCode;
	}
	public String getResidentialStatusCode() {
		return residentialStatusCode;
	}
	public void setResidentialStatusCode(String residentialStatusCode) {
		this.residentialStatusCode = residentialStatusCode;
	}
    
    
  
}