package va.gov.jpa.dto;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;



@Entity
@Table(name = "InsuranceInformation") // @genTable is optional, but "user" is a keyword in many SQL variants */
@NamedQueries({
	@NamedQuery(name = "InsuranceInformation.findInsByReqId", query = "select alog from InsuranceInformation alog where alog.requestId=:rid and alog.loopCode=:lcode")

					
})

public class InsuranceInformation implements java.io.Serializable{
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)  
	@Column(name = "INSRecordNumber", unique = true, nullable = false)
	Long iNSRecordNumber;   
	@Column(name = "RequestId")
    int requestId; 
	@Column(name = "LoopCode")
    String loopCode;
   	@Column(name = "LoopNumber")
    String loopNumber;
   	@Column(name = "SequenceNumber")
    String sequenceNumber;
   	@Column(name = "YesNo")
    String yesNoCode;
   	@Column(name = "IndiviualRelationshipCode")
    String individualRelationshipCode;
   	@Column(name = "EmploymentStatusCode")
    String employmentStatusCode;
    @Column(name = "Number")
    String Number;
	public Long getiNSRecordNumber() {
		return iNSRecordNumber;
	}
	public void setiNSRecordNumber(Long iNSRecordNumber) {
		this.iNSRecordNumber = iNSRecordNumber;
	}
	
	public int getRequestId() {
		return requestId;
	}
	public void setRequestId(int requestId) {
		this.requestId = requestId;
	}
	public String getLoopCode() {
		return loopCode;
	}
	public void setLoopCode(String loopCode) {
		this.loopCode = loopCode;
	}
	public String getLoopNumber() {
		return loopNumber;
	}
	public void setLoopNumber(String loopNumber) {
		this.loopNumber = loopNumber;
	}
	public String getSequenceNumber() {
		return sequenceNumber;
	}
	public void setSequenceNumber(String sequenceNumber) {
		this.sequenceNumber = sequenceNumber;
	}
	public String getYesNoCode() {
		return yesNoCode;
	}
	public void setYesNoCode(String yesNoCode) {
		this.yesNoCode = yesNoCode;
	}
	public String getIndividualRelationshipCode() {
		return individualRelationshipCode;
	}
	public void setIndividualRelationshipCode(String individualRelationshipCode) {
		this.individualRelationshipCode = individualRelationshipCode;
	}
	public String getEmploymentStatusCode() {
		return employmentStatusCode;
	}
	public void setEmploymentStatusCode(String employmentStatusCode) {
		this.employmentStatusCode = employmentStatusCode;
	}
	public String getNumber() {
		return Number;
	}
	public void setNumber(String number) {
		Number = number;
	}
    
	
    
    
  
}