package va.gov.jpa.dto;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;



@Entity
@Table(name = "PatientInformation") // @genTable is optional, but "user" is a keyword in many SQL variants */
@NamedQueries({
	@NamedQuery(name = "PatientInformation.findAdditionalByRidLcode", query = "select alog from PatientInformation alog where alog.requestId=:rid and  alog.loopCode=:lcode")

					
})

public class PatientInformation implements java.io.Serializable{
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)  
	@Column(name = "PWKRecordNumber", unique = true, nullable = false)
	Long pWKRecordNumber;   
	@Column(name = "RequestId")
    int requestId;  
	@Column(name = "LoopCode")
    String loopCode;
   	@Column(name = "LoopNumber")
    String loopNumber;
   	@Column(name = "SequenceNumber")
    String sequenceNumber;
   	@Column(name = "ReportTypeCode")
    String reportTypeCode;
   	@Column(name = "ReportTransCode")
    String reportTransmCode;
   	@Column(name = "IDCodeQualifier")
    String iDCodeQualifier;
   	@Column(name = "Identifier")
    String identifier;
	@Column(name = "Description")
    String description;
	public Long getpWKRecordNumber() {
		return pWKRecordNumber;
	}
	public void setpWKRecordNumber(Long pWKRecordNumber) {
		this.pWKRecordNumber = pWKRecordNumber;
	}
	
	public int getRequestId() {
		return requestId;
	}
	public void setRequestId(int requestId) {
		this.requestId = requestId;
	}
	public String getLoopCode() {
		return loopCode;
	}
	public void setLoopCode(String loopCode) {
		this.loopCode = loopCode;
	}
	public String getLoopNumber() {
		return loopNumber;
	}
	public void setLoopNumber(String loopNumber) {
		this.loopNumber = loopNumber;
	}
	public String getSequenceNumber() {
		return sequenceNumber;
	}
	public void setSequenceNumber(String sequenceNumber) {
		this.sequenceNumber = sequenceNumber;
	}
	public String getReportTypeCode() {
		return reportTypeCode;
	}
	public void setReportTypeCode(String reportTypeCode) {
		this.reportTypeCode = reportTypeCode;
	}
	public String getReportTransmCode() {
		return reportTransmCode;
	}
	public void setReportTransmCode(String reportTransmCode) {
		this.reportTransmCode = reportTransmCode;
	}
	public String getiDCodeQualifier() {
		return iDCodeQualifier;
	}
	public void setiDCodeQualifier(String iDCodeQualifier) {
		this.iDCodeQualifier = iDCodeQualifier;
	}
	public String getIdentifier() {
		return identifier;
	}
	public void setIdentifier(String identifier) {
		this.identifier = identifier;
	}
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
   	
	
   	
   	
}