package va.gov.jpa.dto;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;



@Entity
@Table(name = "ProviderInformation") // @genTable is optional, but "user" is a keyword in many SQL variants */
@NamedQueries({
	@NamedQuery(name = "ProviderInformation.findProviderByReqIdLoopCode", query = "select alog from ProviderInformation alog where alog.requestId=:rid and alog.loopCode=:lcode")

					
})

public class ProviderInformation implements java.io.Serializable{
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)  
	@Column(name = "PRVRecordNumber", unique = true, nullable = false)
	Long pRVRecordNumber;   
	@Column(name = "RequestId")
    int requestId;  
	@Column(name = "LoopCode")
    String loopCode;
   	@Column(name = "LoopNumber")
    String loopNumber;
   	@Column(name = "SequenceNumber")
    String sequenceNumber;
   	@Column(name = "ProviderCode")
    String providerCode;
   	@Column(name = "ReferenceIdentificationQualifier")
    String referenceIdentificationQualifier;
   	@Column(name = "ReferenceIdent")
    String refererenceIdent;
	public Long getpRVRecordNumber() {
		return pRVRecordNumber;
	}
	public void setpRVRecordNumber(Long pRVRecordNumber) {
		this.pRVRecordNumber = pRVRecordNumber;
	}
	
	public int getRequestId() {
		return requestId;
	}
	public void setRequestId(int requestId) {
		this.requestId = requestId;
	}
	public String getLoopCode() {
		return loopCode;
	}
	public void setLoopCode(String loopCode) {
		this.loopCode = loopCode;
	}
	public String getLoopNumber() {
		return loopNumber;
	}
	public void setLoopNumber(String loopNumber) {
		this.loopNumber = loopNumber;
	}
	public String getSequenceNumber() {
		return sequenceNumber;
	}
	public void setSequenceNumber(String sequenceNumber) {
		this.sequenceNumber = sequenceNumber;
	}
	public String getProviderCode() {
		return providerCode;
	}
	public void setProviderCode(String providerCode) {
		this.providerCode = providerCode;
	}
	public String getReferenceIdentificationQualifier() {
		return referenceIdentificationQualifier;
	}
	public void setReferenceIdentificationQualifier(String referenceIdentificationQualifier) {
		this.referenceIdentificationQualifier = referenceIdentificationQualifier;
	}
	public String getRefererenceIdent() {
		return refererenceIdent;
	}
	public void setRefererenceIdent(String refererenceIdent) {
		this.refererenceIdent = refererenceIdent;
	}
   	
   	
}