package va.gov.jpa.dto;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;



@Entity
@Table(name = "Reference") // @genTable is optional, but "user" is a keyword in many SQL variants */
@NamedQueries({
	@NamedQuery(name = "References.findReferencesByReqIdLoopCode", query = "select alog from References alog where alog.requestId=:rid and alog.loopCode=:loopCode")

					
})

public class References implements java.io.Serializable{
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)  
	@Column(name = "REFRecordNumber", unique = true, nullable = false)
	Long rEFRecordNumber;   
	@Column(name = "RequestId")
    int requestId; 
	@Column(name = "LoopCode")
    String loopCode;
   	@Column(name = "LoopNumber")
    String loopNumber;
   	@Column(name = "SequenceNumber")
    String sequenceNumber;
   	@Column(name = "ReferenceIdQualifier")
    String referenceIdQualifier;
   	@Column(name = "ReferenceId")
    String referenceId;
	public Long getrEFRecordNumber() {
		return rEFRecordNumber;
	}
	public void setrEFRecordNumber(Long rEFRecordNumber) {
		this.rEFRecordNumber = rEFRecordNumber;
	}

	public int getRequestId() {
		return requestId;
	}
	public void setRequestId(int requestId) {
		this.requestId = requestId;
	}
	public String getLoopCode() {
		return loopCode;
	}
	public void setLoopCode(String loopCode) {
		this.loopCode = loopCode;
	}
	public String getLoopNumber() {
		return loopNumber;
	}
	public void setLoopNumber(String loopNumber) {
		this.loopNumber = loopNumber;
	}
	public String getSequenceNumber() {
		return sequenceNumber;
	}
	public void setSequenceNumber(String sequenceNumber) {
		this.sequenceNumber = sequenceNumber;
	}
	public String getReferenceIdQualifier() {
		return referenceIdQualifier;
	}
	public void setReferenceIdQualifier(String referenceIdQualifier) {
		this.referenceIdQualifier = referenceIdQualifier;
	}
	public String getReferenceId() {
		return referenceId;
	}
	public void setReferenceId(String referenceId) {
		this.referenceId = referenceId;
	}
   
   	
   	
}