package va.gov.jpa.dto;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;



@Entity
@Table(name = "ResponseLog") // @Table is optional, but "user" is a keyword in many SQL variants */
@NamedQueries({
	@NamedQuery(name = "ResponseLog.findQueueList", query = "select aque from ResponseLog aque"),
	@NamedQuery(name = "ResponseLog.findQueueNameById", query = "select aque from ResponseLog aque where aque.queueId=:Id and aque.stationId=:sid"),
	@NamedQuery(name = "ResponseLog.findPatientById", query = "select aque from ResponseLog aque where aque.queueId=:Id and aque.stationId=:sid"),	
	@NamedQuery(name = "ResponseLog.findARPSQueueByReqId", query = "select aque from ResponseLog aque where aque.requestId=:rId")

					
})

public class ResponseLog implements java.io.Serializable{
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)  
	@Column(name = "ResponseId", unique = true, nullable = false)
	int responseId;   
	@Column(name = "RequestId")
    int requestId;
	@Column(name = "ResponseSent")
	Date responseSent ;
	@Column(name = "QueueId")
	int queueId ;
	@Column(name = "Sta3n")
	String stationId ;
	@Column(name = "AssignedStationInstCode")
	String assignedStationInstCode ;
	
	
	public int getResponseId() {
		return responseId;
	}
	public void setResponseId(int responseId) {
		this.responseId = responseId;
	}
	public int getRequestId() {
		return requestId;
	}
	public void setRequestId(int requestId) {
		this.requestId = requestId;
	}
	public String getStationId() {
		return stationId;
	}
	public void setStationId(String stationId) {
		this.stationId = stationId;
	}
	
	public Date getResponseSent() {
		return responseSent;
	}
	public void setResponseSent(Date responseSent) {
		this.responseSent = responseSent;
	}
	public int getQueueId() {
		return queueId;
	}
	public void setQueueId(int queueId) {
		this.queueId = queueId;
	}
	public String getAssignedStationInstCode() {
		return assignedStationInstCode;
	}
	public void setAssignedStationInstCode(String assignedStationInstCode) {
		this.assignedStationInstCode = assignedStationInstCode;
	}
	
	
	
	
   
		
}