package va.gov.jpa.dto;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;



@Entity
@Table(name = "ServicesDental") // @genTable is optional, but "user" is a keyword in many SQL variants */
@NamedQueries({
	@NamedQuery(name = "ServicesDental.findToothByReqIdlcode", query = "select alog from ServicesDental alog where alog.requestId=:rid and alog.loopCode=:lcode")

					
})

public class ServicesDental implements java.io.Serializable{
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)  
	@Column(name = "SV3RecordNumber", unique = true, nullable = false)
	Long SV3RecordNumber;   
	@Column(name = "RequestId")
    int requestId;  
	@Column(name = "LoopCode")
    String loopCode;
   	@Column(name = "LoopNumber")
    String loopNumber;
   	@Column(name = "SequenceNumber")
    String sequenceNumber; 	
   	@Column(name = "ProductServiceIDQualifier")
    String productServiceIDQualifier;
   	@Column(name = "ProductServiceID1")
    String productServiceID1;
   	@Column(name = "ProcedureModifier1")
    String procedureModifier1;	
 	@Column(name = "ProcedureModifier2")
    String ProcedureModifier2;
   	@Column(name = "ProcedureModifier3")
    String ProcedureModifier3;
   	@Column(name = "ProcedureModifier4")
    String ProcedureModifier4; 	
   	@Column(name = "Description1")
    String description1;
   	@Column(name = "MonetaryAmount")
    String monetaryAmount;	
 	@Column(name = "OralCavityDesignationCode1")
    String cavityDesignationCode1;
   	@Column(name = "OralCavityDesignationCode2")
    String cavityDesignationCode2;
   	@Column(name = "OralCavityDesignationCode3")
    String cavityDesignationCode3;
   	@Column(name = "OralCavityDesignationCode4")
    String cavityDesignationCode4;
   	@Column(name = "OralCavityDesignationCode5")
    String cavityDesignationCode5; 	
   	@Column(name = "ProsrhesisCrownInlayCode")
    String prosrhesisCrownInlayCode;
   	@Column(name = "Quantity")
    String quantity;
   	@Column(name = "IsResponse")
    int isResponse;
		
	public Long getSV3RecordNumber() {
		return SV3RecordNumber;
	}
	public void setSV3RecordNumber(Long sV3RecordNumber) {
		SV3RecordNumber = sV3RecordNumber;
	}
	public int getRequestId() {
		return requestId;
	}
	public void setRequestId(int requestId) {
		this.requestId = requestId;
	}
	public String getLoopCode() {
		return loopCode;
	}
	public void setLoopCode(String loopCode) {
		this.loopCode = loopCode;
	}
	public String getLoopNumber() {
		return loopNumber;
	}
	public void setLoopNumber(String loopNumber) {
		this.loopNumber = loopNumber;
	}
	public String getSequenceNumber() {
		return sequenceNumber;
	}
	public void setSequenceNumber(String sequenceNumber) {
		this.sequenceNumber = sequenceNumber;
	}
	public String getProductServiceIDQualifier() {
		return productServiceIDQualifier;
	}
	public void setProductServiceIDQualifier(String productServiceIDQualifier) {
		this.productServiceIDQualifier = productServiceIDQualifier;
	}
	public String getProductServiceID1() {
		return productServiceID1;
	}
	public void setProductServiceID1(String productServiceID1) {
		this.productServiceID1 = productServiceID1;
	}
	public String getProcedureModifier1() {
		return procedureModifier1;
	}
	public void setProcedureModifier1(String procedureModifier1) {
		this.procedureModifier1 = procedureModifier1;
	}
	public String getProcedureModifier2() {
		return ProcedureModifier2;
	}
	public void setProcedureModifier2(String procedureModifier2) {
		ProcedureModifier2 = procedureModifier2;
	}
	public String getProcedureModifier3() {
		return ProcedureModifier3;
	}
	public void setProcedureModifier3(String procedureModifier3) {
		ProcedureModifier3 = procedureModifier3;
	}
	public String getProcedureModifier4() {
		return ProcedureModifier4;
	}
	public void setProcedureModifier4(String procedureModifier4) {
		ProcedureModifier4 = procedureModifier4;
	}
	public String getDescription1() {
		return description1;
	}
	public void setDescription1(String description1) {
		this.description1 = description1;
	}
	
	public String getMonetaryAmount() {
		return monetaryAmount;
	}
	public void setMonetaryAmount(String monetaryAmount) {
		this.monetaryAmount = monetaryAmount;
	}
	public String getCavityDesignationCode1() {
		return cavityDesignationCode1;
	}
	public void setCavityDesignationCode1(String cavityDesignationCode1) {
		this.cavityDesignationCode1 = cavityDesignationCode1;
	}
	public String getCavityDesignationCode2() {
		return cavityDesignationCode2;
	}
	public void setCavityDesignationCode2(String cavityDesignationCode2) {
		this.cavityDesignationCode2 = cavityDesignationCode2;
	}
	public String getCavityDesignationCode3() {
		return cavityDesignationCode3;
	}
	public void setCavityDesignationCode3(String cavityDesignationCode3) {
		this.cavityDesignationCode3 = cavityDesignationCode3;
	}
	public String getCavityDesignationCode4() {
		return cavityDesignationCode4;
	}
	public void setCavityDesignationCode4(String cavityDesignationCode4) {
		this.cavityDesignationCode4 = cavityDesignationCode4;
	}
	public String getCavityDesignationCode5() {
		return cavityDesignationCode5;
	}
	public void setCavityDesignationCode5(String cavityDesignationCode5) {
		this.cavityDesignationCode5 = cavityDesignationCode5;
	}
	public String getProsrhesisCrownInlayCode() {
		return prosrhesisCrownInlayCode;
	}
	public void setProsrhesisCrownInlayCode(String prosrhesisCrownInlayCode) {
		this.prosrhesisCrownInlayCode = prosrhesisCrownInlayCode;
	}
	public String getQuantity() {
		return quantity;
	}
	public void setQuantity(String quantity) {
		this.quantity = quantity;
	}
	public int getIsResponse() {
		return isResponse;
	}
	public void setIsResponse(int isResponse) {
		this.isResponse = isResponse;
	}
	
   	
  
   	
}