package va.gov.jpa.dto;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;



@Entity
@Table(name = "ServicesProfessional") // @genTable is optional, but "user" is a keyword in many SQL variants */
@NamedQueries({
	@NamedQuery(name = "ServicesProfessional.findToothByReqIdlcode", query = "select alog from ServicesProfessional alog where alog.requestId=:rid and  alog.loopCode=:lcode")

					
})

public class ServicesProfessional implements java.io.Serializable{
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)  
	@Column(name = "SV1RecordNumber", unique = true, nullable = false)
	Long sV1RecordNumber;   
	@Column(name = "RequestId")
    int requestId; 
	@Column(name = "LoopCode")
    String loopCode;
   	@Column(name = "LoopNumber")
    String loopNumber;
   	@Column(name = "SequenceNumber")
    String sequenceNumber; 	
   	@Column(name = "ProductServiceIDQualifier")
    String productServiceIDQualifier;
   	@Column(name = "ProductServiceID1")
    String productServiceID1;	
   	@Column(name = "ProcedureModifier1")
    String ProcedureModifier1;
 	@Column(name = "ProcedureModifier2")
    String ProcedureModifier2;
   	@Column(name = "ProcedureModifier3")
    String ProcedureModifier3;
   	@Column(name = "ProcedureModifier4")
    String ProcedureModifier4; 	
   	@Column(name = "Description")
    String description1;
   	@Column(name = "ProductServiceID2")
    String productServiceID2;
   	@Column(name = "MonetaryAmount")
    String monetaryAmount;	
 	@Column(name = "UnitCode")
    String unitCode;
   	@Column(name = "Quantity")
    String quantity;
   	@Column(name = "DiagnosisCodePointer1")
    String diagnosisCodePointer1;
   	@Column(name = "DiagnosisCodePointer2")
    String DiagnosisCodePointer2;
   	@Column(name = "DiagnosisCodePointer3")
    String diagnosisCodePointer3;
   	@Column(name = "DiagnosisCodePointer4")
    String DiagnosisCodePointer4;
   	@Column(name = "LevelOfCareCode")
    String levelOfCareCode;
	public Long getsV1RecordNumber() {
		return sV1RecordNumber;
	}
	public void setsV1RecordNumber(Long sV1RecordNumber) {
		this.sV1RecordNumber = sV1RecordNumber;
	}
	
	public int getRequestId() {
		return requestId;
	}
	public void setRequestId(int requestId) {
		this.requestId = requestId;
	}
	public String getLoopCode() {
		return loopCode;
	}
	public void setLoopCode(String loopCode) {
		this.loopCode = loopCode;
	}
	public String getLoopNumber() {
		return loopNumber;
	}
	public void setLoopNumber(String loopNumber) {
		this.loopNumber = loopNumber;
	}
	public String getSequenceNumber() {
		return sequenceNumber;
	}
	public void setSequenceNumber(String sequenceNumber) {
		this.sequenceNumber = sequenceNumber;
	}
	public String getProductServiceIDQualifier() {
		return productServiceIDQualifier;
	}
	public void setProductServiceIDQualifier(String productServiceIDQualifier) {
		this.productServiceIDQualifier = productServiceIDQualifier;
	}
	public String getProductServiceID1() {
		return productServiceID1;
	}
	public void setProductServiceID1(String productServiceID1) {
		this.productServiceID1 = productServiceID1;
	}
	public String getProcedureModifier1() {
		return ProcedureModifier1;
	}
	public void setProcedureModifier1(String procedureModifier1) {
		ProcedureModifier1 = procedureModifier1;
	}
	public String getProcedureModifier2() {
		return ProcedureModifier2;
	}
	public void setProcedureModifier2(String procedureModifier2) {
		ProcedureModifier2 = procedureModifier2;
	}
	public String getProcedureModifier3() {
		return ProcedureModifier3;
	}
	public void setProcedureModifier3(String procedureModifier3) {
		ProcedureModifier3 = procedureModifier3;
	}
	public String getProcedureModifier4() {
		return ProcedureModifier4;
	}
	public void setProcedureModifier4(String procedureModifier4) {
		ProcedureModifier4 = procedureModifier4;
	}
	public String getDescription1() {
		return description1;
	}
	public void setDescription1(String description1) {
		this.description1 = description1;
	}
	public String getProductServiceID2() {
		return productServiceID2;
	}
	public void setProductServiceID2(String productServiceID2) {
		this.productServiceID2 = productServiceID2;
	}
	public String getMonetaryAmount() {
		return monetaryAmount;
	}
	public void setMonetaryAmount(String monetaryAmount) {
		this.monetaryAmount = monetaryAmount;
	}
	public String getUnitCode() {
		return unitCode;
	}
	public void setUnitCode(String unitCode) {
		this.unitCode = unitCode;
	}
	public String getQuantity() {
		return quantity;
	}
	public void setQuantity(String quantity) {
		this.quantity = quantity;
	}
	public String getDiagnosisCodePointer1() {
		return diagnosisCodePointer1;
	}
	public void setDiagnosisCodePointer1(String diagnosisCodePointer1) {
		this.diagnosisCodePointer1 = diagnosisCodePointer1;
	}
	public String getDiagnosisCodePointer2() {
		return DiagnosisCodePointer2;
	}
	public void setDiagnosisCodePointer2(String diagnosisCodePointer2) {
		DiagnosisCodePointer2 = diagnosisCodePointer2;
	}
	public String getDiagnosisCodePointer3() {
		return diagnosisCodePointer3;
	}
	public void setDiagnosisCodePointer3(String diagnosisCodePointer3) {
		this.diagnosisCodePointer3 = diagnosisCodePointer3;
	}
	public String getDiagnosisCodePointer4() {
		return DiagnosisCodePointer4;
	}
	public void setDiagnosisCodePointer4(String diagnosisCodePointer4) {
		DiagnosisCodePointer4 = diagnosisCodePointer4;
	}
	public String getLevelOfCareCode() {
		return levelOfCareCode;
	}
	public void setLevelOfCareCode(String levelOfCareCode) {
		this.levelOfCareCode = levelOfCareCode;
	}
	
   	
}