package va.gov.jpa.dto;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;



@Entity
@Table(name = "SpinalInformation") // @genTable is optional, but "user" is a keyword in many SQL variants */
@NamedQueries({
	@NamedQuery(name = "SpinalInformation.findDateInforByReqIdlcode", query = "select alog from SpinalInformation alog where alog.requestId=:rid and  alog.loopCode=:lcode")

					
})

public class SpinalInformation implements java.io.Serializable{
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)  
	@Column(name = "CR2RecordNumber", unique = true, nullable = false)
	Long cR2RecordNumber;   
	@Column(name = "RequestId")
    int requestId;  
	@Column(name = "LoopCode")
    String loopCode;
   	@Column(name = "LoopNumber")
    String loopNumber;
   	@Column(name = "SequenceNumber")
    String sequenceNumber; 	
   	@Column(name = "Count")
    String count;
   	@Column(name = "Quantity")
    String quantity;	
   	@Column(name = "SubluxAtionLevelCode1")
    String subluxAtionLevelCode1;
 	@Column(name = "SubluxAtionLevelCode2")
    String subluxAtionLevelCode2;
   	@Column(name = "NatureofConditionCode")
    String natureofConditionCode;
   	@Column(name = "ConditionCode1")
    String condition1; 	
   	@Column(name = "Description1")
    String description1;
   	@Column(name = "Description2")
    String description2;
   	@Column(name = "ConditionCode2")
    String condition2;
	public Long getcR2RecordNumber() {
		return cR2RecordNumber;
	}
	public void setcR2RecordNumber(Long cR2RecordNumber) {
		this.cR2RecordNumber = cR2RecordNumber;
	}
	
	public int getRequestId() {
		return requestId;
	}
	public void setRequestId(int requestId) {
		this.requestId = requestId;
	}
	public String getLoopCode() {
		return loopCode;
	}
	public void setLoopCode(String loopCode) {
		this.loopCode = loopCode;
	}
	public String getLoopNumber() {
		return loopNumber;
	}
	public void setLoopNumber(String loopNumber) {
		this.loopNumber = loopNumber;
	}
	public String getSequenceNumber() {
		return sequenceNumber;
	}
	public void setSequenceNumber(String sequenceNumber) {
		this.sequenceNumber = sequenceNumber;
	}
	public String getCount() {
		return count;
	}
	public void setCount(String count) {
		this.count = count;
	}
	public String getQuantity() {
		return quantity;
	}
	public void setQuantity(String quantity) {
		this.quantity = quantity;
	}
	public String getSubluxAtionLevelCode1() {
		return subluxAtionLevelCode1;
	}
	public void setSubluxAtionLevelCode1(String subluxAtionLevelCode1) {
		this.subluxAtionLevelCode1 = subluxAtionLevelCode1;
	}
	public String getSubluxAtionLevelCode2() {
		return subluxAtionLevelCode2;
	}
	public void setSubluxAtionLevelCode2(String subluxAtionLevelCode2) {
		this.subluxAtionLevelCode2 = subluxAtionLevelCode2;
	}
	public String getNatureofConditionCode() {
		return natureofConditionCode;
	}
	public void setNatureofConditionCode(String natureofConditionCode) {
		this.natureofConditionCode = natureofConditionCode;
	}
	public String getCondition1() {
		return condition1;
	}
	public void setCondition1(String condition1) {
		this.condition1 = condition1;
	}
	public String getDescription1() {
		return description1;
	}
	public void setDescription1(String description1) {
		this.description1 = description1;
	}
	public String getDescription2() {
		return description2;
	}
	public void setDescription2(String description2) {
		this.description2 = description2;
	}
	public String getCondition2() {
		return condition2;
	}
	public void setCondition2(String condition2) {
		this.condition2 = condition2;
	}	
 	
   	
   	
}