package va.gov.jpa.dto;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;



@Entity
@Table(name = "TrackingNumber") // @genTable is optional, but "user" is a keyword in many SQL variants */
@NamedQueries({
	@NamedQuery(name = "TrackingNumber.findTrackInforByReqIdlcode", query = "select alog from TrackingNumber alog where alog.requestId=:rid and alog.loopCode=:lcode and alog.loopNumber=:lno")

					
})

public class TrackingNumber implements java.io.Serializable{
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)  
	@Column(name = "TRNRecordNumber", unique = true, nullable = false)
	Long tRNRecordNumber;   
	@Column(name = "RequestId")
    int requestId;  
	@Column(name = "LoopCode")
    String loopCode;
   	@Column(name = "LoopNumber")
    String loopNumber;
   	@Column(name = "SequenceNumber")
    String sequenceNumber; 	
   	@Column(name = "TraceTypeCode")
    String traceTypeCode;
   	@Column(name = "ReferenceId1")
    String referenceId1;	
   	@Column(name = "OriginatingCompanyID")
    String originatingCompanyID;
 	@Column(name = "ReferenceId2")
    String referenceId2;
	public Long gettRNRecordNumber() {
		return tRNRecordNumber;
	}
	public void settRNRecordNumber(Long tRNRecordNumber) {
		this.tRNRecordNumber = tRNRecordNumber;
	}
	
	public int getRequestId() {
		return requestId;
	}
	public void setRequestId(int requestId) {
		this.requestId = requestId;
	}
	public String getLoopCode() {
		return loopCode;
	}
	public void setLoopCode(String loopCode) {
		this.loopCode = loopCode;
	}
	public String getLoopNumber() {
		return loopNumber;
	}
	public void setLoopNumber(String loopNumber) {
		this.loopNumber = loopNumber;
	}
	public String getSequenceNumber() {
		return sequenceNumber;
	}
	public void setSequenceNumber(String sequenceNumber) {
		this.sequenceNumber = sequenceNumber;
	}
	public String getTraceTypeCode() {
		return traceTypeCode;
	}
	public void setTraceTypeCode(String traceTypeCode) {
		this.traceTypeCode = traceTypeCode;
	}
	public String getReferenceId1() {
		return referenceId1;
	}
	public void setReferenceId1(String referenceId1) {
		this.referenceId1 = referenceId1;
	}
	public String getOriginatingCompanyID() {
		return originatingCompanyID;
	}
	public void setOriginatingCompanyID(String originatingCompanyID) {
		this.originatingCompanyID = originatingCompanyID;
	}
	public String getReferenceId2() {
		return referenceId2;
	}
	public void setReferenceId2(String referenceId2) {
		this.referenceId2 = referenceId2;
	}
   
 	
   	
}