package va.gov.jpa.dto;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;



@Entity
@Table(name = "TransportInformation") // @genTable is optional, but "user" is a keyword in many SQL variants */
@NamedQueries({
	@NamedQuery(name = "TranportInformation.findTranportInformationByReqIdlcode", query = "select alog from TranportInformation alog where alog.requestId=:rid and  alog.loopCode=:lcode")

					
})

public class TranportInformation implements java.io.Serializable{
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)  
	@Column(name = "CR1RecordNumber", unique = true, nullable = false)
	Long cR1RecordNumber;   
	@Column(name = "RequestId")
    int requestId;  
	@Column(name = "LoopCode")
    String loopCode;
   	@Column(name = "LoopNumber")
    String loopNumber;
   	@Column(name = "SequenceNumber")
    String sequenceNumber; 	
   	@Column(name = "UnitBasisCode1")
    String unitBasisCode1;
   	@Column(name = "Weight")
    String weight;	
   	@Column(name = "TransportCode")
    String transportCode;
 	@Column(name = "ReasonCode")
    String reasonCode;
 	@Column(name = "UnitBasisCode2")
    String unitBasisCode2;
 	@Column(name = "Quantity")
    String quantity;
 	@Column(name = "Description1")
    String description1;
 	@Column(name = "Description2")
    String description2;
	public Long getcR1RecordNumber() {
		return cR1RecordNumber;
	}
	public void setcR1RecordNumber(Long cR1RecordNumber) {
		this.cR1RecordNumber = cR1RecordNumber;
	}
	
	public int getRequestId() {
		return requestId;
	}
	public void setRequestId(int requestId) {
		this.requestId = requestId;
	}
	public String getLoopCode() {
		return loopCode;
	}
	public void setLoopCode(String loopCode) {
		this.loopCode = loopCode;
	}
	public String getLoopNumber() {
		return loopNumber;
	}
	public void setLoopNumber(String loopNumber) {
		this.loopNumber = loopNumber;
	}
	public String getSequenceNumber() {
		return sequenceNumber;
	}
	public void setSequenceNumber(String sequenceNumber) {
		this.sequenceNumber = sequenceNumber;
	}
	public String getUnitBasisCode1() {
		return unitBasisCode1;
	}
	public void setUnitBasisCode1(String unitBasisCode1) {
		this.unitBasisCode1 = unitBasisCode1;
	}
	public String getWeight() {
		return weight;
	}
	public void setWeight(String weight) {
		this.weight = weight;
	}
	public String getTransportCode() {
		return transportCode;
	}
	public void setTransportCode(String transportCode) {
		this.transportCode = transportCode;
	}
	public String getReasonCode() {
		return reasonCode;
	}
	public void setReasonCode(String reasonCode) {
		this.reasonCode = reasonCode;
	}
	public String getUnitBasisCode2() {
		return unitBasisCode2;
	}
	public void setUnitBasisCode2(String unitBasisCode2) {
		this.unitBasisCode2 = unitBasisCode2;
	}
	public String getQuantity() {
		return quantity;
	}
	public void setQuantity(String quantity) {
		this.quantity = quantity;
	}
	public String getDescription1() {
		return description1;
	}
	public void setDescription1(String description1) {
		this.description1 = description1;
	}
	public String getDescription2() {
		return description2;
	}
	public void setDescription2(String description2) {
		this.description2 = description2;
	}
 	
	
   	
}