package va.gov.jpa.dto;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;



@Entity
@Table(name = "TransactionLog") // @Table is optional, but "user" is a keyword in many SQL variants */
@NamedQueries({
	@NamedQuery(name = "TransactionLog.findQueueList", query = "select aque from TransactionLog aque"),
	@NamedQuery(name = "TransactionLog.findQueueNameById", query = "select aque from TransactionLog aque where aque.queueId=:Id and aque.stationId=:sid"),
	@NamedQuery(name = "TransactionLog.findPatientById", query = "select aque from TransactionLog aque where aque.queueId=:Id and aque.stationId=:sid"),	
	@NamedQuery(name = "TransactionLog.findARPSQueueByReqId", query = "select aque from TransactionLog aque where aque.requestId=:rId")

					
})

public class TransactionLog implements java.io.Serializable{
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)  
	@Column(name = "RequestId", unique = true, nullable = false)
    int requestId;
	@Column(name = "RequestDate")
	Date requestDate ;
	@Column(name = "QueueId")
	int queueId ;
	@Column(name = "Sta3n")
	String stationId ;
	
	public int getRequestId() {
		return requestId;
	}
	public void setRequestId(int requestId) {
		this.requestId = requestId;
	}
	public String getStationId() {
		return stationId;
	}
	public void setStationId(String stationId) {
		this.stationId = stationId;
	}
	
	
	public Date getRequestDate() {
		return requestDate;
	}
	public void setRequestDate(Date requestDate) {
		this.requestDate = requestDate;
	}
	public int getQueueId() {
		return queueId;
	}
	public void setQueueId(int queueId) {
		this.queueId = queueId;
	}
	
	
	
	
   
		
}