
package va.gov.jpa.service;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceUnit;
import javax.persistence.TypedQuery;

import org.apache.log4j.Logger;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import va.gov.jpa.dto.ARPSQueueCodes;
import va.gov.jpa.dto.DenialReason;
import va.gov.jpa.dto.EntityName;

public class GeneralService {

	@PersistenceUnit(unitName = "vaPU")
	EntityManager em = CommonEntityManagerFactory.entityManagerFactory();

	private static final Logger LOGGER = Logger.getLogger(GeneralService.class);

	private static GeneralService instance = null;

	public static synchronized GeneralService getInstance() {
		/*
		 * Creates the Singleton instance, if needed.
		 */
		if (instance == null) {
			instance = new GeneralService();
		}
		return instance;
	}
	

	
	
	@Transactional(propagation = Propagation.SUPPORTS, rollbackFor = Exception.class)
	public String findQDescrebyQueueId( String code ) {

		if (LOGGER.isDebugEnabled()) {
			LOGGER.debug("Enter  in GeneralService:-findQDescrebyQueueId");
		}
		List<ARPSQueueCodes> userList = new ArrayList<ARPSQueueCodes>();
		ARPSQueueCodes user = null;
		String descr="";
		
		try {
			// use entity manager to retrieve named query
			TypedQuery<ARPSQueueCodes> queryUserByName = em.createNamedQuery("ARPSQueueCodes.findQueueNameById", ARPSQueueCodes.class);

			// set dynamic data for query
			queryUserByName.setParameter("Id", new Integer(code));
		
			userList = queryUserByName.getResultList();
			
			if (userList.size() == 1) {
				user = (ARPSQueueCodes) userList.get(0);
				descr = user.getQueueName();
			}
			// execute query and get results
			
			
			
		} catch (Exception e) {
			if (LOGGER.isDebugEnabled()) {
				LOGGER.debug("\n === Exception in GenService:-findQDescrebyQueueId:=== "
						+ e.getMessage() + "\n" +e.getCause());
			}
		} finally {
		}
		return descr;
	}

	@Transactional(propagation = Propagation.SUPPORTS, rollbackFor = Exception.class)
	public String findDenyReasonDescrById( String code ) {

		if (LOGGER.isDebugEnabled()) {
			LOGGER.debug("Enter  in GeneralService:-findDenyReasonDescrById");
		}
		DenialReason codelist = new DenialReason();
		String descr = null;

		try {
			// use entity manager to retrieve named query
			TypedQuery<DenialReason> queryUserByName = em.createNamedQuery("DenialReason.findRnasoDescrpById", DenialReason.class);

			// set dynamic data for query
			queryUserByName.setParameter("Id", (code));
		

			// execute query and get results
			codelist = queryUserByName.getSingleResult();
	
			descr = codelist.getName();
			
		} catch (Exception e) {
			if (LOGGER.isDebugEnabled()) {
				LOGGER.debug("\n === Exception in GenService:-findDenyReasonDescrById:=== "
						+ e.getMessage() + "\n" +e.getCause());
			}
		} finally {
		}
		return descr;
	}

	


}