package va.gov.util;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;
import java.sql.Timestamp;
import java.text.DateFormat;
import java.text.Format;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.servlet.http.HttpServletRequest;

import org.apache.log4j.Logger;

import va.gov.jpa.dto.EntityName;
import va.gov.jpa.dto.SearchPatientById;
/**
 * Utility Class has some util method which is used 
 * common for all classes.
 * 
 *
 */
public class Utility {
	
	private static final Logger LOGGER = Logger.getLogger(Utility.class);
	private static final String API_URL = "https://api.tinypng.com/shrink";
	/**
	 * Split the string
	 * @param str
	 * @param splitPattern
	 * @return
	 */
	public static String[] stringSplit(String str, String splitPattern) {
		// String str = "2007-06-19 12:43:59";
		// String splitPattern = " ";
		// output 0=>2007-06-19 1=>12:43:59
		String[] tokens = null;
		tokens = str.split(splitPattern);
		return tokens;
	}
	
	public static String convertDate (Timestamp d) {
		   String str = new SimpleDateFormat("d MMM yyyy 'at' HH:mm:ss z", Locale.US).format(d);

		    return str;
		    
		}

	public static String convertMMDDYYDate (String strd) throws Exception{
		String newDateString = "";
		java.util.Date tempD = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSSSSS").parse(strd);
		
		DateFormat toFormat = new SimpleDateFormat("MM/dd/yyyy");
		toFormat.setLenient(false);

		newDateString = (toFormat.format(tempD));
	    return newDateString;
	}
	
	public static String convertMMDDYYFromyyyyMMDD (String strd) throws Exception{
		String newDateString = "";
		java.util.Date tempD = new SimpleDateFormat("yyyy-MM-dd").parse(strd);
		
		DateFormat toFormat = new SimpleDateFormat("MM/dd/yyyy");
		toFormat.setLenient(false);

		newDateString = (toFormat.format(tempD));
	    return newDateString;
	}
	
	public static String conStrToMMDDYY (String strd, String dtformat) {
		String newDateString = "";
		try {
			if (strd.equals("D8")){
				java.util.Date tempD = new SimpleDateFormat("yyyyMMdd").parse(dtformat);			
				DateFormat toFormat = new SimpleDateFormat("MM/dd/yyyy");
				toFormat.setLenient(false);	
				newDateString = (toFormat.format(tempD));
			}
			else {
				String[] atokens = dtformat.split("-");
				String strStrg= Utility.conStrToMMDDYY("D8" ,atokens[0]);
				String endStrg= Utility.conStrToMMDDYY("D8", atokens[1]);
				newDateString=strStrg +"-" +endStrg;
			}
	    } catch (ParseException e) {
	        e.printStackTrace();
		}
	    return newDateString;
	}
	/**
	 * return the starting date for generating report 
	 * @param timePeriod
	 * @return
	 */
	
	public static String formatDate(String timePeriod) {
		
		Format formatter;
		Date date = new Date();
		formatter = new SimpleDateFormat("E, dd MMM yyyy HH:mm:ss");
		String s = formatter.format(date);
		
		return s;
		
	}
	
public static String returnStartDate(String timePeriod) {
		
	
	DateFormat formatter = null ; 
	
	DateFormat dateFormat = new SimpleDateFormat("MM/dd/yy");
    java.util.Date date = new java.util.Date();
    String startDate1 = dateFormat.format(date);
  //  String timePeriod = dateFormat.format(date);
    String startDate=null;
		SimpleDateFormat sdf = new SimpleDateFormat("MM/dd/yy");
		Calendar c = Calendar.getInstance();
		
		
		int month=date.getMonth();
							
		if(timePeriod.equals("thisMonth")){
			
			c.set(Calendar.MONTH, month);
			c.set(Calendar.DAY_OF_MONTH, 1);
			startDate= sdf.format(c.getTime());
		}else if(timePeriod.equals("lastMonth")){
			c.set(Calendar.MONTH, month-1) ; 
			c.set(Calendar.DAY_OF_MONTH, 1);
			startDate= sdf.format(c.getTime());
		}else if(timePeriod.equals("thisWeek")){
			c.set(Calendar.DAY_OF_WEEK, c.getActualMinimum(Calendar.DAY_OF_WEEK));
			startDate= sdf.format(c.getTime());
		}else if(timePeriod.equals("lastWeek")){
			//c.set(Calendar.WEEK_OF_MONTH, Calendar.WEEK_OF_MONTH -1);
			c.set(Calendar.DAY_OF_WEEK, c.getActualMinimum(Calendar.DAY_OF_WEEK));
			startDate= sdf.format(c.getTime());
		}
		return startDate;
	}
	/**
	 * return the starting date for generating report 
	 * @param timePeriod
	 * @return
	 */
	public static String returnEndDate(String timePeriod) {
		
		SimpleDateFormat sdf = new SimpleDateFormat("MM/dd/yy");
		Calendar c = Calendar.getInstance();
		Date date=new Date();
		int month=date.getMonth();
		String endDate=null;
		
		if(timePeriod.equals("thisMonth")){
			c.set(Calendar.MONTH, month);
			c.set(Calendar.DAY_OF_MONTH, c.getActualMaximum(Calendar.DAY_OF_MONTH));
			endDate= sdf.format(c.getTime());
		}else if(timePeriod.equals("lastMonth")){
			c.set(Calendar.MONTH, month-1) ;
			c.set(Calendar.DAY_OF_MONTH, c.getActualMaximum(Calendar.DAY_OF_MONTH));
			endDate= sdf.format(c.getTime());
		}else if(timePeriod.equals("thisWeek")){
			c.set(Calendar.DAY_OF_WEEK, c.getActualMaximum(Calendar.DAY_OF_WEEK));
			endDate= sdf.format(c.getTime());
		}else if(timePeriod.equals("lastWeek")){
			c.set(Calendar.WEEK_OF_MONTH, Calendar.WEEK_OF_MONTH -1) ;
			c.set(Calendar.DAY_OF_WEEK, c.getActualMaximum(Calendar.DAY_OF_WEEK));
			endDate= sdf.format(c.getTime());
		}
		return endDate;


	}
	/**
	 * Check for numeric or not
	 * @param string
	 * @return true/false
	 */
	public static boolean isNumeric(String string) {
		return string.matches("^[-+]?\\d+(\\.\\d+)?$");
	}

	/**
	 * Check for valid email or not
	 * @param email
	 * @return true/false
	 */
	public static boolean isValidEmail(String email) {
		if (!email.matches(".+@.+\\..+")) {
			return false;
		} else {
			return true;
		}
	}
	
	public static boolean validateEmailaddress (String eaddress){
	    Pattern p = Pattern.compile(".+@.+\\.[a-z]+");
	    //Match the given string with the pattern
	    Matcher m = p.matcher(eaddress);
	    //check whether match is found 
	    boolean matchFound = m.matches();
	    return matchFound;
	}
	
	
	public static boolean validatePassword (String password){
		
		Pattern letter = Pattern.compile("[a-zA-z]");  
		Pattern digit = Pattern.compile("[0-9]");  
		//Pattern special = Pattern.compile ("[!@#$%&*()_+=|<>?{}\\[\\]~-]");  
		Pattern special = Pattern.compile("(?=.*[a-zA-Z])");
		Pattern length = Pattern.compile (".{5,12}");  
		Pattern sequ=  Pattern.compile("(?!(.+?)\\1).*");
		boolean  haslength = false; 
		
	   Matcher hasLetter = letter.matcher(password);  
	   Matcher hasDigit = digit.matcher(password);  
	   Matcher hasSpecial = special.matcher(password);  
	   if (password.length() >5 && password.length() <12) 
		     haslength = true; 
	   boolean hasSequ = checkSeq (password);
	   return hasLetter.find() && hasDigit.find() && hasSpecial.find() && haslength;  
		
		
	}
	
	private static boolean checkSeq(String passwd) {
		for (int index = 0; index < passwd.length(); index++) {
			char c1 = passwd.charAt(index);
			int index2 = passwd.indexOf(c1, index + 1);
			if (index2 != -1) {
				String str1 = passwd.substring(index, index2);
				String str2 = passwd.substring(index2, 2 * index2 - index);
				if(str1.equals(str2)){
					return false;
				}
			}
		}
		return true;
	}

	/**
	 * Check for valid user name or not
	 * @param email
	 * @return true/false
	 */
	public static boolean isValidUserName(String userName) {
		if (!userName.matches("\\W")) {
			return false;
		} else {
			return true;
		}
	}
	
	/**
	 * Check for valid date
	 * @param dt
	 * @return  true/false
	 */

	public static boolean isValidDate(String dt) {
		// String dt = "04/31/2005"; //Invalid Date
		// String dt = "02/29/2004"; //Valid Date
		try {
			DateFormat df = DateFormat.getDateInstance(DateFormat.SHORT);
			df.setLenient(false); // this is important!
			return true;
		}

		catch (IllegalArgumentException e) {
			if (LOGGER.isDebugEnabled()){
				LOGGER.error("Exception in Utility:isValidDate " + e.getMessage() );
			}
			return false;
		}
	}
	/**
	 * Split the the string as date and time
	 * @param str	String 
	 * @param splitPattern	
	 * @return  array of string
	 */
	public String[] explode(String str, String splitPattern) {
		// String str = "2007-06-19 12:43:59";
		// String splitPattern = " ";
		// output 0=>2007-06-19 1=>12:43:59
		String[] tokens = null;
		tokens = str.split(splitPattern);
		return tokens;
	}

	/**
	 * Adding slash "\" character before quote "'" in a query
	 * @param str
	 * @return
	 */
	public String addSlashes(String str) {
		if (str == null)
			return "";

		StringBuffer s = new StringBuffer((String) str);
		for (int i = 0; i < s.length(); i++)
			if (s.charAt(i) == '\'')
				s.insert(i++, '\\');
		return s.toString();
	}

	/**
	 * Generate Random number
	 * @param strlength
	 * @return String
	 */
	static public String generateRandomNo(int strlength) {
		String mystr = "";
		String[] arr = { "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k",
				"l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w",
				"x", "y", "z", "1", "2", "3", "4", "5", "6", "7", "8", "9",
				"0", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K",
				"L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "X",
				"Y", "Z" };
		for (int i = 0; i < strlength; i++) {
			int val = (int) (60 * Math.random());
			mystr += arr[val];
		}
		return mystr;
	}

	/**
	 * Method format --> formats string type date to string type date via date
	 * type date
	 * 
	 * @param inputformat
	 * @param inputdocdate
	 * @param outputformat
	 * @return String
	 */

	public static String format(String inputformat, String inputdocdate,
			String outputformat) {

		DateFormat myInitialDateFormat = new SimpleDateFormat(inputformat);
		java.util.Date docdate = null;
		String docdatetime = null;

		try {
			docdate = myInitialDateFormat.parse(inputdocdate);

			DateFormat myFinalDateFormat = new SimpleDateFormat(outputformat);
			docdatetime = myFinalDateFormat.format(docdate);

		} catch (ParseException e) {
			if (LOGGER.isDebugEnabled()){
				LOGGER.error("Exception in Utility:format " + e.getMessage() );
			}
		}

		return docdatetime;
	}

	/**
	 * Method getDateFromString --> converts string to date
	 * 
	 * @param inputformat
	 * @param inputdocdate
	 * @return Date
	 */
	public static java.util.Date getDateFromString(String inputformat,
			String inputdocdate) {

		DateFormat myInitialDateFormat = new SimpleDateFormat(inputformat);
		java.util.Date docdate = null;

		try {
			docdate = myInitialDateFormat.parse(inputdocdate);
		} catch (ParseException e) {
			if (LOGGER.isDebugEnabled()){
				LOGGER.error("Exception in Utility:getDateFromString " + e.getMessage() );
			}
		}

		return docdate;
	}

	/**
	 * Method createDirectory --> create directory in file system.
	 * 
	 * @param fname
	 * @param dirName
	 * @return boolean
	 */
	public static boolean createDirectory(String dirName) {

		File dir = new File(dirName);

		if (!dir.exists()) {
			boolean success = dir.mkdir();
			if (!success) {
				return false;
			}
		}
		return true;
	}
	/**
	 * getting the string start from beginning but ending '_' position.
	 * @param fullstr
	 * @return String
	 */
	public static String parseID(String fullstr) {
		String id = null;
		if (fullstr != null && fullstr.length() > 1) {
			id = fullstr.substring(0, fullstr.indexOf('-'));
		}
		return id;
	}
	/**
	 * getting the string start from '_' position.
	 * @param fullstr
	 * @return String
	 */
	public static String parseName(String fullstr) {
		String name = null;
		if (fullstr != null && fullstr.length() > 1) {
			name = fullstr.substring(fullstr.indexOf('-') + 2, fullstr.length());
			name = name.trim();
		}
		return name;
	}
	/**
	 * getting current timestamp.
	 * @return Timestamp
	 */
	public static Timestamp getCurrentTimestamp() {
		Timestamp timesp = new Timestamp(System.currentTimeMillis());

		return timesp;
	}
	
	

	/**
	 * validating the directory name
	 * @param dirName
	 * @return true/ false
	 */
	public static boolean validatedirectory(String dirName) {

		File dir = new File(dirName);

		if (!dir.exists()) {
			boolean success = dir.mkdirs();
			if (!success) {
				return false;
			}
		}
		return true;
	}
	/**
	 * validating the file name
	 * @param fileName
	 * @return true/ false
	 */
	public static boolean validatefile(String fileName) {

		File file = new File(fileName);

		if (!file.exists())
			return false;
		else
			return true;
	}

	
	/**
	 * Coping the file
	 * @param fromFileName
	 * @param toFileName
	 * @return
	 * @throws IOException
	 */
	public static boolean copyfile(String fromFileName, String toFileName)
			throws IOException {
		File fromFile = new File(fromFileName);
		File toFile = new File(toFileName);

		if (!fromFile.exists())
			throw new IOException("FileCopy: " + "no such source file: "
					+ fromFileName);
		if (!fromFile.isFile())
			throw new IOException("FileCopy: " + "can't copy directory: "
					+ fromFileName);
		if (!fromFile.canRead())
			throw new IOException("FileCopy: " + "source file is unreadable: "
					+ fromFileName);

		if (toFile.isDirectory())
			toFile = new File(toFile, fromFile.getName());

		if (toFile.exists()) {
			if (!toFile.canWrite())
				throw new IOException("FileCopy: "
						+ "destination file is unwriteable: " + toFileName);
			BufferedReader in = new BufferedReader(new InputStreamReader(
					System.in));
			String response = in.readLine();
			if (!("Y").equals(response) )
				throw new IOException("FileCopy: "
						+ "existing file was not overwritten.");
		} else {
			String parent = toFile.getParent();
			if (parent == null)
				parent = System.getProperty("user.dir");
			File dir = new File(parent);
			if (!dir.exists())
				throw new IOException("FileCopy: "
						+ "destination directory doesn't exist: " + parent);
			if (dir.isFile())
				throw new IOException("FileCopy: "
						+ "destination is not a directory: " + parent);
			if (!dir.canWrite())
				throw new IOException("FileCopy: "
						+ "destination directory is unwriteable: " + parent);
		}

		FileInputStream from = null;
		FileOutputStream to = null;
		try {
			from = new FileInputStream(fromFile);
			to = new FileOutputStream(toFile);
			byte[] buffer = new byte[8192];
			int bytesRead;

			while ((bytesRead = from.read(buffer)) != -1)
				to.write(buffer, 0, bytesRead); // write
		} finally {
			if (from != null)
				try {
					from.close();
				} catch (IOException e) {
					if (LOGGER.isDebugEnabled()){
						LOGGER.error("Exception in Utility:copyfile " + e.getMessage() );
					}
					;
				}
			if (to != null)
				try {
					to.close();
				} catch (IOException e) {
					if (LOGGER.isDebugEnabled()){
						LOGGER.error("Exception in Utility:copyfile " + e.getMessage() );
					}
				}
		}

		return true;

	}
	
	/**
	 * Checking the url
	 * @param s
	 * @return int
	 */
	public static int checkurl (String s)
	{
		int response =0;
	    
	    try {
	            URL url = new URL(s);
	            URLConnection connection = 
	            url.openConnection();
	            if (connection instanceof HttpURLConnection) {
	              HttpURLConnection httpConnection =(HttpURLConnection)connection;
	              httpConnection.connect();
	              response = httpConnection.getResponseCode();

	            }
	          } catch (IOException e) {
	        	  if (LOGGER.isDebugEnabled()){
	        		  LOGGER.error("Exception in Utility:checkurl " + e.getMessage() );
					}
	          }
	          
	          return response;

	}
	/**
	 * reads the line from the file and print it to the console
	 * @param filename
	 */
	public static void readfile (String filename){


	    File file = new File(filename);
	    FileInputStream fis = null;
	    BufferedInputStream bis = null;
	    DataInputStream dis = null;

	    try {
	      fis = new FileInputStream(file);

	      // Here BufferedInputStream is added for fast reading.
	      bis = new BufferedInputStream(fis);
	      dis = new DataInputStream(bis);
	     
	      // dis.available() returns 0 if the file does not have more lines.
	      while (dis.available() != 0) {

	      // this statement reads the line from the file and print it to
	        // the console.
	        dis.readLine();
	      }

	      // dispose all the resources after using them.
	      fis.close();
	      bis.close();
	      dis.close();

	    } catch (FileNotFoundException e) {
	    	if (LOGGER.isDebugEnabled()){
	    		LOGGER.error("Exception in Utility:readfile " + e.getMessage() );
			}
	    } catch (IOException e) {
	    	if (LOGGER.isDebugEnabled()){
	    		LOGGER.error("Exception in Utility:readfile " + e.getMessage() );
			}
	    }

	}
	/**
	 * * readLine is a bit quirky :
	         * it returns the content of a line MINUS the newline.
	         * it returns null only for the END of the stream.
	         * it returns an empty String if two newlines appear in a row.
	 * @param aFile
	 * @return
	 */
	 static public String getContents(File aFile) {
	     //...checks on aFile are elided
	     StringBuffer contents = new StringBuffer();
	     
	     try {
	       //use buffering, reading one line at a time
	       //FileReader always assumes default encoding is OK!
	       BufferedReader input =  new BufferedReader(new FileReader(aFile));
	       try {
	         String line = null; //not declared within while loop
	         /*
	         * readLine is a bit quirky :
	         * it returns the content of a line MINUS the newline.
	         * it returns null only for the END of the stream.
	         * it returns an empty String if two newlines appear in a row.
	         */
	         while (( line = input.readLine()) != null){
	           contents.append(line);
	           contents.append(System.getProperty("line.separator"));
	         }
	       }
	       finally {
	         input.close();
	       }
	     }
	     catch (IOException ex){
	    	 if (LOGGER.isDebugEnabled()){
	    		 LOGGER.error("Exception in Utility:getContents " + ex.getMessage() );
				}
	     }
	     
	     return contents.toString();
	   }
	 /**
	  * write a file
	  * @param aFile
	  * @param st
	  * @return true/ false
	  */
	 static public boolean writefile(File aFile, String st){
	     
	 
	 try {
	        BufferedWriter out = new BufferedWriter(new FileWriter(aFile));
	        out.write(st);
	        out.close();
	    } catch (IOException e) {
	    	if (LOGGER.isDebugEnabled()){
	    		LOGGER.error("Exception in Utility:writefile " + e.getMessage() );
			}
		return false;
	    }
	    return true;
	 }
	 /**
	  * Convert a String s to an Array, the elements
	    are delimited by sep
	  * @param s
	  * @param sep
	  * @return
	  */
	 public static String[] stringToArray(String s, String sep) {
	        // Convert a String s to an Array, the elements
	        // are delimited by sep
	        StringBuffer buf = new StringBuffer(s);
	        int arraysize = 1;
	        for(int i=0; i<buf.length(); i++) {
	            if (sep.indexOf(buf.charAt(i))!=-1)
	                arraysize++;
	        }
	        String[] elements = new String [arraysize];
	        int y, z = 0;
	        if(buf.toString().indexOf(sep)!=-1) {
	            while(buf.length()>0) {
	                 if(buf.toString().indexOf(sep) != -1) {
	                     y =  buf.toString().indexOf(sep);
	                     if(y!=buf.toString().lastIndexOf(sep)) {
	                         elements[z] = buf.toString().substring(0, y ); z++;
	                         buf.delete(0, y + 1);
	                     }
	                     else if(buf.toString().lastIndexOf(sep)==y) {
	                         elements[z]=buf.toString().substring(0, buf.toString().indexOf(sep));
	                         z++;
	                         buf.delete(0, buf.toString().indexOf(sep)+1);
	                         elements[z] = buf.toString();
	                         z++;
	                         buf.delete(0, buf.length());
	                     }
	                 }
	             }
	         }
	         else
	             elements[0] = buf.toString();
	         buf = null;
	         return elements;
	    }




			
			public static String stringReplacement(String emailText,String changedKey,String changedValue) {
				
				
				char leading='%'; char trailing='%';
				
					Map<String, String> params = new HashMap<String, String>();
					
					params.put(changedKey, changedValue);
				  String pattern = "";
				  if (leading != 0) {
				    pattern += leading;
				  }
				  pattern += "(\\w+)";
				  if (trailing != 0) {
				    pattern += trailing;
				  }
				  Pattern p = Pattern.compile(pattern);
				  Matcher m = p.matcher(emailText);
				  boolean result = m.find();
				  if (result) {
				    StringBuffer sb = new StringBuffer();
				    do {
				      String replacement = params.get(m.group(1));
				      if (replacement == null) {
				        replacement = m.group();
				      }
				      m.appendReplacement(sb, replacement);
				      result = m.find();
				    } while (result);
				    m.appendTail(sb);
				    return sb.toString();
				  }
				  return emailText;
				}

			public static Date getCurrentDate() throws Exception
			
			{
				
				DateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
				Date date = new Date();
				// java.sql.Date sqlDate = new java.sql.Date(utilDate.getTime());
				//dateFormat.parse(dateFormat.format(date));
				
				return dateFormat.parse(dateFormat.format(date));
			}

			
			public static String getIpAddress(HttpServletRequest request) {
				String ipAddress  = request.getHeader("X-FORWARDED-FOR");
				if(ipAddress == null)
				{
				  ipAddress = request.getRemoteAddr();
				}
				//String ipadd = request.getRemoteAddr();
				return ipAddress;
			}
			  
			
			public static String buildName(EntityName  entm){
				String name=null;
				if (entm.getNameLastOrganization()!=null){
					name = entm.getNameLastOrganization();
				}
				if (entm.getNameFirst()!=null){
					name = entm.getNameFirst() +" " +entm.getNameLastOrganization();
				}
				if (entm.getNameFirst()!=null && entm.getNameMiddle()!=null ){
					name = entm.getNameFirst() +" " +entm.getNameMiddle()+ " "+entm.getNameLastOrganization();
				}
				if (entm.getNameFirst()!=null &&  entm.getNameSuffix()!=null ){
					name = entm.getNameFirst() + " "+entm.getNameLastOrganization() +" "+ entm.getNameSuffix();
				}
				if (entm.getNameFirst()!=null && entm.getNameMiddle()!=null && entm.getNameSuffix()!=null ){
					name = entm.getNameFirst() +" " +entm.getNameMiddle()+ " "+entm.getNameLastOrganization() +" "+ entm.getNameSuffix();
				}
				if (entm.getNameFirst()!=null && entm.getNameMiddle()!=null && entm.getNameSuffix()!=null && entm.getNamePrefix()!=null ){
					name = entm.getNamePrefix() + " "+entm.getNameFirst() +" " +entm.getNameMiddle()+ " "+entm.getNameLastOrganization() +" "+ entm.getNameSuffix();
				}

				return name;
			}
			
			public static String buildNameorOrg (EntityName ent){
				String name=null;
				if (ent.getEntityType().equals("2")){
					name = ent.getNameLastOrganization();
					return name;							
				}
				else{
					if (ent.getNameLastOrganization()!=null){
						name = ent.getNameLastOrganization();
					}
					if (ent.getNameFirst()!=null){
						name = ent.getNameFirst() +" " +ent.getNameLastOrganization();
					}
					if (ent.getNameFirst()!=null && ent.getNameMiddle()!=null ){
						name = ent.getNameFirst() +" " +ent.getNameMiddle()+ " "+ent.getNameLastOrganization();
					}
					if (ent.getNameFirst()!=null &&  ent.getNameSuffix()!=null ){
						name = ent.getNameFirst() + " "+ent.getNameLastOrganization() +" "+ ent.getNameSuffix();
					}
					if (ent.getNameFirst()!=null && ent.getNameMiddle()!=null && ent.getNameSuffix()!=null ){
						name = ent.getNameFirst() +" " +ent.getNameMiddle()+ " "+ent.getNameLastOrganization() +" "+ ent.getNameSuffix();
					}
					if (ent.getNameFirst()!=null && ent.getNameMiddle()!=null && ent.getNameSuffix()!=null && ent.getNamePrefix()!=null ){
						name = ent.getNamePrefix() + " "+ent.getNameFirst() +" " +ent.getNameMiddle()+ " "+ent.getNameLastOrganization() +" "+ ent.getNameSuffix();
					}
				}
				return name;
			}
			
			public static String buildName(SearchPatientById  entm){
				String name=null;
				if (entm.getLname()!=null){
					name = entm.getLname();
				}
				if (entm.getFname()!=null){
					name = entm.getFname() +" " +entm.getLname();
				}
				if (entm.getFname()!=null && entm.getMname()!=null ){
					name = entm.getFname() +" " +entm.getMname()+ " "+entm.getLname();
				}
				if (entm.getFname()!=null &&  entm.getSuf()!=null ){
					name = entm.getFname() + " "+entm.getLname() +" "+ entm.getSuf();
				}
				if (entm.getFname()!=null && entm.getMname()!=null && entm.getSuf()!=null ){
					name = entm.getFname() +" " +entm.getMname()+ " "+entm.getLname() +" "+ entm.getSuf();
				}
				if (entm.getFname()!=null && entm.getMname()!=null && entm.getSuf()!=null && entm.getPre()!=null ){
					name = entm.getPre() + " "+entm.getFname() +" " +entm.getMname()+ " "+entm.getLname() +" "+ entm.getSuf();
				}

				return name;
			}
			    
			
	
}	
	
