
package va.gov.ws;

import java.security.Principal;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.FormParam;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.UriInfo;

import org.apache.log4j.Logger;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.MessageSource;
import org.springframework.ui.ModelMap;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonObject;

import va.gov.domain.AuditLogAdapter;
import va.gov.jpa.dto.ARPSQueueCodes;
//import va.gov.jpa.dto.ARPSQueueCodes;
import va.gov.jpa.dto.AuditLog;
import va.gov.jpa.dto.ContactInformation;
import va.gov.jpa.dto.DemographicInformation;
import va.gov.jpa.dto.EntityAddress;
import va.gov.jpa.dto.EntityName;
import va.gov.jpa.dto.HealthServicesReview;
import va.gov.jpa.dto.InsuranceInformation;
import va.gov.jpa.dto.ProviderInformation;
import va.gov.jpa.dto.References;
import va.gov.jpa.dto.SearchPatientById;
import va.gov.jpa.dto.UserAuthorization;
import va.gov.service.PatientServiceIntf;
import va.gov.util.Utility;



@Path("/ws/sp")
public class PatientService {
		
	private static final Logger LOGGER = Logger.getLogger(PatientService.class);
	  @Context
	  UriInfo uriInfo;
	  @Context
	  HttpServletRequest req;
	  
	  @Context
	  HttpServletResponse  res;
	  
	  ModelMap modelMap = new ModelMap();
	  
	  @Autowired
		private PatientServiceIntf patService;

		public void setPatService(PatientServiceIntf patService) {
			this.patService = patService;
		}

	  @Autowired  
	  protected MessageSource messages;


	  public void setMessages(MessageSource messages) {
	  	this.messages = messages;
	  }
	  
@GET
@Path("/getPatientInfoById")
public String getPatientInfoById(@QueryParam("id") String id, @QueryParam("chkArc") String arhFlag) throws Exception {
	  			if (LOGGER.isDebugEnabled()) {
	  				LOGGER.debug("Enter  in getPatientInfoById");
	  			}
	  			JsonObject patientjson = new JsonObject();
	  			JsonArray refjarray = new JsonArray();
	  			
	  			
	  	
	  			List<SearchPatientById> entlo= patService.getPatientById(id, "442");	
	  				
	  				for (int i=0; i<entlo.size();i++){
	  					JsonObject reqRefjson = new JsonObject();
	  					SearchPatientById indref = (SearchPatientById) entlo.get(i);
	  					//reqRefjson.addProperty("refIdCodQual", patService.getDecodedDescription("2010B", "REF01",indref.getReferenceIdQualifier()));
	  					reqRefjson.addProperty("name",   Utility.buildName(indref));
	  					reqRefjson.addProperty("id",   indref.getId() );	
	  					reqRefjson.addProperty("dob",   indref.getDob() );	
	  					
	  					List<EntityName> ent= patService.getEntityInfo( indref.getRequestId() , "2010B"); //Loop code				
	  					EntityName entnm = ent.get(0);
	  					
	  					reqRefjson.addProperty("requester",Utility.buildName(entnm));
	  					
	  				//service
						HealthServicesReview hrev = patService.getHealthServicesInfo(indref.getRequestId(),"2000E","1" ); 
						if (hrev!=null){
						if(null !=hrev.getRequestCategCode()) {String strUM01 = patService.getDecodedDescription("2000E", "UM01", hrev.getRequestCategCode() );
						String strUM02 = patService.getDecodedDescription("2000E", "UM02", hrev.getCertificationType());
						String strUM03 = patService.getDecodedDescription("2000E", "UM03", hrev.getServicesTypeCode());
						String scodedesc =strUM01 + "-" +strUM02 +"-"+strUM03;
						
						reqRefjson.addProperty("service",scodedesc );
						}
						}else{
							reqRefjson.addProperty("service","");
						}
	  					reqRefjson.addProperty("reqDate",   indref.getReqDate() );	
	  					reqRefjson.addProperty("qName",   indref.getQueueName() );	
	  					reqRefjson.addProperty("reqId",   indref.getRequestId() );	
	  					refjarray.add(reqRefjson);
	  					
	  				}
	  				patientjson.add("refer", refjarray);
	  				modelMap.addAttribute("patSearchList", patientjson); 	
	  			
	  return refjarray.toString();
	  
}
	  
@GET
@Path("/getDependentInfo")
	  
public String getDependentInfo(@QueryParam("rid") String id) throws Exception {
			if (LOGGER.isDebugEnabled()) {
				LOGGER.debug("Enter  in NavController:getDependentInfo");
			}
			
			Integer	rId = new Integer(id);				
			JsonObject djson = new JsonObject();
			//dependent
			List<EntityName> entlo= patService.getEntityInfo(rId , "2010D"); //Loop code	
			
			if (entlo!=null && entlo.size()>0){
			EntityName ent =entlo.get(0); 
			djson.addProperty("depEntId",patService.getDecodedDescription("2010D", "NM101", ent.getEntityIdCode()) );
			djson.addProperty("depEntIdQual",patService.getDecodedDescription("2010D", "NM102", ent.getEntityType()) );
			
			djson.addProperty("depLnameOrg",ent.getNameLastOrganization());
			djson.addProperty("depFname",ent.getNameFirst());
			djson.addProperty("depMname",ent.getNameMiddle());
			djson.addProperty("depnameP",ent.getNamePrefix());
			djson.addProperty("depnameS",ent.getNameSuffix());
				 
			//address
				EntityAddress add= patService.getAddress(rId , "2010D");
				String reqAdd;
				if (add != null) {
					if (add.getAddress2()!=null && !add.getAddress2().equals("")){
					 reqAdd= add.getAddress1() + ", "+add.getAddress2();
					}
					else {
						reqAdd= add.getAddress1() ;
					}
					djson.addProperty("address", reqAdd);
				
					djson.addProperty("city", add.getCity());
					djson.addProperty("state", add.getStateProvCode());
					djson.addProperty("zip", add.getPostalCode());
					djson.addProperty("country", add.getCountryCode());
				}
				else{
					djson.addProperty("address", "");
				}
				
			//References
				List<References> refs= patService.getReferences(rId , "2010D");
				if (refs.size()>0){
					StringBuilder tmp = new StringBuilder();
					for (int i=0; i<refs.size();i++){
						References indref = (References) refs.get(i);
						String ref = patService.getDecodedDescription("2010D", "REF01", indref.getReferenceIdQualifier() );
						tmp.append(indref.getReferenceId() +'\t'+ ref+'\n');
					}
					djson.addProperty("ref", tmp.toString());
				}
				
		//DMZ			
				DemographicInformation demo= patService.getDOBInfo(rId, "2010D" ); 
				if (demo!=null){
					try {
						djson.addProperty("ddob",Utility.convertMMDDYYDate(demo.getDateTimePeriod()));
					}
					catch (Exception e){
						djson.addProperty("ddob","");
					}
					djson.addProperty("dgender",demo.getGenderCode());
				}
				else {
					djson.addProperty("ddob","");
					djson.addProperty("dgender","");
				}
		//INS
				InsuranceInformation sinfo= patService.getInsuranceInfo(rId , "2010D");
				if (sinfo!=null){
					djson.addProperty("insYN", sinfo.getYesNoCode() );	
					djson.addProperty("insRcode", patService.getDecodedDescription("2010D", "INS01", sinfo.getIndividualRelationshipCode() ));	
					djson.addProperty("empScode", patService.getDecodedDescription("2010D", "INS02", sinfo.getEmploymentStatusCode() ));	
				
				
				}
				
			}
				modelMap.addAttribute("dependentjson", djson);
			    return djson.toString();  	
}






@GET
@Path("/getRequesterInfo")
public String getRequesterInfo(@QueryParam("id") String id) throws Exception {
			if (LOGGER.isDebugEnabled()) {
				LOGGER.debug("Enter  in getRequesterInfo");
			}
			JsonObject patientjson = new JsonObject();
			Integer	rId = new Integer(id);
	
		//requester
				List<EntityName> entlo= patService.getEntityInfo(rId , "2010B"); //Loop code	
				
				EntityName ent =entlo.get(0); 
				patientjson.addProperty("reqEntIdCode",patService.getDecodedDescription("2010B", "NM101", ent.getEntityIdentificationCode()) );
				patientjson.addProperty("reqEntIdQual",patService.getDecodedDescription("2010B", "NM102", ent.getEntityType()) );
				//nm103-107
				
				patientjson.addProperty("reqLnameOrg",Utility.buildNameorOrg(ent));

				//patientjson.addProperty("reqLnameOrg",ent.getNameLastOrganization());
				if (ent.getNameMiddle()!=null) patientjson.addProperty("reqLnameF",ent.getNameFirst());
				if (ent.getNameFirst()!=null) patientjson.addProperty("reqLnameM",ent.getNameMiddle());
				else {
					patientjson.addProperty("reqLnameM","0");
				}
				if (ent.getNamePrefix()!=null) patientjson.addProperty("reqLnameP",ent.getNamePrefix());
				if (ent.getNameSuffix()!=null) patientjson.addProperty("reqLnameS",ent.getNameSuffix());
			//	patientjson.addProperty("idCode",patService.getDecodedDescription("2010B", "NM108", ent.getEntityIdCode()) );
			//	patientjson.addProperty("idQual",patService.getDecodedDescription("2010B", "NM109", ent.getEntityIdCodeQualifier()) );
				
				String strNM108= patService.getDecodedDescription("2010B", "NM108", ent.getEntityIdCodeQualifier());
				String strNM109= ent.getEntityIdentificationCode();
				String strNM = strNM108 +" " +strNM109;
				patientjson.addProperty("IdQual", strNM );
				
		//References
				JsonArray refjarray = new JsonArray();
				List<References> refs= patService.getReferences(rId , "2010B");
				for (int i=0; i<refs.size();i++){
					JsonObject reqRefjson = new JsonObject();
					References indref = (References) refs.get(i);
					reqRefjson.addProperty("refIdCodQual", patService.getDecodedDescription("2010B", "REF01",indref.getReferenceIdQualifier()));
					reqRefjson.addProperty("refId",   indref.getReferenceId() );	
					refjarray.add(reqRefjson);
					
				}
				patientjson.add("refer", refjarray);
				modelMap.addAttribute("requestRefer", patientjson); 	
				
		//address
				EntityAddress add= patService.getEntityAddress(rId , "2010B"); //Loop code	
				String reqAdd="";
				if (add!=null){
					if (add.getAddress2()!=null){
						reqAdd= add.getAddress1() + add.getAddress2() ;
					}
					else {
						reqAdd= add.getAddress1() ;
					}
					patientjson.addProperty("address", reqAdd);
					patientjson.addProperty("city", add.getCity());
					patientjson.addProperty("state", add.getStateProvCode());
					patientjson.addProperty("zip", add.getPostalCode());
					patientjson.addProperty("country", add.getCountryCode());
				}
		//contact
				ContactInformation nfo= patService.getContactnfoI(rId , "2010B");
				if (nfo!=null){
					patientjson.addProperty("contactName", nfo.getContactName());
					patientjson.addProperty("contactFnId", nfo.getContactFunctionId());
					String strper03= patService.getDecodedDescription("2010B", "PER03", nfo.getCommNumberQualifier1()) ;
					String strper04= nfo.getCommNumber1();
					patientjson.addProperty("comQual1", strper03 +"--" + strper04);
					//patientjson.addProperty("comNo1", nfo.getCommNumber1());
					
					String strper05=patService.getDecodedDescription("2010B", "PER05", nfo.getCommNumberQualifier2());
					String strper06=nfo.getCommNumber2();
					patientjson.addProperty("comQual2",  strper05 +"--"+strper06);
					
					String strper07=patService.getDecodedDescription("2010B", "PER07", nfo.getCommNumberQualifier3());
					String strper08=nfo.getCommNumber3();		
					patientjson.addProperty("comQual3", strper07 + "--"+strper08);
					//patientjson.addProperty("comNo3", nfo.getCommNumber3());
				}
		//provider
				ProviderInformation pinfo= patService.getProviderInfo(rId , "2010B");
				if (pinfo!=null){
					String ptype = patService.getDecodedDescription("2010B", "PRV01", pinfo.getProviderCode() );
					patientjson.addProperty("providerType", ptype);
				}

				modelMap.addAttribute("dependentjson", patientjson);
			
			
return patientjson.toString();
}


@GET
@Path("/getSubscriberInfo")
public String getSubscriberInfo(@QueryParam("id") String id) throws Exception {
			if (LOGGER.isDebugEnabled()) {
				LOGGER.debug("Enter  in getSubscriberInfo");
			}
			JsonObject patientjson = new JsonObject();
			Integer	rId = new Integer(id);
			
	//subscriber
				List<EntityName> entlo= patService.getEntityInfo(rId , "2010C"); //Loop code	
				
				EntityName ent =entlo.get(0); 
				patientjson.addProperty("sEntIdCode",patService.getDecodedDescription("2010C", "NM101", ent.getEntityIdCode()) );
				patientjson.addProperty("sEntType",patService.getDecodedDescription("2010C", "NM102", ent.getEntityType()) );
				
				if (ent.getNameLastOrganization()!=null) patientjson.addProperty("subLname", ent.getNameLastOrganization());
				if (ent.getNameFirst()!=null) patientjson.addProperty("subFname",ent.getNameFirst());
				if (ent.getNameMiddle()!=null) patientjson.addProperty("subMname",ent.getNameMiddle());
				if (ent.getNamePrefix()!=null) patientjson.addProperty("subnameP",ent.getNamePrefix());
				if (ent.getNameSuffix()!=null) patientjson.addProperty("subnameS",ent.getNameSuffix());
				
				patientjson.addProperty("sEntIdCodequal",patService.getDecodedDescription("2010C", "NM108", ent.getEntityIdCodeQualifier()) );
				patientjson.addProperty("sEntIdCode", ent.getEntityIdCode() ); 
				
				
	//address
				EntityAddress add= patService.getAddress(rId , "2010C");
				String reqAdd;
				if (add != null) {
					if (add.getAddress2()!=null){
					 reqAdd= add.getAddress1() + ", "+add.getAddress2();
					}
					else {
						reqAdd= add.getAddress1() ;
					}
					patientjson.addProperty("address", reqAdd);
				}
				else{
					patientjson.addProperty("address", "");
				}
				patientjson.addProperty("city", add.getCity());
				patientjson.addProperty("state", add.getStateProvCode());
				patientjson.addProperty("zip", add.getPostalCode());
				patientjson.addProperty("country", add.getCountryCode());

	//DMZ			
				DemographicInformation demo= patService.getDOBInfo(rId, "2010C" ); 
				if (demo!=null){
					try {
						patientjson.addProperty("sdob",Utility.convertMMDDYYDate(demo.getDateTimePeriod()));
					}
					catch (Exception e){
						patientjson.addProperty("sdob","");
					}
					patientjson.addProperty("sgender",demo.getGenderCode());
				}
				else {
					patientjson.addProperty("sdob","");
					patientjson.addProperty("sgender","");
				}
	//INS
				InsuranceInformation sinfo= patService.getInsuranceInfo(rId , "2010C");
				if (sinfo!=null){
					patientjson.addProperty("insYN", sinfo.getYesNoCode() );	
					patientjson.addProperty("insRcode", patService.getDecodedDescription("2010C", "INS02", sinfo.getIndividualRelationshipCode() ));	
					patientjson.addProperty("empScode", patService.getDecodedDescription("2010C", "INS02", sinfo.getEmploymentStatusCode() ));	
				
				
				}
	//References
				List<References> refs= patService.getReferences(rId , "2010C");
				StringBuilder tmp = new StringBuilder();
				for (int i=0; i<refs.size();i++){
					References indref = (References) refs.get(i);
					String ref = patService.getDecodedDescription("2010C", "REF01", indref.getReferenceIdQualifier() );
					tmp.append(indref.getReferenceId() +'\t'+ ref+'\n');
				}
				patientjson.addProperty("ref", tmp.toString());
			     	
				modelMap.addAttribute("dependentjson", patientjson);
			
			
				return patientjson.toString();
}





@GET
@Path("/getAdmininfo")
public String getAdmininfo() throws Exception {
	if (LOGGER.isDebugEnabled()) {
		LOGGER.debug("Enter  in getAdmininfo");
	}
	
	 List<UserAuthorization> pList = patService.getUserList();
		JsonArray jarray = new JsonArray();
		JsonObject patjson = new JsonObject();
		String feeds =null;
		
		if (pList!=null && pList.size()>0){
			//patjson.addProperty("adminFlag","1");
			//patjson.addProperty("adminCount",pList.size());
		  	for (int i=0; i<pList.size();i++){
		  		JsonObject carejson = new JsonObject();
		  		UserAuthorization indref = (UserAuthorization) pList.get(i);
		  		carejson.addProperty("UserId",   indref.getUserId() );
		  		carejson.addProperty("Domain",   indref.getDomain() );
		  		carejson.addProperty("Admin",   indref.getAdmin() );
		  		carejson.addProperty("Status",   indref.getStatus() );
		  		carejson.addProperty("Station",   indref.getStation_number() );
		  	
		  		jarray.add(carejson);
		  	}
		  //	patjson.addProperty("adminInfo",jarray.toString());
		  	
		  	feeds= " {\"data\": "+ jarray +"}";
		  	return jarray.toString();
		}
		else {
			patjson.addProperty("adminFlag","0");
			patjson.addProperty("adminCount","0");
		}
return patjson.toString(); 		
}


@GET
@Path("/getAuditLog")
public Response getAuditLog(@QueryParam("id") String id) throws Exception {
	if (LOGGER.isDebugEnabled()) {
		LOGGER.debug("Enter  in getEventTracking");
	}
	 String feeds = null;
	
	 List<AuditLog> pList = patService.getAuditLog(new Long(id));
	GsonBuilder gsonBuilder = new GsonBuilder();
	Gson gson = gsonBuilder.registerTypeAdapter(AuditLog.class, new AuditLogAdapter()).create();
	 feeds = gson.toJson(pList);
		modelMap.addAttribute("dependentjson", feeds);

	return Response.status(200).entity(feeds).build(); 	
}


@POST
@Path("/postAuditLog")
@Produces("text/plain")
public Response postAuditLog(@FormParam("decision") String decision, @FormParam("denialCode") String denialCode, @FormParam("queue") String queue, @FormParam("rid") String rid  ) throws Exception {
	if (LOGGER.isDebugEnabled()) {
		LOGGER.debug("Enter  in getEventTracking");
	}
	 String feeds = null;
	
	 String loginName="";
		Principal userCredentials  = req.getUserPrincipal();
		if (userCredentials != null)  
		loginName = userCredentials.getName();
		String username = System.getProperty("user.name");
		
		if (decision!=null&& decision.equalsIgnoreCase("accept")){
			denialCode="";
		}
		//submit request
		boolean  succ = patService.postAuditLog(username, decision, denialCode, queue, rid);
		
		if (decision!=null&& decision.equalsIgnoreCase("Change Queue")){
			//update queue if change queue
			boolean  succchq  = patService.updateQueue( queue, rid);
		}
		
		if (succ==true){
			feeds="Successfully posted";
			return Response.status(200).entity(feeds).build(); 	
		}else 
		{
			feeds="Something wrong while posting audit";
		}
	return Response.status(200).entity(feeds).build(); 	
}

@POST
@Path("/changeStation")
@Produces("text/plain")
public Response changeStation(@FormParam("user") String user, @FormParam("decision") String decision, @FormParam("station") String station, @FormParam("rid") String rid  ) throws Exception {
	if (LOGGER.isDebugEnabled()) {
		LOGGER.debug("Enter  in changeStation");
	}
	 String feeds = null;
					
	//	if (decision!=null&& decision.equalsIgnoreCase("Change Queue")){
			//update queue if change queue
			boolean  succchq  = patService.updateResponsewithStation( station, rid);
	//	}
		
		if (succchq==true){
			feeds="Successfully changed Station to " +station;
			//return Response.status(200).entity(feeds).build(); 
			

			String loginName=user.substring(0, user.indexOf("@"));
			boolean  succ = patService.postAuditLog(loginName, decision+ " to "+station , "", "", rid);
			
			if (succ==true){
				feeds=feeds + "\nSuccessfully updated audit log";
				return Response.status(200).entity(feeds).build(); 	
			}else 
			{
				feeds=feeds+ "\nSomething wrong while posting audit log";
			}
			
		}else 
		{
			feeds="Something wrong while posting changeStation";
		}
		
		
		
	return Response.status(200).entity(feeds).build(); 	
}


//@GET
//@Path("/getAction")
//public Response getAction() throws Exception {
//	if (LOGGER.isDebugEnabled()) {
//		LOGGER.debug("Enter  in getAction");
//	}
//	 String feeds = null;
//	
//	 List<ARPSQueueCodes> pList = patService.getQueueList();
//	GsonBuilder gsonBuilder = new GsonBuilder();
//	Gson gson = gsonBuilder.registerTypeAdapter(AuditLog.class, new AATGUIQueueAdapter()).create();
//	 feeds = gson.toJson(pList);
//	 feeds= " {\"queue\": "+ feeds +"}";
//		
//		modelMap.addAttribute("queueList", feeds);
//
//	return Response.status(200).entity(feeds).build(); 	
//}
@GET
@Path("/getQueue")
public String getQueue(@QueryParam("stationNo") String stno) throws Exception {
	if (LOGGER.isDebugEnabled()) {
		LOGGER.debug("Enter  in getQueue");
	}
	 JsonArray jarray = new JsonArray();
	 JSONObject carejson = new JSONObject();
	 JSONObject hcarejson = new JSONObject();
	 JSONObject pcarejson = new JSONObject();
	 JSONObject rcarejson = new JSONObject();
	 String feed;
	 List<ARPSQueueCodes> pList = patService.getQueueList(stno);
	 List<ARPSQueueCodes> hfqList = new ArrayList<ARPSQueueCodes>();
	 List<ARPSQueueCodes> pqList = new ArrayList<ARPSQueueCodes>();
	 List<ARPSQueueCodes> rqList = new ArrayList<ARPSQueueCodes>();
	 String highLevelQueue="";
	 if (pList!=null){
		 	for (int i=0; i<pList.size();i++){		 		
		 		ARPSQueueCodes ent = (ARPSQueueCodes) pList.get(i);
				JsonObject djson = new JsonObject();
				if (ent.getMenuOrder()==1){
					hcarejson.put("h1queue","High Priority");
					hcarejson.put("href","HighPriority");
			 		hfqList.add(ent);
					
				}else if (ent.getMenuOrder()==2){
					pcarejson.put("h1queue","Processing");
					pcarejson.put("href","Processing");
					pqList.add(ent);
					
				}
				else {
					rcarejson.put("h1queue","Archive");
					rcarejson.put("href","Archive");
					rqList.add(ent);
				}
				
		 	}	
		 	String hjson = new Gson().toJson(hfqList);
		 	String pjson = new Gson().toJson(pqList);
		 	String refjson = new Gson().toJson(rqList);
		 	
		 	hcarejson.put("QueueList",hjson);
		 	pcarejson.put("QueueList",pjson);
		 	rcarejson.put("QueueList",refjson);
		 	
		 	carejson.put("hcarejson", hcarejson);
		 	carejson.put("pcarejson", pcarejson);
		 	carejson.put("rcarejson", rcarejson);
		 	
		}
	 		
return carejson.toString(); 	 	
}





@POST
@Produces("text/plain")
@Path("/updateUserInfo")
public Response updateUserInfo(@QueryParam("uid") String uid, @QueryParam("admin") String admin, @QueryParam("status") String status, @QueryParam("station") String station, @QueryParam("domain") String domain  ) throws Exception {
	if (LOGGER.isDebugEnabled()) {
		LOGGER.debug("Enter  in updateUserInfo");
	}
	 String feeds = null;
	
	 boolean  succ = patService.updateUserAuth("u", uid, domain, status, station, admin);
	 
	 if (succ==true){
			feeds="Successfully updated";
			return Response.status(200).entity(feeds).build(); 		
		}else 
		{
			feeds="Something wrong while posting user";
		}
	 return Response.status(200).entity(feeds).build(); 	
}

@POST
@Produces("text/plain")
@Path("/delUserInfo")
public Response delUserInfo(@FormParam("uid") String uid, @FormParam("admin") String admin, @FormParam("status") String status, @FormParam("station") String station, @FormParam("domain") String domain  ) throws Exception {
	if (LOGGER.isDebugEnabled()) {
		LOGGER.debug("Enter  in delUserInfo");
	}
	 String feeds = null;
	
	 boolean  succ = patService.updateUserAuth("u", uid, domain, "I", station, admin);
	 
	 if (succ==true){
			feeds="Successfully updated";
			return Response.status(200).entity(feeds).build(); 		
		}else 
		{
			feeds="Something wrong while posting user";
		}
	 return Response.status(200).entity(feeds).build(); 	
}

@POST
@Produces("text/plain")
@Path("/addUserInfo")
public Response addUserInfo(@FormParam("uid") String uid, @FormParam("admin") String admin, @FormParam("status") String status, @FormParam("station") String station, @FormParam("domain") String domain  ) throws Exception {
	if (LOGGER.isDebugEnabled()) {
		LOGGER.debug("Enter  in addUserInfo");
	}
	 String feeds = null;
	
	 boolean  succ = patService.updateUserAuth("a", uid, domain, "A", station, admin);
	 
	 if (succ==true){
			feeds="Successfully updated";
			return Response.status(200).entity(feeds).build(); 		
		}else 
		{
			feeds="Something wrong while posting user";
		}
	 return Response.status(200).entity(feeds).build(); 	
}



}