
package va.gov.ws;

import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.UriInfo;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.MessageSource;
import org.springframework.ui.ModelMap;

import com.google.gson.JsonArray;
import com.google.gson.JsonObject;

import va.gov.jpa.dto.ContactInformation;
import va.gov.jpa.dto.DateInformation;
import va.gov.jpa.dto.EntityName;
import va.gov.jpa.dto.HealthCareServicesDelivery;
import va.gov.jpa.dto.HealthServicesReview;
import va.gov.jpa.dto.MessageText;
import va.gov.jpa.dto.PatientInformation;
import va.gov.jpa.dto.References;
import va.gov.jpa.dto.ServicesDental;
import va.gov.jpa.dto.ServicesInstitution;
import va.gov.jpa.dto.ServicesProfessional;
import va.gov.jpa.dto.ServicesTooth;
import va.gov.jpa.dto.TrackingNumber;
import va.gov.service.PatientServiceIntf;
import va.gov.util.Utility;



@Path("/ws/sp")
public class SVCService {
		
	private static final Logger LOGGER = Logger.getLogger(SVCService.class);
	  @Context
	  UriInfo uriInfo;
	  @Context
	  HttpServletRequest req;
	  
	  @Context
	  HttpServletResponse  res;
	  
	  ModelMap modelMap = new ModelMap();
	  
	  @Autowired
		private PatientServiceIntf patService;

		public void setPatService(PatientServiceIntf patService) {
			this.patService = patService;
		}


		
	  		

	  @Autowired  
	  protected MessageSource messages;


	  public void setMessages(MessageSource messages) {
	  	this.messages = messages;
	  }
	  

	  @GET
	  @Path("/geSrvtracking")
	  @Produces("application/json")
	  public String getSvctracking(@QueryParam("id") String id , @QueryParam("lno") String lno) throws Exception {
	  	if (LOGGER.isDebugEnabled()) {
	  		LOGGER.debug("Enter  in geSrvtracking");
	  	}
	  	Integer	rId = new Integer(id);
	  	JsonArray jarray = new JsonArray();
	  	JsonObject servjson = new JsonObject();
	  	//trace
	  	List<TrackingNumber> dinfo= patService.getTrackList(rId , "2000F", lno );
	  	if (dinfo!=null && dinfo.size()>0){
	  	for (int i=0; i<dinfo.size();i++){
	  		JsonObject carejson = new JsonObject();
	  		TrackingNumber dd = (TrackingNumber) dinfo.get(i);
	  		carejson.addProperty("traceCode", patService.getDecodedDescription("2000F", "TRN01",dd.getTraceTypeCode()));
	  		carejson.addProperty("orgComp",   dd.getOriginatingCompanyID() );
	  		carejson.addProperty("refer1",   dd.getReferenceId1() );
	  		carejson.addProperty("refer2",   dd.getReferenceId2() );
	  		carejson.addProperty("lno",   lno );
	  		jarray.add(carejson);
	  	}
	  	servjson.addProperty("tracSInfo",jarray.toString());
		}
		
		else {
			servjson.addProperty("trackSFlag","0");
			servjson.addProperty("trackSCount","0");
		}
			 return servjson.toString(); 	
	  }


	  @GET
	  @Path("/getSReviewSvc")
	  @Produces("application/json")
	  public String getSvcSReview(@QueryParam("id") String id,  @QueryParam("lno") String lno) throws Exception {
	  	if (LOGGER.isDebugEnabled()) {
	  		LOGGER.debug("Enter  in getSReviewSvc");
	  	}
	  	Integer	rId = new Integer(id);
	  	JsonObject carejson = new JsonObject();
	  	//service
	  	HealthServicesReview hrev = patService.getHealthServicesInfo(rId , "2000F", lno  ); 
	  	if (hrev!=null ){
	  	carejson.addProperty("servSFlag","1");
	  	carejson.addProperty("rqCatalog", patService.getDecodedDescription("2000F", "UM01", hrev.getRequestCategCode()));
	  	//carejson.addProperty("serviceTypeCode",  patService.getDecodedDescription("2000F", "UM02", hrev.getcServicesTypeCode()));
	  	carejson.addProperty("servTypeCode", patService.getDecodedDescription("2000F", "UM03", hrev.getServicesTypeCode()));
	  	carejson.addProperty("facility",  patService.getDecodedDescription("2000F", "UM041", hrev.getFacility()));
	  	carejson.addProperty("facilityqual", patService.getDecodedDescription("2000F", "UM042", hrev.getFacilityQualifier()));
	  	carejson.addProperty("relCauseCode1",  patService.getDecodedDescription("2000F", "UM051", hrev.getRelatedCauseCode1()));
	  	carejson.addProperty("relCauseCode2", patService.getDecodedDescription("2000F", "UM052", hrev.getRelatedCauseCode2()));
	  	carejson.addProperty("relCauseCode3",  patService.getDecodedDescription("2000F", "UM053", hrev.getRelatedCauseCode3()));
	  	carejson.addProperty("state", patService.getDecodedDescription("2000F", "UM054", hrev.getStateProvCode()));
	  	carejson.addProperty("country",  patService.getDecodedDescription("2000F", "UM055", hrev.getCountryCode()));
	  	carejson.addProperty("lofService",  patService.getDecodedDescription("2000F", "UM06", hrev.getLevelOfServiceCode()));
	  	carejson.addProperty("curHealthcode", patService.getDecodedDescription("2000F", "UM07", hrev.getCurrentHealthConditionCode()));
	  	carejson.addProperty("progcode",  patService.getDecodedDescription("2000F", "UM08", hrev.getPrognosisCode()));
	  	carejson.addProperty("relInfoCode", patService.getDecodedDescription("2000F", "UM09", hrev.getReleaseOfInformationCode()));
	  	carejson.addProperty("delayReasonCode",  patService.getDecodedDescription("2000F", "UM10", hrev.getDelayReasonCode()));
	  	carejson.addProperty("lno",   lno );
	  	}
	  	else {
	  		carejson.addProperty("servSFlag","0");
	  	}
	  	
	  	return carejson.toString();
	  }


	 
	  
	  @GET
	  @Path("/getSvcReferences")
	  @Produces("application/json")
	  public String getSvcReferences(@QueryParam("id") String id,  @QueryParam("lno") String lno) throws Exception {
	  	if (LOGGER.isDebugEnabled()) {
	  		LOGGER.debug("Enter  in getSvcReferences");
	  	}
	  	Integer	rId = new Integer(id);
	  	JsonArray jarray = new JsonArray();
		JsonObject servjson = new JsonObject();
		  
	  	//References
	  	List<References> refs= patService.getReferences(rId , "2000F");
	  	if (refs!=null && refs.size()>0){
	  		servjson.addProperty("refSFlag","1");
	  		servjson.addProperty("refSCount",refs.size());
		  	for (int i=0; i<refs.size();i++){
		  		JsonObject carejson = new JsonObject();
		  		References indref = (References) refs.get(i);
		  		carejson.addProperty("refIdQual", patService.getDecodedDescription("2000F", "REF01",indref.getReferenceIdQualifier()));
		  		carejson.addProperty("refId",   indref.getReferenceId() );
		  		carejson.addProperty("lno",   lno );
		  		jarray.add(carejson);
		  	}
	  	servjson.addProperty("refSInfo",jarray.toString());
		}
		else {
			servjson.addProperty("refSFlag","0");
			servjson.addProperty("refSCount","0");
		}
			 return servjson.toString(); 	
	  }
	  
	  @GET
	  @Path("/getSvcDates")
	  @Produces("application/json")
	  public String getSvcDates(@QueryParam("id") String id,  @QueryParam("lno") String lno) throws Exception {
	  	if (LOGGER.isDebugEnabled()) {
	  		LOGGER.debug("Enter  in getSvcDates");
	  	}
	  	Integer	rId = new Integer(id);
	  	JsonArray jarray = new JsonArray();
	  	JsonObject servjson = new JsonObject();
		
	  	//dates
	  	
	  	List<DateInformation> dinfo= patService.getDateList(rId , "2000F","1");
	  	if (dinfo!=null & dinfo.size()>0){
	  		servjson.addProperty("dateSFlag",dinfo.size());
		  	for (int i=0; i<dinfo.size();i++){
		  		JsonObject carejson = new JsonObject();
		  		DateInformation dd = (DateInformation) dinfo.get(i);
		  		carejson.addProperty("dateQual", patService.getDecodedDescription("2000E", "DTP01",dd.getDateTimeQualifier()));
		  		if (dd.getDateTimePeriodFormat().equals("RD8")){
		  			String[] atokens = dd.getDateTimePeriod().split("-");
		  			String strStrg= Utility.conStrToMMDDYY("D8" , atokens[0]);
		  			String endStrg= Utility.conStrToMMDDYY("D8" , atokens[1]);
		  			carejson.addProperty("dateTimeP",   strStrg +"-" +endStrg);
		  		}else
		  		{
		  			carejson.addProperty("dateTimeP",   Utility.conStrToMMDDYY(dd.getDateTimePeriod(), dd.getDateTimePeriodFormat()) );
		  		}
		  		carejson.addProperty("lno",   lno );
		  		jarray.add(carejson);
		  	}
		  	servjson.addProperty("dateSInfo",jarray.toString());
	  	}
	  	else {
	  		servjson.addProperty("dateSFlag","0");
			servjson.addProperty("dateSCount","0");
	  	}
	  	
	  	return servjson.toString(); 	
	  }

	  
	  @GET
	  @Path("/getSvcProfService")
	  @Produces("application/json")
	  public String getSvcProfService(@QueryParam("id") String id,  @QueryParam("lno") String lno) throws Exception {
	  	if (LOGGER.isDebugEnabled()) {
	  		LOGGER.debug("Enter  in getSvcdentalServS");
	  	}
	  	Integer	rId = new Integer(id);
	  	JsonObject carejson = new JsonObject();
	  	//service
	  	ServicesProfessional hrev = patService.getProfessionalServicesInfo(rId , "2000F"); 
	  	if (hrev!=null) {
	  		carejson.addProperty("profSFlag","1");
	  		carejson.addProperty("profSCount","1");
		  	carejson.addProperty("diagCPointer1", patService.getDecodedDescription("2000F", "SV107", hrev.getDiagnosisCodePointer1()));
		  	carejson.addProperty("diagCPointer2", patService.getDecodedDescription("2000F", "SV107", hrev.getDiagnosisCodePointer2()));
		  	carejson.addProperty("diagCPointer3", patService.getDecodedDescription("2000F", "SV107", hrev.getDiagnosisCodePointer3()));
		  	carejson.addProperty("diagCPointer4", patService.getDecodedDescription("2000F", "SV107", hrev.getDiagnosisCodePointer4()));
		  	
		  	carejson.addProperty("descr1",  hrev.getDescription1());
		  	carejson.addProperty("locCode", patService.getDecodedDescription("2000F", "SV120", hrev.getLevelOfCareCode()));
		  	carejson.addProperty("mAmount",  hrev.getMonetaryAmount());
	//	  	carejson.addProperty("state", patService.getDecodedDescription("2000F", "SV1", hrev.getStateProvCode()));
	//	  	carejson.addProperty("country",  patService.getDecodedDescription("2000F", "SV1", hrev.getCountryCode()));
	//	  	carejson.addProperty("lofService",  patService.getDecodedDescription("2000F", "SV1", hrev.getLevelOfServiceCode()));
	//	  	carejson.addProperty("curHealthcode", patService.getDecodedDescription("2000F", "SV1", hrev.getCurrentHealthConditionCode()));
	//	  	carejson.addProperty("progcode",  patService.getDecodedDescription("2000F", "SV1", hrev.getPrognosisCode()));
	//	  	carejson.addProperty("relInfoCode", patService.getDecodedDescription("2000F", "SV1", hrev.getReleaseOfInformationCode()));
	//	  	carejson.addProperty("delayReasonCode",  patService.getDecodedDescription("2000F", "SV1", hrev.getDelayReasonCode()));	 
		  	carejson.addProperty("lno",   lno );
	  	}
	  	else {
	  		carejson.addProperty("profSFlag","0");
	  		carejson.addProperty("profSCount","0");
	  	}
	  	return carejson.toString();
	  }
	  
	  @GET
	  @Path("/getSvcInstServS")
	  @Produces("application/json")
	  public String getSvcInstServS(@QueryParam("id") String id,  @QueryParam("lno") String lno) throws Exception {
	  	if (LOGGER.isDebugEnabled()) {
	  		LOGGER.debug("Enter  in getSvcdentalServS");
	  	}
	  	Integer	rId = new Integer(id);
	  	JsonObject carejson = new JsonObject();
	  	//service
	  	ServicesInstitution hrev = patService.getServiceInstitutionInfo(rId,"2000F" ); 
		if (hrev!=null) {
	  		carejson.addProperty("instSFlag","1");
	  		carejson.addProperty("instSCount","1");
	  		
	  		carejson.addProperty("productId", patService.getDecodedDescription("2000F", "SV201", hrev.getProcedureServiceID()));		  		
	  		carejson.addProperty("prodQual", patService.getDecodedDescription("2000F", "SV202-2", hrev.getProductServiceIDQualifier()));	  		
	  		
	  		carejson.addProperty("prodid", patService.getDecodedDescription("2000F", "SV202-2", hrev.getProductServiceIDQualifier()));	  		
	  		carejson.addProperty("procMod1",  hrev.getProcedureModifier1());	  
	  		carejson.addProperty("procMod2",  hrev.getProcedureModifier2());	
	  		carejson.addProperty("procMod3",  hrev.getProcedureModifier3());	
	  		carejson.addProperty("procMod4",  hrev.getProcedureModifier4());	
	  		carejson.addProperty("description",  hrev.getDescription1());	
	  		carejson.addProperty("prodid2",  hrev.getProductServiceID2());	
	  		
	  		carejson.addProperty("amount",  hrev.getMonetaryAmount());
	  		carejson.addProperty("unitMeaCode", patService.getDecodedDescription("2000F", "SV204", hrev.getUnitCode()));	
	  		carejson.addProperty("quantity",  hrev.getQuantity());
	  		carejson.addProperty("unitRate", patService.getDecodedDescription("2000F", "SV206", hrev.getUnitRate()));
		  	carejson.addProperty("lofCareCodeCode", patService.getDecodedDescription("2000F", "SV210", hrev.getLevelOfCareCode()));
		  	carejson.addProperty("lno",   lno );
		}
		else {
	  		carejson.addProperty("instSFlag","0");
	  		carejson.addProperty("instsSCount","0");
	  	}
	  	
	  	return carejson.toString();
	  }
	  
	  @GET
	  @Path("/getSvcdentalServS")
	  @Produces("application/json")
	  public String getSvcdentalServS(@QueryParam("id") String id,  @QueryParam("lno") String lno) throws Exception {
	  	if (LOGGER.isDebugEnabled()) {
	  		LOGGER.debug("Enter  in getSvcdentalServS");
	  	}
	  	Integer	rId = new Integer(id);
	  	JsonObject carejson = new JsonObject();
	  	//service
	  	ServicesDental hrev = patService.getDentalServicesInfo(rId , "2000F"); 
	  	if (hrev!=null) {
	  		carejson.addProperty("dentSFlag","1");
	  		carejson.addProperty("dentSCount","1");
	  		
	  	carejson.addProperty("cav1", hrev.getCavityDesignationCode1());
	  	carejson.addProperty("cav2", hrev.getCavityDesignationCode2());
	  	carejson.addProperty("cav3", hrev.getCavityDesignationCode3());
	  	carejson.addProperty("cav4", hrev.getCavityDesignationCode4());
	  	carejson.addProperty("cav5", hrev.getCavityDesignationCode5());
	  	carejson.addProperty("descr1",  hrev.getDescription1());
	  	//carejson.addProperty("descr2",  hrev.getDescription2());
	  	carejson.addProperty("monAmount",  hrev.getMonetaryAmount());
	  	carejson.addProperty("procMod1", patService.getDecodedDescription("2000F", "SV301-1", hrev.getProcedureModifier1()));
	  	carejson.addProperty("procMod2",  patService.getDecodedDescription("2000F", "SV301", hrev.getProcedureModifier2()));
	  	carejson.addProperty("procMod3", patService.getDecodedDescription("2000F", "SV301", hrev.getProcedureModifier3()));
	  	carejson.addProperty("procMod4",  patService.getDecodedDescription("2000F", "SV301", hrev.getProcedureModifier4()));
	  	carejson.addProperty("proServ1",  hrev.getProductServiceID1());
	  	carejson.addProperty("proServIdQual",  patService.getDecodedDescription("2000F", "SV301-1", hrev.getProductServiceIDQualifier()));
	  	carejson.addProperty("proCrownCode",  patService.getDecodedDescription("2000F", "SV305", hrev.getProsrhesisCrownInlayCode()));
	  	carejson.addProperty("quan",  hrev.getQuantity());
	  	carejson.addProperty("lno",   lno );
	  	}
		else {
	  		carejson.addProperty("dentSFlag","0");
	  		carejson.addProperty("dentSCount","0");
	  	}
	  	
	  	return carejson.toString();
	  }

	  @GET
	  @Path("/getSvcToothInfo")
	  @Produces("application/json")
	  public String getSvcToothInfo(@QueryParam("id") String id,  @QueryParam("lno") String lno) throws Exception {
	  	if (LOGGER.isDebugEnabled()) {
	  		LOGGER.debug("Enter  in getSvcToothInfo");
	  	}
	  	Integer	rId = new Integer(id);
	  	JsonArray jarray = new JsonArray();
		JsonObject servjson = new JsonObject();
		
	  	//References
	  	List<ServicesTooth> refs= patService.getToothInfo(rId , "2000F");
		if (refs!=null & refs.size()>0){
			servjson.addProperty("toothSFlag","1");
	  		servjson.addProperty("toothSCount",refs.size());
	  	for (int i=0; i<refs.size();i++){
	  		JsonObject carejson = new JsonObject();
	  		ServicesTooth indref = (ServicesTooth) refs.get(i);
	  		carejson.addProperty("codeListQual", patService.getDecodedDescription("2000F", "TOO01",indref.getCodeListQualifier()));
	  		carejson.addProperty("indCode",   indref.getIndustryCode() );
	  		carejson.addProperty("tsurf1",   patService.getDecodedDescription("2000F", "TOO03-1",indref.getSurfaceCode1()) );
	  		carejson.addProperty("tsurf2",   patService.getDecodedDescription("2000F", "TOO03-2",indref.getSurfaceCode2()) );
	  		carejson.addProperty("tsurf3",   patService.getDecodedDescription("2000F", "TOO03-3",indref.getSurfaceCode3()) );
	  		carejson.addProperty("tsurf4",   patService.getDecodedDescription("2000F", "TOO03-4",indref.getSurfaceCode4()) );
	  		carejson.addProperty("tsurf5",   patService.getDecodedDescription("2000F", "TOO03-5",indref.getSurfaceCode5()) );
	  		carejson.addProperty("lno",   lno );
	  		jarray.add(carejson);
	  	}
		servjson.addProperty("toothSInfo",jarray.toString());
		}
		else {
			servjson.addProperty("toothSFlag","0");
			servjson.addProperty("toothSCount","0");
		}
	  	
	  	return servjson.toString(); 	
	  }
	  
	  @GET
	  @Path("/getSvcSerDelivery")
	  @Produces("application/json")
	  public String getSvcSerDelivery(@QueryParam("id") String id,  @QueryParam("lno") String lno) throws Exception {
		  	if (LOGGER.isDebugEnabled()) {
		  		LOGGER.debug("Enter  in getSReviewSvc");
		  	}
		  	Integer	rId = new Integer(id);
		  	JsonObject carejson = new JsonObject();
		  	//service
		  	HealthCareServicesDelivery hrev = patService.getHealthCareServicesDelivery(rId , "2000F","1"); 
		  	if (hrev!=null){
			  		carejson.addProperty("svcDelSFlag","1");
			  		carejson.addProperty("svcDelSCount","1");
			  	carejson.addProperty("delcode",  patService.getDecodedDescription("2000F", "HSD08", hrev.getDeliveryCode()));
			  	carejson.addProperty("delpatCode", patService.getDecodedDescription("2000F", "HSD07", hrev.getDeliveryPatternCode()));
			  	carejson.addProperty("freq",  hrev.getFrequency());
			  	carejson.addProperty("noOfPeriod", hrev.getNumberofPeriods());
			  	//carejson.addProperty("timePeriod", hrev.gettNumberofPeriods());
			  	carejson.addProperty("quantity",  hrev.getQuantity());
			  	carejson.addProperty("unit",  hrev.getUnitCode());
			  	carejson.addProperty("quanqual",  patService.getDecodedDescription("2000F", "HSD01", hrev.getQuantityQualifierCode()));
			  	carejson.addProperty("lno",   lno );
		  	}
		  	else {
		  		carejson.addProperty("svcDelSFlag","0");
		  		carejson.addProperty("svcDelSCount","0");
		  	}
		  	
		  	return carejson.toString();
		  }
	  
	  @GET
	  @Path("/getAdditionalSer")
	  @Produces("application/json")
	  public String getAdditionalSer(@QueryParam("id") String id,  @QueryParam("lno") String lno) throws Exception {
		  	if (LOGGER.isDebugEnabled()) {
		  		LOGGER.debug("Enter  in getAdditionalSer");
		  	}
		  	Integer	rId = new Integer(id);
		  	JsonObject carejson = new JsonObject();
		  	//service
		  	PatientInformation hrev = patService.getAdditionalServices(rId , "2000F"); 
		  	if (hrev!=null){
		  		carejson.addProperty("addnSFlag","1");
		  		carejson.addProperty("addnSCount","1");
			  	carejson.addProperty("rTypeCode",  patService.getDecodedDescription("2000F", "PWK01", hrev.getReportTypeCode()));
			  	carejson.addProperty("rTransCode", patService.getDecodedDescription("2000F", "PWK02", hrev.getReportTransmCode()));
			  	carejson.addProperty("idCodeQual", patService.getDecodedDescription("2000F", "PWK05", hrev.getiDCodeQualifier()));
			  	carejson.addProperty("id",    hrev.getIdentifier());
			  	carejson.addProperty("descr",  hrev.getDescription());
			  	carejson.addProperty("lno",   lno );
		  	} 
		  	else {
		  		carejson.addProperty("addnSFlag","0");
		  		carejson.addProperty("addnSCount","0");
		  	}
		  	return carejson.toString();
		  }

	  @GET
	  @Path("/getMessage")
	  @Produces("application/json")
	  public String getMessage(@QueryParam("id") String id,  @QueryParam("lno") String lno) throws Exception {
		  	if (LOGGER.isDebugEnabled()) {
		  		LOGGER.debug("Enter  in getMessage");
		  	}
		  	Integer	rId = new Integer(id);
		  	JsonObject carejson = new JsonObject();
		  	//service
		  	MessageText hrev = patService.getMessges(rId , "2000F"); 
			if (hrev!=null){
		  		carejson.addProperty("msgSFlag","1");
		  		carejson.addProperty("msgSCount","1");
		  	carejson.addProperty("freMesg", hrev.getMessage());
		  	carejson.addProperty("lno",   lno );
			} 
		  	else {
		  		carejson.addProperty("msgSFlag","0");
		  		carejson.addProperty("msgSCount","0");
		  	}	  
		  	return carejson.toString();
		  }
	  
	  @GET
	  @Path("/getServiceProvNameSvc")
	  @Produces("application/json")
	  public String getServiceProvNameSvc(@QueryParam("id") String id,  @QueryParam("lno") String lno) throws Exception {
	  	  	if (LOGGER.isDebugEnabled()) {
	  	  		LOGGER.debug("Enter  in getServiceProvNameSvc");
	  	  	}
	  	  	Integer	rId = new Integer(id);
	  	  	JsonObject servjson = new JsonObject();
	  	  	JsonArray jarray = new JsonArray();
	  	  	//service
	  	  	List<EntityName> entlo= patService.getEntityInfo(rId , "2010FA"); //Loop code		
	  		if (entlo!=null && entlo.size()>0){
	  			servjson.addProperty("sProvNameSFlag","1");
				servjson.addProperty("sProvNameSCount",entlo.size());
	  		 	for (int i=0; i<entlo.size();i++){
	  		 		
	  		 		EntityName ent = (EntityName) entlo.get(i);
	  			JsonObject djson = new JsonObject();
	  			djson.addProperty("reqLnameOrg",Utility.buildNameorOrg(ent));
	  			
	  			djson.addProperty("reqEntIdQual",patService.getDecodedDescription("2010FA", "NM102", ent.getEntityIdCodeQualifier()) );
	  			djson.addProperty("reqEntIdCode",ent.getEntityIdCode() );
	  			djson.addProperty("IdQual",patService.getDecodedDescription("2010FA", "NM108", ent.getEntityIdCodeQualifier()) );
	  			djson.addProperty("IdCode",ent.getEntityIdentificationCode() );
	  			djson.addProperty("lno",   lno );
	  			jarray.add(djson);
	  		 	}	 
	  		 	servjson.addProperty("servProvSInfo",jarray.toString());
			}
			else {
				servjson.addProperty("sProvNameSFlag","0");
				servjson.addProperty("sProvNameSCount","0");
			}
	  		return servjson.toString();

	  }
	  
	  @GET
	  @Path("/getAddServInfoContactSvc")
	  @Produces("application/json")
	  public String getAddServInfoContactSvc(@QueryParam("id") String id,  @QueryParam("lno") String lno) throws Exception {
	  	  	if (LOGGER.isDebugEnabled()) {
	  	  		LOGGER.debug("Enter  in getServiceProvNameSvc");
	  	  	}
	  	  	Integer	rId = new Integer(id);
	  	  JsonObject djson = new JsonObject();
	  	  	//service
	  	  ContactInformation nfo= patService.getContactnfoI(rId , "2010FB");
			if (nfo!=null){
					djson.addProperty("aServContSFlag","1");
					djson.addProperty("aServContSCount","1");
	  			djson.addProperty("name",nfo.getContactName());
	  			djson.addProperty("functionCode",nfo.getContactFunctionId());
	  			djson.addProperty("Com1Qual",nfo.getCommNumberQualifier1());
	  			djson.addProperty("Com1num",nfo.getCommNumber1());
	  			djson.addProperty("Com1Qua2",nfo.getCommNumberQualifier2());
	  			djson.addProperty("Com1num2",nfo.getCommNumber2());
	  			djson.addProperty("Com1Qua3",nfo.getCommNumberQualifier3());
	  			djson.addProperty("Com1num3",nfo.getCommNumber3());
	  			djson.addProperty("lno",   lno );
				}
				else {
					djson.addProperty("aServContSFlag","0");
					djson.addProperty("aServContSCount","0");
			  	}	  
	  			return djson.toString(); 
	  }

}