﻿/*
 * Program Name: New Standards and Operating Rules - Payer Side (POR)
 * Contractor Name: Harris Corporation
 * Contract Number: VA118-11-D-1009
 * Project: POR - CORE Compliance - Automated Eligibility Tool (AET)
 * 
 * Developer: Zach Bertram
 * Date: 01.22.2013
 * ----------------
 * Added settings for DB containing Service Type Code info
 */

using System;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using Microsoft.ManagementConsole;
using Microsoft.Win32;
using System.ServiceProcess;
using System.Threading;
using System.Diagnostics;
using Microsoft.VisualBasic.Devices;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Collections;
using AnsiParser5010;
using System.IO;
using System.Data;
using System.Linq;
using System.Security;




namespace AETServiceSettings
{
    /// <summary>
    /// The selection control class.
    /// </summary>
    public partial class AETControl : UserControl, Microsoft.ManagementConsole.IFormViewControl
    {
        private bool buttonsEnabled = true;
        private ComputerInfo ci;
        private PerformanceCounter cpuCounter;
        private ServiceController sc;
        private List<float> cpuSamples;
        public ToolTip toolTip1;
        private IContainer components;
        private Label label23;
        private Label label24;
        private GroupBox groupBox5;
        private TextBox textBox6;
        private TextBox textBox7;
        private Label label25;
        private Label label26;
        private TextBox textBox8;
        private GroupBox groupBox6;
        private TextBox textBox9;
        private TextBox textBox10;
        private TextBox textBox11;
        private Button button2;
        private TextBox textBox12;
        private Label label27;
        private Label label28;
        private Label label29;
        private OpenFileDialog openFileDialog1;
        private TabPage tabPage5;
        private GroupBox groupBox7;
        private TextBox txtLEIEUpdate;
        private Label label38;
        private Button button8;
        private TextBox LEIEExt;
        private TextBox LEIEWatchFolder;
        private Label label30;
        private Label label31;
        private GroupBox groupBox8;
        private Button button7;
        private TextBox LEIEUser;
        private TextBox LEIEPw;
        private TextBox LEIEDatabase;
        private TextBox LEIEServer;
        private Button button3;
        private TextBox LEIEFileName;
        private Label label32;
        private Label label33;
        private Label label34;
        private Label label35;
        private Label label36;
        private TabPage tabPage4;
        private GroupBox groupBox4;
        private TextBox txtZipUpdate;
        private Label label37;
        private Button button4;
        private TextBox ZipCodeExt;
        private TextBox ZipCodeWatchFolder;
        private Label label22;
        private Label label21;
        private GroupBox groupBox1;
        private Button button5;
        private TextBox ZUser;
        private TextBox ZPw;
        private TextBox ZDatabase;
        private TextBox ZServer;
        private Button button1;
        private TextBox VMACFileName;
        private Label label5;
        private Label label7;
        private Label label8;
        private Label label11;
        private Label label9;
        private TabPage tabPage3;
        private Button button10;
        private TextBox AETReportName;
        private Label label48;
        private Button button9;
        private Label label47;
        private Label label46;
        private DateTimePicker dateTimePicker2;
        private DateTimePicker dateTimePicker1;
        private TabPage tabPage1;
        private Label lblMVIStatus;
        private Label lblTRNID;
        private Label lblEBReturn;
        private Label lblESRTime;
        private Label lblESRStatus;
        private Label lblMVITime;
        private Label label40;
        private Label lblElapsedTime;
        private Label lblIP;
        private Label lblErrorMsg;
        private Label lblErrorID;
        private Label lblStatus;
        private Label lblClearingHouse;
        private Label lblResponseQual;
        private Label lblResponseTime;
        private Label lblRequestQual;
        private Label lblRequestTime;
        private Button btnBack;
        private Button btnSelect;
        private DateTimePicker logDatePicker;
        private DataGridView dataGridView1;
        private WebBrowser webBrowser271;
        private WebBrowser webBrowser270;
        private TabPage tabEligibilityConfiguration;
        private GroupBox DBNames;
        private Label label1;
        private TextBox leieDB;
        private TextBox zipDb;
        private Label label4;
        private TextBox ansiDb;
        private Label label6;
        private TextBox logDb;
        private Label label10;
        private GroupBox groupBox3;
        private TextBox esPW;
        private TextBox esSA;
        private TextBox pkiCert;
        private Label label15;
        private Label label18;
        private Label label17;
        private GroupBox groupBox2;
        private TextBox esURL;
        private TextBox mviURL;
        private Label label14;
        private Label label16;
        private GroupBox dbGroup;
        private Label label3;
        private Label label2;
        private Label zipServerLabel;
        private TextBox DBPassword;
        private TextBox DBUser;
        private TextBox DBServerName;
        private Button saveButton2;
        private Label savedSettingsLabel2;
        private TabPage controlTab;
        private GroupBox controlGroup;
        private Label label13;
        private Label statusLabel;
        private Button restartButton;
        private Button startButton;
        private Button stopButton;
        private GroupBox performanceGroup;
        private ProgressBar virtualMemUsage;
        private ProgressBar physicalMemUsage;
        private Label virtualMemLabel;
        private Label physicalMemLabel;
        private Label cpuLabel;
        private ProgressBar cpuUsage;
        private TabControl tabControl1;
        private TextBox tbRequestTime;
        private TextBox tbResponceTime;
        private GroupBox STCGroup;
        private Label label39;
        private TextBox STCPassword;
        private TextBox STCUser;
        private Label label41;
        private TextBox STCServer;
        private Label label42;
        private TextBox STCDatabase;
        private Label label43;
        private Label label52;
        //private CheckBox chkEnableLogging2;
        //private TextBox txtLoggingDirectory2;
        private Label label51;
        private TabPage tabAuthorizationConfiguration;
        private GroupBox groupBox9;
        private Label label44;
        private TextBox txtAatDatabasePassword;
        private TextBox txtAatDatabaseUsername;
        private Label label45;
        private TextBox txtAatServer;
        private Label label49;
        private TextBox txtAatDatabase;
        private Label label50;
        private TabPage tabServiceConfiguration;
        private Button saveButton1;
        private Button saveButton3;
        private GroupBox generalGroup;
        private CheckBox cbEnableDebug;
        private TextBox whiteIP;
        private TextBox sslCertName;
        private Label label20;
        private Label label19;
        private Label servicePortLabel;
        private Label label12;
        private TextBox servicePort;
        private TextBox controlPort;
        private GroupBox groupBoxLogging;
        private TextBox txtLoggingDirectory;
        private Label label54;
        private Label label53;
        private CheckBox chkEnableLogging;
        private GroupBox groupBox10;
        private TextBox txtCdwServer;
        private Label label57;
        private TextBox txtCdwDatabase;
        private Label label58;
        private CheckBox chkLogZeroLength;
		private TabPage tabPage2;
		private GroupBox groupBox11;
		private TextBox txtNPIUpdate;
		private Label label55;
		private Button cmdSaveNPI;
		private TextBox NPIExt;
		private TextBox NPIWatchFolder;
		private Label label56;
		private Label label59;
		AETFormView aetFormView = null;

        // Added by Steve Speck 11/2/2011
        //private ToolTip tooltip;

        public AETControl()
        {
            InitializeComponent();
            savedSettingsLabel2.Text = "";
            try
            {
                ReadRegistry();
            }
            catch
            {
                //MessageBox.Show("Missing Registry Settings!");
            }
            ci = new ComputerInfo();
            physicalMemUsage.Maximum = (int)(ci.TotalPhysicalMemory / 1048576); //int doesn't have enough precision
            virtualMemUsage.Maximum = (int)(ci.TotalVirtualMemory / 1048576);
            cpuUsage.Maximum = 100;
            cpuCounter = new PerformanceCounter();
            cpuCounter.CategoryName = "Processor";
            cpuCounter.CounterName = "% Processor Time";
            cpuCounter.InstanceName = "_Total";
            // fill sample array for smooth cpu usage tracking 
            cpuSamples = new List<float>();
            for (int i = 0; i < 10; i++) cpuSamples.Add(cpuCounter.NextValue());
            sc = new ServiceController("AETService");
            try
            {
                sc.Refresh();
                if (sc.Status == ServiceControllerStatus.Running) { } // throws exception if service is not installed
                new Thread(new ThreadStart(updateControlLoop)).Start();
            }
            catch (InvalidOperationException)
            {
                MessageBox.Show("AET Service was not found on your computer");
                Environment.Exit(-1);
                startButton.Enabled = false;
                stopButton.Enabled = false;
                restartButton.Enabled = false;
                saveButton2.Enabled = false;
            }
            new Thread(new ThreadStart(updatePerformanceLoop)).Start();
        }
        void IFormViewControl.Initialize(FormView parentSelectionFormView)
        {
            aetFormView = (AETFormView)parentSelectionFormView;
        }
        private void InitializeComponent()
        {
			this.components = new System.ComponentModel.Container();
			this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
			this.LEIEFileName = new System.Windows.Forms.TextBox();
			this.button3 = new System.Windows.Forms.Button();
			this.LEIEServer = new System.Windows.Forms.TextBox();
			this.LEIEDatabase = new System.Windows.Forms.TextBox();
			this.LEIEPw = new System.Windows.Forms.TextBox();
			this.LEIEUser = new System.Windows.Forms.TextBox();
			this.LEIEWatchFolder = new System.Windows.Forms.TextBox();
			this.LEIEExt = new System.Windows.Forms.TextBox();
			this.ZipCodeWatchFolder = new System.Windows.Forms.TextBox();
			this.ZipCodeExt = new System.Windows.Forms.TextBox();
			this.DBServerName = new System.Windows.Forms.TextBox();
			this.logDb = new System.Windows.Forms.TextBox();
			this.ansiDb = new System.Windows.Forms.TextBox();
			this.zipDb = new System.Windows.Forms.TextBox();
			this.leieDB = new System.Windows.Forms.TextBox();
			this.STCPassword = new System.Windows.Forms.TextBox();
			this.STCUser = new System.Windows.Forms.TextBox();
			this.STCServer = new System.Windows.Forms.TextBox();
			this.STCDatabase = new System.Windows.Forms.TextBox();
			this.txtAatDatabasePassword = new System.Windows.Forms.TextBox();
			this.txtAatDatabaseUsername = new System.Windows.Forms.TextBox();
			this.txtAatServer = new System.Windows.Forms.TextBox();
			this.txtAatDatabase = new System.Windows.Forms.TextBox();
			this.txtCdwServer = new System.Windows.Forms.TextBox();
			this.txtCdwDatabase = new System.Windows.Forms.TextBox();
			this.label23 = new System.Windows.Forms.Label();
			this.label24 = new System.Windows.Forms.Label();
			this.groupBox5 = new System.Windows.Forms.GroupBox();
			this.textBox6 = new System.Windows.Forms.TextBox();
			this.textBox7 = new System.Windows.Forms.TextBox();
			this.label25 = new System.Windows.Forms.Label();
			this.label26 = new System.Windows.Forms.Label();
			this.textBox8 = new System.Windows.Forms.TextBox();
			this.groupBox6 = new System.Windows.Forms.GroupBox();
			this.textBox9 = new System.Windows.Forms.TextBox();
			this.textBox10 = new System.Windows.Forms.TextBox();
			this.textBox11 = new System.Windows.Forms.TextBox();
			this.button2 = new System.Windows.Forms.Button();
			this.textBox12 = new System.Windows.Forms.TextBox();
			this.label27 = new System.Windows.Forms.Label();
			this.label28 = new System.Windows.Forms.Label();
			this.label29 = new System.Windows.Forms.Label();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.tabPage5 = new System.Windows.Forms.TabPage();
			this.groupBox7 = new System.Windows.Forms.GroupBox();
			this.txtLEIEUpdate = new System.Windows.Forms.TextBox();
			this.label38 = new System.Windows.Forms.Label();
			this.button8 = new System.Windows.Forms.Button();
			this.label30 = new System.Windows.Forms.Label();
			this.label31 = new System.Windows.Forms.Label();
			this.groupBox8 = new System.Windows.Forms.GroupBox();
			this.button7 = new System.Windows.Forms.Button();
			this.label32 = new System.Windows.Forms.Label();
			this.label33 = new System.Windows.Forms.Label();
			this.label34 = new System.Windows.Forms.Label();
			this.label35 = new System.Windows.Forms.Label();
			this.label36 = new System.Windows.Forms.Label();
			this.tabPage4 = new System.Windows.Forms.TabPage();
			this.groupBox4 = new System.Windows.Forms.GroupBox();
			this.txtZipUpdate = new System.Windows.Forms.TextBox();
			this.label37 = new System.Windows.Forms.Label();
			this.button4 = new System.Windows.Forms.Button();
			this.label22 = new System.Windows.Forms.Label();
			this.label21 = new System.Windows.Forms.Label();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.button5 = new System.Windows.Forms.Button();
			this.ZUser = new System.Windows.Forms.TextBox();
			this.ZPw = new System.Windows.Forms.TextBox();
			this.ZDatabase = new System.Windows.Forms.TextBox();
			this.ZServer = new System.Windows.Forms.TextBox();
			this.button1 = new System.Windows.Forms.Button();
			this.VMACFileName = new System.Windows.Forms.TextBox();
			this.label5 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.label11 = new System.Windows.Forms.Label();
			this.label9 = new System.Windows.Forms.Label();
			this.tabPage3 = new System.Windows.Forms.TabPage();
			this.button10 = new System.Windows.Forms.Button();
			this.AETReportName = new System.Windows.Forms.TextBox();
			this.label48 = new System.Windows.Forms.Label();
			this.button9 = new System.Windows.Forms.Button();
			this.label47 = new System.Windows.Forms.Label();
			this.label46 = new System.Windows.Forms.Label();
			this.dateTimePicker2 = new System.Windows.Forms.DateTimePicker();
			this.dateTimePicker1 = new System.Windows.Forms.DateTimePicker();
			this.tabPage1 = new System.Windows.Forms.TabPage();
			this.tbResponceTime = new System.Windows.Forms.TextBox();
			this.tbRequestTime = new System.Windows.Forms.TextBox();
			this.lblMVIStatus = new System.Windows.Forms.Label();
			this.lblTRNID = new System.Windows.Forms.Label();
			this.lblEBReturn = new System.Windows.Forms.Label();
			this.lblESRTime = new System.Windows.Forms.Label();
			this.lblESRStatus = new System.Windows.Forms.Label();
			this.lblMVITime = new System.Windows.Forms.Label();
			this.label40 = new System.Windows.Forms.Label();
			this.lblElapsedTime = new System.Windows.Forms.Label();
			this.lblIP = new System.Windows.Forms.Label();
			this.lblErrorMsg = new System.Windows.Forms.Label();
			this.lblErrorID = new System.Windows.Forms.Label();
			this.lblStatus = new System.Windows.Forms.Label();
			this.lblClearingHouse = new System.Windows.Forms.Label();
			this.lblResponseQual = new System.Windows.Forms.Label();
			this.lblResponseTime = new System.Windows.Forms.Label();
			this.lblRequestQual = new System.Windows.Forms.Label();
			this.lblRequestTime = new System.Windows.Forms.Label();
			this.btnBack = new System.Windows.Forms.Button();
			this.btnSelect = new System.Windows.Forms.Button();
			this.logDatePicker = new System.Windows.Forms.DateTimePicker();
			this.dataGridView1 = new System.Windows.Forms.DataGridView();
			this.webBrowser271 = new System.Windows.Forms.WebBrowser();
			this.webBrowser270 = new System.Windows.Forms.WebBrowser();
			this.tabEligibilityConfiguration = new System.Windows.Forms.TabPage();
			this.STCGroup = new System.Windows.Forms.GroupBox();
			this.label39 = new System.Windows.Forms.Label();
			this.label41 = new System.Windows.Forms.Label();
			this.label42 = new System.Windows.Forms.Label();
			this.label43 = new System.Windows.Forms.Label();
			this.DBNames = new System.Windows.Forms.GroupBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.label10 = new System.Windows.Forms.Label();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.esPW = new System.Windows.Forms.TextBox();
			this.esSA = new System.Windows.Forms.TextBox();
			this.pkiCert = new System.Windows.Forms.TextBox();
			this.label15 = new System.Windows.Forms.Label();
			this.label18 = new System.Windows.Forms.Label();
			this.label17 = new System.Windows.Forms.Label();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.esURL = new System.Windows.Forms.TextBox();
			this.mviURL = new System.Windows.Forms.TextBox();
			this.label14 = new System.Windows.Forms.Label();
			this.label16 = new System.Windows.Forms.Label();
			this.dbGroup = new System.Windows.Forms.GroupBox();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.zipServerLabel = new System.Windows.Forms.Label();
			this.DBPassword = new System.Windows.Forms.TextBox();
			this.DBUser = new System.Windows.Forms.TextBox();
			this.saveButton2 = new System.Windows.Forms.Button();
			this.savedSettingsLabel2 = new System.Windows.Forms.Label();
			this.label52 = new System.Windows.Forms.Label();
			this.label51 = new System.Windows.Forms.Label();
			this.controlTab = new System.Windows.Forms.TabPage();
			this.controlGroup = new System.Windows.Forms.GroupBox();
			this.label13 = new System.Windows.Forms.Label();
			this.statusLabel = new System.Windows.Forms.Label();
			this.restartButton = new System.Windows.Forms.Button();
			this.startButton = new System.Windows.Forms.Button();
			this.stopButton = new System.Windows.Forms.Button();
			this.performanceGroup = new System.Windows.Forms.GroupBox();
			this.virtualMemUsage = new System.Windows.Forms.ProgressBar();
			this.physicalMemUsage = new System.Windows.Forms.ProgressBar();
			this.virtualMemLabel = new System.Windows.Forms.Label();
			this.physicalMemLabel = new System.Windows.Forms.Label();
			this.cpuLabel = new System.Windows.Forms.Label();
			this.cpuUsage = new System.Windows.Forms.ProgressBar();
			this.tabControl1 = new System.Windows.Forms.TabControl();
			this.tabServiceConfiguration = new System.Windows.Forms.TabPage();
			this.groupBoxLogging = new System.Windows.Forms.GroupBox();
			this.chkLogZeroLength = new System.Windows.Forms.CheckBox();
			this.txtLoggingDirectory = new System.Windows.Forms.TextBox();
			this.label54 = new System.Windows.Forms.Label();
			this.label53 = new System.Windows.Forms.Label();
			this.chkEnableLogging = new System.Windows.Forms.CheckBox();
			this.generalGroup = new System.Windows.Forms.GroupBox();
			this.cbEnableDebug = new System.Windows.Forms.CheckBox();
			this.whiteIP = new System.Windows.Forms.TextBox();
			this.sslCertName = new System.Windows.Forms.TextBox();
			this.label20 = new System.Windows.Forms.Label();
			this.label19 = new System.Windows.Forms.Label();
			this.servicePortLabel = new System.Windows.Forms.Label();
			this.label12 = new System.Windows.Forms.Label();
			this.servicePort = new System.Windows.Forms.TextBox();
			this.controlPort = new System.Windows.Forms.TextBox();
			this.saveButton1 = new System.Windows.Forms.Button();
			this.tabAuthorizationConfiguration = new System.Windows.Forms.TabPage();
			this.groupBox10 = new System.Windows.Forms.GroupBox();
			this.label57 = new System.Windows.Forms.Label();
			this.label58 = new System.Windows.Forms.Label();
			this.saveButton3 = new System.Windows.Forms.Button();
			this.groupBox9 = new System.Windows.Forms.GroupBox();
			this.label44 = new System.Windows.Forms.Label();
			this.label45 = new System.Windows.Forms.Label();
			this.label49 = new System.Windows.Forms.Label();
			this.label50 = new System.Windows.Forms.Label();
			this.tabPage2 = new System.Windows.Forms.TabPage();
			this.groupBox11 = new System.Windows.Forms.GroupBox();
			this.txtNPIUpdate = new System.Windows.Forms.TextBox();
			this.label55 = new System.Windows.Forms.Label();
			this.cmdSaveNPI = new System.Windows.Forms.Button();
			this.NPIExt = new System.Windows.Forms.TextBox();
			this.NPIWatchFolder = new System.Windows.Forms.TextBox();
			this.label56 = new System.Windows.Forms.Label();
			this.label59 = new System.Windows.Forms.Label();
			this.groupBox5.SuspendLayout();
			this.groupBox6.SuspendLayout();
			this.tabPage5.SuspendLayout();
			this.groupBox7.SuspendLayout();
			this.groupBox8.SuspendLayout();
			this.tabPage4.SuspendLayout();
			this.groupBox4.SuspendLayout();
			this.groupBox1.SuspendLayout();
			this.tabPage3.SuspendLayout();
			this.tabPage1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.dataGridView1)).BeginInit();
			this.tabEligibilityConfiguration.SuspendLayout();
			this.STCGroup.SuspendLayout();
			this.DBNames.SuspendLayout();
			this.groupBox3.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.dbGroup.SuspendLayout();
			this.controlTab.SuspendLayout();
			this.controlGroup.SuspendLayout();
			this.performanceGroup.SuspendLayout();
			this.tabControl1.SuspendLayout();
			this.tabServiceConfiguration.SuspendLayout();
			this.groupBoxLogging.SuspendLayout();
			this.generalGroup.SuspendLayout();
			this.tabAuthorizationConfiguration.SuspendLayout();
			this.groupBox10.SuspendLayout();
			this.groupBox9.SuspendLayout();
			this.tabPage2.SuspendLayout();
			this.groupBox11.SuspendLayout();
			this.SuspendLayout();
			// 
			// toolTip1
			// 
			this.toolTip1.AutoPopDelay = 5000;
			this.toolTip1.InitialDelay = 250;
			this.toolTip1.IsBalloon = true;
			this.toolTip1.ReshowDelay = 100;
			// 
			// LEIEFileName
			// 
			this.LEIEFileName.Location = new System.Drawing.Point(104, 27);
			this.LEIEFileName.Name = "LEIEFileName";
			this.LEIEFileName.Size = new System.Drawing.Size(238, 20);
			this.LEIEFileName.TabIndex = 1;
			this.toolTip1.SetToolTip(this.LEIEFileName, "File to import");
			// 
			// button3
			// 
			this.button3.Location = new System.Drawing.Point(353, 22);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(25, 29);
			this.button3.TabIndex = 2;
			this.button3.Text = "...";
			this.toolTip1.SetToolTip(this.button3, "Browse for Import File.");
			this.button3.UseVisualStyleBackColor = true;
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// LEIEServer
			// 
			this.LEIEServer.Location = new System.Drawing.Point(133, 53);
			this.LEIEServer.Name = "LEIEServer";
			this.LEIEServer.Size = new System.Drawing.Size(209, 20);
			this.LEIEServer.TabIndex = 4;
			this.toolTip1.SetToolTip(this.LEIEServer, "LEIE database Server");
			this.LEIEServer.TextChanged += new System.EventHandler(this.textBox18_TextChanged);
			// 
			// LEIEDatabase
			// 
			this.LEIEDatabase.Location = new System.Drawing.Point(133, 76);
			this.LEIEDatabase.Name = "LEIEDatabase";
			this.LEIEDatabase.Size = new System.Drawing.Size(209, 20);
			this.LEIEDatabase.TabIndex = 6;
			this.toolTip1.SetToolTip(this.LEIEDatabase, "LEIE Database");
			this.LEIEDatabase.TextChanged += new System.EventHandler(this.textBox17_TextChanged);
			// 
			// LEIEPw
			// 
			this.LEIEPw.Location = new System.Drawing.Point(133, 125);
			this.LEIEPw.Name = "LEIEPw";
			this.LEIEPw.PasswordChar = '*';
			this.LEIEPw.Size = new System.Drawing.Size(209, 20);
			this.LEIEPw.TabIndex = 10;
			this.toolTip1.SetToolTip(this.LEIEPw, "LEIE Database Password");
			// 
			// LEIEUser
			// 
			this.LEIEUser.Location = new System.Drawing.Point(133, 100);
			this.LEIEUser.Name = "LEIEUser";
			this.LEIEUser.Size = new System.Drawing.Size(209, 20);
			this.LEIEUser.TabIndex = 8;
			this.toolTip1.SetToolTip(this.LEIEUser, "LEIE Database user");
			// 
			// LEIEWatchFolder
			// 
			this.LEIEWatchFolder.Location = new System.Drawing.Point(115, 33);
			this.LEIEWatchFolder.Name = "LEIEWatchFolder";
			this.LEIEWatchFolder.Size = new System.Drawing.Size(249, 20);
			this.LEIEWatchFolder.TabIndex = 1;
			this.toolTip1.SetToolTip(this.LEIEWatchFolder, "LEIE Import Folder to monitor");
			// 
			// LEIEExt
			// 
			this.LEIEExt.Location = new System.Drawing.Point(115, 66);
			this.LEIEExt.Name = "LEIEExt";
			this.LEIEExt.Size = new System.Drawing.Size(159, 20);
			this.LEIEExt.TabIndex = 3;
			this.toolTip1.SetToolTip(this.LEIEExt, "File Extension to monitor");
			// 
			// ZipCodeWatchFolder
			// 
			this.ZipCodeWatchFolder.Location = new System.Drawing.Point(125, 31);
			this.ZipCodeWatchFolder.Name = "ZipCodeWatchFolder";
			this.ZipCodeWatchFolder.Size = new System.Drawing.Size(294, 20);
			this.ZipCodeWatchFolder.TabIndex = 1;
			this.toolTip1.SetToolTip(this.ZipCodeWatchFolder, "Folder to watch for a import file.");
			// 
			// ZipCodeExt
			// 
			this.ZipCodeExt.Location = new System.Drawing.Point(125, 59);
			this.ZipCodeExt.Name = "ZipCodeExt";
			this.ZipCodeExt.Size = new System.Drawing.Size(100, 20);
			this.ZipCodeExt.TabIndex = 3;
			this.toolTip1.SetToolTip(this.ZipCodeExt, "File Extention to watch for.");
			// 
			// DBServerName
			// 
			this.DBServerName.Location = new System.Drawing.Point(112, 19);
			this.DBServerName.Name = "DBServerName";
			this.DBServerName.Size = new System.Drawing.Size(183, 20);
			this.DBServerName.TabIndex = 1;
			this.DBServerName.Tag = "This";
			this.toolTip1.SetToolTip(this.DBServerName, "Enter the SQL Server Database Server. Please obtain this information for a AITC D" +
        "BA.");
			// 
			// logDb
			// 
			this.logDb.Location = new System.Drawing.Point(112, 50);
			this.logDb.Name = "logDb";
			this.logDb.Size = new System.Drawing.Size(186, 20);
			this.logDb.TabIndex = 3;
			this.toolTip1.SetToolTip(this.logDb, "Please enter the AET Log Database name.");
			// 
			// ansiDb
			// 
			this.ansiDb.Location = new System.Drawing.Point(112, 21);
			this.ansiDb.Name = "ansiDb";
			this.ansiDb.Size = new System.Drawing.Size(186, 20);
			this.ansiDb.TabIndex = 1;
			this.toolTip1.SetToolTip(this.ansiDb, "Please enter the ASCx12 Database name.");
			// 
			// zipDb
			// 
			this.zipDb.Location = new System.Drawing.Point(112, 76);
			this.zipDb.Name = "zipDb";
			this.zipDb.Size = new System.Drawing.Size(186, 20);
			this.zipDb.TabIndex = 5;
			this.toolTip1.SetToolTip(this.zipDb, "Please enter the Zip Code to VA Crosswalk Database name.");
			// 
			// leieDB
			// 
			this.leieDB.Location = new System.Drawing.Point(112, 105);
			this.leieDB.Name = "leieDB";
			this.leieDB.Size = new System.Drawing.Size(186, 20);
			this.leieDB.TabIndex = 7;
			this.toolTip1.SetToolTip(this.leieDB, "Please enter the LEIE database name.");
			// 
			// STCPassword
			// 
			this.STCPassword.Location = new System.Drawing.Point(112, 105);
			this.STCPassword.Name = "STCPassword";
			this.STCPassword.PasswordChar = '*';
			this.STCPassword.Size = new System.Drawing.Size(186, 20);
			this.STCPassword.TabIndex = 7;
			this.toolTip1.SetToolTip(this.STCPassword, "Please enter the LEIE database name.");
			// 
			// STCUser
			// 
			this.STCUser.Location = new System.Drawing.Point(112, 76);
			this.STCUser.Name = "STCUser";
			this.STCUser.Size = new System.Drawing.Size(186, 20);
			this.STCUser.TabIndex = 5;
			this.toolTip1.SetToolTip(this.STCUser, "Please enter the Zip Code to VA Crosswalk Database name.");
			// 
			// STCServer
			// 
			this.STCServer.Location = new System.Drawing.Point(112, 21);
			this.STCServer.Name = "STCServer";
			this.STCServer.Size = new System.Drawing.Size(186, 20);
			this.STCServer.TabIndex = 1;
			this.toolTip1.SetToolTip(this.STCServer, "Please enter the ASCx12 Database name.");
			// 
			// STCDatabase
			// 
			this.STCDatabase.Location = new System.Drawing.Point(112, 50);
			this.STCDatabase.Name = "STCDatabase";
			this.STCDatabase.Size = new System.Drawing.Size(186, 20);
			this.STCDatabase.TabIndex = 3;
			this.toolTip1.SetToolTip(this.STCDatabase, "Please enter the AET Log Database name.");
			// 
			// txtAatDatabasePassword
			// 
			this.txtAatDatabasePassword.Location = new System.Drawing.Point(112, 105);
			this.txtAatDatabasePassword.Name = "txtAatDatabasePassword";
			this.txtAatDatabasePassword.PasswordChar = '*';
			this.txtAatDatabasePassword.Size = new System.Drawing.Size(186, 20);
			this.txtAatDatabasePassword.TabIndex = 7;
			this.toolTip1.SetToolTip(this.txtAatDatabasePassword, "Please enter the LEIE database name.");
			// 
			// txtAatDatabaseUsername
			// 
			this.txtAatDatabaseUsername.Location = new System.Drawing.Point(112, 76);
			this.txtAatDatabaseUsername.Name = "txtAatDatabaseUsername";
			this.txtAatDatabaseUsername.Size = new System.Drawing.Size(186, 20);
			this.txtAatDatabaseUsername.TabIndex = 5;
			this.toolTip1.SetToolTip(this.txtAatDatabaseUsername, "Please enter the Zip Code to VA Crosswalk Database name.");
			// 
			// txtAatServer
			// 
			this.txtAatServer.Location = new System.Drawing.Point(112, 21);
			this.txtAatServer.Name = "txtAatServer";
			this.txtAatServer.Size = new System.Drawing.Size(186, 20);
			this.txtAatServer.TabIndex = 1;
			this.toolTip1.SetToolTip(this.txtAatServer, "Please enter the ASCx12 Database name.");
			// 
			// txtAatDatabase
			// 
			this.txtAatDatabase.Location = new System.Drawing.Point(112, 50);
			this.txtAatDatabase.Name = "txtAatDatabase";
			this.txtAatDatabase.Size = new System.Drawing.Size(186, 20);
			this.txtAatDatabase.TabIndex = 3;
			this.toolTip1.SetToolTip(this.txtAatDatabase, "Please enter the AET Log Database name.");
			// 
			// txtCdwServer
			// 
			this.txtCdwServer.Location = new System.Drawing.Point(112, 21);
			this.txtCdwServer.Name = "txtCdwServer";
			this.txtCdwServer.Size = new System.Drawing.Size(186, 20);
			this.txtCdwServer.TabIndex = 1;
			this.toolTip1.SetToolTip(this.txtCdwServer, "Please enter the ASCx12 Database name.");
			// 
			// txtCdwDatabase
			// 
			this.txtCdwDatabase.Location = new System.Drawing.Point(112, 50);
			this.txtCdwDatabase.Name = "txtCdwDatabase";
			this.txtCdwDatabase.Size = new System.Drawing.Size(186, 20);
			this.txtCdwDatabase.TabIndex = 3;
			this.toolTip1.SetToolTip(this.txtCdwDatabase, "Please enter the AET Log Database name.");
			// 
			// label23
			// 
			this.label23.AutoSize = true;
			this.label23.Location = new System.Drawing.Point(7, 128);
			this.label23.Name = "label23";
			this.label23.Size = new System.Drawing.Size(123, 13);
			this.label23.TabIndex = 4;
			this.label23.Text = "Zip Database Password:";
			// 
			// label24
			// 
			this.label24.AutoSize = true;
			this.label24.Location = new System.Drawing.Point(31, 103);
			this.label24.Name = "label24";
			this.label24.Size = new System.Drawing.Size(99, 13);
			this.label24.TabIndex = 3;
			this.label24.Text = "Zip Database User:";
			// 
			// groupBox5
			// 
			this.groupBox5.Controls.Add(this.textBox6);
			this.groupBox5.Controls.Add(this.textBox7);
			this.groupBox5.Controls.Add(this.label25);
			this.groupBox5.Controls.Add(this.label26);
			this.groupBox5.Location = new System.Drawing.Point(14, 237);
			this.groupBox5.Name = "groupBox5";
			this.groupBox5.Size = new System.Drawing.Size(392, 121);
			this.groupBox5.TabIndex = 8;
			this.groupBox5.TabStop = false;
			this.groupBox5.Text = "Schedule Zip Code Import";
			// 
			// textBox6
			// 
			this.textBox6.Location = new System.Drawing.Point(172, 58);
			this.textBox6.Name = "textBox6";
			this.textBox6.Size = new System.Drawing.Size(100, 20);
			this.textBox6.TabIndex = 8;
			// 
			// textBox7
			// 
			this.textBox7.Location = new System.Drawing.Point(172, 26);
			this.textBox7.Name = "textBox7";
			this.textBox7.Size = new System.Drawing.Size(100, 20);
			this.textBox7.TabIndex = 7;
			// 
			// label25
			// 
			this.label25.AutoSize = true;
			this.label25.Location = new System.Drawing.Point(53, 66);
			this.label25.Name = "label25";
			this.label25.Size = new System.Drawing.Size(116, 13);
			this.label25.TabIndex = 6;
			this.label25.Text = "Import ScheduledTime:";
			// 
			// label26
			// 
			this.label26.AutoSize = true;
			this.label26.Location = new System.Drawing.Point(10, 34);
			this.label26.Name = "label26";
			this.label26.Size = new System.Drawing.Size(159, 13);
			this.label26.TabIndex = 5;
			this.label26.Text = "Import Scheduled Day of Week:";
			// 
			// textBox8
			// 
			this.textBox8.Location = new System.Drawing.Point(133, 100);
			this.textBox8.Name = "textBox8";
			this.textBox8.Size = new System.Drawing.Size(209, 20);
			this.textBox8.TabIndex = 10;
			// 
			// groupBox6
			// 
			this.groupBox6.Controls.Add(this.textBox8);
			this.groupBox6.Controls.Add(this.textBox9);
			this.groupBox6.Controls.Add(this.textBox10);
			this.groupBox6.Controls.Add(this.textBox11);
			this.groupBox6.Controls.Add(this.button2);
			this.groupBox6.Controls.Add(this.textBox12);
			this.groupBox6.Controls.Add(this.label27);
			this.groupBox6.Controls.Add(this.label28);
			this.groupBox6.Controls.Add(this.label29);
			this.groupBox6.Controls.Add(this.label23);
			this.groupBox6.Controls.Add(this.label24);
			this.groupBox6.Location = new System.Drawing.Point(14, 20);
			this.groupBox6.Name = "groupBox6";
			this.groupBox6.Size = new System.Drawing.Size(392, 187);
			this.groupBox6.TabIndex = 7;
			this.groupBox6.TabStop = false;
			this.groupBox6.Text = "Zip Code Import";
			// 
			// textBox9
			// 
			this.textBox9.Location = new System.Drawing.Point(133, 125);
			this.textBox9.Name = "textBox9";
			this.textBox9.Size = new System.Drawing.Size(209, 20);
			this.textBox9.TabIndex = 9;
			// 
			// textBox10
			// 
			this.textBox10.Location = new System.Drawing.Point(133, 76);
			this.textBox10.Name = "textBox10";
			this.textBox10.Size = new System.Drawing.Size(209, 20);
			this.textBox10.TabIndex = 8;
			// 
			// textBox11
			// 
			this.textBox11.Location = new System.Drawing.Point(133, 53);
			this.textBox11.Name = "textBox11";
			this.textBox11.Size = new System.Drawing.Size(209, 20);
			this.textBox11.TabIndex = 7;
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(353, 22);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(25, 29);
			this.button2.TabIndex = 6;
			this.button2.Text = "...";
			this.button2.UseVisualStyleBackColor = true;
			// 
			// textBox12
			// 
			this.textBox12.Location = new System.Drawing.Point(104, 27);
			this.textBox12.Name = "textBox12";
			this.textBox12.Size = new System.Drawing.Size(238, 20);
			this.textBox12.TabIndex = 5;
			// 
			// label27
			// 
			this.label27.AutoSize = true;
			this.label27.ForeColor = System.Drawing.Color.Black;
			this.label27.Location = new System.Drawing.Point(7, 30);
			this.label27.Name = "label27";
			this.label27.Size = new System.Drawing.Size(91, 13);
			this.label27.TabIndex = 0;
			this.label27.Text = "VMAC Import File:";
			// 
			// label28
			// 
			this.label28.AutoSize = true;
			this.label28.Location = new System.Drawing.Point(40, 57);
			this.label28.Name = "label28";
			this.label28.Size = new System.Drawing.Size(90, 13);
			this.label28.TabIndex = 1;
			this.label28.Text = "Database Server:";
			// 
			// label29
			// 
			this.label29.AutoSize = true;
			this.label29.Location = new System.Drawing.Point(28, 80);
			this.label29.Name = "label29";
			this.label29.Size = new System.Drawing.Size(102, 13);
			this.label29.TabIndex = 2;
			this.label29.Text = "Zip Code Database:";
			// 
			// openFileDialog1
			// 
			this.openFileDialog1.FileName = "openFileDialog1";
			// 
			// tabPage5
			// 
			this.tabPage5.Controls.Add(this.groupBox7);
			this.tabPage5.Controls.Add(this.groupBox8);
			this.tabPage5.Location = new System.Drawing.Point(4, 22);
			this.tabPage5.Name = "tabPage5";
			this.tabPage5.Size = new System.Drawing.Size(964, 606);
			this.tabPage5.TabIndex = 5;
			this.tabPage5.Text = "LEIE";
			this.tabPage5.UseVisualStyleBackColor = true;
			// 
			// groupBox7
			// 
			this.groupBox7.Controls.Add(this.txtLEIEUpdate);
			this.groupBox7.Controls.Add(this.label38);
			this.groupBox7.Controls.Add(this.button8);
			this.groupBox7.Controls.Add(this.LEIEExt);
			this.groupBox7.Controls.Add(this.LEIEWatchFolder);
			this.groupBox7.Controls.Add(this.label30);
			this.groupBox7.Controls.Add(this.label31);
			this.groupBox7.Location = new System.Drawing.Point(13, 245);
			this.groupBox7.Name = "groupBox7";
			this.groupBox7.Size = new System.Drawing.Size(392, 162);
			this.groupBox7.TabIndex = 1;
			this.groupBox7.TabStop = false;
			this.groupBox7.Text = "Automated LEIE Import";
			// 
			// txtLEIEUpdate
			// 
			this.txtLEIEUpdate.Location = new System.Drawing.Point(84, 95);
			this.txtLEIEUpdate.Name = "txtLEIEUpdate";
			this.txtLEIEUpdate.ReadOnly = true;
			this.txtLEIEUpdate.Size = new System.Drawing.Size(226, 20);
			this.txtLEIEUpdate.TabIndex = 5;
			// 
			// label38
			// 
			this.label38.AutoSize = true;
			this.label38.Location = new System.Drawing.Point(16, 98);
			this.label38.Name = "label38";
			this.label38.Size = new System.Drawing.Size(68, 13);
			this.label38.TabIndex = 4;
			this.label38.Text = "Last Update:";
			// 
			// button8
			// 
			this.button8.Location = new System.Drawing.Point(303, 124);
			this.button8.Name = "button8";
			this.button8.Size = new System.Drawing.Size(75, 23);
			this.button8.TabIndex = 6;
			this.button8.Text = "Save";
			this.button8.UseVisualStyleBackColor = true;
			this.button8.Click += new System.EventHandler(this.button8_Click);
			// 
			// label30
			// 
			this.label30.AutoSize = true;
			this.label30.Location = new System.Drawing.Point(10, 68);
			this.label30.Name = "label30";
			this.label30.Size = new System.Drawing.Size(107, 13);
			this.label30.TabIndex = 2;
			this.label30.Text = "Import File Extension:";
			this.label30.Click += new System.EventHandler(this.label30_Click);
			// 
			// label31
			// 
			this.label31.AutoSize = true;
			this.label31.Location = new System.Drawing.Point(18, 35);
			this.label31.Name = "label31";
			this.label31.Size = new System.Drawing.Size(97, 13);
			this.label31.TabIndex = 0;
			this.label31.Text = "LEIE Import Folder:";
			// 
			// groupBox8
			// 
			this.groupBox8.Controls.Add(this.button7);
			this.groupBox8.Controls.Add(this.LEIEUser);
			this.groupBox8.Controls.Add(this.LEIEPw);
			this.groupBox8.Controls.Add(this.LEIEDatabase);
			this.groupBox8.Controls.Add(this.LEIEServer);
			this.groupBox8.Controls.Add(this.button3);
			this.groupBox8.Controls.Add(this.LEIEFileName);
			this.groupBox8.Controls.Add(this.label32);
			this.groupBox8.Controls.Add(this.label33);
			this.groupBox8.Controls.Add(this.label34);
			this.groupBox8.Controls.Add(this.label35);
			this.groupBox8.Controls.Add(this.label36);
			this.groupBox8.Location = new System.Drawing.Point(13, 28);
			this.groupBox8.Name = "groupBox8";
			this.groupBox8.Size = new System.Drawing.Size(392, 187);
			this.groupBox8.TabIndex = 0;
			this.groupBox8.TabStop = false;
			this.groupBox8.Text = "Manual LEIE Import";
			// 
			// button7
			// 
			this.button7.Location = new System.Drawing.Point(187, 156);
			this.button7.Name = "button7";
			this.button7.Size = new System.Drawing.Size(75, 23);
			this.button7.TabIndex = 11;
			this.button7.Text = "Import";
			this.button7.UseVisualStyleBackColor = true;
			this.button7.Click += new System.EventHandler(this.button7_Click);
			// 
			// label32
			// 
			this.label32.AutoSize = true;
			this.label32.ForeColor = System.Drawing.Color.Black;
			this.label32.Location = new System.Drawing.Point(7, 30);
			this.label32.Name = "label32";
			this.label32.Size = new System.Drawing.Size(84, 13);
			this.label32.TabIndex = 0;
			this.label32.Text = "LEIE Import File:";
			// 
			// label33
			// 
			this.label33.AutoSize = true;
			this.label33.Location = new System.Drawing.Point(40, 57);
			this.label33.Name = "label33";
			this.label33.Size = new System.Drawing.Size(90, 13);
			this.label33.TabIndex = 3;
			this.label33.Text = "Database Server:";
			// 
			// label34
			// 
			this.label34.AutoSize = true;
			this.label34.Location = new System.Drawing.Point(28, 80);
			this.label34.Name = "label34";
			this.label34.Size = new System.Drawing.Size(82, 13);
			this.label34.TabIndex = 5;
			this.label34.Text = "LEIE Database:";
			// 
			// label35
			// 
			this.label35.AutoSize = true;
			this.label35.Location = new System.Drawing.Point(7, 128);
			this.label35.Name = "label35";
			this.label35.Size = new System.Drawing.Size(131, 13);
			this.label35.TabIndex = 9;
			this.label35.Text = "LEIE Database Password:";
			// 
			// label36
			// 
			this.label36.AutoSize = true;
			this.label36.Location = new System.Drawing.Point(25, 103);
			this.label36.Name = "label36";
			this.label36.Size = new System.Drawing.Size(107, 13);
			this.label36.TabIndex = 7;
			this.label36.Text = "LEIE Database User:";
			// 
			// tabPage4
			// 
			this.tabPage4.Controls.Add(this.groupBox4);
			this.tabPage4.Controls.Add(this.groupBox1);
			this.tabPage4.Location = new System.Drawing.Point(4, 22);
			this.tabPage4.Name = "tabPage4";
			this.tabPage4.Size = new System.Drawing.Size(964, 606);
			this.tabPage4.TabIndex = 4;
			this.tabPage4.Text = "Zip Code Crosswalk";
			this.tabPage4.UseVisualStyleBackColor = true;
			this.tabPage4.Click += new System.EventHandler(this.tabPage4_Click);
			// 
			// groupBox4
			// 
			this.groupBox4.Controls.Add(this.txtZipUpdate);
			this.groupBox4.Controls.Add(this.label37);
			this.groupBox4.Controls.Add(this.button4);
			this.groupBox4.Controls.Add(this.ZipCodeExt);
			this.groupBox4.Controls.Add(this.ZipCodeWatchFolder);
			this.groupBox4.Controls.Add(this.label22);
			this.groupBox4.Controls.Add(this.label21);
			this.groupBox4.Location = new System.Drawing.Point(13, 244);
			this.groupBox4.Name = "groupBox4";
			this.groupBox4.Size = new System.Drawing.Size(392, 146);
			this.groupBox4.TabIndex = 1;
			this.groupBox4.TabStop = false;
			this.groupBox4.Text = "Automated Zip Code Import";
			// 
			// txtZipUpdate
			// 
			this.txtZipUpdate.Location = new System.Drawing.Point(85, 89);
			this.txtZipUpdate.Name = "txtZipUpdate";
			this.txtZipUpdate.ReadOnly = true;
			this.txtZipUpdate.Size = new System.Drawing.Size(215, 20);
			this.txtZipUpdate.TabIndex = 5;
			// 
			// label37
			// 
			this.label37.AutoSize = true;
			this.label37.Location = new System.Drawing.Point(15, 92);
			this.label37.Name = "label37";
			this.label37.Size = new System.Drawing.Size(68, 13);
			this.label37.TabIndex = 4;
			this.label37.Text = "Last Update:";
			// 
			// button4
			// 
			this.button4.Location = new System.Drawing.Point(289, 117);
			this.button4.Name = "button4";
			this.button4.Size = new System.Drawing.Size(75, 23);
			this.button4.TabIndex = 6;
			this.button4.Text = "Save";
			this.button4.UseVisualStyleBackColor = true;
			this.button4.Click += new System.EventHandler(this.button4_Click);
			// 
			// label22
			// 
			this.label22.AutoSize = true;
			this.label22.Location = new System.Drawing.Point(10, 65);
			this.label22.Name = "label22";
			this.label22.Size = new System.Drawing.Size(107, 13);
			this.label22.TabIndex = 2;
			this.label22.Text = "Import File Extension:";
			// 
			// label21
			// 
			this.label21.AutoSize = true;
			this.label21.Location = new System.Drawing.Point(6, 34);
			this.label21.Name = "label21";
			this.label21.Size = new System.Drawing.Size(117, 13);
			this.label21.TabIndex = 0;
			this.label21.Text = "Zip Code Import Folder:";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.button5);
			this.groupBox1.Controls.Add(this.ZUser);
			this.groupBox1.Controls.Add(this.ZPw);
			this.groupBox1.Controls.Add(this.ZDatabase);
			this.groupBox1.Controls.Add(this.ZServer);
			this.groupBox1.Controls.Add(this.button1);
			this.groupBox1.Controls.Add(this.VMACFileName);
			this.groupBox1.Controls.Add(this.label5);
			this.groupBox1.Controls.Add(this.label7);
			this.groupBox1.Controls.Add(this.label8);
			this.groupBox1.Controls.Add(this.label11);
			this.groupBox1.Controls.Add(this.label9);
			this.groupBox1.Location = new System.Drawing.Point(13, 27);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(392, 187);
			this.groupBox1.TabIndex = 0;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Manual  Zip Code Import";
			this.groupBox1.Enter += new System.EventHandler(this.groupBox1_Enter);
			// 
			// button5
			// 
			this.button5.Location = new System.Drawing.Point(150, 158);
			this.button5.Name = "button5";
			this.button5.Size = new System.Drawing.Size(75, 23);
			this.button5.TabIndex = 10;
			this.button5.Text = "Import";
			this.button5.UseVisualStyleBackColor = true;
			this.button5.Click += new System.EventHandler(this.button5_Click);
			// 
			// ZUser
			// 
			this.ZUser.Location = new System.Drawing.Point(133, 100);
			this.ZUser.Name = "ZUser";
			this.ZUser.Size = new System.Drawing.Size(209, 20);
			this.ZUser.TabIndex = 8;
			this.ZUser.TextChanged += new System.EventHandler(this.textBox4_TextChanged);
			// 
			// ZPw
			// 
			this.ZPw.Location = new System.Drawing.Point(133, 125);
			this.ZPw.Name = "ZPw";
			this.ZPw.PasswordChar = '*';
			this.ZPw.Size = new System.Drawing.Size(209, 20);
			this.ZPw.TabIndex = 9;
			// 
			// ZDatabase
			// 
			this.ZDatabase.Location = new System.Drawing.Point(133, 76);
			this.ZDatabase.Name = "ZDatabase";
			this.ZDatabase.Size = new System.Drawing.Size(209, 20);
			this.ZDatabase.TabIndex = 6;
			this.ZDatabase.TextChanged += new System.EventHandler(this.textBox2_TextChanged);
			// 
			// ZServer
			// 
			this.ZServer.Location = new System.Drawing.Point(133, 53);
			this.ZServer.Name = "ZServer";
			this.ZServer.Size = new System.Drawing.Size(209, 20);
			this.ZServer.TabIndex = 4;
			this.ZServer.TextChanged += new System.EventHandler(this.VMACerver_TextChanged);
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(353, 22);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(25, 29);
			this.button1.TabIndex = 2;
			this.button1.Text = "...";
			this.button1.UseVisualStyleBackColor = true;
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// VMACFileName
			// 
			this.VMACFileName.Location = new System.Drawing.Point(104, 27);
			this.VMACFileName.Name = "VMACFileName";
			this.VMACFileName.Size = new System.Drawing.Size(238, 20);
			this.VMACFileName.TabIndex = 1;
			this.VMACFileName.TextChanged += new System.EventHandler(this.VMACFileName_TextChanged);
			// 
			// label5
			// 
			this.label5.AutoSize = true;
			this.label5.ForeColor = System.Drawing.Color.Black;
			this.label5.Location = new System.Drawing.Point(7, 30);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(91, 13);
			this.label5.TabIndex = 0;
			this.label5.Text = "VMAC Import File:";
			this.label5.Click += new System.EventHandler(this.label5_Click);
			// 
			// label7
			// 
			this.label7.AutoSize = true;
			this.label7.Location = new System.Drawing.Point(40, 57);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(90, 13);
			this.label7.TabIndex = 3;
			this.label7.Text = "Database Server:";
			this.label7.Click += new System.EventHandler(this.label7_Click);
			// 
			// label8
			// 
			this.label8.AutoSize = true;
			this.label8.Location = new System.Drawing.Point(28, 80);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(102, 13);
			this.label8.TabIndex = 5;
			this.label8.Text = "Zip Code Database:";
			this.label8.Click += new System.EventHandler(this.label8_Click);
			// 
			// label11
			// 
			this.label11.AutoSize = true;
			this.label11.Location = new System.Drawing.Point(7, 128);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(123, 13);
			this.label11.TabIndex = 4;
			this.label11.Text = "Zip Database Password:";
			// 
			// label9
			// 
			this.label9.AutoSize = true;
			this.label9.Location = new System.Drawing.Point(31, 103);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(99, 13);
			this.label9.TabIndex = 7;
			this.label9.Text = "Zip Database User:";
			// 
			// tabPage3
			// 
			this.tabPage3.Controls.Add(this.button10);
			this.tabPage3.Controls.Add(this.AETReportName);
			this.tabPage3.Controls.Add(this.label48);
			this.tabPage3.Controls.Add(this.button9);
			this.tabPage3.Controls.Add(this.label47);
			this.tabPage3.Controls.Add(this.label46);
			this.tabPage3.Controls.Add(this.dateTimePicker2);
			this.tabPage3.Controls.Add(this.dateTimePicker1);
			this.tabPage3.Location = new System.Drawing.Point(4, 22);
			this.tabPage3.Name = "tabPage3";
			this.tabPage3.Size = new System.Drawing.Size(964, 606);
			this.tabPage3.TabIndex = 3;
			this.tabPage3.Text = "View Logs";
			this.tabPage3.UseVisualStyleBackColor = true;
			// 
			// button10
			// 
			this.button10.Location = new System.Drawing.Point(300, 180);
			this.button10.Name = "button10";
			this.button10.Size = new System.Drawing.Size(28, 23);
			this.button10.TabIndex = 7;
			this.button10.Text = "...";
			this.button10.UseVisualStyleBackColor = true;
			this.button10.Click += new System.EventHandler(this.button10_Click);
			// 
			// AETReportName
			// 
			this.AETReportName.Location = new System.Drawing.Point(84, 180);
			this.AETReportName.Name = "AETReportName";
			this.AETReportName.Size = new System.Drawing.Size(210, 20);
			this.AETReportName.TabIndex = 6;
			this.AETReportName.Text = "allAET.csv";
			// 
			// label48
			// 
			this.label48.AutoSize = true;
			this.label48.Location = new System.Drawing.Point(16, 180);
			this.label48.Name = "label48";
			this.label48.Size = new System.Drawing.Size(61, 13);
			this.label48.TabIndex = 5;
			this.label48.Text = "Output File:";
			// 
			// button9
			// 
			this.button9.Location = new System.Drawing.Point(140, 135);
			this.button9.Name = "button9";
			this.button9.Size = new System.Drawing.Size(75, 23);
			this.button9.TabIndex = 4;
			this.button9.Text = "Run Report";
			this.button9.UseVisualStyleBackColor = true;
			this.button9.Click += new System.EventHandler(this.button9_Click);
			// 
			// label47
			// 
			this.label47.AutoSize = true;
			this.label47.Location = new System.Drawing.Point(27, 68);
			this.label47.Name = "label47";
			this.label47.Size = new System.Drawing.Size(90, 13);
			this.label47.TabIndex = 2;
			this.label47.Text = "Report End Date:";
			// 
			// label46
			// 
			this.label46.AutoSize = true;
			this.label46.Location = new System.Drawing.Point(19, 35);
			this.label46.Name = "label46";
			this.label46.Size = new System.Drawing.Size(98, 13);
			this.label46.TabIndex = 0;
			this.label46.Text = "Report Begin Date:";
			// 
			// dateTimePicker2
			// 
			this.dateTimePicker2.Location = new System.Drawing.Point(123, 68);
			this.dateTimePicker2.Name = "dateTimePicker2";
			this.dateTimePicker2.Size = new System.Drawing.Size(200, 20);
			this.dateTimePicker2.TabIndex = 3;
			// 
			// dateTimePicker1
			// 
			this.dateTimePicker1.Location = new System.Drawing.Point(123, 31);
			this.dateTimePicker1.Name = "dateTimePicker1";
			this.dateTimePicker1.Size = new System.Drawing.Size(200, 20);
			this.dateTimePicker1.TabIndex = 1;
			// 
			// tabPage1
			// 
			this.tabPage1.Controls.Add(this.tbResponceTime);
			this.tabPage1.Controls.Add(this.tbRequestTime);
			this.tabPage1.Controls.Add(this.lblMVIStatus);
			this.tabPage1.Controls.Add(this.lblTRNID);
			this.tabPage1.Controls.Add(this.lblEBReturn);
			this.tabPage1.Controls.Add(this.lblESRTime);
			this.tabPage1.Controls.Add(this.lblESRStatus);
			this.tabPage1.Controls.Add(this.lblMVITime);
			this.tabPage1.Controls.Add(this.label40);
			this.tabPage1.Controls.Add(this.lblElapsedTime);
			this.tabPage1.Controls.Add(this.lblIP);
			this.tabPage1.Controls.Add(this.lblErrorMsg);
			this.tabPage1.Controls.Add(this.lblErrorID);
			this.tabPage1.Controls.Add(this.lblStatus);
			this.tabPage1.Controls.Add(this.lblClearingHouse);
			this.tabPage1.Controls.Add(this.lblResponseQual);
			this.tabPage1.Controls.Add(this.lblResponseTime);
			this.tabPage1.Controls.Add(this.lblRequestQual);
			this.tabPage1.Controls.Add(this.lblRequestTime);
			this.tabPage1.Controls.Add(this.btnBack);
			this.tabPage1.Controls.Add(this.btnSelect);
			this.tabPage1.Controls.Add(this.logDatePicker);
			this.tabPage1.Controls.Add(this.dataGridView1);
			this.tabPage1.Controls.Add(this.webBrowser271);
			this.tabPage1.Controls.Add(this.webBrowser270);
			this.tabPage1.ForeColor = System.Drawing.SystemColors.Highlight;
			this.tabPage1.Location = new System.Drawing.Point(4, 22);
			this.tabPage1.Name = "tabPage1";
			this.tabPage1.Size = new System.Drawing.Size(964, 606);
			this.tabPage1.TabIndex = 2;
			this.tabPage1.Text = "View EDI Files";
			this.tabPage1.UseVisualStyleBackColor = true;
			this.tabPage1.Click += new System.EventHandler(this.tabPage1_Click);
			// 
			// tbResponceTime
			// 
			this.tbResponceTime.Location = new System.Drawing.Point(292, 480);
			this.tbResponceTime.Name = "tbResponceTime";
			this.tbResponceTime.Size = new System.Drawing.Size(110, 20);
			this.tbResponceTime.TabIndex = 3;
			this.tbResponceTime.Visible = false;
			// 
			// tbRequestTime
			// 
			this.tbRequestTime.Location = new System.Drawing.Point(87, 480);
			this.tbRequestTime.Name = "tbRequestTime";
			this.tbRequestTime.Size = new System.Drawing.Size(116, 20);
			this.tbRequestTime.TabIndex = 1;
			this.tbRequestTime.Visible = false;
			// 
			// lblMVIStatus
			// 
			this.lblMVIStatus.AutoSize = true;
			this.lblMVIStatus.Location = new System.Drawing.Point(12, 546);
			this.lblMVIStatus.Name = "lblMVIStatus";
			this.lblMVIStatus.Size = new System.Drawing.Size(62, 13);
			this.lblMVIStatus.TabIndex = 13;
			this.lblMVIStatus.Text = "MVI Status:";
			this.lblMVIStatus.Visible = false;
			// 
			// lblTRNID
			// 
			this.lblTRNID.AutoSize = true;
			this.lblTRNID.Location = new System.Drawing.Point(408, 545);
			this.lblTRNID.Name = "lblTRNID";
			this.lblTRNID.Size = new System.Drawing.Size(47, 13);
			this.lblTRNID.TabIndex = 15;
			this.lblTRNID.Text = "TRN ID:";
			this.lblTRNID.Visible = false;
			// 
			// lblEBReturn
			// 
			this.lblEBReturn.AutoSize = true;
			this.lblEBReturn.Location = new System.Drawing.Point(209, 530);
			this.lblEBReturn.Name = "lblEBReturn";
			this.lblEBReturn.Size = new System.Drawing.Size(59, 13);
			this.lblEBReturn.TabIndex = 12;
			this.lblEBReturn.Text = "EB Return:";
			this.lblEBReturn.Visible = false;
			// 
			// lblESRTime
			// 
			this.lblESRTime.AutoSize = true;
			this.lblESRTime.Location = new System.Drawing.Point(209, 563);
			this.lblESRTime.Name = "lblESRTime";
			this.lblESRTime.Size = new System.Drawing.Size(58, 13);
			this.lblESRTime.TabIndex = 17;
			this.lblESRTime.Text = "ESR Time:";
			this.lblESRTime.Visible = false;
			// 
			// lblESRStatus
			// 
			this.lblESRStatus.AutoSize = true;
			this.lblESRStatus.Location = new System.Drawing.Point(209, 546);
			this.lblESRStatus.Name = "lblESRStatus";
			this.lblESRStatus.Size = new System.Drawing.Size(65, 13);
			this.lblESRStatus.TabIndex = 14;
			this.lblESRStatus.Text = "ESR Status:";
			this.lblESRStatus.Visible = false;
			// 
			// lblMVITime
			// 
			this.lblMVITime.AutoSize = true;
			this.lblMVITime.Location = new System.Drawing.Point(12, 564);
			this.lblMVITime.Name = "lblMVITime";
			this.lblMVITime.Size = new System.Drawing.Size(55, 13);
			this.lblMVITime.TabIndex = 16;
			this.lblMVITime.Text = "MVI Time:";
			this.lblMVITime.Visible = false;
			// 
			// label40
			// 
			this.label40.AutoSize = true;
			this.label40.Location = new System.Drawing.Point(12, 547);
			this.label40.Name = "label40";
			this.label40.Size = new System.Drawing.Size(0, 13);
			this.label40.TabIndex = 16;
			// 
			// lblElapsedTime
			// 
			this.lblElapsedTime.AutoSize = true;
			this.lblElapsedTime.Location = new System.Drawing.Point(12, 530);
			this.lblElapsedTime.Name = "lblElapsedTime";
			this.lblElapsedTime.Size = new System.Drawing.Size(74, 13);
			this.lblElapsedTime.TabIndex = 11;
			this.lblElapsedTime.Text = "Elapsed Time:";
			this.lblElapsedTime.Visible = false;
			// 
			// lblIP
			// 
			this.lblIP.AutoSize = true;
			this.lblIP.Location = new System.Drawing.Point(408, 513);
			this.lblIP.Name = "lblIP";
			this.lblIP.Size = new System.Drawing.Size(71, 13);
			this.lblIP.TabIndex = 10;
			this.lblIP.Text = "Response IP:";
			this.lblIP.Visible = false;
			// 
			// lblErrorMsg
			// 
			this.lblErrorMsg.AutoSize = true;
			this.lblErrorMsg.Location = new System.Drawing.Point(408, 499);
			this.lblErrorMsg.Name = "lblErrorMsg";
			this.lblErrorMsg.Size = new System.Drawing.Size(35, 13);
			this.lblErrorMsg.TabIndex = 7;
			this.lblErrorMsg.Text = "Error: ";
			this.lblErrorMsg.Visible = false;
			// 
			// lblErrorID
			// 
			this.lblErrorID.AutoSize = true;
			this.lblErrorID.Location = new System.Drawing.Point(408, 483);
			this.lblErrorID.Name = "lblErrorID";
			this.lblErrorID.Size = new System.Drawing.Size(46, 13);
			this.lblErrorID.TabIndex = 4;
			this.lblErrorID.Text = "Error ID:";
			this.lblErrorID.Visible = false;
			// 
			// lblStatus
			// 
			this.lblStatus.AutoSize = true;
			this.lblStatus.Location = new System.Drawing.Point(209, 513);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(43, 13);
			this.lblStatus.TabIndex = 9;
			this.lblStatus.Text = "Status: ";
			this.lblStatus.Visible = false;
			// 
			// lblClearingHouse
			// 
			this.lblClearingHouse.AutoSize = true;
			this.lblClearingHouse.Location = new System.Drawing.Point(12, 513);
			this.lblClearingHouse.Name = "lblClearingHouse";
			this.lblClearingHouse.Size = new System.Drawing.Size(85, 13);
			this.lblClearingHouse.TabIndex = 8;
			this.lblClearingHouse.Text = "Clearing House: ";
			this.lblClearingHouse.Visible = false;
			// 
			// lblResponseQual
			// 
			this.lblResponseQual.AutoSize = true;
			this.lblResponseQual.Location = new System.Drawing.Point(209, 499);
			this.lblResponseQual.Name = "lblResponseQual";
			this.lblResponseQual.Size = new System.Drawing.Size(102, 13);
			this.lblResponseQual.TabIndex = 6;
			this.lblResponseQual.Text = "Response Qualifier: ";
			this.lblResponseQual.Visible = false;
			// 
			// lblResponseTime
			// 
			this.lblResponseTime.AutoSize = true;
			this.lblResponseTime.Location = new System.Drawing.Point(209, 483);
			this.lblResponseTime.Name = "lblResponseTime";
			this.lblResponseTime.Size = new System.Drawing.Size(87, 13);
			this.lblResponseTime.TabIndex = 2;
			this.lblResponseTime.Text = "Response Time: ";
			this.lblResponseTime.Visible = false;
			// 
			// lblRequestQual
			// 
			this.lblRequestQual.AutoSize = true;
			this.lblRequestQual.Location = new System.Drawing.Point(12, 499);
			this.lblRequestQual.Name = "lblRequestQual";
			this.lblRequestQual.Size = new System.Drawing.Size(94, 13);
			this.lblRequestQual.TabIndex = 5;
			this.lblRequestQual.Text = "Request Qualifier: ";
			this.lblRequestQual.Visible = false;
			// 
			// lblRequestTime
			// 
			this.lblRequestTime.AutoSize = true;
			this.lblRequestTime.Location = new System.Drawing.Point(12, 483);
			this.lblRequestTime.Name = "lblRequestTime";
			this.lblRequestTime.Size = new System.Drawing.Size(76, 13);
			this.lblRequestTime.TabIndex = 0;
			this.lblRequestTime.Text = "Request Time:";
			this.lblRequestTime.Visible = false;
			// 
			// btnBack
			// 
			this.btnBack.Location = new System.Drawing.Point(459, 564);
			this.btnBack.Name = "btnBack";
			this.btnBack.Size = new System.Drawing.Size(75, 23);
			this.btnBack.TabIndex = 18;
			this.btnBack.Text = "Back";
			this.btnBack.UseVisualStyleBackColor = true;
			this.btnBack.Visible = false;
			this.btnBack.Click += new System.EventHandler(this.btnBack_Click);
			// 
			// btnSelect
			// 
			this.btnSelect.Location = new System.Drawing.Point(555, 563);
			this.btnSelect.Name = "btnSelect";
			this.btnSelect.Size = new System.Drawing.Size(75, 23);
			this.btnSelect.TabIndex = 19;
			this.btnSelect.Text = "Select";
			this.btnSelect.UseVisualStyleBackColor = true;
			this.btnSelect.Visible = false;
			this.btnSelect.Click += new System.EventHandler(this.btnSelect_Click);
			// 
			// logDatePicker
			// 
			this.logDatePicker.Location = new System.Drawing.Point(4, 8);
			this.logDatePicker.Name = "logDatePicker";
			this.logDatePicker.Size = new System.Drawing.Size(200, 20);
			this.logDatePicker.TabIndex = 3;
			this.logDatePicker.ValueChanged += new System.EventHandler(this.logDatePicker_ValueChanged);
			// 
			// dataGridView1
			// 
			this.dataGridView1.AccessibleDescription = "View EDI Transactions";
			this.dataGridView1.AccessibleName = "EDI Transactions";
			this.dataGridView1.AllowUserToAddRows = false;
			this.dataGridView1.AllowUserToDeleteRows = false;
			this.dataGridView1.ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode.AutoSize;
			this.dataGridView1.Location = new System.Drawing.Point(4, 34);
			this.dataGridView1.MultiSelect = false;
			this.dataGridView1.Name = "dataGridView1";
			this.dataGridView1.ReadOnly = true;
			this.dataGridView1.RowHeadersVisible = false;
			this.dataGridView1.SelectionMode = System.Windows.Forms.DataGridViewSelectionMode.FullRowSelect;
			this.dataGridView1.ShowEditingIcon = false;
			this.dataGridView1.Size = new System.Drawing.Size(726, 335);
			this.dataGridView1.TabIndex = 22;
			this.dataGridView1.CellDoubleClick += new System.Windows.Forms.DataGridViewCellEventHandler(this.dataGridView1_CellDoubleClick);
			// 
			// webBrowser271
			// 
			this.webBrowser271.Location = new System.Drawing.Point(3, 286);
			this.webBrowser271.MinimumSize = new System.Drawing.Size(20, 20);
			this.webBrowser271.Name = "webBrowser271";
			this.webBrowser271.Size = new System.Drawing.Size(742, 188);
			this.webBrowser271.TabIndex = 23;
			this.webBrowser271.DocumentCompleted += new System.Windows.Forms.WebBrowserDocumentCompletedEventHandler(this.webBrowser271_DocumentCompleted);
			// 
			// webBrowser270
			// 
			this.webBrowser270.Location = new System.Drawing.Point(4, 8);
			this.webBrowser270.MinimumSize = new System.Drawing.Size(20, 20);
			this.webBrowser270.Name = "webBrowser270";
			this.webBrowser270.Size = new System.Drawing.Size(741, 247);
			this.webBrowser270.TabIndex = 3;
			// 
			// tabEligibilityConfiguration
			// 
			this.tabEligibilityConfiguration.Controls.Add(this.STCGroup);
			this.tabEligibilityConfiguration.Controls.Add(this.DBNames);
			this.tabEligibilityConfiguration.Controls.Add(this.groupBox3);
			this.tabEligibilityConfiguration.Controls.Add(this.groupBox2);
			this.tabEligibilityConfiguration.Controls.Add(this.dbGroup);
			this.tabEligibilityConfiguration.Controls.Add(this.saveButton2);
			this.tabEligibilityConfiguration.Controls.Add(this.savedSettingsLabel2);
			this.tabEligibilityConfiguration.Location = new System.Drawing.Point(4, 22);
			this.tabEligibilityConfiguration.Name = "tabEligibilityConfiguration";
			this.tabEligibilityConfiguration.Padding = new System.Windows.Forms.Padding(3);
			this.tabEligibilityConfiguration.Size = new System.Drawing.Size(964, 606);
			this.tabEligibilityConfiguration.TabIndex = 1;
			this.tabEligibilityConfiguration.Text = "Eligibility Configuration";
			this.tabEligibilityConfiguration.UseVisualStyleBackColor = true;
			// 
			// STCGroup
			// 
			this.STCGroup.Controls.Add(this.label39);
			this.STCGroup.Controls.Add(this.STCPassword);
			this.STCGroup.Controls.Add(this.STCUser);
			this.STCGroup.Controls.Add(this.label41);
			this.STCGroup.Controls.Add(this.STCServer);
			this.STCGroup.Controls.Add(this.label42);
			this.STCGroup.Controls.Add(this.STCDatabase);
			this.STCGroup.Controls.Add(this.label43);
			this.STCGroup.Location = new System.Drawing.Point(9, 374);
			this.STCGroup.Name = "STCGroup";
			this.STCGroup.Size = new System.Drawing.Size(305, 133);
			this.STCGroup.TabIndex = 8;
			this.STCGroup.TabStop = false;
			this.STCGroup.Text = "Service Type Code Database";
			// 
			// label39
			// 
			this.label39.AutoSize = true;
			this.label39.Location = new System.Drawing.Point(23, 80);
			this.label39.Name = "label39";
			this.label39.Size = new System.Drawing.Size(81, 13);
			this.label39.TabIndex = 4;
			this.label39.Text = "Database User:";
			this.label39.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label41
			// 
			this.label41.AutoSize = true;
			this.label41.Location = new System.Drawing.Point(1, 108);
			this.label41.Name = "label41";
			this.label41.Size = new System.Drawing.Size(105, 13);
			this.label41.TabIndex = 6;
			this.label41.Text = "Database Password:";
			this.label41.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label42
			// 
			this.label42.AutoSize = true;
			this.label42.Location = new System.Drawing.Point(14, 27);
			this.label42.Name = "label42";
			this.label42.Size = new System.Drawing.Size(90, 13);
			this.label42.TabIndex = 0;
			this.label42.Text = "Database Server:";
			this.label42.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label43
			// 
			this.label43.AutoSize = true;
			this.label43.Location = new System.Drawing.Point(48, 53);
			this.label43.Name = "label43";
			this.label43.Size = new System.Drawing.Size(56, 13);
			this.label43.TabIndex = 2;
			this.label43.Text = "Database:";
			this.label43.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// DBNames
			// 
			this.DBNames.Controls.Add(this.label1);
			this.DBNames.Controls.Add(this.leieDB);
			this.DBNames.Controls.Add(this.zipDb);
			this.DBNames.Controls.Add(this.label4);
			this.DBNames.Controls.Add(this.ansiDb);
			this.DBNames.Controls.Add(this.label6);
			this.DBNames.Controls.Add(this.logDb);
			this.DBNames.Controls.Add(this.label10);
			this.DBNames.Location = new System.Drawing.Point(9, 115);
			this.DBNames.Name = "DBNames";
			this.DBNames.Size = new System.Drawing.Size(305, 133);
			this.DBNames.TabIndex = 2;
			this.DBNames.TabStop = false;
			this.DBNames.Text = "Database";
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.Location = new System.Drawing.Point(3, 79);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(102, 13);
			this.label1.TabIndex = 4;
			this.label1.Text = "Zip Code Database:";
			// 
			// label4
			// 
			this.label4.AutoSize = true;
			this.label4.Location = new System.Drawing.Point(23, 108);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(82, 13);
			this.label4.TabIndex = 6;
			this.label4.Text = "LEIE Database:";
			// 
			// label6
			// 
			this.label6.AutoSize = true;
			this.label6.Location = new System.Drawing.Point(8, 24);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(97, 13);
			this.label6.TabIndex = 0;
			this.label6.Text = "ASCx12 Database:";
			// 
			// label10
			// 
			this.label10.AutoSize = true;
			this.label10.Location = new System.Drawing.Point(28, 53);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(77, 13);
			this.label10.TabIndex = 2;
			this.label10.Text = "Log Database:";
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.Add(this.esPW);
			this.groupBox3.Controls.Add(this.esSA);
			this.groupBox3.Controls.Add(this.pkiCert);
			this.groupBox3.Controls.Add(this.label15);
			this.groupBox3.Controls.Add(this.label18);
			this.groupBox3.Controls.Add(this.label17);
			this.groupBox3.Location = new System.Drawing.Point(373, 253);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(248, 112);
			this.groupBox3.TabIndex = 4;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "Web Service Authentication";
			// 
			// esPW
			// 
			this.esPW.Location = new System.Drawing.Point(127, 76);
			this.esPW.Name = "esPW";
			this.esPW.PasswordChar = '*';
			this.esPW.Size = new System.Drawing.Size(115, 20);
			this.esPW.TabIndex = 5;
			this.esPW.TextChanged += new System.EventHandler(this.textBox6_TextChanged);
			// 
			// esSA
			// 
			this.esSA.Location = new System.Drawing.Point(127, 48);
			this.esSA.Name = "esSA";
			this.esSA.Size = new System.Drawing.Size(115, 20);
			this.esSA.TabIndex = 3;
			// 
			// pkiCert
			// 
			this.pkiCert.Location = new System.Drawing.Point(127, 20);
			this.pkiCert.Name = "pkiCert";
			this.pkiCert.Size = new System.Drawing.Size(115, 20);
			this.pkiCert.TabIndex = 1;
			// 
			// label15
			// 
			this.label15.AutoSize = true;
			this.label15.Location = new System.Drawing.Point(6, 23);
			this.label15.Name = "label15";
			this.label15.Size = new System.Drawing.Size(124, 13);
			this.label15.TabIndex = 0;
			this.label15.Text = "VAAFI PKI Certificate ID:";
			// 
			// label18
			// 
			this.label18.AutoSize = true;
			this.label18.Location = new System.Drawing.Point(6, 78);
			this.label18.Name = "label18";
			this.label18.Size = new System.Drawing.Size(73, 13);
			this.label18.TabIndex = 4;
			this.label18.Text = "ES Password:";
			// 
			// label17
			// 
			this.label17.AutoSize = true;
			this.label17.Location = new System.Drawing.Point(6, 51);
			this.label17.Name = "label17";
			this.label17.Size = new System.Drawing.Size(106, 13);
			this.label17.TabIndex = 2;
			this.label17.Text = "ES Service Account:";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.esURL);
			this.groupBox2.Controls.Add(this.mviURL);
			this.groupBox2.Controls.Add(this.label14);
			this.groupBox2.Controls.Add(this.label16);
			this.groupBox2.Location = new System.Drawing.Point(6, 273);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(358, 86);
			this.groupBox2.TabIndex = 3;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Web Service URLs";
			// 
			// esURL
			// 
			this.esURL.Location = new System.Drawing.Point(113, 55);
			this.esURL.Name = "esURL";
			this.esURL.Size = new System.Drawing.Size(239, 20);
			this.esURL.TabIndex = 3;
			// 
			// mviURL
			// 
			this.mviURL.Location = new System.Drawing.Point(113, 20);
			this.mviURL.Name = "mviURL";
			this.mviURL.Size = new System.Drawing.Size(239, 20);
			this.mviURL.TabIndex = 1;
			// 
			// label14
			// 
			this.label14.AutoSize = true;
			this.label14.Location = new System.Drawing.Point(17, 28);
			this.label14.Name = "label14";
			this.label14.Size = new System.Drawing.Size(79, 13);
			this.label14.TabIndex = 0;
			this.label14.Text = "IdS (MVI) URL:";
			// 
			// label16
			// 
			this.label16.AutoSize = true;
			this.label16.Location = new System.Drawing.Point(17, 58);
			this.label16.Name = "label16";
			this.label16.Size = new System.Drawing.Size(49, 13);
			this.label16.TabIndex = 2;
			this.label16.Text = "ES URL:";
			// 
			// dbGroup
			// 
			this.dbGroup.Controls.Add(this.label3);
			this.dbGroup.Controls.Add(this.label2);
			this.dbGroup.Controls.Add(this.zipServerLabel);
			this.dbGroup.Controls.Add(this.DBPassword);
			this.dbGroup.Controls.Add(this.DBUser);
			this.dbGroup.Controls.Add(this.DBServerName);
			this.dbGroup.Location = new System.Drawing.Point(9, 6);
			this.dbGroup.Name = "dbGroup";
			this.dbGroup.Size = new System.Drawing.Size(301, 104);
			this.dbGroup.TabIndex = 0;
			this.dbGroup.TabStop = false;
			this.dbGroup.Text = "SQL Database Credentials";
			// 
			// label3
			// 
			this.label3.AutoSize = true;
			this.label3.Location = new System.Drawing.Point(4, 73);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(105, 13);
			this.label3.TabIndex = 4;
			this.label3.Text = "Database Password:";
			// 
			// label2
			// 
			this.label2.AutoSize = true;
			this.label2.Location = new System.Drawing.Point(28, 47);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(81, 13);
			this.label2.TabIndex = 2;
			this.label2.Text = "Database User:";
			// 
			// zipServerLabel
			// 
			this.zipServerLabel.AutoSize = true;
			this.zipServerLabel.Location = new System.Drawing.Point(19, 22);
			this.zipServerLabel.Name = "zipServerLabel";
			this.zipServerLabel.Size = new System.Drawing.Size(90, 13);
			this.zipServerLabel.TabIndex = 0;
			this.zipServerLabel.Text = "Database Server:";
			// 
			// DBPassword
			// 
			this.DBPassword.Location = new System.Drawing.Point(112, 70);
			this.DBPassword.Name = "DBPassword";
			this.DBPassword.PasswordChar = '*';
			this.DBPassword.Size = new System.Drawing.Size(183, 20);
			this.DBPassword.TabIndex = 5;
			// 
			// DBUser
			// 
			this.DBUser.Location = new System.Drawing.Point(112, 44);
			this.DBUser.Name = "DBUser";
			this.DBUser.Size = new System.Drawing.Size(183, 20);
			this.DBUser.TabIndex = 3;
			// 
			// saveButton2
			// 
			this.saveButton2.Location = new System.Drawing.Point(500, 87);
			this.saveButton2.Name = "saveButton2";
			this.saveButton2.Size = new System.Drawing.Size(105, 23);
			this.saveButton2.TabIndex = 5;
			this.saveButton2.Text = "Save All Settings";
			this.saveButton2.UseVisualStyleBackColor = true;
			this.saveButton2.Click += new System.EventHandler(this.saveButton_Click);
			// 
			// savedSettingsLabel2
			// 
			this.savedSettingsLabel2.AutoSize = true;
			this.savedSettingsLabel2.Location = new System.Drawing.Point(514, 124);
			this.savedSettingsLabel2.Name = "savedSettingsLabel2";
			this.savedSettingsLabel2.Size = new System.Drawing.Size(82, 13);
			this.savedSettingsLabel2.TabIndex = 6;
			this.savedSettingsLabel2.Text = "Settings Saved.";
			// 
			// label52
			// 
			this.label52.AutoSize = true;
			this.label52.Location = new System.Drawing.Point(3, 78);
			this.label52.Name = "label52";
			this.label52.Size = new System.Drawing.Size(263, 13);
			this.label52.TabIndex = 9;
			this.label52.Text = "(Leave empty to write to same directory as executable)";
			// 
			// label51
			// 
			this.label51.AutoSize = true;
			this.label51.Location = new System.Drawing.Point(3, 65);
			this.label51.Name = "label51";
			this.label51.Size = new System.Drawing.Size(93, 13);
			this.label51.TabIndex = 6;
			this.label51.Text = "Logging Directory:";
			// 
			// controlTab
			// 
			this.controlTab.Controls.Add(this.controlGroup);
			this.controlTab.Controls.Add(this.performanceGroup);
			this.controlTab.Location = new System.Drawing.Point(4, 22);
			this.controlTab.Name = "controlTab";
			this.controlTab.Padding = new System.Windows.Forms.Padding(3);
			this.controlTab.Size = new System.Drawing.Size(964, 606);
			this.controlTab.TabIndex = 0;
			this.controlTab.Text = "Control";
			this.controlTab.UseVisualStyleBackColor = true;
			// 
			// controlGroup
			// 
			this.controlGroup.Controls.Add(this.label13);
			this.controlGroup.Controls.Add(this.statusLabel);
			this.controlGroup.Controls.Add(this.restartButton);
			this.controlGroup.Controls.Add(this.startButton);
			this.controlGroup.Controls.Add(this.stopButton);
			this.controlGroup.Location = new System.Drawing.Point(6, 133);
			this.controlGroup.Name = "controlGroup";
			this.controlGroup.Size = new System.Drawing.Size(612, 142);
			this.controlGroup.TabIndex = 1;
			this.controlGroup.TabStop = false;
			this.controlGroup.Text = "Service Control";
			// 
			// label13
			// 
			this.label13.AutoSize = true;
			this.label13.Font = new System.Drawing.Font("Microsoft Sans Serif", 20.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.label13.ForeColor = System.Drawing.SystemColors.ActiveCaption;
			this.label13.Location = new System.Drawing.Point(350, 32);
			this.label13.Name = "label13";
			this.label13.Size = new System.Drawing.Size(221, 93);
			this.label13.TabIndex = 4;
			this.label13.Text = " VistA Fee 5010\r\n  AET Service\r\n Configuration";
			// 
			// statusLabel
			// 
			this.statusLabel.AutoSize = true;
			this.statusLabel.Location = new System.Drawing.Point(13, 33);
			this.statusLabel.Name = "statusLabel";
			this.statusLabel.Size = new System.Drawing.Size(76, 13);
			this.statusLabel.TabIndex = 0;
			this.statusLabel.Text = "Service Status";
			// 
			// restartButton
			// 
			this.restartButton.Enabled = false;
			this.restartButton.Location = new System.Drawing.Point(197, 102);
			this.restartButton.Name = "restartButton";
			this.restartButton.Size = new System.Drawing.Size(64, 23);
			this.restartButton.TabIndex = 3;
			this.restartButton.Text = "Restart";
			this.restartButton.UseVisualStyleBackColor = true;
			this.restartButton.Click += new System.EventHandler(this.restartButton_Click);
			// 
			// startButton
			// 
			this.startButton.Location = new System.Drawing.Point(16, 102);
			this.startButton.Name = "startButton";
			this.startButton.Size = new System.Drawing.Size(64, 23);
			this.startButton.TabIndex = 1;
			this.startButton.Text = "Start";
			this.startButton.UseVisualStyleBackColor = true;
			this.startButton.Click += new System.EventHandler(this.startButton_Click);
			// 
			// stopButton
			// 
			this.stopButton.Location = new System.Drawing.Point(110, 102);
			this.stopButton.Name = "stopButton";
			this.stopButton.Size = new System.Drawing.Size(64, 23);
			this.stopButton.TabIndex = 2;
			this.stopButton.Text = "Stop";
			this.stopButton.UseVisualStyleBackColor = true;
			this.stopButton.Click += new System.EventHandler(this.stopButton_Click);
			// 
			// performanceGroup
			// 
			this.performanceGroup.Controls.Add(this.virtualMemUsage);
			this.performanceGroup.Controls.Add(this.physicalMemUsage);
			this.performanceGroup.Controls.Add(this.virtualMemLabel);
			this.performanceGroup.Controls.Add(this.physicalMemLabel);
			this.performanceGroup.Controls.Add(this.cpuLabel);
			this.performanceGroup.Controls.Add(this.cpuUsage);
			this.performanceGroup.Location = new System.Drawing.Point(6, 7);
			this.performanceGroup.Name = "performanceGroup";
			this.performanceGroup.Size = new System.Drawing.Size(612, 120);
			this.performanceGroup.TabIndex = 0;
			this.performanceGroup.TabStop = false;
			this.performanceGroup.Text = "Performance";
			// 
			// virtualMemUsage
			// 
			this.virtualMemUsage.BackColor = System.Drawing.SystemColors.ControlDark;
			this.virtualMemUsage.Location = new System.Drawing.Point(176, 78);
			this.virtualMemUsage.Name = "virtualMemUsage";
			this.virtualMemUsage.Size = new System.Drawing.Size(430, 23);
			this.virtualMemUsage.Style = System.Windows.Forms.ProgressBarStyle.Continuous;
			this.virtualMemUsage.TabIndex = 5;
			// 
			// physicalMemUsage
			// 
			this.physicalMemUsage.BackColor = System.Drawing.SystemColors.ControlDark;
			this.physicalMemUsage.Location = new System.Drawing.Point(176, 49);
			this.physicalMemUsage.Name = "physicalMemUsage";
			this.physicalMemUsage.Size = new System.Drawing.Size(430, 23);
			this.physicalMemUsage.Style = System.Windows.Forms.ProgressBarStyle.Continuous;
			this.physicalMemUsage.TabIndex = 4;
			// 
			// virtualMemLabel
			// 
			this.virtualMemLabel.AutoSize = true;
			this.virtualMemLabel.Location = new System.Drawing.Point(13, 86);
			this.virtualMemLabel.Name = "virtualMemLabel";
			this.virtualMemLabel.Size = new System.Drawing.Size(147, 13);
			this.virtualMemLabel.TabIndex = 2;
			this.virtualMemLabel.Text = "System Virtual Memory Usage";
			// 
			// physicalMemLabel
			// 
			this.physicalMemLabel.AutoSize = true;
			this.physicalMemLabel.Location = new System.Drawing.Point(13, 59);
			this.physicalMemLabel.Name = "physicalMemLabel";
			this.physicalMemLabel.Size = new System.Drawing.Size(157, 13);
			this.physicalMemLabel.TabIndex = 1;
			this.physicalMemLabel.Text = "System Physical Memory Usage";
			// 
			// cpuLabel
			// 
			this.cpuLabel.AutoSize = true;
			this.cpuLabel.Location = new System.Drawing.Point(13, 30);
			this.cpuLabel.Name = "cpuLabel";
			this.cpuLabel.Size = new System.Drawing.Size(100, 13);
			this.cpuLabel.TabIndex = 0;
			this.cpuLabel.Text = "System CPU Usage";
			// 
			// cpuUsage
			// 
			this.cpuUsage.BackColor = System.Drawing.SystemColors.ControlDark;
			this.cpuUsage.Location = new System.Drawing.Point(176, 20);
			this.cpuUsage.Name = "cpuUsage";
			this.cpuUsage.Size = new System.Drawing.Size(430, 23);
			this.cpuUsage.Style = System.Windows.Forms.ProgressBarStyle.Continuous;
			this.cpuUsage.TabIndex = 3;
			// 
			// tabControl1
			// 
			this.tabControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
			this.tabControl1.Controls.Add(this.controlTab);
			this.tabControl1.Controls.Add(this.tabServiceConfiguration);
			this.tabControl1.Controls.Add(this.tabEligibilityConfiguration);
			this.tabControl1.Controls.Add(this.tabAuthorizationConfiguration);
			this.tabControl1.Controls.Add(this.tabPage1);
			this.tabControl1.Controls.Add(this.tabPage3);
			this.tabControl1.Controls.Add(this.tabPage4);
			this.tabControl1.Controls.Add(this.tabPage5);
			this.tabControl1.Controls.Add(this.tabPage2);
			this.tabControl1.Location = new System.Drawing.Point(4, 5);
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.Size = new System.Drawing.Size(972, 632);
			this.tabControl1.TabIndex = 0;
			this.tabControl1.SelectedIndexChanged += new System.EventHandler(this.tabControl1_SelectedIndexChanged_1);
			// 
			// tabServiceConfiguration
			// 
			this.tabServiceConfiguration.Controls.Add(this.groupBoxLogging);
			this.tabServiceConfiguration.Controls.Add(this.generalGroup);
			this.tabServiceConfiguration.Controls.Add(this.saveButton1);
			this.tabServiceConfiguration.Location = new System.Drawing.Point(4, 22);
			this.tabServiceConfiguration.Name = "tabServiceConfiguration";
			this.tabServiceConfiguration.Size = new System.Drawing.Size(964, 606);
			this.tabServiceConfiguration.TabIndex = 7;
			this.tabServiceConfiguration.Text = "Service Configuration";
			this.tabServiceConfiguration.UseVisualStyleBackColor = true;
			// 
			// groupBoxLogging
			// 
			this.groupBoxLogging.Controls.Add(this.chkLogZeroLength);
			this.groupBoxLogging.Controls.Add(this.txtLoggingDirectory);
			this.groupBoxLogging.Controls.Add(this.label54);
			this.groupBoxLogging.Controls.Add(this.label53);
			this.groupBoxLogging.Controls.Add(this.chkEnableLogging);
			this.groupBoxLogging.Location = new System.Drawing.Point(23, 190);
			this.groupBoxLogging.Name = "groupBoxLogging";
			this.groupBoxLogging.Size = new System.Drawing.Size(322, 187);
			this.groupBoxLogging.TabIndex = 10;
			this.groupBoxLogging.TabStop = false;
			this.groupBoxLogging.Text = "Logging";
			// 
			// chkLogZeroLength
			// 
			this.chkLogZeroLength.AutoSize = true;
			this.chkLogZeroLength.Location = new System.Drawing.Point(6, 164);
			this.chkLogZeroLength.Name = "chkLogZeroLength";
			this.chkLogZeroLength.Size = new System.Drawing.Size(156, 17);
			this.chkLogZeroLength.TabIndex = 4;
			this.chkLogZeroLength.Text = "Log Zero Length Messages";
			this.chkLogZeroLength.UseVisualStyleBackColor = true;
			// 
			// txtLoggingDirectory
			// 
			this.txtLoggingDirectory.Location = new System.Drawing.Point(7, 118);
			this.txtLoggingDirectory.Name = "txtLoggingDirectory";
			this.txtLoggingDirectory.Size = new System.Drawing.Size(309, 20);
			this.txtLoggingDirectory.TabIndex = 3;
			// 
			// label54
			// 
			this.label54.AutoSize = true;
			this.label54.Location = new System.Drawing.Point(6, 102);
			this.label54.Name = "label54";
			this.label54.Size = new System.Drawing.Size(200, 13);
			this.label54.TabIndex = 2;
			this.label54.Text = "(leave empty to use executable directory)";
			// 
			// label53
			// 
			this.label53.AutoSize = true;
			this.label53.Location = new System.Drawing.Point(6, 74);
			this.label53.Name = "label53";
			this.label53.Size = new System.Drawing.Size(90, 13);
			this.label53.TabIndex = 1;
			this.label53.Text = "Logging Directory";
			// 
			// chkEnableLogging
			// 
			this.chkEnableLogging.AutoSize = true;
			this.chkEnableLogging.Location = new System.Drawing.Point(9, 30);
			this.chkEnableLogging.Name = "chkEnableLogging";
			this.chkEnableLogging.Size = new System.Drawing.Size(100, 17);
			this.chkEnableLogging.TabIndex = 0;
			this.chkEnableLogging.Text = "Enable Logging";
			this.chkEnableLogging.UseVisualStyleBackColor = true;
			// 
			// generalGroup
			// 
			this.generalGroup.Controls.Add(this.cbEnableDebug);
			this.generalGroup.Controls.Add(this.whiteIP);
			this.generalGroup.Controls.Add(this.sslCertName);
			this.generalGroup.Controls.Add(this.label20);
			this.generalGroup.Controls.Add(this.label19);
			this.generalGroup.Controls.Add(this.servicePortLabel);
			this.generalGroup.Controls.Add(this.label12);
			this.generalGroup.Controls.Add(this.servicePort);
			this.generalGroup.Controls.Add(this.controlPort);
			this.generalGroup.Location = new System.Drawing.Point(23, 33);
			this.generalGroup.Name = "generalGroup";
			this.generalGroup.Size = new System.Drawing.Size(301, 126);
			this.generalGroup.TabIndex = 9;
			this.generalGroup.TabStop = false;
			this.generalGroup.Text = "Client Connection";
			// 
			// cbEnableDebug
			// 
			this.cbEnableDebug.AutoSize = true;
			this.cbEnableDebug.Location = new System.Drawing.Point(200, 21);
			this.cbEnableDebug.Name = "cbEnableDebug";
			this.cbEnableDebug.Size = new System.Drawing.Size(94, 17);
			this.cbEnableDebug.TabIndex = 8;
			this.cbEnableDebug.Text = "Enable Debug";
			this.cbEnableDebug.UseVisualStyleBackColor = true;
			// 
			// whiteIP
			// 
			this.whiteIP.Location = new System.Drawing.Point(139, 97);
			this.whiteIP.Name = "whiteIP";
			this.whiteIP.Size = new System.Drawing.Size(156, 20);
			this.whiteIP.TabIndex = 7;
			// 
			// sslCertName
			// 
			this.sslCertName.Location = new System.Drawing.Point(139, 71);
			this.sslCertName.Name = "sslCertName";
			this.sslCertName.Size = new System.Drawing.Size(156, 20);
			this.sslCertName.TabIndex = 5;
			// 
			// label20
			// 
			this.label20.AutoSize = true;
			this.label20.Location = new System.Drawing.Point(6, 100);
			this.label20.Name = "label20";
			this.label20.Size = new System.Drawing.Size(70, 13);
			this.label20.TabIndex = 6;
			this.label20.Text = "IP White List:";
			// 
			// label19
			// 
			this.label19.AutoSize = true;
			this.label19.Location = new System.Drawing.Point(6, 74);
			this.label19.Name = "label19";
			this.label19.Size = new System.Drawing.Size(111, 13);
			this.label19.TabIndex = 4;
			this.label19.Text = "SSL Certificate Name:";
			// 
			// servicePortLabel
			// 
			this.servicePortLabel.AutoSize = true;
			this.servicePortLabel.Location = new System.Drawing.Point(6, 48);
			this.servicePortLabel.Name = "servicePortLabel";
			this.servicePortLabel.Size = new System.Drawing.Size(68, 13);
			this.servicePortLabel.TabIndex = 2;
			this.servicePortLabel.Text = "Service Port:";
			// 
			// label12
			// 
			this.label12.AutoSize = true;
			this.label12.Location = new System.Drawing.Point(6, 22);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(65, 13);
			this.label12.TabIndex = 0;
			this.label12.Text = "Control Port:";
			// 
			// servicePort
			// 
			this.servicePort.Location = new System.Drawing.Point(139, 45);
			this.servicePort.Name = "servicePort";
			this.servicePort.Size = new System.Drawing.Size(44, 20);
			this.servicePort.TabIndex = 3;
			// 
			// controlPort
			// 
			this.controlPort.Location = new System.Drawing.Point(139, 19);
			this.controlPort.Name = "controlPort";
			this.controlPort.Size = new System.Drawing.Size(44, 20);
			this.controlPort.TabIndex = 1;
			// 
			// saveButton1
			// 
			this.saveButton1.Location = new System.Drawing.Point(539, 101);
			this.saveButton1.Name = "saveButton1";
			this.saveButton1.Size = new System.Drawing.Size(105, 23);
			this.saveButton1.TabIndex = 7;
			this.saveButton1.Text = "Save All Settings";
			this.saveButton1.UseVisualStyleBackColor = true;
			this.saveButton1.Click += new System.EventHandler(this.saveButton_Click);
			// 
			// tabAuthorizationConfiguration
			// 
			this.tabAuthorizationConfiguration.Controls.Add(this.groupBox10);
			this.tabAuthorizationConfiguration.Controls.Add(this.saveButton3);
			this.tabAuthorizationConfiguration.Controls.Add(this.groupBox9);
			this.tabAuthorizationConfiguration.Location = new System.Drawing.Point(4, 22);
			this.tabAuthorizationConfiguration.Name = "tabAuthorizationConfiguration";
			this.tabAuthorizationConfiguration.Size = new System.Drawing.Size(964, 606);
			this.tabAuthorizationConfiguration.TabIndex = 6;
			this.tabAuthorizationConfiguration.Text = "Authorization Configuration";
			this.tabAuthorizationConfiguration.UseVisualStyleBackColor = true;
			// 
			// groupBox10
			// 
			this.groupBox10.Controls.Add(this.txtCdwServer);
			this.groupBox10.Controls.Add(this.label57);
			this.groupBox10.Controls.Add(this.txtCdwDatabase);
			this.groupBox10.Controls.Add(this.label58);
			this.groupBox10.Location = new System.Drawing.Point(23, 15);
			this.groupBox10.Name = "groupBox10";
			this.groupBox10.Size = new System.Drawing.Size(305, 81);
			this.groupBox10.TabIndex = 11;
			this.groupBox10.TabStop = false;
			this.groupBox10.Text = "CDW Database";
			// 
			// label57
			// 
			this.label57.AutoSize = true;
			this.label57.Location = new System.Drawing.Point(14, 27);
			this.label57.Name = "label57";
			this.label57.Size = new System.Drawing.Size(90, 13);
			this.label57.TabIndex = 0;
			this.label57.Text = "Database Server:";
			this.label57.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label58
			// 
			this.label58.AutoSize = true;
			this.label58.Location = new System.Drawing.Point(48, 53);
			this.label58.Name = "label58";
			this.label58.Size = new System.Drawing.Size(56, 13);
			this.label58.TabIndex = 2;
			this.label58.Text = "Database:";
			this.label58.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// saveButton3
			// 
			this.saveButton3.Location = new System.Drawing.Point(429, 42);
			this.saveButton3.Name = "saveButton3";
			this.saveButton3.Size = new System.Drawing.Size(105, 23);
			this.saveButton3.TabIndex = 10;
			this.saveButton3.Text = "Save All Settings";
			this.saveButton3.UseVisualStyleBackColor = true;
			this.saveButton3.Click += new System.EventHandler(this.saveButton_Click);
			// 
			// groupBox9
			// 
			this.groupBox9.Controls.Add(this.label44);
			this.groupBox9.Controls.Add(this.txtAatDatabasePassword);
			this.groupBox9.Controls.Add(this.txtAatDatabaseUsername);
			this.groupBox9.Controls.Add(this.label45);
			this.groupBox9.Controls.Add(this.txtAatServer);
			this.groupBox9.Controls.Add(this.label49);
			this.groupBox9.Controls.Add(this.txtAatDatabase);
			this.groupBox9.Controls.Add(this.label50);
			this.groupBox9.Location = new System.Drawing.Point(23, 197);
			this.groupBox9.Name = "groupBox9";
			this.groupBox9.Size = new System.Drawing.Size(305, 133);
			this.groupBox9.TabIndex = 9;
			this.groupBox9.TabStop = false;
			this.groupBox9.Text = "AAT Database";
			this.groupBox9.Visible = false;
			// 
			// label44
			// 
			this.label44.AutoSize = true;
			this.label44.Location = new System.Drawing.Point(23, 80);
			this.label44.Name = "label44";
			this.label44.Size = new System.Drawing.Size(81, 13);
			this.label44.TabIndex = 4;
			this.label44.Text = "Database User:";
			this.label44.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label45
			// 
			this.label45.AutoSize = true;
			this.label45.Location = new System.Drawing.Point(1, 108);
			this.label45.Name = "label45";
			this.label45.Size = new System.Drawing.Size(105, 13);
			this.label45.TabIndex = 6;
			this.label45.Text = "Database Password:";
			this.label45.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label49
			// 
			this.label49.AutoSize = true;
			this.label49.Location = new System.Drawing.Point(14, 27);
			this.label49.Name = "label49";
			this.label49.Size = new System.Drawing.Size(90, 13);
			this.label49.TabIndex = 0;
			this.label49.Text = "Database Server:";
			this.label49.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label50
			// 
			this.label50.AutoSize = true;
			this.label50.Location = new System.Drawing.Point(48, 53);
			this.label50.Name = "label50";
			this.label50.Size = new System.Drawing.Size(56, 13);
			this.label50.TabIndex = 2;
			this.label50.Text = "Database:";
			this.label50.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// tabPage2
			// 
			this.tabPage2.Controls.Add(this.groupBox11);
			this.tabPage2.Location = new System.Drawing.Point(4, 22);
			this.tabPage2.Name = "tabPage2";
			this.tabPage2.Padding = new System.Windows.Forms.Padding(3);
			this.tabPage2.Size = new System.Drawing.Size(964, 606);
			this.tabPage2.TabIndex = 8;
			this.tabPage2.Text = "NPI TIN Crosswalk";
			this.tabPage2.UseVisualStyleBackColor = true;
			// 
			// groupBox11
			// 
			this.groupBox11.Controls.Add(this.txtNPIUpdate);
			this.groupBox11.Controls.Add(this.label55);
			this.groupBox11.Controls.Add(this.cmdSaveNPI);
			this.groupBox11.Controls.Add(this.NPIExt);
			this.groupBox11.Controls.Add(this.NPIWatchFolder);
			this.groupBox11.Controls.Add(this.label56);
			this.groupBox11.Controls.Add(this.label59);
			this.groupBox11.Location = new System.Drawing.Point(26, 29);
			this.groupBox11.Name = "groupBox11";
			this.groupBox11.Size = new System.Drawing.Size(392, 162);
			this.groupBox11.TabIndex = 2;
			this.groupBox11.TabStop = false;
			this.groupBox11.Text = "Automated NPI/TIN Import";
			// 
			// txtNPIUpdate
			// 
			this.txtNPIUpdate.Location = new System.Drawing.Point(84, 95);
			this.txtNPIUpdate.Name = "txtNPIUpdate";
			this.txtNPIUpdate.ReadOnly = true;
			this.txtNPIUpdate.Size = new System.Drawing.Size(226, 20);
			this.txtNPIUpdate.TabIndex = 5;
			// 
			// label55
			// 
			this.label55.AutoSize = true;
			this.label55.Location = new System.Drawing.Point(16, 98);
			this.label55.Name = "label55";
			this.label55.Size = new System.Drawing.Size(68, 13);
			this.label55.TabIndex = 4;
			this.label55.Text = "Last Update:";
			// 
			// cmdSaveNPI
			// 
			this.cmdSaveNPI.Location = new System.Drawing.Point(303, 124);
			this.cmdSaveNPI.Name = "cmdSaveNPI";
			this.cmdSaveNPI.Size = new System.Drawing.Size(75, 23);
			this.cmdSaveNPI.TabIndex = 6;
			this.cmdSaveNPI.Text = "Save";
			this.cmdSaveNPI.UseVisualStyleBackColor = true;
			this.cmdSaveNPI.Click += new System.EventHandler(this.cmdSaveNPI_Click);
			// 
			// NPIExt
			// 
			this.NPIExt.Enabled = false;
			this.NPIExt.Location = new System.Drawing.Point(115, 66);
			this.NPIExt.Name = "NPIExt";
			this.NPIExt.Size = new System.Drawing.Size(159, 20);
			this.NPIExt.TabIndex = 3;
			this.NPIExt.Text = ".xlsx";
			this.toolTip1.SetToolTip(this.NPIExt, "File Extension to monitor");
			// 
			// NPIWatchFolder
			// 
			this.NPIWatchFolder.Location = new System.Drawing.Point(139, 32);
			this.NPIWatchFolder.Name = "NPIWatchFolder";
			this.NPIWatchFolder.Size = new System.Drawing.Size(249, 20);
			this.NPIWatchFolder.TabIndex = 1;
			this.toolTip1.SetToolTip(this.NPIWatchFolder, "LEIE Import Folder to monitor");
			// 
			// label56
			// 
			this.label56.AutoSize = true;
			this.label56.Location = new System.Drawing.Point(10, 68);
			this.label56.Name = "label56";
			this.label56.Size = new System.Drawing.Size(107, 13);
			this.label56.TabIndex = 2;
			this.label56.Text = "Import File Extension:";
			// 
			// label59
			// 
			this.label59.AutoSize = true;
			this.label59.Location = new System.Drawing.Point(18, 35);
			this.label59.Name = "label59";
			this.label59.Size = new System.Drawing.Size(115, 13);
			this.label59.TabIndex = 0;
			this.label59.Text = "NPI/TIN Import Folder:";
			// 
			// AETControl
			// 
			this.Controls.Add(this.tabControl1);
			this.Name = "AETControl";
			this.Size = new System.Drawing.Size(993, 653);
			this.TabIndexChanged += new System.EventHandler(this.AETControl_TabIndexChanged);
			this.groupBox5.ResumeLayout(false);
			this.groupBox5.PerformLayout();
			this.groupBox6.ResumeLayout(false);
			this.groupBox6.PerformLayout();
			this.tabPage5.ResumeLayout(false);
			this.groupBox7.ResumeLayout(false);
			this.groupBox7.PerformLayout();
			this.groupBox8.ResumeLayout(false);
			this.groupBox8.PerformLayout();
			this.tabPage4.ResumeLayout(false);
			this.groupBox4.ResumeLayout(false);
			this.groupBox4.PerformLayout();
			this.groupBox1.ResumeLayout(false);
			this.groupBox1.PerformLayout();
			this.tabPage3.ResumeLayout(false);
			this.tabPage3.PerformLayout();
			this.tabPage1.ResumeLayout(false);
			this.tabPage1.PerformLayout();
			((System.ComponentModel.ISupportInitialize)(this.dataGridView1)).EndInit();
			this.tabEligibilityConfiguration.ResumeLayout(false);
			this.tabEligibilityConfiguration.PerformLayout();
			this.STCGroup.ResumeLayout(false);
			this.STCGroup.PerformLayout();
			this.DBNames.ResumeLayout(false);
			this.DBNames.PerformLayout();
			this.groupBox3.ResumeLayout(false);
			this.groupBox3.PerformLayout();
			this.groupBox2.ResumeLayout(false);
			this.groupBox2.PerformLayout();
			this.dbGroup.ResumeLayout(false);
			this.dbGroup.PerformLayout();
			this.controlTab.ResumeLayout(false);
			this.controlGroup.ResumeLayout(false);
			this.controlGroup.PerformLayout();
			this.performanceGroup.ResumeLayout(false);
			this.performanceGroup.PerformLayout();
			this.tabControl1.ResumeLayout(false);
			this.tabServiceConfiguration.ResumeLayout(false);
			this.groupBoxLogging.ResumeLayout(false);
			this.groupBoxLogging.PerformLayout();
			this.generalGroup.ResumeLayout(false);
			this.generalGroup.PerformLayout();
			this.tabAuthorizationConfiguration.ResumeLayout(false);
			this.groupBox10.ResumeLayout(false);
			this.groupBox10.PerformLayout();
			this.groupBox9.ResumeLayout(false);
			this.groupBox9.PerformLayout();
			this.tabPage2.ResumeLayout(false);
			this.groupBox11.ResumeLayout(false);
			this.groupBox11.PerformLayout();
			this.ResumeLayout(false);

        }

        void tabControl1_SelectedIndexChanged_1(object sender, EventArgs e)
        {
            switch (tabControl1.SelectedIndex)
            {
                case 0:
                    //MessageBox.Show("Selected Control Tab");
                    break;
                case 1:
                    //MessageBox.Show("Selected Configuration Tab");
                    break;
                case 2:
                    //MessageBox.Show("Selected View Files Tab");
                    DateChanged();
                    break;
                default: break;
            }




        }


        private void startButton_Click(object sender, EventArgs e)
        {
            savedSettingsLabel2.Text = "";
            buttonsEnabled = false;
            updateControlStatus();
            controlGroup.Refresh();
            new Thread(new ParameterizedThreadStart(startService)).Start(sc);
        }
        private void stopButton_Click(object sender, EventArgs e)
        {
            buttonsEnabled = false;
            updateControlStatus();
            controlGroup.Refresh();
            new Thread(new ParameterizedThreadStart(stopService)).Start(sc);
        }
        private void restartButton_Click(object sender, EventArgs e)
        {
            buttonsEnabled = false;
            //updateControlStatus();
            //controlGroup.Refresh();
            //new Thread(new ParameterizedThreadStart(restartService)).Start(sc);
        }
        private void startService(object sc)
        {
            try
            {
                ((ServiceController)sc).Start();
            }
            catch
            {
                Invoke(new StringCallback(showMessage), new object[] { "Cannot start AET Service" });
            }
            buttonsEnabled = true;
        }
        private void stopService(object sc)
        {
            try
            {
                ((ServiceController)sc).Stop();
            }
            catch
            {
                Invoke(new StringCallback(showMessage), new object[] { "Cannot stop AET Service" });
            }
            buttonsEnabled = true;
        }
        private void restartService(object sc)
        {
            try
            {
                ((ServiceController)sc).Stop(); this.startButton = new System.Windows.Forms.Button();
                this.statusLabel = new System.Windows.Forms.Label();
                this.stopButton = new System.Windows.Forms.Button();
                this.restartButton = new System.Windows.Forms.Button();
                this.controlGroup = new System.Windows.Forms.GroupBox();
                this.performanceGroup = new System.Windows.Forms.GroupBox();
                this.virtualMemUsage = new System.Windows.Forms.ProgressBar();
                this.physicalMemUsage = new System.Windows.Forms.ProgressBar();
                this.virtualMemLabel = new System.Windows.Forms.Label();
                this.physicalMemLabel = new System.Windows.Forms.Label();
                this.cpuLabel = new System.Windows.Forms.Label();
                this.cpuUsage = new System.Windows.Forms.ProgressBar();
                this.tabControl1 = new System.Windows.Forms.TabControl();
                this.controlTab = new System.Windows.Forms.TabPage();
                this.tabEligibilityConfiguration = new System.Windows.Forms.TabPage();
                //this.generalGroup = new System.Windows.Forms.GroupBox();
                this.savedSettingsLabel2 = new System.Windows.Forms.Label();
                this.saveButton2 = new System.Windows.Forms.Button();
                //this.servicePortLabel = new System.Windows.Forms.Label();
                //this.label12 = new System.Windows.Forms.Label();
                //this.servicePort = new System.Windows.Forms.TextBox();
                //this.controlPort = new System.Windows.Forms.TextBox();
                this.DBNames = new System.Windows.Forms.GroupBox();

                this.label10 = new System.Windows.Forms.Label();

                this.logDb = new System.Windows.Forms.TextBox();

                this.label4 = new System.Windows.Forms.Label();

                this.label6 = new System.Windows.Forms.Label();

                this.dbGroup = new System.Windows.Forms.GroupBox();
                this.label3 = new System.Windows.Forms.Label();
                this.label2 = new System.Windows.Forms.Label();
                this.label1 = new System.Windows.Forms.Label();
                this.zipServerLabel = new System.Windows.Forms.Label();
                this.DBPassword = new System.Windows.Forms.TextBox();
                this.DBUser = new System.Windows.Forms.TextBox();
                this.zipDb = new System.Windows.Forms.TextBox();
                this.DBServerName = new System.Windows.Forms.TextBox();
                this.tabPage1 = new System.Windows.Forms.TabPage();
                this.lblIP = new System.Windows.Forms.Label();
                this.lblErrorMsg = new System.Windows.Forms.Label();
                this.lblErrorID = new System.Windows.Forms.Label();
                this.lblStatus = new System.Windows.Forms.Label();
                this.lblClearingHouse = new System.Windows.Forms.Label();
                this.lblResponseQual = new System.Windows.Forms.Label();
                this.lblResponseTime = new System.Windows.Forms.Label();
                this.lblRequestQual = new System.Windows.Forms.Label();
                this.lblRequestTime = new System.Windows.Forms.Label();
                this.btnBack = new System.Windows.Forms.Button();
                this.btnSelect = new System.Windows.Forms.Button();
                this.logDatePicker = new System.Windows.Forms.DateTimePicker();
                this.dataGridView1 = new System.Windows.Forms.DataGridView();
                this.webBrowser271 = new System.Windows.Forms.WebBrowser();
                this.webBrowser270 = new System.Windows.Forms.WebBrowser();
                this.label13 = new System.Windows.Forms.Label();
                this.label14 = new System.Windows.Forms.Label();
                this.label15 = new System.Windows.Forms.Label();
                this.label16 = new System.Windows.Forms.Label();
                this.label17 = new System.Windows.Forms.Label();
                this.label18 = new System.Windows.Forms.Label();
                //this.label19 = new System.Windows.Forms.Label();
                //this.label20 = new System.Windows.Forms.Label();
                //this.sslCertName = new System.Windows.Forms.TextBox();
                //this.whiteIP = new System.Windows.Forms.TextBox();
                this.groupBox2 = new System.Windows.Forms.GroupBox();
                this.groupBox3 = new System.Windows.Forms.GroupBox();
                this.mviURL = new System.Windows.Forms.TextBox();
                this.esURL = new System.Windows.Forms.TextBox();
                this.pkiCert = new System.Windows.Forms.TextBox();
                this.esSA = new System.Windows.Forms.TextBox();
                this.esPW = new System.Windows.Forms.TextBox();
                this.controlGroup.SuspendLayout();
                this.performanceGroup.SuspendLayout();
                this.tabControl1.SuspendLayout();
                this.controlTab.SuspendLayout();
                this.tabEligibilityConfiguration.SuspendLayout();
                //this.generalGroup.SuspendLayout();
                this.DBNames.SuspendLayout();

                this.dbGroup.SuspendLayout();
                this.tabPage1.SuspendLayout();
                ((System.ComponentModel.ISupportInitialize)(this.dataGridView1)).BeginInit();
                this.groupBox2.SuspendLayout();
                this.groupBox3.SuspendLayout();
                this.SuspendLayout();
                // 
                // startButton
                // 
                this.startButton.Location = new System.Drawing.Point(16, 102);
                this.startButton.Name = "startButton";
                this.startButton.Size = new System.Drawing.Size(64, 23);
                this.startButton.TabIndex = 1;
                this.startButton.Text = "Start";
                this.startButton.UseVisualStyleBackColor = true;
                this.startButton.Click += new System.EventHandler(this.startButton_Click);
                // 
                // statusLabel
                // 
                this.statusLabel.AutoSize = true;
                this.statusLabel.Location = new System.Drawing.Point(13, 33);
                this.statusLabel.Name = "statusLabel";
                this.statusLabel.Size = new System.Drawing.Size(76, 13);
                this.statusLabel.TabIndex = 0;
                this.statusLabel.Text = "Service Status";
                // 
                // stopButton
                // 
                this.stopButton.Location = new System.Drawing.Point(110, 102);
                this.stopButton.Name = "stopButton";
                this.stopButton.Size = new System.Drawing.Size(64, 23);
                this.stopButton.TabIndex = 2;
                this.stopButton.Text = "Stop";
                this.stopButton.UseVisualStyleBackColor = true;
                this.stopButton.Click += new System.EventHandler(this.stopButton_Click);
                // 
                // restartButton
                // 
                this.restartButton.Location = new System.Drawing.Point(197, 102);
                this.restartButton.Name = "restartButton";
                this.restartButton.Size = new System.Drawing.Size(64, 23);
                this.restartButton.TabIndex = 3;
                this.restartButton.Text = "Restart";
                this.restartButton.UseVisualStyleBackColor = true;
                this.restartButton.Click += new System.EventHandler(this.restartButton_Click);
                // 
                // controlGroup
                // 
                this.controlGroup.Controls.Add(this.label13);
                this.controlGroup.Controls.Add(this.statusLabel);
                this.controlGroup.Controls.Add(this.restartButton);
                this.controlGroup.Controls.Add(this.startButton);
                this.controlGroup.Controls.Add(this.stopButton);
                this.controlGroup.Location = new System.Drawing.Point(6, 133);
                this.controlGroup.Name = "controlGroup";
                this.controlGroup.Size = new System.Drawing.Size(612, 142);
                this.controlGroup.TabIndex = 1;
                this.controlGroup.TabStop = false;
                this.controlGroup.Text = "Service Control";
                // 
                // performanceGroup
                // 
                this.performanceGroup.Controls.Add(this.virtualMemUsage);
                this.performanceGroup.Controls.Add(this.physicalMemUsage);
                this.performanceGroup.Controls.Add(this.virtualMemLabel);
                this.performanceGroup.Controls.Add(this.physicalMemLabel);
                this.performanceGroup.Controls.Add(this.cpuLabel);
                this.performanceGroup.Controls.Add(this.cpuUsage);
                this.performanceGroup.Location = new System.Drawing.Point(6, 7);
                this.performanceGroup.Name = "performanceGroup";
                this.performanceGroup.Size = new System.Drawing.Size(612, 120);
                this.performanceGroup.TabIndex = 0;
                this.performanceGroup.TabStop = false;
                this.performanceGroup.Text = "Performance";
                // 
                // virtualMemUsage
                // 
                this.virtualMemUsage.BackColor = System.Drawing.SystemColors.ControlDark;
                this.virtualMemUsage.Location = new System.Drawing.Point(176, 78);
                this.virtualMemUsage.Name = "virtualMemUsage";
                this.virtualMemUsage.Size = new System.Drawing.Size(430, 23);
                this.virtualMemUsage.Style = System.Windows.Forms.ProgressBarStyle.Continuous;
                this.virtualMemUsage.TabIndex = 5;
                // 
                // physicalMemUsage
                // 
                this.physicalMemUsage.BackColor = System.Drawing.SystemColors.ControlDark;
                this.physicalMemUsage.Location = new System.Drawing.Point(176, 49);
                this.physicalMemUsage.Name = "physicalMemUsage";
                this.physicalMemUsage.Size = new System.Drawing.Size(430, 23);
                this.physicalMemUsage.Style = System.Windows.Forms.ProgressBarStyle.Continuous;
                this.physicalMemUsage.TabIndex = 4;
                // 
                // virtualMemLabel
                // 
                this.virtualMemLabel.AutoSize = true;
                this.virtualMemLabel.Location = new System.Drawing.Point(13, 86);
                this.virtualMemLabel.Name = "virtualMemLabel";
                this.virtualMemLabel.Size = new System.Drawing.Size(147, 13);
                this.virtualMemLabel.TabIndex = 2;
                this.virtualMemLabel.Text = "System Virtual Memory Usage";
                // 
                // physicalMemLabel
                // 
                this.physicalMemLabel.AutoSize = true;
                this.physicalMemLabel.Location = new System.Drawing.Point(13, 59);
                this.physicalMemLabel.Name = "physicalMemLabel";
                this.physicalMemLabel.Size = new System.Drawing.Size(157, 13);
                this.physicalMemLabel.TabIndex = 1;
                this.physicalMemLabel.Text = "System Physical Memory Usage";
                // 
                // cpuLabel
                // 
                this.cpuLabel.AutoSize = true;
                this.cpuLabel.Location = new System.Drawing.Point(13, 30);
                this.cpuLabel.Name = "cpuLabel";
                this.cpuLabel.Size = new System.Drawing.Size(100, 13);
                this.cpuLabel.TabIndex = 0;
                this.cpuLabel.Text = "System CPU Usage";
                // 
                // cpuUsage
                // 
                this.cpuUsage.BackColor = System.Drawing.SystemColors.ControlDark;
                this.cpuUsage.Location = new System.Drawing.Point(176, 20);
                this.cpuUsage.Name = "cpuUsage";
                this.cpuUsage.Size = new System.Drawing.Size(430, 23);
                this.cpuUsage.Style = System.Windows.Forms.ProgressBarStyle.Continuous;
                this.cpuUsage.TabIndex = 3;
                // 
                // tabControl1
                // 
                this.tabControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                            | System.Windows.Forms.AnchorStyles.Left)
                            | System.Windows.Forms.AnchorStyles.Right)));
                this.tabControl1.Controls.Add(this.controlTab);
                this.tabControl1.Controls.Add(this.tabEligibilityConfiguration);
                this.tabControl1.Controls.Add(this.tabPage1);
                this.tabControl1.Location = new System.Drawing.Point(4, 5);
                this.tabControl1.Name = "tabControl1";
                this.tabControl1.SelectedIndex = 0;
                this.tabControl1.Size = new System.Drawing.Size(757, 424);
                this.tabControl1.TabIndex = 7;
                this.tabControl1.SelectedIndexChanged += new EventHandler(tabControl1_SelectedIndexChanged);
                // 
                // controlTab
                // 
                this.controlTab.Controls.Add(this.controlGroup);
                this.controlTab.Controls.Add(this.performanceGroup);
                this.controlTab.Location = new System.Drawing.Point(4, 22);
                this.controlTab.Name = "controlTab";
                this.controlTab.Padding = new System.Windows.Forms.Padding(3);
                this.controlTab.Size = new System.Drawing.Size(749, 373);
                this.controlTab.TabIndex = 0;
                this.controlTab.Text = "Control";
                this.controlTab.UseVisualStyleBackColor = true;
                // 
                // tabPage2
                // 
                this.tabEligibilityConfiguration.Controls.Add(this.groupBox3);
                this.tabEligibilityConfiguration.Controls.Add(this.groupBox2);
                //this.tabEligibilityConfiguration.Controls.Add(this.generalGroup);
                this.tabEligibilityConfiguration.Controls.Add(this.DBNames);

                this.tabEligibilityConfiguration.Controls.Add(this.dbGroup);
                this.tabEligibilityConfiguration.Controls.Add(this.saveButton2);
                this.tabEligibilityConfiguration.Controls.Add(this.savedSettingsLabel2);
                this.tabEligibilityConfiguration.Location = new System.Drawing.Point(4, 22);
                this.tabEligibilityConfiguration.Name = "tabPage2";
                this.tabEligibilityConfiguration.Padding = new System.Windows.Forms.Padding(3);
                this.tabEligibilityConfiguration.Size = new System.Drawing.Size(749, 398);
                this.tabEligibilityConfiguration.TabIndex = 1;
                this.tabEligibilityConfiguration.Text = "Configuration";
                this.tabEligibilityConfiguration.UseVisualStyleBackColor = true;
                // 
                // generalGroup
                // 
                //this.generalGroup.Controls.Add(this.whiteIP);
                //this.generalGroup.Controls.Add(this.sslCertName);
                //this.generalGroup.Controls.Add(this.label20);
                //this.generalGroup.Controls.Add(this.label19);
                //this.generalGroup.Controls.Add(this.servicePortLabel);
                //this.generalGroup.Controls.Add(this.label12);
                //this.generalGroup.Controls.Add(this.servicePort);
                //this.generalGroup.Controls.Add(this.controlPort);
                //this.generalGroup.Location = new System.Drawing.Point(320, 143);
                //this.generalGroup.Name = "generalGroup";
                //this.generalGroup.Size = new System.Drawing.Size(301, 131);
                //this.generalGroup.TabIndex = 3;
                //this.generalGroup.TabStop = false;
                //this.generalGroup.Text = "Client Connection";
                // 
                // savedSettingsLabel
                // 
                this.savedSettingsLabel2.AutoSize = true;
                this.savedSettingsLabel2.Location = new System.Drawing.Point(644, 195);
                this.savedSettingsLabel2.Name = "savedSettingsLabel";
                this.savedSettingsLabel2.Size = new System.Drawing.Size(82, 13);
                this.savedSettingsLabel2.TabIndex = 13;
                this.savedSettingsLabel2.Text = "Settings Saved.";
                // 
                // saveButton
                // 
                this.saveButton2.Location = new System.Drawing.Point(630, 160);
                this.saveButton2.Name = "saveButton";
                this.saveButton2.Size = new System.Drawing.Size(105, 23);
                this.saveButton2.TabIndex = 12;
                this.saveButton2.Text = "Save All Settings";
                this.saveButton2.UseVisualStyleBackColor = true;
                this.saveButton2.Click += new System.EventHandler(this.saveButton_Click);
                // 
                // servicePortLabel
                // 
                //this.servicePortLabel.AutoSize = true;
                //this.servicePortLabel.Location = new System.Drawing.Point(6, 48);
                //this.servicePortLabel.Name = "servicePortLabel";
                //this.servicePortLabel.Size = new System.Drawing.Size(68, 13);
                //this.servicePortLabel.TabIndex = 11;
                //this.servicePortLabel.Text = "Service Port:";
                // 
                // label12
                // 
                //this.label12.AutoSize = true;
                //this.label12.Location = new System.Drawing.Point(6, 22);
                //this.label12.Name = "label12";
                //this.label12.Size = new System.Drawing.Size(65, 13);
                //this.label12.TabIndex = 10;
                //this.label12.Text = "Control Port:";
                // 
                // servicePort
                // 
                //this.servicePort.Location = new System.Drawing.Point(139, 45);
                //this.servicePort.Name = "servicePort";
                //this.servicePort.Size = new System.Drawing.Size(156, 20);
                //this.servicePort.TabIndex = 9;
                // 
                // controlPort
                // 
                //this.controlPort.Location = new System.Drawing.Point(139, 19);
                //this.controlPort.Name = "controlPort";
                //this.controlPort.Size = new System.Drawing.Size(156, 20);
                //this.controlPort.TabIndex = 8;
                // 
                // groupBox1
                // 

                this.DBNames.Controls.Add(this.logDb);
                this.DBNames.Location = new System.Drawing.Point(9, 143);
                this.DBNames.Name = "groupBox1";
                this.DBNames.Size = new System.Drawing.Size(301, 131);
                this.DBNames.TabIndex = 2;
                this.DBNames.TabStop = false;
                this.DBNames.Text = "Log Database";
                // 

                // 
                // label10
                // 
                this.label10.AutoSize = true;
                this.label10.Location = new System.Drawing.Point(6, 48);
                this.label10.Name = "label10";
                this.label10.Size = new System.Drawing.Size(87, 13);
                this.label10.TabIndex = 2;
                this.label10.Text = "Database Name:";

                //tooltip.AutoPopDelay = 20 * 1000;
                //tooltip.SetToolTip(this.label10, "Enter the SQL Server Database Server that will support the Zip Code to VA Crosswalk.\n Please obtain this information for a AITC DBA.");
                // 
                // label11
                // 

                // 
                // logUser
                // 

                // 
                // logDb
                // 
                this.logDb.Location = new System.Drawing.Point(139, 45);
                this.logDb.Name = "logDb";
                this.logDb.Size = new System.Drawing.Size(156, 20);
                this.logDb.TabIndex = 3;
                // 
                // DBServerName
                // 

                // 
                // label4
                // 
                this.label4.AutoSize = true;
                this.label4.Location = new System.Drawing.Point(6, 100);
                this.label4.Name = "label4";
                this.label4.Size = new System.Drawing.Size(105, 13);
                this.label4.TabIndex = 6;
                this.label4.Text = "Database Password:";

                // 
                // label6
                // 
                this.label6.AutoSize = true;
                this.label6.Location = new System.Drawing.Point(6, 48);
                this.label6.Name = "label6";
                this.label6.Size = new System.Drawing.Size(87, 13);
                this.label6.TabIndex = 2;
                this.label6.Text = "Database Name:";


                // 
                // ansiDb
                // 
                this.ansiDb.Location = new System.Drawing.Point(139, 45);
                this.ansiDb.Name = "ansiDb";
                this.ansiDb.Size = new System.Drawing.Size(156, 20);
                this.ansiDb.TabIndex = 3;

                // 
                // zipGroup
                // 
                this.dbGroup.Controls.Add(this.label3);
                this.dbGroup.Controls.Add(this.label2);
                this.dbGroup.Controls.Add(this.label1);
                this.dbGroup.Controls.Add(this.zipServerLabel);
                this.dbGroup.Controls.Add(this.DBPassword);
                this.dbGroup.Controls.Add(this.DBUser);
                this.dbGroup.Controls.Add(this.zipDb);
                this.dbGroup.Controls.Add(this.DBServerName);
                this.dbGroup.Location = new System.Drawing.Point(9, 6);
                this.dbGroup.Name = "zipGroup";
                this.dbGroup.Size = new System.Drawing.Size(301, 131);
                this.dbGroup.TabIndex = 0;
                this.dbGroup.TabStop = false;
                this.dbGroup.Text = "Zip Database";
                // 
                // label3
                // 
                this.label3.AutoSize = true;
                this.label3.Location = new System.Drawing.Point(6, 100);
                this.label3.Name = "label3";
                this.label3.Size = new System.Drawing.Size(105, 13);
                this.label3.TabIndex = 6;
                this.label3.Text = "Database Password:";
                // 
                // label2
                // 
                this.label2.AutoSize = true;
                this.label2.Location = new System.Drawing.Point(6, 74);
                this.label2.Name = "label2";
                this.label2.Size = new System.Drawing.Size(81, 13);
                this.label2.TabIndex = 4;
                this.label2.Text = "Database User:";
                // 
                // label1
                // 
                this.label1.AutoSize = true;
                this.label1.Location = new System.Drawing.Point(6, 48);
                this.label1.Name = "label1";
                this.label1.Size = new System.Drawing.Size(87, 13);
                this.label1.TabIndex = 2;
                this.label1.Text = "Database Name:";
                // 
                // zipServerLabel
                // 
                this.zipServerLabel.AutoSize = true;
                this.zipServerLabel.Location = new System.Drawing.Point(6, 22);
                this.zipServerLabel.Name = "zipServerLabel";
                this.zipServerLabel.Size = new System.Drawing.Size(90, 13);
                this.zipServerLabel.TabIndex = 0;
                this.zipServerLabel.Text = "Database Server:";


                // 
                // DBPassword
                // 
                this.DBPassword.Location = new System.Drawing.Point(139, 97);
                this.DBPassword.Name = "DBPassword";
                this.DBPassword.PasswordChar = '*';
                this.DBPassword.Size = new System.Drawing.Size(156, 20);
                this.DBPassword.TabIndex = 7;
                // 
                // DBUser
                // 
                this.DBUser.Location = new System.Drawing.Point(139, 71);
                this.DBUser.Name = "DBUser";
                this.DBUser.Size = new System.Drawing.Size(156, 20);
                this.DBUser.TabIndex = 5;
                // 
                // zipDb
                // 
                this.zipDb.Location = new System.Drawing.Point(139, 45);
                this.zipDb.Name = "zipDb";
                this.zipDb.Size = new System.Drawing.Size(156, 20);
                this.zipDb.TabIndex = 3;


                // 
                // DBServerName
                // 
                this.DBServerName.Location = new System.Drawing.Point(139, 19);
                this.DBServerName.Name = "DBServerName";
                this.DBServerName.Size = new System.Drawing.Size(156, 20);
                this.DBServerName.TabIndex = 1;
                // 
                // tabPage1
                // 
                this.tabPage1.Controls.Add(this.lblIP);
                this.tabPage1.Controls.Add(this.lblErrorMsg);
                this.tabPage1.Controls.Add(this.lblErrorID);
                this.tabPage1.Controls.Add(this.lblStatus);
                this.tabPage1.Controls.Add(this.lblClearingHouse);
                this.tabPage1.Controls.Add(this.lblResponseQual);
                this.tabPage1.Controls.Add(this.lblResponseTime);
                this.tabPage1.Controls.Add(this.lblRequestQual);
                this.tabPage1.Controls.Add(this.lblRequestTime);
                this.tabPage1.Controls.Add(this.btnBack);
                this.tabPage1.Controls.Add(this.btnSelect);
                this.tabPage1.Controls.Add(this.logDatePicker);
                this.tabPage1.Controls.Add(this.dataGridView1);
                this.tabPage1.Controls.Add(this.webBrowser271);
                this.tabPage1.Controls.Add(this.webBrowser270);
                this.tabPage1.Location = new System.Drawing.Point(4, 22);
                this.tabPage1.Name = "tabPage1";
                this.tabPage1.Size = new System.Drawing.Size(749, 373);
                this.tabPage1.TabIndex = 2;
                this.tabPage1.Text = "View Files";
                this.tabPage1.UseVisualStyleBackColor = true;
                // 
                // lblIP
                // 
                this.lblIP.AutoSize = true;
                this.lblIP.Location = new System.Drawing.Point(408, 348);
                this.lblIP.Name = "lblIP";
                this.lblIP.Size = new System.Drawing.Size(71, 13);
                this.lblIP.TabIndex = 14;
                this.lblIP.Text = "Response IP:";
                this.lblIP.Visible = false;
                // 
                // lblErrorMsg
                // 
                this.lblErrorMsg.AutoSize = true;
                this.lblErrorMsg.Location = new System.Drawing.Point(408, 334);
                this.lblErrorMsg.Name = "lblErrorMsg";
                this.lblErrorMsg.Size = new System.Drawing.Size(35, 13);
                this.lblErrorMsg.TabIndex = 13;
                this.lblErrorMsg.Text = "Error: ";
                this.lblErrorMsg.Visible = false;
                // 
                // lblErrorID
                // 
                this.lblErrorID.AutoSize = true;
                this.lblErrorID.Location = new System.Drawing.Point(408, 318);
                this.lblErrorID.Name = "lblErrorID";
                this.lblErrorID.Size = new System.Drawing.Size(46, 13);
                this.lblErrorID.TabIndex = 12;
                this.lblErrorID.Text = "Error ID:";
                this.lblErrorID.Visible = false;
                // 
                // lblStatus
                // 
                this.lblStatus.AutoSize = true;
                this.lblStatus.Location = new System.Drawing.Point(209, 348);
                this.lblStatus.Name = "lblStatus";
                this.lblStatus.Size = new System.Drawing.Size(43, 13);
                this.lblStatus.TabIndex = 11;
                this.lblStatus.Text = "Status: ";
                this.lblStatus.Visible = false;
                // 
                // lblClearingHouse
                // 
                this.lblClearingHouse.AutoSize = true;
                this.lblClearingHouse.Location = new System.Drawing.Point(12, 348);
                this.lblClearingHouse.Name = "lblClearingHouse";
                this.lblClearingHouse.Size = new System.Drawing.Size(85, 13);
                this.lblClearingHouse.TabIndex = 10;
                this.lblClearingHouse.Text = "Clearing House: ";
                this.lblClearingHouse.Visible = false;
                // 
                // lblResponseQual
                // 
                this.lblResponseQual.AutoSize = true;
                this.lblResponseQual.Location = new System.Drawing.Point(209, 334);
                this.lblResponseQual.Name = "lblResponseQual";
                this.lblResponseQual.Size = new System.Drawing.Size(102, 13);
                this.lblResponseQual.TabIndex = 9;
                this.lblResponseQual.Text = "Response Qualifier: ";
                this.lblResponseQual.Visible = false;
                // 
                // lblResponseTime
                // 
                this.lblResponseTime.AutoSize = true;
                this.lblResponseTime.Location = new System.Drawing.Point(209, 318);
                this.lblResponseTime.Name = "lblResponseTime";
                this.lblResponseTime.Size = new System.Drawing.Size(87, 13);
                this.lblResponseTime.TabIndex = 8;
                this.lblResponseTime.Text = "Response Time: ";
                this.lblResponseTime.Visible = false;
                // 
                // lblRequestQual
                // 
                this.lblRequestQual.AutoSize = true;
                this.lblRequestQual.Location = new System.Drawing.Point(12, 334);
                this.lblRequestQual.Name = "lblRequestQual";
                this.lblRequestQual.Size = new System.Drawing.Size(94, 13);
                this.lblRequestQual.TabIndex = 7;
                this.lblRequestQual.Text = "Request Qualifier: ";
                this.lblRequestQual.Visible = false;
                // 
                // lblRequestTime
                // 
                this.lblRequestTime.AutoSize = true;
                this.lblRequestTime.Location = new System.Drawing.Point(12, 318);
                this.lblRequestTime.Name = "lblRequestTime";
                this.lblRequestTime.Size = new System.Drawing.Size(76, 13);
                this.lblRequestTime.TabIndex = 6;
                this.lblRequestTime.Text = "Request Time:";
                this.lblRequestTime.Visible = false;
                // 
                // btnBack
                // 
                this.btnBack.Location = new System.Drawing.Point(555, 338);
                this.btnBack.Name = "btnBack";
                this.btnBack.Size = new System.Drawing.Size(75, 23);
                this.btnBack.TabIndex = 5;
                this.btnBack.Text = "Back";
                this.btnBack.UseVisualStyleBackColor = true;
                this.btnBack.Visible = false;
                this.btnBack.Click += new System.EventHandler(this.btnBack_Click);
                // 
                // btnSelect
                // 
                this.btnSelect.Location = new System.Drawing.Point(13, 283);
                this.btnSelect.Name = "btnSelect";
                this.btnSelect.Size = new System.Drawing.Size(75, 23);
                this.btnSelect.TabIndex = 2;
                this.btnSelect.Text = "Select";
                this.btnSelect.UseVisualStyleBackColor = true;
                this.btnSelect.Click += new System.EventHandler(this.btnSelect_Click);
                // 
                // logDatePicker
                // 
                this.logDatePicker.Location = new System.Drawing.Point(4, 8);
                this.logDatePicker.Name = "logDatePicker";
                this.logDatePicker.Size = new System.Drawing.Size(200, 20);
                this.logDatePicker.TabIndex = 1;
                this.logDatePicker.ValueChanged += new System.EventHandler(this.logDatePicker_ValueChanged);
                // 
                // dataGridView1
                // 
                this.dataGridView1.AllowUserToAddRows = false;
                this.dataGridView1.AllowUserToDeleteRows = false;
                this.dataGridView1.ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode.AutoSize;
                this.dataGridView1.Location = new System.Drawing.Point(4, 34);
                this.dataGridView1.MultiSelect = false;
                this.dataGridView1.Name = "dataGridView1";
                this.dataGridView1.ReadOnly = true;
                this.dataGridView1.RowHeadersVisible = false;
                this.dataGridView1.SelectionMode = System.Windows.Forms.DataGridViewSelectionMode.FullRowSelect;
                this.dataGridView1.ShowEditingIcon = false;
                this.dataGridView1.Size = new System.Drawing.Size(725, 243);
                this.dataGridView1.TabIndex = 0;
                // 
                // webBrowser271
                // 
                this.webBrowser271.Location = new System.Drawing.Point(3, 163);
                this.webBrowser271.MinimumSize = new System.Drawing.Size(20, 20);
                this.webBrowser271.Name = "webBrowser271";
                this.webBrowser271.Size = new System.Drawing.Size(742, 149);
                this.webBrowser271.TabIndex = 4;
                // 
                // webBrowser270
                // 
                this.webBrowser270.Location = new System.Drawing.Point(4, 8);
                this.webBrowser270.MinimumSize = new System.Drawing.Size(20, 20);
                this.webBrowser270.Name = "webBrowser270";
                this.webBrowser270.Size = new System.Drawing.Size(742, 149);
                this.webBrowser270.TabIndex = 3;
                // 
                // label13
                // 
                this.label13.AutoSize = true;
                this.label13.Font = new System.Drawing.Font("Microsoft Sans Serif", 20.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                this.label13.ForeColor = System.Drawing.SystemColors.ActiveCaption;
                this.label13.Location = new System.Drawing.Point(350, 32);
                this.label13.Name = "label13";
                this.label13.Size = new System.Drawing.Size(213, 93);
                this.label13.TabIndex = 4;
                this.label13.Text = "VistA Fee 5010\r\n  AET Service\r\n Configuration";
                // 
                // label14
                // 
                this.label14.AutoSize = true;
                this.label14.Location = new System.Drawing.Point(17, 28);
                this.label14.Name = "label14";
                this.label14.Size = new System.Drawing.Size(79, 13);
                this.label14.TabIndex = 14;
                this.label14.Text = "IdS (MVI) URL:";
                // 
                // label15
                // 
                this.label15.AutoSize = true;
                this.label15.Location = new System.Drawing.Point(6, 23);
                this.label15.Name = "label15";
                this.label15.Size = new System.Drawing.Size(124, 13);
                this.label15.TabIndex = 15;
                this.label15.Text = "VAAFI PKI Certificate ID:";
                // 
                // label16
                // 
                this.label16.AutoSize = true;
                this.label16.Location = new System.Drawing.Point(17, 58);
                this.label16.Name = "label16";
                this.label16.Size = new System.Drawing.Size(49, 13);
                this.label16.TabIndex = 16;
                this.label16.Text = "ES URL:";
                // 
                // label17
                // 
                this.label17.AutoSize = true;
                this.label17.Location = new System.Drawing.Point(6, 51);
                this.label17.Name = "label17";
                this.label17.Size = new System.Drawing.Size(106, 13);
                this.label17.TabIndex = 17;
                this.label17.Text = "ES Service Account:";
                // 
                // label18
                // 
                this.label18.AutoSize = true;
                this.label18.Location = new System.Drawing.Point(6, 78);
                this.label18.Name = "label18";
                this.label18.Size = new System.Drawing.Size(73, 13);
                this.label18.TabIndex = 18;
                this.label18.Text = "ES Password:";
                // 
                // label19
                // 
                //this.label19.AutoSize = true;
                //this.label19.Location = new System.Drawing.Point(6, 74);
                //this.label19.Name = "label19";
                //this.label19.Size = new System.Drawing.Size(111, 13);
                //this.label19.TabIndex = 12;
                //this.label19.Text = "SSL Certificate Name:";
                // 
                // label20
                // 
                //this.label20.AutoSize = true;
                //this.label20.Location = new System.Drawing.Point(6, 100);
                //this.label20.Name = "label20";
                //this.label20.Size = new System.Drawing.Size(70, 13);
                //this.label20.TabIndex = 13;
                //this.label20.Text = "IP White List:";
                // 
                // sslCertName
                // 
                //this.sslCertName.Location = new System.Drawing.Point(139, 71);
                //this.sslCertName.Name = "sslCertName";
                //this.sslCertName.Size = new System.Drawing.Size(156, 20);
                //this.sslCertName.TabIndex = 14;
                // 
                // whiteIP
                // 
                //this.whiteIP.Location = new System.Drawing.Point(139, 97);
                //this.whiteIP.Name = "whiteIP";
                //this.whiteIP.Size = new System.Drawing.Size(156, 20);
                //this.whiteIP.TabIndex = 15;
                // 
                // groupBox2
                // 
                this.groupBox2.Controls.Add(this.esURL);
                this.groupBox2.Controls.Add(this.mviURL);
                this.groupBox2.Controls.Add(this.label14);
                this.groupBox2.Controls.Add(this.label16);
                this.groupBox2.Location = new System.Drawing.Point(9, 281);
                this.groupBox2.Name = "groupBox2";
                this.groupBox2.Size = new System.Drawing.Size(358, 86);
                this.groupBox2.TabIndex = 19;
                this.groupBox2.TabStop = false;
                this.groupBox2.Text = "Web Service URL\'s";
                // 
                // groupBox3
                // 
                this.groupBox3.Controls.Add(this.esPW);
                this.groupBox3.Controls.Add(this.esSA);
                this.groupBox3.Controls.Add(this.pkiCert);
                this.groupBox3.Controls.Add(this.label15);
                this.groupBox3.Controls.Add(this.label18);
                this.groupBox3.Controls.Add(this.label17);
                this.groupBox3.Location = new System.Drawing.Point(373, 280);
                this.groupBox3.Name = "groupBox3";
                this.groupBox3.Size = new System.Drawing.Size(248, 112);
                this.groupBox3.TabIndex = 20;
                this.groupBox3.TabStop = false;
                this.groupBox3.Text = "Web Service Authentication";
                // 
                // mviURL
                // 
                this.mviURL.Location = new System.Drawing.Point(113, 20);
                this.mviURL.Name = "mviURL";
                this.mviURL.Size = new System.Drawing.Size(239, 20);
                this.mviURL.TabIndex = 17;
                // 
                // esURL
                // 
                this.esURL.Location = new System.Drawing.Point(113, 55);
                this.esURL.Name = "esURL";
                this.esURL.Size = new System.Drawing.Size(239, 20);
                this.esURL.TabIndex = 18;
                // 
                // pkiCert
                // 
                this.pkiCert.Location = new System.Drawing.Point(127, 20);
                this.pkiCert.Name = "pkiCert";
                this.pkiCert.Size = new System.Drawing.Size(115, 20);
                this.pkiCert.TabIndex = 19;
                // 
                // esSA
                // 
                this.esSA.Location = new System.Drawing.Point(127, 48);
                this.esSA.Name = "esSA";
                this.esSA.Size = new System.Drawing.Size(115, 20);
                this.esSA.TabIndex = 20;
                // 
                // esPW
                // 
                this.esPW.Location = new System.Drawing.Point(127, 76);
                this.esPW.Name = "esPW";
                this.esPW.Size = new System.Drawing.Size(115, 20);
                this.esPW.TabIndex = 21;
                this.esPW.TextChanged += new System.EventHandler(this.textBox6_TextChanged);
                // 
                // AETControl
                // 
                this.Controls.Add(this.tabControl1);
                this.Name = "AETControl";
                this.Size = new System.Drawing.Size(778, 445);
                this.controlGroup.ResumeLayout(false);
                this.controlGroup.PerformLayout();
                this.performanceGroup.ResumeLayout(false);
                this.performanceGroup.PerformLayout();
                this.tabControl1.ResumeLayout(false);
                this.controlTab.ResumeLayout(false);
                this.tabEligibilityConfiguration.ResumeLayout(false);
                this.tabEligibilityConfiguration.PerformLayout();
                //this.generalGroup.ResumeLayout(false);
                //this.generalGroup.PerformLayout();
                this.DBNames.ResumeLayout(false);
                this.DBNames.PerformLayout();

                this.dbGroup.ResumeLayout(false);
                this.dbGroup.PerformLayout();
                this.tabPage1.ResumeLayout(false);
                this.tabPage1.PerformLayout();
                ((System.ComponentModel.ISupportInitialize)(this.dataGridView1)).EndInit();
                this.groupBox2.ResumeLayout(false);
                this.groupBox2.PerformLayout();
                this.groupBox3.ResumeLayout(false);
                this.groupBox3.PerformLayout();
                this.ResumeLayout(false);
            }
            catch
            {
                Invoke(new StringCallback(showMessage), new object[] { "Cannot stop AET Service" });
                buttonsEnabled = true;
                return;
            }
            Thread.Sleep(1000); // sc.Stop() returns too soon, give it time to actually stop
            try
            {
                ((ServiceController)sc).Start();
                savedSettingsLabel2.Text = "";
            }
            catch
            {
                Invoke(new StringCallback(showMessage), new object[] { "Cannot restart AET Service" });
            }
            buttonsEnabled = true;
        }
        private void showMessage(string s) { MessageBox.Show(s); }
        private void updateControlStatus()
        {

            switch (sc.Status)
            {
                case ServiceControllerStatus.Running:
                    statusLabel.Text = "AET Service is Running";
                    startButton.Enabled = false;
                    stopButton.Enabled = true;
                    break;
                case ServiceControllerStatus.Stopped:
                    statusLabel.Text = "AET Service is Stopped";
                    startButton.Enabled = true;
                    stopButton.Enabled = false;
                    break;
                case ServiceControllerStatus.Paused:
                    statusLabel.Text = "AET Service is Paused";
                    startButton.Enabled = true;
                    stopButton.Enabled = true;
                    break;
                case ServiceControllerStatus.StopPending:
                    statusLabel.Text = "AET Service is pending stop";
                    startButton.Enabled = false;
                    stopButton.Enabled = false;
                    break;
                case ServiceControllerStatus.StartPending:
                    statusLabel.Text = "AET Service is pending start";
                    startButton.Enabled = false;
                    stopButton.Enabled = false;
                    break;
                case ServiceControllerStatus.ContinuePending:
                    statusLabel.Text = "AET Service is pending continue";
                    startButton.Enabled = false;
                    stopButton.Enabled = false;
                    break;
                default:
                    statusLabel.Text = "AET Service status unknown";
                    startButton.Enabled = true;
                    stopButton.Enabled = true;
                    break;
            }
            restartButton.Enabled = false; // stopButton.Enabled;
            if (!buttonsEnabled)
            {
                startButton.Enabled = false;
                stopButton.Enabled = false;
                restartButton.Enabled = false;
            }
            controlGroup.Refresh();
        }
        private void updateControlLoop()
        {
            ServiceControllerStatus? prevStatus = null;
            while (true)
            {
                try
                {
                    Invoke(new SCCCallback(updateControl), new object[] { prevStatus });
                }
                catch { } // errors on window just opened/closed and controls are not ready
                Thread.Sleep(100);
            }
        }
        private void updateControl(ServiceControllerStatus? prevStatus)
        {
            sc.Refresh();
            if (sc.Status != prevStatus)
            {
                try
                {
                    this.updateControlStatus();
                }
                catch { } // errors on window just opened/closed and controls are not ready
                prevStatus = sc.Status;
            }
        }
        private void updatePerformanceLoop()
        {
            while (true)
            {
                try
                {
                    Invoke(new VoidCallback(updatePerformance));
                }
                catch { } // errors on window just opened/closed and controls are not ready
                Thread.Sleep(100);
            }
        }
        private void updatePerformance()
        {
            physicalMemUsage.Value = physicalMemUsage.Maximum - (int)(ci.AvailablePhysicalMemory / 1048576);
            virtualMemUsage.Value = virtualMemUsage.Maximum - (int)(ci.AvailableVirtualMemory / 1048576);
            cpuSamples.RemoveAt(0);
            cpuSamples.Add(cpuCounter.NextValue());
            cpuUsage.Value = Average(cpuSamples);
            int cpuPercent = (int)(((double)cpuUsage.Value / (double)cpuUsage.Maximum) * 100);
            Font progressFont = new Font("Arial", 10, FontStyle.Regular);
            string cpuText = cpuPercent + "%";
            string physicalMemText = string.Format("{0}/{1} MB", physicalMemUsage.Value, physicalMemUsage.Maximum);
            string virtualMemText = string.Format("{0}/{1} MB", virtualMemUsage.Value, virtualMemUsage.Maximum);
            SetProgressBarText(cpuUsage, Color.White, progressFont, cpuText);
            SetProgressBarText(physicalMemUsage, Color.White, progressFont, physicalMemText);
            SetProgressBarText(virtualMemUsage, Color.White, progressFont, virtualMemText);
        }
        private void SetProgressBarText(ProgressBar Target, Color TextColor, Font TextFont, string Text)
        {
            try
            {
                Target.Refresh();
                using (Graphics gr = Target.CreateGraphics())
                {
                    gr.DrawString(Text, TextFont, new SolidBrush(TextColor),
                        new PointF(Target.Width / 2 - (gr.MeasureString(Text, TextFont).Width / 2.0F),
                            Target.Height / 2 - (gr.MeasureString(Text,
                            TextFont).Height / 2.0F)));
                }
            }
            catch { } // errors on window just opened/closed and controls are not ready
        }

        private int Average(List<float> cpuSamples)
        {
            float total = 0;
            int count = 0;
            foreach (float f in cpuSamples)
            {
                count++;
                total += f;
            }
            return (count == 0) ? 0 : (int)(total / count);
        }

        private void saveButton_Click(object sender, EventArgs e)
        {

            //System.Windows.Forms.MessageBox.Show("Settings Saved");
            //return;
            try
            {
                RegistryKey system = Microsoft.Win32.Registry.LocalMachine.OpenSubKey("System");        //Open the HKEY_LOCAL_MACHINE\SYSTEM key
                RegistryKey currentControlSet = system.OpenSubKey("CurrentControlSet");                 //Open CurrentControlSet
                RegistryKey services = currentControlSet.OpenSubKey("Services");                        //Go to the services key
                RegistryKey aetService = services.OpenSubKey("AETService", true);                                //Open the AETService service, and allow writing
                RegistryKey aetParameters = aetService.OpenSubKey("Parameters", true);                                    //Create the Parameters key ETService, and allow writing

                try
                {
                    if (cbEnableDebug.Checked == true)
                    {
                        aetParameters.SetValue("SSLNameVC", "TRACE=YES;PAYLOAD=NO;WEBSERVICE=YES;PRECHECK=YES");
                    }
                    else
                    {
                        aetParameters.SetValue("SSLNameVC", "TRACE=NO;PAYLOAD=NO;WEBSERVICE=NO;PRECHECK=YES");
                    }
                }
                catch (Exception ex)
                {
                    using (System.IO.StreamWriter writer = new System.IO.StreamWriter(@"SnapIn.txt", true))
                    {
                        writer.WriteLine(ex.Message.ToString());
                        //writer.Close();
                    }
                }

                //ZEB VA118-11-D-1009 1/21/13 (+16) fix AET- and Ctl- port reversal, add actual saving of CtlPort
                try
                {
                    aetParameters.SetValue("AETPort", Crypto.AES.Encrypt(servicePort.Text));
                }
                catch
                {
                    aetParameters.SetValue("AETPort", servicePort.Text);
                }

                try
                {
                    aetParameters.SetValue("CtlPort", Crypto.AES.Encrypt(controlPort.Text));
                }
                catch
                {
                    aetParameters.SetValue("CtlPort", controlPort.Text);
                }

                aetParameters.SetValue("ZipServer", DBServerName.Text);
                aetParameters.SetValue("ZipDatabase", zipDb.Text);
                aetParameters.SetValue("ZipUser", DBUser.Text);
                aetParameters.SetValue("ZipPassword", DBPassword.Text);

                aetParameters.SetValue("LEIEServer", DBServerName.Text);
                aetParameters.SetValue("LEIEDatabase", leieDB.Text);
                aetParameters.SetValue("LEIEUser", DBUser.Text);
                aetParameters.SetValue("LEIEPassword", DBPassword.Text);

                aetParameters.SetValue("ANSIServer", DBServerName.Text);
                aetParameters.SetValue("ANSIDatabase", ansiDb.Text);
                aetParameters.SetValue("ANSIUser", DBUser.Text);
                aetParameters.SetValue("ANSIPassword", DBPassword.Text);

                aetParameters.SetValue("LogServer", DBServerName.Text);
                aetParameters.SetValue("LogDatabase", logDb.Text);
                aetParameters.SetValue("LogUser", DBUser.Text);
                aetParameters.SetValue("LogPassword", DBPassword.Text);

                aetParameters.SetValue("STCServer", STCServer.Text);  //ZEB VA118-11-D-1009 1/22/13 (+3) added Service Type Code database info
                aetParameters.SetValue("STCDatabase", STCDatabase.Text);
                aetParameters.SetValue("STCUser", STCUser.Text);
                aetParameters.SetValue("STCPassword", STCPassword.Text);

                /*try
                {
                    config.SetValue("ZipServer", Crypto.AES.Encrypt(DBServerName.Text));
                }
                catch
                {
                    config.SetValue("ZipServer", DBServerName.Text);
                }
                
                
                ////////////////////////
                try
                {
                    config.SetValue("ZipDatabase", Crypto.AES.Encrypt(zipDb.Text));
                }
                catch
                {
                    config.SetValue("ZipDatabase", zipDb.Text);
                }
                try
                {
                    config.SetValue("ZipUser", Crypto.AES.Encrypt(DBUser.Text));
                }
                catch
                {
                    config.SetValue("ZipUser", DBUser.Text);
                }
                
                try
                {
                    config.SetValue("ZipPassword", Crypto.AES.Encrypt( DBPassword.Text));
                }
                catch
                {
                    config.SetValue("ZipPassword", DBPassword.Text);
                }

                try
                {
                    config.SetValue("LEIEServer", Crypto.AES.Encrypt(DBServerName.Text));
                }
                catch
                {
                    config.SetValue("LEIEServer", DBServerName.Text);
                }


                ////////////////////////
                try
                {
                    config.SetValue("LEIEDatabase", Crypto.AES.Encrypt(leieDB.Text));
                }
                catch
                {
                    config.SetValue("LEIEDatabase", leieDB.Text);
                }
                try
                {
                    config.SetValue("LEIEUser", Crypto.AES.Encrypt(DBUser.Text));
                }
                catch
                {
                    config.SetValue("LEIEUser", DBUser.Text);
                }

                try
                {
                    config.SetValue("LEIEPassword", Crypto.AES.Encrypt(DBPassword.Text));
                }
                catch
                {
                    config.SetValue("LEIEPassword", DBPassword.Text);
                }
                               


                try
                {
                    config.SetValue("ANSIServer", Crypto.AES.Encrypt(DBServerName.Text));
                }
                catch
                {
                    config.SetValue("ANSIServer", DBServerName.Text);
                }
                try
                {
                    config.SetValue("ANSIDatabase", Crypto.AES.Encrypt( ansiDb.Text));
                }
                catch
                {
                    config.SetValue("ANSIDatabase", ansiDb.Text);
                }
                try
                {
                    config.SetValue("ANSIUser", Crypto.AES.Encrypt(DBUser.Text));
                }
                catch
                {
                    config.SetValue("ANSIUser", DBUser.Text);
                }
                try
                {
                    config.SetValue("ANSIPassword", Crypto.AES.Encrypt(DBPassword.Text));
                }
                catch
                {
                    config.SetValue("ANSIPassword", DBPassword.Text);
                }
                try
                {
                    config.SetValue("LogServer", Crypto.AES.Encrypt(DBServerName.Text));
                }
                catch
                {
                    config.SetValue("LogServer", DBServerName.Text);
                }
                try
                {
                    config.SetValue("LogDatabase", Crypto.AES.Encrypt( logDb.Text));
                }
                catch
                {
                    config.SetValue("LogDatabase", logDb.Text);
                }
                try
                {
                    config.SetValue("LogUser", Crypto.AES.Encrypt(DBUser.Text));
                }
                catch
                {
                    config.SetValue("LogUser", DBUser.Text);
                }
                try
                {
                    config.SetValue("LogPassword", Crypto.AES.Encrypt(DBPassword.Text));
                }
                catch
                {
                    config.SetValue("LogPassword", DBPassword.Text);
                }
                */
                try
                {
                    aetParameters.SetValue("MVIURL", Crypto.AES.Encrypt(mviURL.Text));
                }
                catch
                {
                    aetParameters.SetValue("MVIURL", mviURL.Text);
                }

                try
                {
                    aetParameters.SetValue("MVIPKI", Crypto.AES.Encrypt(pkiCert.Text));
                }
                catch
                {
                    aetParameters.SetValue("MVIPKI", pkiCert.Text);
                }

                try
                {
                    aetParameters.SetValue("ESURL", Crypto.AES.Encrypt(esURL.Text));
                }
                catch
                {
                    aetParameters.SetValue("ESURL", esURL.Text);
                }

                try
                {
                    aetParameters.SetValue("ESUN", Crypto.AES.Encrypt(esSA.Text));
                }
                catch
                {
                    aetParameters.SetValue("ESUN", esSA.Text);
                }

                try
                {
                    aetParameters.SetValue("ESPW", Crypto.AES.Encrypt(esPW.Text));
                }
                catch
                {
                    aetParameters.SetValue("ESPW", esPW.Text);
                }

                try
                {
                    aetParameters.SetValue("ESPW", Crypto.AES.Encrypt(esPW.Text));
                }
                catch
                {
                    aetParameters.SetValue("ESPW", esPW.Text);
                }

                try
                {
                    aetParameters.SetValue("SSLName", Crypto.AES.Encrypt(sslCertName.Text));
                }
                catch
                {
                    aetParameters.SetValue("SSLName", sslCertName.Text);
                }
                try
                {
                    aetParameters.SetValue("IPWL", Crypto.AES.Encrypt(whiteIP.Text));
                }
                catch
                {
                    aetParameters.SetValue("IPWL", whiteIP.Text);
                }

                aetParameters.SetValue("EnableLogging", chkEnableLogging.Checked.ToString());
                aetParameters.SetValue("LogZeroLength", chkLogZeroLength.Checked.ToString());
                aetParameters.SetValue("LoggingDirectory", txtLoggingDirectory.Text);
                aetParameters.SetValue("AatServer", Crypto.AES.Encrypt(txtAatServer.Text));
                aetParameters.SetValue("AatDatabase", Crypto.AES.Encrypt(txtAatDatabase.Text));
                aetParameters.SetValue("AatDatabaseUsername", Crypto.AES.Encrypt(txtAatDatabaseUsername.Text));
                aetParameters.SetValue("AatDatabasePassword", Crypto.AES.Encrypt(txtAatDatabasePassword.Text));
                aetParameters.SetValue("CdwServer", Crypto.AES.Encrypt(txtCdwServer.Text));
                aetParameters.SetValue("CdwDatabase", Crypto.AES.Encrypt(txtCdwDatabase.Text));

                if (sc.Status != ServiceControllerStatus.Stopped)
                {
                    MessageBox.Show("Settings saved.  Please restart the AET Service for new settings to take effect.");
                }
                else
                {
                    MessageBox.Show("Settings saved.");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Settings could not be saved - " + ex.ToString());
            }
        }

        private void ReadRegistry()
        {
            RegistryKey system = Microsoft.Win32.Registry.LocalMachine.OpenSubKey("System");        //Open the HKEY_LOCAL_MACHINE\SYSTEM key
            RegistryKey currentControlSet = system.OpenSubKey("CurrentControlSet");                 //Open CurrentControlSet
            RegistryKey services = currentControlSet.OpenSubKey("Services");                        //Go to the services key
            RegistryKey aetService = services.OpenSubKey("AETService");                                //Open the AETService service
            RegistryKey aetParameters = aetService.OpenSubKey("Parameters");                                  //Open the Parameters key

            string ZipImportFolder = string.Empty;
            string LEIEImportFolder = string.Empty;
			string NPIImportFolder = string.Empty;
			string sDebugData = string.Empty;

            //using (System.IO.StreamWriter log = new StreamWriter(@"snapIn.log"))
            //{
            //log.WriteLine("SnapIn Started:" + System.DateTime.Now.ToString());


            //ZEB VA118-11-D-1009 1/22/13 (+16) fix AETPort/CtlPort reversal
            try
            {
                controlPort.Text = Crypto.AES.Decrypt(aetParameters.GetValue("CtlPort").ToString());
            }
            catch
            {
                controlPort.Text = aetParameters.GetValue("CtlPort").ToString();
            }
            try
            {
                servicePort.Text = Crypto.AES.Decrypt(aetParameters.GetValue("AETPort").ToString());
            }
            catch
            {
                servicePort.Text = aetParameters.GetValue("AETPort").ToString();
            }


            //////////////////////////////////////////////
            // Load the database credentials
            // Map the ZipCode credentials to all credentials

            try
            {
                DBServerName.Text = Crypto.AES.Decrypt(aetParameters.GetValue("ZipServer").ToString());
                ZServer.Text = DBServerName.Text;
                LEIEServer.Text = DBServerName.Text;
            }
            catch
            {
                DBServerName.Text = aetParameters.GetValue("ZipServer").ToString();
                ZServer.Text = DBServerName.Text;
                LEIEServer.Text = DBServerName.Text;
            }
            try
            {
                zipDb.Text = Crypto.AES.Decrypt(aetParameters.GetValue("ZipDatabase").ToString());
                ZDatabase.Text = zipDb.Text;
                LEIEDatabase.Text = "VALEIE";
                leieDB.Text = "VALEIE";
            }
            catch
            {
                zipDb.Text = aetParameters.GetValue("ZipDatabase").ToString();
                ZDatabase.Text = zipDb.Text;
                LEIEDatabase.Text = "VALEIE";
                leieDB.Text = "VALEIE";
            }
            try
            {
                DBUser.Text = Crypto.AES.Decrypt(aetParameters.GetValue("ZipUser").ToString());
                ZUser.Text = DBUser.Text;
                LEIEUser.Text = DBUser.Text;
            }
            catch
            {
                DBUser.Text = aetParameters.GetValue("ZipUser").ToString();
                ZUser.Text = DBUser.Text;
                LEIEUser.Text = DBUser.Text;
            }
            try
            {
                ansiDb.Text = Crypto.AES.Decrypt(aetParameters.GetValue("ANSIDatabase").ToString());
            }
            catch
            {
                ansiDb.Text = aetParameters.GetValue("ANSIDatabase").ToString();
            }
            try
            {
                logDb.Text = Crypto.AES.Decrypt(aetParameters.GetValue("LogDatabase").ToString());
            }
            catch
            {
                logDb.Text = aetParameters.GetValue("LogDatabase").ToString();
            }

            //ZEB VA118-11-D-1009 1/22/13 (+32) save new Service Type Code database info
            try
            {
                STCServer.Text = Crypto.AES.Decrypt(aetParameters.GetValue("STCServer").ToString());
            }
            catch
            {
                STCServer.Text = aetParameters.GetValue("STCServer").ToString();
            }
            try
            {
                STCDatabase.Text = Crypto.AES.Decrypt(aetParameters.GetValue("STCDatabase").ToString());
            }
            catch
            {
                STCDatabase.Text = aetParameters.GetValue("STCDatabase").ToString();
            }
            try
            {
                STCUser.Text = Crypto.AES.Decrypt(aetParameters.GetValue("STCUser").ToString());
            }
            catch
            {
                STCUser.Text = aetParameters.GetValue("STCUser").ToString();
            }
            try
            {
                STCPassword.Text = Crypto.AES.Decrypt(aetParameters.GetValue("STCPassword").ToString());
            }
            catch
            {
                STCPassword.Text = aetParameters.GetValue("STCPassword").ToString();
            }

            DBPassword.Text = aetParameters.GetValue("ZipPassword").ToString();
            ZPw.Text = DBPassword.Text;
            LEIEPw.Text = DBPassword.Text;



            ////////////////////////////////////////////////////////////////////////
            // ZipCode Import Folder & Extention.
            try
            {
                ZipImportFolder = Crypto.AES.Decrypt(aetParameters.GetValue("ZipImportFolder").ToString());
            }
            catch
            {
                ZipImportFolder = aetParameters.GetValue("ZipImportFolder").ToString();
            }
            if (ZipImportFolder.Length > 0)
            {
                string[] zipInfo = ZipImportFolder.Split(';');
                ZipCodeWatchFolder.Text = zipInfo[0];
                if (zipInfo.Count() == 2)
                    ZipCodeExt.Text = zipInfo[1];
            }
            ////////////////////////////////////////////////////////////////////////
            // LEIE Import Folder  & Extention.
            try
            {
                LEIEImportFolder = Crypto.AES.Decrypt(aetParameters.GetValue("LEIEImportFolder").ToString());
            }
            catch
            {
                LEIEImportFolder = aetParameters.GetValue("LEIEImportFolder").ToString();
            }
            if (LEIEImportFolder.Length > 0)
            {

                string[] leieInfo = LEIEImportFolder.Split(';');
                LEIEWatchFolder.Text = leieInfo[0];
                if (leieInfo.Count() == 2)
                    LEIEExt.Text = leieInfo[1];
            }

			////////////////////////////////////////////////////////////////////////
			// NPI Import Folder  & Extention.
			try
			{
				NPIImportFolder = Crypto.AES.Decrypt(aetParameters.GetValue("NPIImportFolder").ToString());
			}
			catch
			{
				NPIImportFolder = aetParameters.GetValue("NPIImportFolder").ToString();
			}
			if (NPIImportFolder.Length > 0)
			{
				string[] npiInfo = NPIImportFolder.Split(';');
				NPIWatchFolder.Text = npiInfo[0];
				if (npiInfo.Count() == 2)
					NPIExt.Text = npiInfo[1];
			}



			////////////////////////////////////////////////////////////////////////
			// Degug string
			try
            {
                sDebugData = Crypto.AES.Decrypt(aetParameters.GetValue("SSLNameVC").ToString());
            }
            catch
            {
                sDebugData = aetParameters.GetValue("SSLNameVC").ToString();
            }
            cbEnableDebug.Checked = (sDebugData.Contains("TRACE=NO")) ? false : true;

            //log.WriteLine("All config items loaded.");

            //l/og.Close();
            //}


            /*try
            {
                DBPassword.Text = Crypto.AES.Decrypt( config.GetValue("ZipPassword").ToString());
                ZPw.Text = DBPassword.Text;
                LEIEPw.Text = DBPassword.Text;
            }
            catch
            {
                DBPassword.Text = config.GetValue("ZipPassword").ToString();
                ZPw.Text = DBPassword.Text;
                LEIEPw.Text = DBPassword.Text;
            }*/


            try
            {
                mviURL.Text = Crypto.AES.Decrypt(aetParameters.GetValue("MVIURL").ToString());
            }
            catch
            {
                mviURL.Text = aetParameters.GetValue("MVIURL").ToString();
            }

            try
            {
                pkiCert.Text = Crypto.AES.Decrypt(aetParameters.GetValue("MVIPKI").ToString());
            }
            catch
            {
                pkiCert.Text = aetParameters.GetValue("MVIPKI").ToString();
            }

            try
            {
                esURL.Text = Crypto.AES.Decrypt(aetParameters.GetValue("ESURL").ToString());
            }
            catch
            {
                esURL.Text = aetParameters.GetValue("ESURL").ToString();
            }

            try
            {
                esSA.Text = Crypto.AES.Decrypt(aetParameters.GetValue("ESUN").ToString());
            }
            catch
            {
                esSA.Text = aetParameters.GetValue("ESUN").ToString();
            }

            try
            {
                esPW.Text = Crypto.AES.Decrypt(aetParameters.GetValue("ESPW").ToString());
            }
            catch
            {
                esPW.Text = aetParameters.GetValue("ESPW").ToString();
            }

            try
            {
                sslCertName.Text = Crypto.AES.Decrypt(aetParameters.GetValue("SSLName").ToString());
            }
            catch
            {
                sslCertName.Text = aetParameters.GetValue("SSLName").ToString();
            }

            try
            {
                whiteIP.Text = Crypto.AES.Decrypt(aetParameters.GetValue("IPWL").ToString());
            }
            catch
            {
                whiteIP.Text = aetParameters.GetValue("IPWL").ToString();
            }

            bool tempBool;
            if (bool.TryParse(aetParameters.GetValue("EnableLogging").ToString(), out tempBool))
                chkEnableLogging.Checked = tempBool;
            else
                chkEnableLogging.Checked = false;
            if (bool.TryParse(aetParameters.GetValue("LogZeroLength").ToString(), out tempBool))
                chkLogZeroLength.Checked = tempBool;
            else
                chkLogZeroLength.Checked = false;
            //aetParameters.SetValue("LoggingDirectory", txtLoggingDirectory.Text);
            //aetParameters.SetValue("AatServer", Crypto.AES.Encrypt(txtAatServer.Text));
            //aetParameters.SetValue("AatDatabase", Crypto.AES.Encrypt(txtAatDatabase.Text));
            //aetParameters.SetValue("AatDatabaseUsername", Crypto.AES.Encrypt(txtAatDatabaseUsername.Text));
            //aetParameters.SetValue("AatDatabasePassword", Crypto.AES.Encrypt(txtAatDatabasePassword.Text));

            txtLoggingDirectory.Text = aetParameters.GetValue("LoggingDirectory").ToString();
            try
            {
                txtAatServer.Text = Crypto.AES.Decrypt(aetParameters.GetValue("AatServer").ToString());
            }
            catch (Exception)
            {
                txtAatServer.Text = aetParameters.GetValue("AatServer").ToString();
            }
            try
            {
                txtAatDatabase.Text = Crypto.AES.Decrypt(aetParameters.GetValue("AatDatabase").ToString());
            }
            catch (Exception)
            {
                txtAatDatabase.Text = aetParameters.GetValue("AatDatabase").ToString();
            }
            try
            {
                txtAatDatabaseUsername.Text = Crypto.AES.Decrypt(aetParameters.GetValue("AatDatabaseUsername").ToString());
            }
            catch (Exception)
            {
                txtAatDatabaseUsername.Text = aetParameters.GetValue("AatDatabaseUsername").ToString();
            }
            try
            {
                txtAatDatabasePassword.Text = Crypto.AES.Decrypt(aetParameters.GetValue("AatDatabasePassword").ToString());
            }
            catch (Exception)
            {
                txtAatDatabasePassword.Text = aetParameters.GetValue("AatDatabasePassword").ToString();
            }
            try
            {
                txtCdwServer.Text = Crypto.AES.Decrypt(aetParameters.GetValue("CdwServer").ToString());
            }
            catch (Exception)
            {
                txtCdwServer.Text = aetParameters.GetValue("CdwServer").ToString();
            }
            try
            {
                txtCdwDatabase.Text = Crypto.AES.Decrypt(aetParameters.GetValue("CdwDatabase").ToString());
            }
            catch (Exception)
            {
                txtCdwDatabase.Text = aetParameters.GetValue("CdwDatabase").ToString();
            }

            string sUpd;

            sUpd = aetParameters.GetValue("ImportUpdate").ToString();
            //////////////////////////////////////////////////////////////////////////////////
            string[] UpText = sUpd.Split(';');
            if (UpText.Count() == 2)
            {
                if (UpText[0].Contains("Zip="))
                    txtZipUpdate.Text = UpText[0].Replace("Zip=", "");
                if (UpText[1].Contains("LEIE="))
                    txtLEIEUpdate.Text = UpText[1].Replace("LEIE=", "");

                //System.IO.StreamWriter writer = new System.IO.StreamWriter(@"C:\LogFile.txt", false);
                //writer.WriteLine(txtZipUpdate.Text);
                //writer.WriteLine("----------------");
                //writer.WriteLine(txtLEIEUpdate.Text);
                //writer.WriteLine("================");

                //writer.Close();

                //else if (UpText[1].Contains("Zip="))
                //txtZipUpdate.Text = UpText[1].Replace("Zip=", "");
                //else if (UpText[0].Contains("LEIE="))
                //txtLEIEUpdate.Text = UpText[0].Replace("LEIE=", "");
            }
            if (UpText.Count() == 1)
            {
            }
        }
        //THREAD SAFE CALLS
        delegate void VoidCallback();
        delegate void StringCallback(string s);
        delegate void SCCCallback(ServiceControllerStatus? prevStatus);

        private void logDatePicker_ValueChanged(object sender, EventArgs e)
        {
            new Thread(new ThreadStart(DateChanged)).Start();
        }

        private void DateChanged()
        {
            try
            {
                //MessageBox.Show("debug version of the snap-in");
                SqlConnectionStringBuilder scb = new SqlConnectionStringBuilder();
                scb.PersistSecurityInfo = false;
                scb.IntegratedSecurity = false;
                //DEBUG: use test connection string
                scb.DataSource = DBServerName.Text;
                //scb.DataSource = "megas-0003\\MSSQL2008";
                scb.InitialCatalog = logDb.Text;
                scb.UserID = DBUser.Text;
                //DEBUG: different password for test
                //scb.Password = "megas_2009";
                scb.Password = DBPassword.Text;
                SqlConnection sqlCon = new SqlConnection(scb.ConnectionString);
                sqlCon.Open();
                SqlCommand cmd = new SqlCommand("SELECT * FROM BenefitAuditLog WHERE RequestTime >= @Min AND RequestTime <= @Max", sqlCon);
                cmd.CommandType = System.Data.CommandType.Text;
                cmd.Parameters.AddWithValue("@Min", logDatePicker.Value.ToString("yyyy-MM-dd") + " 0:00");
                cmd.Parameters.AddWithValue("@Max", logDatePicker.Value.ToString("yyyy-MM-dd") + " 23:59:59");
                SqlDataReader dr = cmd.ExecuteReader();
                ArrayList test = new ArrayList();


                /*
    0	    [k_pk_id]
    1       [ClearingHouseCtlID]
    2       [RequestTime]
    3       [RequestQualifier]
    4       [ResponseTime]
    5       [ResponseQualifier]
    6       [StatusIndicator]
    7       [EBReturn]
    8       [ErrorID]
    9       [ErrorMessage]
    10      [EXETime]
    11      [ASC270Errors]
    12      [TRNID]
    13      [InboundPayload]
    14      [OutboundPayload]
    15      [ResponseIPAddress]
    16      [MVITime]
    17      [MVIStatus]
    18      [MVIPayload]
    19      [ESRTime]
    20      [ESRStatus]
    21      [ESRPayload]
                 * 
                 * */


                //MessageBox.Show("DateChanged 2");
                while (dr.Read())
                {
                    LogRow row = new LogRow();

                    try { row.ID = dr.GetInt32(0).ToString(); }
                    catch { };

                    try { row.ClearingHouse = dr.GetString(1); }
                    catch { };
                    try { row.RequestTime = dr.GetDateTime(2).ToString(); }
                    catch { };
                    try { row.ResponseQualifier = dr.GetString(3); }
                    catch { };
                    try { row.ResponseTime = dr.GetDateTime(4).ToString(); }
                    catch { };
                    try { row.ResponseQualifier = dr.GetString(5); }
                    catch { };
                    try { row.Status = dr.GetString(6); }
                    catch { };
                    try { row.EBReturn = dr.GetValue(7).ToString(); }
                    catch { };
                    try { row.ErrorID = dr.GetInt32(8).ToString(); }
                    catch { };
                    try { row.ErrorMessage = dr.GetString(9); }
                    catch { };
                    try { row.EXETime = dr.GetValue(10).ToString(); }
                    catch { };
                    try { row.ASC270Errors = dr.GetValue(11).ToString(); }
                    catch { };
                    try { row.TRNID = dr.GetValue(12).ToString(); }
                    catch { };
                    try { row.MVITime = dr.GetValue(16).ToString(); }
                    catch { };
                    try { row.MVIStatus = dr.GetValue(17).ToString(); }
                    catch { };

                    try { row.ESRTime = dr.GetValue(19).ToString(); }
                    catch { };
                    try { row.ESRStatus = dr.GetValue(20).ToString(); }
                    catch { };

                    try { row.IP = dr.GetString(15); }
                    catch { };
                    try { test.Add(row); }
                    catch { };
                }

                //MessageBox.Show("DateChanged 3");
                dataGridView1.DataSource = test;
                dr.Close();
                dr.Dispose();
                cmd.Dispose();
                sqlCon.Close();
            }
            catch (Exception ex)
            {
                using (System.IO.StreamWriter writer = new System.IO.StreamWriter(@"SnapIn.txt", true))
                {
                    writer.WriteLine(ex.Message.ToString());
                    //writer.Close();
                }
            }
        }

        private void SelectRow()
        {
            try
            {
                if (dataGridView1.SelectedRows.Count > 0)
                {
                    string the270 = "";
                    string the271 = "";
                    LogRow row = null;
                    try
                    {
                        row = (LogRow)dataGridView1.SelectedRows[0].DataBoundItem;
                    }
                    catch
                    {
                    }

                    lblClearingHouse.Text = "Clearing House: " + row.ClearingHouse;
                    lblClearingHouse.Visible = true;

                    lblRequestTime.Text = "Request Time: ";
                    tbRequestTime.Text = row.RequestTime;
                    lblRequestTime.Visible = true;
                    tbRequestTime.Visible = true;

                    lblResponseTime.Text = "Response Time: ";
                    tbResponceTime.Text = row.ResponseTime;
                    lblResponseTime.Visible = true;
                    tbResponceTime.Visible = true;

                    lblRequestQual.Text = "Request Qualifier: 1"; // +row.RequestQualifier;
                    lblRequestQual.Visible = true;

                    lblResponseQual.Text = "Response Qualifier: 2"; // +row.ResponseQualifier;
                    lblResponseQual.Visible = true;
                    lblStatus.Text = "Status: " + row.Status;
                    lblStatus.Visible = true;
                    lblErrorID.Text = "Error ID: " + row.ErrorID;
                    lblErrorID.Visible = true;
                    lblErrorMsg.Text = "Error Message: " + row.ErrorMessage;
                    lblErrorMsg.Visible = true;
                    lblIP.Text = "IP: " + row.IP;
                    lblIP.Visible = true;

                    lblElapsedTime.Text = "ElapsedTime: " + row.EXETime;
                    lblElapsedTime.Visible = true;

                    lblEBReturn.Text = "EB Return: " + row.EBReturn;
                    lblEBReturn.Visible = true;

                    lblMVIStatus.Text = "MVI Status: " + row.MVIStatus;
                    lblMVIStatus.Visible = true;

                    lblMVITime.Text = "MVI Time: " + row.MVITime;
                    lblMVITime.Visible = true;

                    lblESRStatus.Text = "ES Status: " + row.ESRStatus;
                    lblESRStatus.Visible = true;

                    lblESRTime.Text = "ES Time: " + row.ESRTime;
                    lblESRTime.Visible = true;

                    lblTRNID.Text = "TRN: " + row.TRNID;
                    lblTRNID.Visible = true;

                    int pk = Convert.ToInt32(dataGridView1.SelectedRows[0].Cells[0].Value);
                    SqlConnectionStringBuilder scb = new SqlConnectionStringBuilder();
                    scb.PersistSecurityInfo = false;
                    scb.IntegratedSecurity = false;
                    //DEBUG: 
                    //scb.DataSource = "megas-0003\\MSSQL2008";
                    scb.DataSource = DBServerName.Text;
                    scb.InitialCatalog = logDb.Text;
                    scb.UserID = DBUser.Text;
                    //DEBUG:
                    //scb.Password = "megas_2009";
                    scb.Password = DBPassword.Text;
                    using (SqlConnection sqlCon = new SqlConnection(scb.ConnectionString))
                    {
                        sqlCon.Open();
                        using (SqlCommand cmd = new SqlCommand("SELECT InboundPayload, OutboundPayload FROM BenefitAuditLog WHERE k_pk_id = @ID", sqlCon))
                        {
                            cmd.CommandType = System.Data.CommandType.Text;
                            cmd.Parameters.AddWithValue("@ID", pk);
                            using (SqlDataReader dr = cmd.ExecuteReader())
                            {
                                if (dr.Read())
                                {
                                    try
                                    {
                                        the270 = dr.GetString(0).Substring(6);
                                        the271 = dr.GetString(1);
                                    }
                                    catch
                                    {
                                    }
                                    ;
                                }
                                //dr.Close();
                                //dr.Dispose();
                            }
                            //cmd.Dispose();
                        }
                        //sqlCon.Close();
                    }
                    scb = new SqlConnectionStringBuilder();
                    scb.PersistSecurityInfo = false;
                    scb.IntegratedSecurity = false;
                    scb.DataSource = DBServerName.Text;
                    scb.InitialCatalog = ansiDb.Text;
                    scb.UserID = DBUser.Text;
                    scb.Password = DBPassword.Text;
                    ANSIReader ansiReader = new ANSIReader(scb.ConnectionString);
                    string out270 = "";
                    try
                    {
                        out270 = ansiReader.ParseFile(the270, true);
                    }
                    catch (Exception ex)
                    {
                        //log parsing error
                        out270 = "<html><head></head><body>Error parsing input: " + ex.Message + "</body><//html>";
                    }
                    string out271 = "";
                    try
                    {
                        out271 = ansiReader.ParseFile(the271, true);
                    }
                    catch (Exception ex)
                    {
                        //log parsing error
                        out271 = "<html><head></head><body>Error parsing input: " + ex.Message + "</body></html>";
                    }

                    logDatePicker.Visible = false;
                    dataGridView1.Visible = false;
                    btnSelect.Visible = false;
                    webBrowser270.Visible = true;
                    webBrowser271.Visible = true;
                    btnBack.Visible = true;
                    webBrowser270.Navigate("about:blank");
                    webBrowser271.Navigate("about:blank");
                    webBrowser270.Document.Write(out270);
                    webBrowser271.Document.Write(out271);
                    webBrowser270.Refresh();
                    webBrowser271.Refresh();
                }
            }
            catch (Exception ex)
            {
                System.IO.StreamWriter writer = new System.IO.StreamWriter(@"SnapIn.txt", true);
                writer.WriteLine("DBERR:" + ex.Message.ToString());
                writer.Close();
            }
        }

        private void BackButton()
        {
            webBrowser270.Visible = false;
            webBrowser271.Visible = false;
            btnBack.Visible = false;
            lblClearingHouse.Visible = false;
            lblRequestTime.Visible = false;
            lblRequestQual.Visible = false;
            lblResponseTime.Visible = false;
            lblResponseQual.Visible = false;
            lblStatus.Visible = false;
            lblErrorID.Visible = false;
            lblErrorMsg.Visible = false;
            lblIP.Visible = false;
            tbRequestTime.Visible = false;
            tbResponceTime.Visible = false;

            lblElapsedTime.Visible = false;
            lblEBReturn.Visible = false;
            lblMVIStatus.Visible = false;
            lblESRStatus.Visible = false;
            lblTRNID.Visible = false;
            lblMVITime.Visible = false;
            lblESRTime.Visible = false;

            logDatePicker.Visible = true;
            dataGridView1.Visible = true;
            btnSelect.Visible = true;
        }

        private void btnSelect_Click(object sender, EventArgs e)
        {
            try
            {
                Invoke(new VoidCallback(SelectRow));
            }
            catch (Exception ex)
            {
                using (System.IO.StreamWriter writer = new System.IO.StreamWriter(@"AETLog.txt", true))
                {
                    writer.Write(ex.Message.ToString());
                    writer.Close();
                }
            }
            //new Thread(new ThreadStart(SelectRow)).Start();
        }

        private void btnBack_Click(object sender, EventArgs e)
        {
            Invoke(new VoidCallback(BackButton));
        }


        /*0	    [k_pk_id]
        1       [ClearingHouseCtlID]
        2       [RequestTime]
        3       [RequestQualifier]
        4       [ResponseTime]
        5       [ResponseQualifier]
        6       [StatusIndicator]
        7       [EBReturn]
        8       [ErrorID]
        9       [ErrorMessage]
        10      [EXETime]
        11      [ASC270Errors]
        12      [TRNID]
        13      [InboundPayload]
        14      [OutboundPayload]
        15      [ResponseIPAddress]
        16      [MVITime]
        17      [MVIStatus]
        18      [MVIPayload]
        19      [ESRTime]
        20      [ESRStatus]
        21      [ESRPayload]*/

        private class LogRow
        {
            private string _id;
            private string _clearingHouse;
            private string _requestTime;
            private string _status;

            public string RequestQualifier = string.Empty;
            public string ResponseTime;
            public string ResponseQualifier;
            public string EBReturn;
            public string ErrorID;
            public string ErrorMessage;
            public string IP;
            public string EXETime;
            public string ASC270Errors;
            public string TRNID;
            public string MVITime;
            public string MVIStatus;
            public string ESRTime;
            public string ESRStatus;

            public string ID
            {
                get { return _id; }
                set { _id = value; }
            }
            public string ClearingHouse
            {
                get { return _clearingHouse; }
                set { _clearingHouse = value; }
            }
            public string RequestTime
            {
                get { return _requestTime; }
                set { _requestTime = value; }
            }
            public string Status
            {
                get { return _status; }
                set { _status = value; }
            }
        }

        private void textBox6_TextChanged(object sender, EventArgs e)
        {
        }

        private void AETControl_TabIndexChanged(object sender, EventArgs e)
        {
            //MessageBox.Show("You are in the Control.TabIndexChanged event.");
        }

        private void tabControl1_SelectedIndexChanged(object sender, EventArgs e)
        {
        }

        private void dataGridView1_CellDoubleClick(object sender, DataGridViewCellEventArgs e)
        {
            Invoke(new VoidCallback(SelectRow));
        }

        private void tabPage2_Click(object sender, EventArgs e)
        {
        }

        private void tabPage4_Click(object sender, EventArgs e)
        {
        }

        private void label5_Click(object sender, EventArgs e)
        {
        }

        private void VMACFileName_TextChanged(object sender, EventArgs e)
        {
        }

        private void label7_Click(object sender, EventArgs e)
        {
        }

        private void VMACerver_TextChanged(object sender, EventArgs e)
        {
        }

        private void label8_Click(object sender, EventArgs e)
        {

        }

        private void textBox2_TextChanged(object sender, EventArgs e)
        {
        }

        private void groupBox1_Enter(object sender, EventArgs e)
        {
        }

        private void textBox4_TextChanged(object sender, EventArgs e)
        {
        }

        /// <summary>
        /// //////////////////////////////////////////////////////////////////////////////////////////
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button3_Click(object sender, EventArgs e)
        {
            openFileDialog1.InitialDirectory = ZipCodeWatchFolder.Text;
            openFileDialog1.RestoreDirectory = true;
            openFileDialog1.FileName = "";

            DialogResult rslt = openFileDialog1.ShowDialog();
            if (rslt == DialogResult.OK)
            {
                LEIEFileName.Text = openFileDialog1.FileName;
            }
            else
            {
                LEIEFileName.Text = "";
            }
        }

        private void button7_Click(object sender, EventArgs e)
        {
            if (LEIEFileName.Text.Length < 2)
            {
                MessageBox.Show("Please select a LEIE import file.");
                return;
            }
            string cn = string.Format("Initial Catalog=VALEIE;Data Source={0};User Id={1};Password={2};Persist Security Info=False", LEIEServer.Text, LEIEUser.Text, LEIEPw.Text);
            ImportLEIEFile(cn, LEIEFileName.Text);
        }

        public void ImportLEIEFile(string LEIEConnection, string FileName)
        {
            bool bLoop = true;
            System.Threading.Thread.Sleep(1000 * 5);
            SqlCommand cmd = null;
            System.IO.StreamReader importfile = null;
            try
            {
                cmd = new SqlCommand();
                cmd.Connection = new SqlConnection(LEIEConnection);
                cmd.Connection.Open();
                cmd.CommandType = CommandType.Text;
                cmd.CommandText = "UPDATE LEIELookup SET Retired = 'Y'";
                cmd.ExecuteNonQuery();

                cmd.CommandText = "INSERT INTO [VALEIE].[dbo].[LEIELookup]([NPI]) VALUES (@NPI)";

                cmd.Parameters.Add("@NPI", SqlDbType.NVarChar);

                importfile = new StreamReader(FileName);
                string tmpLine = importfile.ReadLine();
                tmpLine = importfile.ReadLine();
                char[] splitchar = new char[1] { ',' };
                string[] fields = null;
                string tmp = "";
                int RecordCount = 0;

                while (!string.IsNullOrEmpty(tmpLine) && bLoop)
                {
                    RecordCount++;
                    fields = tmpLine.Split(splitchar);
                    if (fields.Count() < 18)
                    {
                        cmd.Parameters.Clear();
                        cmd.CommandText = "DELETE FROM LEIELookup WHERE [Retired] IS NULL";
                        cmd.ExecuteNonQuery();
                        cmd.CommandText = "UPDATE LEIELookup SET [Retired] = NULL";
                        cmd.ExecuteNonQuery();
                        string msg = String.Format("LEIE Import FAILED Field Count 18:{0} File :{1}", fields.Count(), FileName);
                        //System.Diagnostics.EventLog.WriteEntry("AETService", msg, System.Diagnostics.EventLogEntryType.Error, 110, 500);
                        bLoop = false;
                        continue;
                    }

                    if (RecordCount == 1)
                    {
                        string msg = String.Format("LEIE Import File Validation Complete!");
                        //System.Diagnostics.EventLog.WriteEntry("AETService", msg, System.Diagnostics.EventLogEntryType.Information);
                    }
                    tmp = SafeSubString(fields[8].Trim(), 255);

                    tmp = tmp.Replace("\"", "");

                    if (!string.IsNullOrEmpty(tmp))
                    {
                        cmd.Parameters["@NPI"].Value = tmp;
                    }
                    else
                    {
                        cmd.Parameters["@NPI"].Value = DBNull.Value;
                    }

                    cmd.ExecuteNonQuery();
                    tmpLine = importfile.ReadLine();
                }

                if (bLoop == true)
                {
                    cmd.Parameters.Clear();
                    cmd.CommandText = "DELETE FROM LEIELookup WHERE [Retired] = 'Y'";
                    cmd.ExecuteNonQuery();
                }

                if (bLoop == true)
                {
                    string sMsg = string.Format("AET Imported {0} LEIE NPI's into the database.", RecordCount);
                    //System.Diagnostics.EventLog.WriteEntry("AETService", sMsg, System.Diagnostics.EventLogEntryType.Information, 142, 200);

                    DateTime d1 = DateTime.Now;
                    txtLEIEUpdate.Text = String.Format("{0} {1} ({2}) Records", d1.ToShortDateString(), d1.ToShortTimeString(), RecordCount);
                }
                else
                {
                    string sMsg = string.Format("AET Imported 0 LEIE NPI's into the database.", RecordCount);
                    //System.Diagnostics.EventLog.WriteEntry("AETService", sMsg, System.Diagnostics.EventLogEntryType.Warning, 142, 200);
                    //txtLEIEUpdate.Text = "";
                }
            }
            catch (Exception ex)
            {
                string sMsg = string.Format("Error on LEIE import File: {0}", ex.Message);
                //System.Diagnostics.EventLog.WriteEntry("AETService", sMsg, System.Diagnostics.EventLogEntryType.Error, 142, 500);
                sMsg = string.Format("LEIE Error Data: {0}", LEIEConnection);
                //System.Diagnostics.EventLog.WriteEntry("AETService", sMsg, System.Diagnostics.EventLogEntryType.Warning, 142, 200);

                bLoop = false;

                if (cmd != null && cmd.Connection != null && cmd.Connection.State == System.Data.ConnectionState.Open)
                {
                    cmd.Parameters.Clear();
                    cmd.CommandText = "DELETE FROM LEIELookup WHERE [Retired] IS NULL";
                    cmd.ExecuteNonQuery();
                    cmd.CommandText = "UPDATE LEIELookup SET [Retired] = NULL";
                    cmd.ExecuteNonQuery();
                }
            }
            finally
            {
                if (cmd.Connection != null)
                {
                    if (cmd.Connection.State == System.Data.ConnectionState.Open)
                    {
                        cmd.Connection.Close();
                    }
                }
                cmd.Dispose();

                importfile.Close();

                if (bLoop == true)
                {
                    try
                    {
                        RegistryKey system = Microsoft.Win32.Registry.LocalMachine.OpenSubKey("System");        //Open the HKEY_LOCAL_MACHINE\SYSTEM key
                        RegistryKey currentControlSet = system.OpenSubKey("CurrentControlSet");                 //Open CurrentControlSet
                        RegistryKey services = currentControlSet.OpenSubKey("Services");                        //Go to the services key
                        RegistryKey service = services.OpenSubKey("AETService", true);                                    //Open the AETService service, and allow writing
                        RegistryKey config = service.OpenSubKey("Parameters", true);                                      //Create the Parameters key ETService, and allow writing

                        string s = string.Format("Zip={0};LEIE={1}", txtZipUpdate.Text, txtLEIEUpdate.Text);
                        config.SetValue("ImportUpdate", s);

                        config.Close();
                        service.Close();
                        services.Close();
                        currentControlSet.Close();
                        system.Close();
                    }
                    catch (Exception ex)
                    {
                        string sMsg = string.Format("Error saving LEIE stats: {0}", ex.Message);
                        //System.Diagnostics.EventLog.WriteEntry("AETService", sMsg, System.Diagnostics.EventLogEntryType.Warning);
                    }
                    MessageBox.Show("New LEIE file has been Imported");
                }
                else
                {
                    MessageBox.Show("New LEIE file FAILED to Import! Please see Windows Event Log.");
                }
            }
        }

        /// <summary>
        /// ///////////////////////////////////////////////////////////////////////////////////////
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click(object sender, EventArgs e)
        {
            openFileDialog1.InitialDirectory = ZipCodeWatchFolder.Text;
            openFileDialog1.RestoreDirectory = true;
            openFileDialog1.FileName = "";

            DialogResult rslt = openFileDialog1.ShowDialog();
            if (rslt == DialogResult.OK)
            {
                VMACFileName.Text = openFileDialog1.FileName;
            }
            else
            {
                VMACFileName.Text = "";
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            if (VMACFileName.Text.Length < 2)
            {
                MessageBox.Show("Please select a Zip Code import file.");
                return;

            }
            string cn = string.Format("Initial Catalog=VAZip;Data Source={0};User Id={1};Password={2};Persist Security Info=False", ZServer.Text, ZUser.Text, ZPw.Text);
            ImportZipFile(cn, VMACFileName.Text);
        }

        public void ImportZipFile(string ZipConnection, string FileName)
        {
            bool bLoop = true;

            SqlCommand cmd = null;
            System.IO.StreamReader importfile = null;
            try
            {
                int RecordCount = 0;
                using (importfile = new StreamReader(FileName))
                {
                    char[] splitchar = new char[1] { '\t' };
                    string[] fields = null;
                    string tmp = "";

                    string tmpLine = importfile.ReadLine();
                    while (bLoop && !string.IsNullOrEmpty(tmpLine))
                    {
                        fields = tmpLine.Split(splitchar);

                        int fc = fields.Count();
                        RecordCount++;
                        if (RecordCount == 1)
                        {
                            string msg = String.Empty;
                            string Hdr = SafeSubString(fields[0].Trim(), 15);
                            if (Hdr != "Lookup Zip Code")
                            {
                                msg = String.Format("Zip Code Import File Error: " + "Invaliad Header Record.");
                                //System.Diagnostics.EventLog.WriteEntry("AETService", msg, System.Diagnostics.EventLogEntryType.Error, 110, 500);
                                bLoop = false;
                                continue;
                            }
                            if (fc != 10)
                            {
                                msg = String.Format("Zip Code Import File Error: Invaliad Field Count. {0} and should be 10", fc);
                                //System.Diagnostics.EventLog.WriteEntry("AETService", msg, System.Diagnostics.EventLogEntryType.Error, 110, 500);
                                bLoop = false;
                                continue;
                            }

                            msg = String.Format("Zip Code Import File Validation Complete!");

                            //System.Diagnostics.EventLog.WriteEntry("AETService", msg, System.Diagnostics.EventLogEntryType.Information);

                            cmd = new SqlCommand();
                            cmd.Connection = new SqlConnection(ZipConnection);
                            cmd.Connection.Open();
                            cmd.CommandType = CommandType.Text;
                            cmd.CommandText = "UPDATE ZipLookup SET Retired = 'Y'";
                            cmd.ExecuteNonQuery();

                            cmd.CommandText = "INSERT INTO [VAZip].[dbo].[ZipLookup]([LookupZip],[FacilityName],[AddressLine1],[AddressLine2],[City],[State],[FacilityZip],[ContactPhone],[ContactFax],[ContactEmail]) VALUES (@ZipLookup,@FacilityName,@AddressLine1,@AddressLine2,@City,@State,@FacilityZip,@ContactPhone,@ContactFax,@ContactEmail)";
                            cmd.Parameters.Add("@ZipLookup", SqlDbType.NVarChar);
                            cmd.Parameters.Add("@FacilityName", SqlDbType.NVarChar);
                            cmd.Parameters.Add("@AddressLine1", SqlDbType.NVarChar);
                            cmd.Parameters.Add("@AddressLine2", SqlDbType.NVarChar);
                            cmd.Parameters.Add("@City", SqlDbType.NVarChar);
                            cmd.Parameters.Add("@State", SqlDbType.NVarChar);
                            cmd.Parameters.Add("@FacilityZip", SqlDbType.NVarChar);
                            cmd.Parameters.Add("@ContactPhone", SqlDbType.NVarChar);
                            cmd.Parameters.Add("@ContactFax", SqlDbType.NVarChar);
                            cmd.Parameters.Add("@ContactEmail", SqlDbType.NVarChar);

                            tmpLine = importfile.ReadLine();
                            continue;
                        }

                        cmd.Parameters["@ZipLookup"].Value = SafeSubString(fields[0].Trim(), 5);
                        cmd.Parameters["@FacilityName"].Value = SafeSubString(fields[1].Trim(), 50);
                        tmp = SafeSubString(fields[2].Trim(), 255);
                        if (!string.IsNullOrEmpty(tmp))
                        {
                            cmd.Parameters["@AddressLine1"].Value = tmp;
                        }
                        else
                        {
                            cmd.Parameters["@AddressLine1"].Value = DBNull.Value;
                        }

                        tmp = SafeSubString(fields[3].Trim(), 255);
                        if (!string.IsNullOrEmpty(tmp))
                        {
                            cmd.Parameters["@AddressLine2"].Value = tmp;
                        }
                        else
                        {
                            cmd.Parameters["@AddressLine2"].Value = DBNull.Value;
                        }

                        tmp = SafeSubString(fields[4].Trim(), 50);
                        if (!string.IsNullOrEmpty(tmp))
                        {
                            cmd.Parameters["@City"].Value = tmp;
                        }
                        else
                        {
                            cmd.Parameters["@City"].Value = DBNull.Value;
                        }

                        tmp = SafeSubString(fields[5].Trim(), 2);
                        if (!string.IsNullOrEmpty(tmp))
                        {
                            cmd.Parameters["@State"].Value = tmp;
                        }
                        else
                        {
                            cmd.Parameters["@State"].Value = DBNull.Value;
                        }

                        tmp = SafeSubString(fields[6].Trim(), 10);
                        if (!string.IsNullOrEmpty(tmp))
                        {
                            cmd.Parameters["@FacilityZip"].Value = tmp;
                        }
                        else
                        {
                            cmd.Parameters["@FacilityZip"].Value = DBNull.Value;
                        }

                        tmp = SafeSubString(fields[7].Trim(), 20);
                        if (!string.IsNullOrEmpty(tmp))
                        {
                            cmd.Parameters["@ContactPhone"].Value = tmp;
                        }
                        else
                        {
                            cmd.Parameters["@ContactPhone"].Value = DBNull.Value;
                        }

                        tmp = SafeSubString(fields[8].Trim(), 20);
                        if (!string.IsNullOrEmpty(tmp))
                        {
                            cmd.Parameters["@ContactFax"].Value = tmp;
                        }
                        else
                        {
                            cmd.Parameters["@ContactFax"].Value = DBNull.Value;
                        }

                        tmp = SafeSubString(fields[9].Trim(), 255);
                        if (!string.IsNullOrEmpty(tmp))
                        {
                            cmd.Parameters["@ContactEmail"].Value = tmp;
                        }
                        else
                        {
                            cmd.Parameters["@ContactEmail"].Value = DBNull.Value;
                        }

                        cmd.ExecuteNonQuery();

                        tmpLine = importfile.ReadLine();
                    }
                }

                if (bLoop == true)
                {
                    cmd.Parameters.Clear();
                    cmd.CommandText = "DELETE FROM ZipLookup WHERE [Retired] = 'Y'";
                    cmd.ExecuteNonQuery();

                    string sMsg = string.Format("AET OnLine after Importing {0} Zipcodes", RecordCount);
                    //System.Diagnostics.EventLog.WriteEntry("AETService", sMsg, System.Diagnostics.EventLogEntryType.Information, 140, 200);

                    DateTime d1 = DateTime.Now;
                    txtZipUpdate.Text = String.Format("{0} {1} ({2}) Records", d1.ToShortDateString(), d1.ToShortTimeString(), RecordCount);
                }
                else
                {
                    string sMsg = string.Format("AET Imported 0 Zip Code's into the database.", (RecordCount - 1));
                    //System.Diagnostics.EventLog.WriteEntry("AETService", sMsg, System.Diagnostics.EventLogEntryType.Warning, 142, 200);
                }
            }
            catch (Exception ex)
            {
                string sMsg = string.Format("Error on ZipCode import File: {0}", ex.Message);
                //System.Diagnostics.EventLog.WriteEntry("AETService", sMsg, System.Diagnostics.EventLogEntryType.Error, 142, 500);
                sMsg = string.Format("ZipCode Error Data: {0}", ZipConnection);
                //System.Diagnostics.EventLog.WriteEntry("AETService", sMsg, System.Diagnostics.EventLogEntryType.Warning, 142, 200);

                bLoop = false;

                if (cmd != null && cmd.Connection != null && cmd.Connection.State == System.Data.ConnectionState.Open)
                {
                    cmd.Parameters.Clear();
                    cmd.CommandText = "DELETE FROM ZipLookup WHERE [Retired] IS NULL";
                    cmd.ExecuteNonQuery();
                    cmd.CommandText = "UPDATE ZipLookup SET [Retired] = NULL";
                    cmd.ExecuteNonQuery();
                }
            }
            finally
            {
                if (cmd != null)
                {
                    if (cmd.Connection != null)
                    {
                        if (cmd.Connection.State == System.Data.ConnectionState.Open)
                        {
                            cmd.Connection.Close();
                        }
                    }
                    cmd.Dispose();
                }

                if (bLoop == true)
                {
                    try
                    {
                        RegistryKey system = Microsoft.Win32.Registry.LocalMachine.OpenSubKey("System");        //Open the HKEY_LOCAL_MACHINE\SYSTEM key
                        RegistryKey currentControlSet = system.OpenSubKey("CurrentControlSet");                 //Open CurrentControlSet
                        RegistryKey services = currentControlSet.OpenSubKey("Services");                        //Go to the services key
                        RegistryKey service = services.OpenSubKey("AETService", true);                                    //Open the AETService service, and allow writing
                        RegistryKey config = service.OpenSubKey("Parameters", true);                                      //Create the Parameters key ETService, and allow writing

                        string s = string.Format("Zip={0};LEIE={1}", txtZipUpdate.Text, txtLEIEUpdate.Text);
                        config.SetValue("ImportUpdate", s);

                        config.Close();
                        service.Close();
                        services.Close();
                        currentControlSet.Close();
                        system.Close();
                    }
                    catch (Exception ex)
                    {
                        string sMsg = string.Format("Error saving ZipCode stats: {0}", ex.Message);
                        //System.Diagnostics.EventLog.WriteEntry("AETService", sMsg, System.Diagnostics.EventLogEntryType.Warning);
                    }
                    MessageBox.Show("New Zip Code file has been Imported");
                }
                else
                {
                    MessageBox.Show("New Zip Code file FAILED to Import! Please see Windows Event Log.");
                }
            }
        }

        private string SafeSubString(string Input, int len)
        {
            string rtn = string.Empty;
            if (!string.IsNullOrEmpty(Input))
            {
                if (Input.Length >= len)
                {
                    rtn = Input.Substring(0, len);
                }
                else
                {
                    rtn = Input;
                }
            }
            return rtn;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            RegistryKey system = Microsoft.Win32.Registry.LocalMachine.OpenSubKey("System");        //Open the HKEY_LOCAL_MACHINE\SYSTEM key
            RegistryKey currentControlSet = system.OpenSubKey("CurrentControlSet");                 //Open CurrentControlSet
            RegistryKey services = currentControlSet.OpenSubKey("Services");                        //Go to the services key
            RegistryKey service = services.OpenSubKey("AETService", true);                                    //Open the AETService service, and allow writing
            RegistryKey config = service.OpenSubKey("Parameters", true);                                      //Create the Parameters key ETService, and allow writing

            string sMsg = string.Format("{0};{1}", ZipCodeWatchFolder.Text, ZipCodeExt.Text);
            try
            {
                config.SetValue("ZipImportFolder", Crypto.AES.Encrypt(sMsg));
            }
            catch
            {
                config.SetValue("ZipImportFolder", sMsg);
            }
            config.Close();
            service.Close();
            services.Close();
            currentControlSet.Close();
            system.Close();
        }

        private void label30_Click(object sender, EventArgs e)
        {
        }


        private void textBox18_TextChanged(object sender, EventArgs e)
        {
        }

        private void button6_Click(object sender, EventArgs e)
        {
        }

        private bool RunClient()
        {
            try
            {
                System.Diagnostics.Process p = new System.Diagnostics.Process();

                SecureString ss = new SecureString();

                ss.AppendChar('M');
                ss.AppendChar('u');
                ss.AppendChar('r');
                ss.AppendChar('e');
                ss.AppendChar('x');
                ss.AppendChar('T');
                ss.AppendChar('h');
                ss.AppendChar('e');
                ss.AppendChar('S');
                ss.AppendChar('h');
                ss.AppendChar('e');
                ss.AppendChar('l');
                ss.AppendChar('l');
                ss.AppendChar('4');

                p.StartInfo.Domain = "MEGAS.Local";
                p.StartInfo.UserName = "vallen";
                p.StartInfo.Password = ss;

                p.StartInfo.FileName = "\"C:\\Program Files\\VistAFee5010\\AETService\\Tools\\TcpClient.exe\"";
                p.StartInfo.WorkingDirectory = "";
                p.StartInfo.Arguments = "";
                p.StartInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Normal;
                p.StartInfo.UseShellExecute = false;
                p.Start();
                //string sMsg = String.Format("Start ProcessID = {0} [{1} {2}])", p.Id, Exe, Args); ;
                p.WaitForExit();
            }
            catch (Exception ex)
            {
                string s = String.Format("RunClient ERROR={0}", ex.ToString());
                //System.Diagnostics.EventLog.WriteEntry("AETService", s, System.Diagnostics.EventLogEntryType.Error, 190, 600);
            }
            return true;
        }

        private void textBox17_TextChanged(object sender, EventArgs e)
        {
        }

        private void webBrowser271_DocumentCompleted(object sender, WebBrowserDocumentCompletedEventArgs e)
        {
        }

        private void tabPage1_Click(object sender, EventArgs e)
        {
        }

        private void button9_Click(object sender, EventArgs e)
        {
            // RunReport

            string Rtn = string.Empty;
            string NL = "\r\n";

            try
            {
                //MessageBox.Show("debug version of the snap-in");
                SqlConnectionStringBuilder scb = new SqlConnectionStringBuilder();
                scb.PersistSecurityInfo = false;
                scb.IntegratedSecurity = false;
                //DEBUG: use test connection string
                scb.DataSource = DBServerName.Text;
                scb.InitialCatalog = "VA_Audit";
                scb.UserID = DBUser.Text;
                //DEBUG: different password for test
                //scb.Password = "megas_2009";
                scb.Password = DBPassword.Text;
                SqlConnection sqlCon = new SqlConnection(scb.ConnectionString);
                sqlCon.Open();
                SqlCommand cmd = new SqlCommand("SELECT * FROM BenefitAuditLog WHERE RequestTime >= @Min AND RequestTime <= @Max", sqlCon);
                cmd.CommandType = System.Data.CommandType.Text;
                cmd.Parameters.AddWithValue("@Min", dateTimePicker1.Value.ToString("yyyy-MM-dd") + " 0:00");
                cmd.Parameters.AddWithValue("@Max", dateTimePicker2.Value.ToString("yyyy-MM-dd") + " 23:59:59");
                SqlDataReader readerB = cmd.ExecuteReader();

                Rtn = NL;
                Rtn += "AET ID,Transaction Number,Request Time,Transaction Time,EB Return Value,MVI Time,MVI Status,ES Time,ES Status,ErrorID,ErrorMsg,270Errors\r\n";

                /*
    0	    [k_pk_id]
    1       [ClearingHouseCtlID]
    2       [RequestTime]
    3       [RequestQualifier]
    4       [ResponseTime]
    5       [ResponseQualifier]
    6       [StatusIndicator]
    7       [EBReturn]
    8       [ErrorID]
    9       [ErrorMessage]
    10      [EXETime]
    11      [ASC270Errors]
    12      [TRNID]
    13      [InboundPayload]
    14      [OutboundPayload]
    15      [ResponseIPAddress]
    16      [MVITime]
    17      [MVIStatus]
    18      [MVIPayload]
    19      [ESRTime]
    20      [ESRStatus]
    21      [ESRPayload]
                 * 
                 * */


                // k_pk_id, TRNID, RequestTime, EBReturn, MVIStatus, MVITime, ESRStatus, ESRTime
                while (readerB.Read())
                {
                    string AETID = string.Empty;
                    string ClearingHouseCtlID = string.Empty;
                    string RequestTime = string.Empty;
                    string RequestQualifier = string.Empty;
                    string ResponseTime = string.Empty;
                    string ResponseQualifier = string.Empty;
                    string StatusIndicator = string.Empty;
                    string EBReturn = string.Empty;
                    string ErrorID = string.Empty;

                    string ErrorMessage = string.Empty;
                    string EXETime = string.Empty;
                    string ASC270Errors = string.Empty;
                    string TRNID = string.Empty;
                    string InboundPayload = string.Empty;
                    string OutboundPayload = string.Empty;
                    string ResponseIPAddress = string.Empty;
                    string MVITime = string.Empty;
                    string MVIStatus = string.Empty;
                    string MVIPayload = string.Empty;
                    string ESRTime = string.Empty;
                    string ESRStatus = string.Empty;
                    string ESRPayload = string.Empty;

                    try
                    {
                        AETID = readerB.GetValue(0).ToString();

                        ClearingHouseCtlID = readerB.GetValue(1).ToString();
                        RequestTime = readerB.GetValue(2).ToString();
                        RequestQualifier = readerB.GetValue(3).ToString();
                        ResponseTime = readerB.GetValue(4).ToString();
                        ResponseQualifier = readerB.GetValue(5).ToString();
                        StatusIndicator = readerB.GetValue(6).ToString();
                        EBReturn = readerB.GetValue(7).ToString();
                        ErrorID = readerB.GetValue(8).ToString();
                        ErrorMessage = readerB.GetValue(9).ToString();
                        EXETime = readerB.GetValue(10).ToString();
                        ASC270Errors = readerB.GetValue(11).ToString();
                        TRNID = readerB.GetValue(12).ToString();
                        InboundPayload = readerB.GetValue(13).ToString();
                        OutboundPayload = readerB.GetValue(14).ToString();
                        ResponseIPAddress = readerB.GetValue(15).ToString();
                        MVITime = readerB.GetValue(16).ToString();
                        MVIStatus = readerB.GetValue(17).ToString();
                        MVIPayload = readerB.GetValue(18).ToString();
                        ESRTime = readerB.GetValue(19).ToString();
                        ESRStatus = readerB.GetValue(20).ToString();
                        ESRPayload = readerB.GetValue(21).ToString();
                    }
                    catch
                    {
                    }

                    if (EXETime.Length > 8)
                        EXETime = EXETime.Substring(0, 8);

                    if (MVITime.Length > 8)
                        MVITime = MVITime.Substring(0, 8);

                    if (ESRTime.Length > 8)
                        ESRTime = ESRTime.Substring(0, 8);

                    //string rptData = String.Format("{0},{1},{2},{3},{4},{5},{6},{7}\r\n", AETID, TRNID, RequestTime, EBReturn, MVITime, MVIStatus, ESRTime, ESRStatus);
                    string rptData = String.Format("{0},{1},{2},{3},{4},{5},{6},{7},{8},{9},{10},{11}\r\n", AETID, TRNID, RequestTime, EXETime, EBReturn, MVITime, MVIStatus, ESRTime, ESRStatus, ErrorID, ErrorMessage, ASC270Errors);
                    Rtn += rptData;
                }
                readerB.Close();
                cmd.Dispose();
                sqlCon.Close();
            }
            catch (Exception ex)
            {
                //string erMsg = String.Format("Log Request failed: {0}\r\nServer: {1}, Database: {2}, UserID: {3}, UserData: {4}\r\n", ex.Message.ToString(), ZServer.Text, "VA_Audit", ZUser.Text, ZPw.Text);
                string erMsg = String.Format("Log Request failed: {0}", ex.Message.ToString());
                Rtn = erMsg;
            }
            Rtn += NL;

            using (System.IO.StreamWriter writer = new System.IO.StreamWriter(AETReportName.Text, false))
            {
                writer.Write(Rtn);
                writer.Close();
            }
        }

        private void button10_Click(object sender, EventArgs e)
        {
        }

        private void button8_Click(object sender, EventArgs e)
        {
            // May 10th 2:20pm (41,454) Records
            RegistryKey system = Microsoft.Win32.Registry.LocalMachine.OpenSubKey("System");        //Open the HKEY_LOCAL_MACHINE\SYSTEM key
            RegistryKey currentControlSet = system.OpenSubKey("CurrentControlSet");                 //Open CurrentControlSet
            RegistryKey services = currentControlSet.OpenSubKey("Services");                        //Go to the services key
            RegistryKey service = services.OpenSubKey("AETService", true);                                //Open the AETService service, and allow writing
            RegistryKey config = service.OpenSubKey("Parameters", true);                                    //Create the Parameters key ETService, and allow writing

            string sMsg = string.Format("{0};{1}", LEIEWatchFolder.Text, LEIEExt.Text);
            try
            {
                config.SetValue("LEIEImportFolder", Crypto.AES.Encrypt(sMsg));
            }
            catch
            {
                config.SetValue("LEIEImportFolder", sMsg);
            }

            config.Close();
            service.Close();
            services.Close();
            currentControlSet.Close();
            system.Close();
        }

		private void cmdSaveNPI_Click(object sender, EventArgs e)
		{

			RegistryKey system = Microsoft.Win32.Registry.LocalMachine.OpenSubKey("System");        //Open the HKEY_LOCAL_MACHINE\SYSTEM key
			RegistryKey currentControlSet = system.OpenSubKey("CurrentControlSet");                 //Open CurrentControlSet
			RegistryKey services = currentControlSet.OpenSubKey("Services");                        //Go to the services key
			RegistryKey service = services.OpenSubKey("AETService", true);                                //Open the AETService service, and allow writing
			RegistryKey config = service.OpenSubKey("Parameters", true);                                    //Create the Parameters key ETService, and allow writing

			string sMsg = string.Format("{0};{1}", NPIWatchFolder.Text, NPIExt.Text);
			try
			{
				config.SetValue("NPIImportFolder", Crypto.AES.Encrypt(sMsg));
			}
			catch
			{
				config.SetValue("NPIImportFolder", sMsg);
			}

			config.Close();
			service.Close();
			services.Close();
			currentControlSet.Close();
			system.Close();
		}
	} // class
} // namespace